package
{
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.core.ErrorTracker;
	import com.despark.tuning3d.model.core.Tracer;
	import com.despark.tuning3d.model.settings.Settings;
	import com.despark.tuning3d.model.sharing.SharingOkProxy;
import com.despark.tuning3d.model.sharing.SharingPinProxy;
import com.despark.tuning3d.model.sharing.SharingProxy;
import com.despark.tuning3d.model.sharing.SharingVkProxy;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.UsersProxy;
	import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
	import com.distriqt.DistriqtController;
	import com.distriqt.GameService;
	import com.distriqt.GameServiceManager;
	import com.distriqt.PushNotification;
	import com.distriqt.extension.application.Application;
	import com.distriqt.extension.firebase.Firebase;
	import com.distriqt.extension.firebase.FirebaseOptions;
	import com.distriqt.extension.firebase.crashlytics.FirebaseCrashlytics;
	import com.distriqt.extension.idfa.IDFA;
	import com.distriqt.extension.idfa.TrackingAuthorisationStatus;
	import com.distriqt.extension.idfa.events.IDFAAuthorisationEvent;
	import com.distriqt.extension.idfa.events.IDFAEvent;
	import com.distriqt.extension.inappbilling.BillingService;
	import com.distriqt.extension.inappbilling.InAppBilling;
	import com.distriqt.extension.memory.Memory;
	import com.distriqt.extension.memory.MemoryInfo;
	import com.distriqt.extension.memory.events.MemoryEvent;
	import com.utils.Console;
	import com.utils.Logger;
import com.utils.MemLeakTest;
import com.utils.MemoryTracker;
import com.utils.Tracker;

	import flash.data.EncryptedLocalStore;

	import flash.desktop.NativeApplication;
import flash.desktop.SystemIdleMode;
import flash.display.Sprite;
import flash.display.StageAlign;
import flash.display.StageScaleMode;
import flash.events.ErrorEvent;
import flash.events.Event;
import flash.events.InvokeEvent;
import flash.events.RemoteNotificationEvent;
import flash.events.StatusEvent;
import flash.events.TimerEvent;
import flash.events.UncaughtErrorEvent;
import flash.filesystem.File;
import flash.filesystem.FileMode;
import flash.filesystem.FileStream;
	import flash.media.AudioPlaybackMode;
	import flash.media.SoundMixer;
	import flash.net.URLVariables;
import flash.notifications.NotificationStyle;
import flash.notifications.RemoteNotifier;
import flash.notifications.RemoteNotifierSubscribeOptions;
import flash.system.Capabilities;
	import flash.utils.ByteArray;
	import flash.utils.Timer;
	import flash.utils.setTimeout;

	import starling.core.Starling;
	import starling.textures.Texture;

	[SWF(backgroundColor="#000000", frameRate="60")]
	public class Tuning3D extends Sprite  
	{
		private var subscribeOptions:RemoteNotifierSubscribeOptions = new RemoteNotifierSubscribeOptions();
		private var preferredStyles:Vector.<String> = new Vector.<String>();
		private var remoteNot:RemoteNotifier = new RemoteNotifier();
		public static var memLeakTest:MemLeakTest=null;
		private var facade : ApplicationFacade;
		public static var GEODATA: Object;
		public static var UPDATE_DATE:Date;
		public static var CAR_UPDATE_DATE:Number=0;
		public static var pushNotificationClass: PushNotification;
		/////////////////////////////////////

		private var _breakTimer:Timer;
		private var delay:int = 100;
		private var isIDFAInitialized:Boolean = false;


		public function Tuning3D() {
			setTimeout(initIDFA, 1000);
		}

		private static function _log(msg:String):void {
			if (Constants.IS_DEBUG) trace(msg)
		}

		private function IDFAInitCallback():void{
			if(UPDATE_DATE){
				return;
			}
			UPDATE_DATE = new Date(2022,9,2);

			DistriqtController.init();

			if (Firebase.isSupported) {
				Firebase.service.initialiseApp();
				if(FirebaseCrashlytics.isSupported){
					FirebaseCrashlytics.service.enableCollection();
				}
			}

			Constants.init();

			NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.KEEP_AWAKE;

			Settings.init();
			SoundManager.init();

			var file:File=File.applicationStorageDirectory.resolvePath("Cars_parts");

			if(file.exists){

				file.deleteDirectoryAsync(true);
			}

			SoundMixer.audioPlaybackMode = AudioPlaybackMode.AMBIENT;

			var bmpDir:File=File.applicationStorageDirectory.resolvePath("CarsBmp");

			if(bmpDir.exists){
				bmpDir.deleteDirectoryAsync(true);
				Tracer.print("DELETE CarsBmp");
			}


			if (Constants.isIOS)
			{
				try {
					if (Memory.isSupported) {
						_log("Memory Supported:\t" + Memory.isSupported + "\nMemory Version:\t" + Memory.service.version);
						Memory.service.addEventListener(MemoryEvent.LOW_MEMORY_WARNING, lowMemoryWarningHandler);
					}
				}catch (e:Error){
					_log("Memory Support ERROR::\t"+e.message);
				}
			}

			memLeakTest=new MemLeakTest();


			var xml : XML = NativeApplication.nativeApplication.applicationDescriptor;
			var ns : Namespace = xml.namespace();
			var version : String = xml.ns::versionNumber;
			Constants.APP_VERSION_PREFIX = "&version=" + version;

			file=File.applicationStorageDirectory.resolvePath(version+".dat");


			if(!file.exists){
				var fs:FileStream=new FileStream();
				fs.open(file, FileMode.WRITE);
				fs.writeByte(1);
				fs.close();

				Constants.FIRST_APP_START=true;
				Constants.FIRST_BRANDS_SCREEN=true;
				Constants.FIRST_TUNING_SCREEN_FREE_CAR=true;
			}

			loaderInfo.uncaughtErrorEvents.addEventListener(UncaughtErrorEvent.UNCAUGHT_ERROR, uncaughtErrorHandler);

			NativeApplication.nativeApplication.addEventListener(Event.EXITING, onExit);

			Logger.startSession(this);


			File.documentsDirectory.preventBackup = true;//+
			File.cacheDirectory.preventBackup = true;//+

			File.applicationStorageDirectory.preventBackup = true;//+
			File.applicationDirectory.preventBackup = true;//+
			File.desktopDirectory.preventBackup = true;//+

			MemoryTracker.stage = stage;
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;

			Constants.IS_EMULATOR = Device.isEmulator();


			try {// only for emulators

				if(Device.isIos()){
					var info:MemoryInfo = Memory.service.getMemoryInfo();
					Constants.TOTAL_MEMORY = info.totalMemory/1024/1024;//info.availableMemory/1024/1024;//systemLib.MemoryInfoGetTotal();
				}
				//Constants.TOTAL_MEMORY = systemLib.MemoryInfoGetTotal();

				trace("Constants.TOTAL_MEMORY:", Constants.TOTAL_MEMORY); //info.totalMemory/1024/1024
			}
			catch(e:Error){
				Constants.TOTAL_MEMORY = 512;
				Constants.ThisIsIPAD=true;
			}



			facade = ApplicationFacade.getInstance();
			facade.startup(this);


			Constants.ThisIsIPAD = (Capabilities.screenResolutionX * Capabilities.screenResolutionY > 780000);
			if(!Device.isIos()){
				Constants.ThisIsIPAD=false;
			}

			Constants.isIOS = Device.isIos();

			Tracker.getInstance().trackPageview("3dtuning");

			if(Device.isIos()){
				Constants.RAM_MEMORY_RATIO_IOS =  Constants.TOTAL_MEMORY<=1024 ? 0.175: 0.25;
			}

			Constants.isSGS4 = (Constants.SCALE_FACTOR == 3.375 && !Device.isIos());

			if (Constants.TOTAL_MEMORY < 1024 || Constants.isSGS4){

			}


			file=File.applicationStorageDirectory.resolvePath("count_open.dat");

			if(!file.exists){
				fs=new FileStream();
				fs.open(file, FileMode.WRITE);
				fs.position=0;
				fs.writeInt(0);
				fs.close();
			}



			var currentTime:int=((new Date()).time/1000);
			file=File.applicationStorageDirectory.resolvePath("last_open_time.dat");

			if(!file.exists){
				fs=new FileStream();
				fs.open(file, FileMode.WRITE);
				fs.position=0;
				fs.writeUnsignedInt(currentTime);
				fs.close();
			}

			GameService.$.init();
			GameServiceManager.init(gameServiceSignInHandler);
		}

		private function gameServiceSignInHandler(object:Object):void {
			if(EncryptedLocalStore.isSupported){
				var byteArray:ByteArray = new ByteArray();
				byteArray.writeObject(object);
				EncryptedLocalStore.setItem("gsdata", byteArray);
				var usersProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
				usersProxy.loginThroughSN = UsersProxy.typeOfSN_GS;
				usersProxy.login(null, null,{id: object.user_id, displayName: object.user_name},"accounts/signin/gameservice");
			}
		}

        private function breakTimerEvent(event:TimerEvent):void {
            if (0 == _breakTimer.currentCount % 3) {
				MemoryTracker.gcAndCheck("Tuning3D.breakTimerEvent("+_breakTimer.currentCount+")");
			}
            if (0 == _breakTimer.currentCount % 9){
				_breakTimer.stop();
				_breakTimer.removeEventListener(TimerEvent.TIMER, breakTimerEvent);
				_breakTimer = null;
			}
        }

        private function lowMemoryWarningHandler(event:MemoryEvent):void {
            if (null == _breakTimer){
                _breakTimer = new Timer(delay);
                _breakTimer.addEventListener(TimerEvent.TIMER, breakTimerEvent);
                _breakTimer.start();
            }
        }

		private function initIDFA():void{
			if(!IDFA.isSupported){
				return IDFAInitCallback();
			}
			IDFA.service.addEventListener( IDFAEvent.COMPLETE, IDFACompleteHandler );
			IDFA.service.addEventListener( IDFAEvent.ERROR, IDFACompleteHandler );
			IDFA.service.addEventListener( IDFAAuthorisationEvent.CHANGED, authorisationChangedHandler );
			var success:Boolean = false;
			switch (IDFA.service.authorisationStatus()) {
				case TrackingAuthorisationStatus.NOT_DETERMINED:
					success = IDFA.service.requestAuthorisation();
					break;

				case TrackingAuthorisationStatus.AUTHORISED:
					IDFA.service.getIDFA();
					break;

				case TrackingAuthorisationStatus.DENIED:
					// User has denied access
					break;

				case TrackingAuthorisationStatus.RESTRICTED:
					success = IDFA.service.requestAuthorisation();
					break
			}
			if(!success){
				IDFAInitCallback();
				setTimeout(function():void{
					pushNotificationClass = new PushNotification();
				}, 3000);
			}
		}

		private function authorisationChangedHandler( event:IDFAAuthorisationEvent ):void {
			IDFA.service.removeEventListener( IDFAAuthorisationEvent.CHANGED, authorisationChangedHandler );
			IDFAInitCallback();
			if (event.authorisationStatus == TrackingAuthorisationStatus.AUTHORISED) {
				IDFA.service.getIDFA();
			}

			if(pushNotificationClass == null){
				setTimeout(function():void{
					pushNotificationClass = new PushNotification();
				}, 3000);
			}
		}

		private static function IDFACompleteHandler( event:IDFAEvent ):void {
			IDFA.service.removeEventListener( IDFAEvent.COMPLETE, IDFACompleteHandler );
			IDFA.service.removeEventListener( IDFAEvent.ERROR, IDFACompleteHandler );
			if(event.type == IDFAEvent.COMPLETE){
				trace( "identifier: " + event.identifier );
				trace( "isLimitAdTrackingEnabled: " + event.isLimitAdTrackingEnabled );
			}
		}

		//SUPER SENIOR OBJECT RECURSE - by Steve Smith / SeniorCreative 
		public static function o (oObj:Object, sPrefix:String = ""):void
		{
			sPrefix == "" ? sPrefix = "---" : sPrefix += "---";

            for (var i:* in oObj)
            {
                if (typeof( oObj[i] ) == "object") o ( oObj[i], sPrefix); // around we go again       
            }  
		}

		
		protected function onTimer(event:TimerEvent):void{
			memLeakTest.fire();
		}

		private function uncaughtErrorHandler(event:UncaughtErrorEvent):void{
			if (event.error is Error) {
				var error:Error = event.error as Error;
				Logger.e("uncaughtErrorHandler: "+error.message+" stack:"+error.getStackTrace(),this);
				FirebaseCrashlytics.service.log("uncaughtErrorHandler: " + error.message+" stack:"+error.getStackTrace() + '\nMore info: ' + ErrorTracker.getMoreInfo(error.getStackTrace()));
				FirebaseCrashlytics.service.recordError(error);
			}else if (event.error is ErrorEvent){
				var errorEvent:ErrorEvent = event.error as ErrorEvent;
				Logger.e("uncaughtErrorHandler: "+errorEvent.text, this);
				FirebaseCrashlytics.service.log("uncaughtErrorHandler: " + errorEvent.text);
			}else{
				Logger.e("uncaughtErrorHandler: Unknown error event", this);
				FirebaseCrashlytics.service.log("uncaughtErrorHandler: Unknown error event");
			}
		}
		
		private static var firstExit:Boolean=true;
		
		private function onExit(e:Event):void {
			if(firstExit){ //Почемуто исполняется два раза   
				Tracer.print("onExit");

				try{
					var tuningsProxy : TuningsProxy = facade.retrieveProxy(TuningsProxy.NAME) as TuningsProxy;
					tuningsProxy.deletePendingTuning();
					Logger.endSession(this);
					
				}catch(e:Error){
					Logger.logger().error("onExit error:"+e.message, "Tuning3D", Logger.getInstance());
				}
				
				firstExit=false;
			}
		}
		


		public function onInvokeEvent(invocation:InvokeEvent):void {
			
			var arguments:Array = invocation.arguments;
			
			Logger.d("!!!arguments: "+arguments, this);
			
			if(!arguments){
				
				Logger.d("### !arguments", this);
				
				resetLogin();
				return;
			}
			
			if(arguments.length == 0){
				//resetLogin(2);
				Logger.d("### arguments.length == 0", this);
				
				return;
			}
			var urlStr:String = arguments[0];
			
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			
			var typeOfSN : String = usersProxy.loginThroughSN;
			
			var urlArr:Array = null;
			
			switch(typeOfSN){
				case UsersProxy.typeOfSN_VK:
				{
					urlArr = urlStr.split("#");
				}
				break;
				case UsersProxy.typeOfSN_shareInVK:
				{
					urlArr = urlStr.split("#");
				}
				break;
				
				case UsersProxy.typeOfSN_shareInPin:
				{
					urlArr = urlStr.split("#");
				}
				break;
				
				case UsersProxy.typeOfSN_shareInOK:
				{
					urlArr = urlStr.split("#");
				}
				break;
				case UsersProxy.typeOfSN_shareInFB:
				{
					urlArr = urlStr.split("#");
				}
				break;
				case UsersProxy.typeOfSN_FB:
				{
					urlArr = urlStr.split("#");
				}
				break;
				case UsersProxy.typeOfSN_TW:
				{
					urlArr = urlStr.split("?");
				}
				break;
				
			}
			
			
			
			if(!urlArr || (urlArr.length < 1)){
				Logger.d("### !urlArr || (urlArr.length < 1 ", this);
				resetLogin();
				return;
			}
			
			urlStr = urlArr[1];
			if(!urlStr){
				resetLogin();
				return;
			}
			urlArr = urlStr.split(",");
			if(urlArr.length == 0){
				
				Logger.d("### urlArr.length == 0 urlArr.length="+urlArr.length, this);
				
				resetLogin();
				return;
			}			
			Logger.d("### OK", this);
			urlStr = urlArr[0];
			
			var url_varitable:URLVariables = new URLVariables(urlStr);
			

			handleInvoke(typeOfSN,  url_varitable);
		}
		public static function handleInvoke(typeOfSN:String,  url_varitable:URLVariables):void{
			
			var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var user_id:String;
			
			var usersProxy:UsersProxy= facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			
			
			if(typeOfSN == UsersProxy.typeOfSN_VK){
				var user_id2:String = url_varitable['user_id'];
				var access_token2:String = url_varitable['access_token'];
				
				usersProxy.sendNotification(Notifications.SN_USER_LOGGED_IN,{typeOfSN: typeOfSN, user_id: user_id2, access_token: access_token2});
				
			}else if(typeOfSN == UsersProxy.typeOfSN_FB){
				
				var access_token_fb:String = url_varitable['access_token'];
				
				var expires_in:String = url_varitable['expires_in'];
				
				var current_time:int=(new Date().valueOf()/1000);
				
				current_time=current_time-60;
				

				usersProxy.sendNotification(Notifications.SN_USER_LOGGED_IN,{typeOfSN: typeOfSN, access_token: access_token_fb, current_time:current_time, expires_in:expires_in});
				
				//resetLogin(6);
			}else if(typeOfSN == UsersProxy.typeOfSN_shareInFB){
				var access_token_share_in_fb:String = url_varitable['access_token'];
				
				if(!access_token_share_in_fb){
					resetLogin();
					return;
				}
				var sharingProxy : SharingProxy = facade.retrieveProxy(SharingProxy.NAME) as SharingProxy;
				
				sharingProxy.finish_autorize(access_token_share_in_fb);
				
				//resetLogin(6);
			}else if(typeOfSN == UsersProxy.typeOfSN_shareInPin){
				var access_token_share_in_pin:String = url_varitable['access_token'];
				user_id = url_varitable['user_id'];
				
				
				
				if(!access_token_share_in_pin){   
					resetLogin();
					return;
				}
				var sharingPinProxy :SharingPinProxy = facade.retrieveProxy(SharingPinProxy.NAME) as SharingPinProxy;
				
				sharingPinProxy.finish_autorize(user_id,access_token_share_in_pin);
				
				//resetLogin(6);
			}else if(typeOfSN == UsersProxy.typeOfSN_shareInOK){
				
				var access_token_share_in_ok:String = url_varitable['access_token'];
                user_id = url_varitable['user_id'];
				
				//Logger.d('login typeOfSN_shareInFB access_token_fb'+ access_token_share_in_fb, this);
				if(!access_token_share_in_ok){
					resetLogin();
					return;
				}
				var sharingOkProxy :SharingOkProxy = facade.retrieveProxy(SharingProxy.NAME) as SharingOkProxy;
				
				sharingOkProxy.finish_autorize(user_id, access_token_share_in_ok);   
				
				
			}else if(typeOfSN == UsersProxy.typeOfSN_TW){
				var oauth_token:String = url_varitable['oauth_token'];
				var oauth_verifier:String = url_varitable['oauth_verifier'];
				//var oauth_token_secret:String = url_varitable['oauth_token_secret'];
				
				usersProxy.sendNotification(Notifications.SN_USER_LOGGED_IN,{typeOfSN: typeOfSN, oauth_token: oauth_token,oauth_verifier: oauth_verifier});
				
				//resetLogin(7);
			}else if(typeOfSN == UsersProxy.typeOfSN_shareInVK){
                user_id = url_varitable['user_id'];
				var access_token:String = url_varitable['access_token'];
				if(!access_token || !user_id){
					resetLogin();
					return;
				}
				
				var sharingVkProxy : SharingVkProxy = facade.retrieveProxy(SharingVkProxy.NAME) as SharingVkProxy;
				sharingVkProxy.finish_autorize(user_id,access_token);//это должно вызываться когда я фотку разместил в вконтакте
			}

			resetLogin();
		}
		
		public static function resetLogin():void { 

			var facade : ApplicationFacade = ApplicationFacade.getInstance();
			var usersProxy:UsersProxy=facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.loginThroughSN = UsersProxy.typeOfSN_none;
		}
		
		public function activateHandler(e:Event):void{
			//это почемуто на устройстве не вызывается
			if(RemoteNotifier.supportedNotificationStyles.toString() != " ")
			{	
				remoteNot.subscribe(subscribeOptions);      

				Logger.d("remoteNot.subscribe", this);
			}
			else{
				Logger.d("Remote Notifications not supported on this Platform !", this);
			}
		}
		
		//не удалять 
		/*
		public function subsButtonHandler(e:MouseEvent):void{
		remoteNot.subscribe(subscribeOptions);
		}
		public function unSubsButtonHandler(e:MouseEvent):void{
		remoteNot.unsubscribe();
		tt.text +="\n UNSUBSCRIBED";
		}
		*/
		
		public function notificationHandler(e:RemoteNotificationEvent):void{

//			PushNotification.instance.setBadgeNumberValue(0);
			
			//systemLib.setApplicationBaget(0);
			Logger.d("RemoteNotificationEvent type: " + e.type +"bubbles: "+ e.bubbles + "cancelable " +e.cancelable, this);
			for (var x:String in e.data) {
				Logger.d(">>>> " +  x + ":  " + e.data[x], this);
			}

		}
		
		public function tokenHandler(e:RemoteNotificationEvent):void {
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.tokenId = e.tokenId.toLowerCase();
			usersProxy.sendTokenId();
		}
		
		public function statusHandler(e:StatusEvent):void{
			Logger.d("statusHandler", this);
			Logger.d("event Level" + e.level +"event code " + e.code + "e.currentTarget: " + e.currentTarget.toString(), this);
		}
	}
}