package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.challenges.ChallengesListScreen;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;

    import org.puremvc.as3.interfaces.INotification;

    public class DisplayChallengeScreenCommand extends DisplayScreenCommand {
        override public function execute(note:INotification):void {
            executeHandler = function ():void {
                var preloaderOpenHandler:Function = function():void{
                    var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                    assetsProxy.loadChallengeListAssets(function():void{
                        var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                        var challengesScreen :ChallengesListScreen = new ChallengesListScreen();
                        challengesScreen.onComplete = function():void{
                            if(blocker){
                                blocker.hide();
                            }
                        }
                        blocker.onHidingComplete = function():void{
                            challengesScreen.transitionComplete();
                        }
                        windowMediator.pushScreen(challengesScreen, true, true);
                    });
                }
                BannerStackedScreen.hideAdBanner(true);
                var isBlackScreen:Boolean = (note.getBody() && note.getBody()["tabMenu"]);
                var blocker : BlockerView;
                if(isBlackScreen){
                    blocker = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);
                }else{
                    blocker = BlockerView.show(BlockerView.LOGO_SCREEN, preloaderOpenHandler);
                }
            };
            super.execute(note);
        }
    }
}
