package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.challenges.ChallengesTuningsListScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesUserTuningsScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesVotingScreen;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;

    public class DisplayChallengesVotingScreenCommand extends  DisplayScreenCommand{
    public function DisplayChallengesVotingScreenCommand() {
    }

    override public function execute(note:INotification):void {
        executeHandler = function ():void {
            var preloaderOpenHandler:Function = function():void{
                var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
                assetsProxy.loadChallengeListAssets(function ():void {
                    var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                    var challengesVotingScreen:ChallengesVotingScreen = new ChallengesVotingScreen();
                    challengesVotingScreen.onComplete = function():void{
                        if(blocker){
                            blocker.hide(0.25);
                        }
                    }
                    blocker.onHidingComplete = function():void{
                        challengesVotingScreen.transitionComplete();
                    }
                    Starling.juggler.delayCall(function ():void {
                        windowMediator.pushScreen(challengesVotingScreen);
                    },.1);
                });
            }
            BannerStackedScreen.hideAdBanner(true);
            var isBlackScreen:Boolean = (note.getBody() && note.getBody()["tabMenu"]);
            var blocker : BlockerView;
            if(isBlackScreen){
                blocker = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);
            }else{
                blocker = BlockerView.show(BlockerView.LOGO_SCREEN, preloaderOpenHandler);
            }
        };
        super.execute(note);
    }
}
}
