package com.despark.tuning3d.controller
{
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.view.WindowMediator;
	import com.despark.tuning3d.view.components.core.BannerStackedScreen;
	import com.despark.tuning3d.view.components.core.BlockerView;
import com.despark.tuning3d.view.components.friends.FriendsListPopUp;

import org.puremvc.as3.interfaces.INotification;
import org.puremvc.as3.patterns.command.SimpleCommand;

public class DisplayFriendsListScreenCommand extends SimpleCommand
	{
		override public function execute(note:INotification) : void
		{
			var preloaderOpenHandler:Function = function():void{
				var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
				assetsProxy.loadFriendsAssets(function () : void  {
					var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
					var screenPopUp : FriendsListPopUp = new FriendsListPopUp(note.getBody());
					windowMediator.animate = false;
					windowMediator.addPopUp(screenPopUp);
					screenPopUp.onComplete = function():void{
						if(blocker){
							blocker.hide();
							blocker.onHidingComplete = function():void{
								if(screenPopUp && screenPopUp.parent){
									screenPopUp.parent.setChildIndex(screenPopUp, screenPopUp.parent.numChildren - 1);
									screenPopUp.transitionComplete();
								}
							}
						}
					}
					blocker.parent.swapChildren(blocker, screenPopUp);
				});
			}
			BannerStackedScreen.hideAdBanner(true);
			var blocker : BlockerView = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);

		}
	}
}