/**
 * Created by Render-2 on 8/8/2017.
 */
package com.despark.tuning3d.controller {
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.WindowMediator;
import com.despark.tuning3d.view.components.challenges.modals.ChallengeNotificationTuningScreen;
import com.despark.tuning3d.view.components.core.BlockerView;
import com.despark.tuning3d.view.components.gallery.GalleryTuningPopup;

import org.puremvc.as3.interfaces.INotification;

public class DisplayGalleryTuningPopupCommand extends  DisplayScreenCommand{
    public function DisplayGalleryTuningPopupCommand() {
    }

    public override function execute(note : INotification) : void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(usersProxy.currentUser && Constants.selectedUser && usersProxy.currentUser.id == Constants.selectedUser.id) {
            Constants.selectedUser = null;
        }
        var blocker : BlockerView = BlockerView.show();
        var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
        var complete:Function = function ():void {
            if(blocker){
                blocker.hide();
            }
            if(note.getBody() && note.getBody().tuning && note.getBody().user) {
                var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var tuningPopup:GalleryTuningPopup = new GalleryTuningPopup(note.getBody());
                tuningPopup.eventDispatcher = note.getBody().eventDispatcher;
                if(note.getBody().hasOwnProperty('animate') && !note.getBody().animate){
                    windowMediator.animate = false;
                }
                if (note.getBody().closeHandler) {
                    tuningPopup.closeHandler = note.getBody().closeHandler;
                }
                windowMediator.addPopUp(tuningPopup);
                tuningPopup.selectTuning(note.getBody().tuning, note.getBody().user);
            }
        };
        assetsProxy.loadLeaderBoardTuning(complete);
    }
}
}
