package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.mailbox.MailBoxPopup;
    import com.despark.tuning3d.view.components.news.NewsPopUp;

    import org.puremvc.as3.interfaces.INotification;
    import org.puremvc.as3.patterns.command.SimpleCommand;

    public class DisplayNewsPopupCommand extends SimpleCommand{
        public override function execute(note : INotification) : void {
            var blocker : BlockerView = BlockerView.show();
            var complete:Function = function ():void {
                blocker.hide();
                var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var screenPopUp : NewsPopUp = new NewsPopUp(note.getBody(), note.getBody().homeScreenPopUp);
                windowMediator.addPopUp(screenPopUp);
            };
            var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
            assetsProxy.loadNewsAssets(complete);
        }
    }
}
