package com.despark.tuning3d.controller {
    import com.despark.tuning3d.model.assets.AssetsProxy;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.WindowMediator;
    import com.despark.tuning3d.view.components.challenges.ChallengesTuningsListScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesUserTuningsScreen;
    import com.despark.tuning3d.view.components.challenges.ChallengesVotingScreen;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.levels.UserLevelInfoPopup;

    import org.puremvc.as3.interfaces.INotification;

    import starling.core.Starling;

    public class DisplayUserLevelInfoPopupCommand extends  DisplayScreenCommand{
    public function DisplayUserLevelInfoPopupCommand() {
    }

    override public function execute(notification:INotification):void {
        executeHandler = function ():void {
            var blocker:BlockerView = BlockerView.show();
            var assetsProxy:AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
            assetsProxy.loadLevelInfoAssets(function ():void {
                blocker.hide();
                var usersProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
                var windowMediator:WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
                var userLevelInfoPopup:UserLevelInfoPopup = new UserLevelInfoPopup(usersProxy.currentUser);
                windowMediator.addPopUp(userLevelInfoPopup, null, false, userLevelInfoPopup.transitionCompleteHandler);
            });
        };
        super.execute(notification);
    }
}
}
