package com.despark.tuning3d.controller
{
	import com.despark.tuning3d.model.assets.AssetsProxy;
	import com.despark.tuning3d.view.WindowMediator;
	import com.despark.tuning3d.view.components.core.BannerStackedScreen;
	import com.despark.tuning3d.view.components.core.BlockerView;
	import com.despark.tuning3d.view.components.votes.VotesListScreen;

	import org.puremvc.as3.interfaces.INotification;

	public class DisplayVotesListScreenCommand extends DisplayScreenCommand {
		override public function execute(note : INotification) : void {
			executeHandler=function ():void {
				var preloaderOpenHandler:Function = function():void{
					var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
					assetsProxy.loadVotesListAssets(function():void{
						var windowMediator : WindowMediator = facade.retrieveMediator(WindowMediator.NAME) as WindowMediator;
						var votesScreen :VotesListScreen = new VotesListScreen();
						votesScreen.onComplete = function():void{
							if(blocker){
								blocker.hide();
							}
						}
						blocker.onHidingComplete = function():void{
							votesScreen.transitionComplete();
						}
						windowMediator.pushScreen(votesScreen);
					});
				}
				BannerStackedScreen.hideAdBanner(true);
				var blocker : BlockerView = BlockerView.show(BlockerView.BLACK_SCREEN, preloaderOpenHandler);
            };
            super.execute(note);
		}
	}
}