package com.despark.tuning3d.model.assets
{
import by.blooddy.crypto.serialization.JSONer;

import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.core.Tracer;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.despark.tuning3d.model.core.http.caching.HttpCachePolicy;
import com.despark.tuning3d.view.core.HomeScreenPopUp;
    import com.utils.Console;
    import com.utils.DevHelper;
    import com.utils.ObjectUtils;

    import flash.filesystem.File;
import flash.net.URLRequestMethod;

import org.puremvc.as3.patterns.proxy.Proxy;

import starling.utils.AssetManager;
import starling.utils.StringUtil;

public class AssetsProxy extends Proxy {
		public static const NAME : String = "AssetsProxy";

        public var httpClient : HttpClient;

		private var _assetManager : AssetManager;
		private var _delayedCompleteHandlers : Object;
		private var _scale : Number;
		private var _imageScaleFactor : Number;
		public function AssetsProxy() {
			super(NAME);
		}
		
		public function set scale(value : Number) : void {
			_scale = value;
			if(!assetManager) {
				_assetManager = new AssetManager(scale);   
			}
		}
		
		public function get scale() : Number
		{
			return _scale;
		}
		
		public function removeTexture(name:String, dispose:Boolean = true):void{
            if(_assetManager.getTexture(name)){
                _assetManager.removeTexture(name, dispose);
            }
		}

		public function loadOneTexture(name:String, completeHandler:Function = null):void {
			if(_assetManager.getTexture(name)){
				if(completeHandler) {
					completeHandler(_assetManager.getTexture(name));
				}
				return 
			}
			
			_assetManager.enqueue(texturePath(name+".png"));//home && tuning
			_assetManager.loadQueue(function(ratio : Number) : void {
				if(ratio == 1) {
					if(completeHandler) {
						completeHandler(_assetManager.getTexture(name));
					}		
				}
			});
		}

        public function loadStartChallengePopupAssets(completeHandler:Function = null):void{
            enqueueTexture("accept_btn_bg", ".png", challengesPath, false);
            enqueueTexture("decline_btn_bg", ".png", challengesPath, false);
            enqueueTexture("active_label_bg", ".png", challengesPath, false);
            enqueueTexture("invitation_label_bg", ".png", challengesPath, false);
            enqueueTexture("arrow_down", ".png", challengesPath, false);
            enqueueTexture("challenges_start_accept_bg", ".png", challengesPath, false);
            enqueueTexture("garage_close", ".png", feed_friend_path, false);

            enqueueTexture("start_challenge_radio_selected", ".png", challengesPath, false);
            enqueueTexture("start_challenge_radio_default", ".png", challengesPath, false);

            enqueueTexture("back_button_clean", ".png", texturePath, true);
            enqueueTexture("details_close", ".png", texturePath, false);
            enqueueTexture("vs_large", ".png", challengesPath, false);


            enqueueTexture("challenge_random_user", ".png", challengesPath, false);
            enqueueTexture("challenge_tuning_default", ".png", challengesPath, false);
            enqueueTexture("challenge_users_default", ".png", challengesPath, false);
            enqueueTexture("rewarded_votes_img", ".png", challengesPath, false);
            enqueueTexture("challenges_accept_logo", ".png", challengesPath, false);
            enqueueTexture("challenge_rules", ".png", challengesPath, false);

            enqueueTexture("challenge_random_default", ".png", challengesPath, false);
            enqueueTexture("challenge_random_select", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_background", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_limit_Icon", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_rewards_Icon", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_default_Icon", ".png", challengesPath, false);

            enqueueTexture("timeline_my_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_car" ,".png", feed_friend_path, false);

            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("src", ".png", texturePath, true);

            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadVotesListAssets(completeHandler:Function = null):void{
            enqueueTexture("header_bg", ".jpg", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("emptyButton", ".png", texturePath, true);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("src", ".png", texturePath, true);

            enqueueTexture("gallery_alphabet", ".png", galleryPath, false);
            enqueueTexture("drop_down_arrow_2", ".png", galleryPath, false);
            enqueueTexture("gallery_like", ".png", galleryPath, false);

            enqueueTexture("likeButtonBg", ".png", texturePath, true);
            enqueueTexture("likeBg", ".png", texturePath, true);
            enqueueTexture("youLikeBg", ".png", texturePath, true);
            enqueueTexture("like", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadBrandScreenAssets(load:Boolean = true, completeHandler:Function = null):void{
            enqueueTexture("btn_buy_coin", ".png", texturePath, false);
            enqueueTexture("a_disk_set_select", ".png", texturePath, false);
            enqueueTexture("popUpContentBackground", ".png", texturePath, true);
            //
            enqueueTexture("tuning_start_btn", ".png", texturePath, false);
            enqueueTexture("tuning_filter_btn", ".png", texturePath, false);
            enqueueTexture("tuning_post_btn", ".png", texturePath, false);

            enqueueTexture("timeline_world_icon" ,".png", feed_friend_path, false);

            enqueueTexture("a_circle_button_bg", ".png", texturePath, false);
            enqueueTexture("a_close_icon", ".png", texturePath, false);
            enqueueTexture("a_filter_icon", ".png", texturePath, false);
            enqueueTexture("a_search_icon", ".png", texturePath, false);
            enqueueTexture("last_added_icon", ".png", texturePath, false);

            enqueueTexture("drop_down_menu", ".png", texturePath, true);
            enqueueTexture("btn_buy_now", ".png", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("rewards_icon", ".png", texturePath, true);

            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("drop_down_menu", ".png", texturePath, true);

            enqueueTexture("slide_arr_lt", ".png", texturePath, true);
            enqueueTexture("rewards_ads_icon", ".png", texturePath, true);

            enqueueTexture("featured", ".png", texturePath, true);
            enqueueTexture("featured_title", ".png", texturePath, true);
            enqueueTexture("featured_price_check", ".png", texturePath, true);
            enqueueTexture("featured_360", ".png", texturePath, true);
            enqueueTexture("up_display", ".png", texturePath, true);

            enqueueTexture("green_car_icon", ".png", texturePath, true);
            enqueueTexture("one_coin_img", ".png", texturePath, false);
            enqueueTexture("buy_3dt_coin", ".png", texturePath, false);

            enqueueTexture("car_lock_big_icon", ".png", texturePath, true);
            enqueueTexture("buy_check_icon", ".png", texturePath, true);
            enqueueTexture("offsetIcon", ".png", texturePath, true);
            enqueueTexture("stance", ".png", texturePath, true);
            enqueueTexture("ulstrarealistic", ".png", texturePath, true);
            enqueueTexture("hd-resolution", ".png", texturePath, true);
            enqueueTexture("top-vew-camera", ".png", texturePath, true);

            enqueueTexture("care_btn", ".png", texturePath, true);
            enqueueTexture("truck_icon", ".png", texturePath, true);
            enqueueTexture("muscle_icon", ".png", texturePath, true);
            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("controlBackground", ".png", texturePath, true);
            enqueueTexture("ebay-close", ".png", texturePath, false);
            enqueueTexture("ebay-full", ".png", texturePath, false);
            enqueueTexture("ebay-full-min", ".png", texturePath, false);
            enqueueTexture("ebay-navi", ".png", texturePath, false);
            enqueueTexture("No-Info-Image-for-Buy", ".png", texturePath, true);

            enqueueTexture("timeline_filter_default", ".png", feed_friend_path, false);
            enqueueTexture("timeline_filter_selected", ".png", feed_friend_path, false);

            enqueueTexture("car_chooser", ".jpg", backgroundsPath, false);
            enqueueTexture("challenge_rewards_icon", ".png", challengesPath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1 && completeHandler != null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                    }
                });
            }
        }

        public function loadFlagTexture(flagId:String, load:Boolean = false, completeHandler:Function = null):void{
            enqueueTexture(flagId.toLowerCase(), ".png", flagPath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1 && completeHandler != null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                    }
                });
            }
        }

        public function loadLeaderBoardTuning(completeHandler:Function = null):void{
            enqueueTexture("sendIcon", ".png", feed_friend_path, false);
            enqueueTexture("garage_comment_1", ".png", feed_friend_path, false);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("a_seporator_1", ".png", texturePath, false);
            enqueueTexture("pageIndicatorSelected", ".png", texturePath, true);
            enqueueTexture("a_effect_bg", ".png", texturePath, true);
            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            loadGarageSocialAssets(true, completeHandler);
        }

        public function loadMailBoxAssets(completeHandler:Function = null):void{
            enqueueTexture("garage_close", ".png", feed_friend_path, false);
            enqueueTexture("a_back_icon", ".png", texturePath, false);
            enqueueTexture("button2", ".png", texturePath, true);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("sendIcon", ".png", feed_friend_path, false);
            enqueueTexture("timeline_photo" ,".png", feed_friend_path, false);
            enqueueTexture("postRectangle" ,".png", feed_friend_path, false);
            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("details_close",".png", texturePath, false);
            enqueueTexture("garage_icon",".png", texturePath, true);

            enqueueTexture("garage_add_friend" ,".png", feed_friend_path, false);
            enqueueTexture("garage_already_friend" ,".png", feed_friend_path, false);
            enqueueTexture("garage_pending_friend" ,".png", feed_friend_path, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("a_back_button", ".png", texturePath, false);

            loadChallengeListAssets(completeHandler);
        }

        public function loadChallengeTuningsListAssets(completeHandler:Function = null, loadRequest:Boolean = true):void{
            enqueueTexture("challenge_tuning_rating_bg", ".png", challengesPath, false);
            if(loadRequest){
                _assetManager.loadQueue(function(ratio : Number) : void{
                    if (ratio == 1 && completeHandler!=null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                    }
                });
            }
        }

        public function loadInAppNotificationsPopupAssets(completeHandler:Function = null, loadRequest:Boolean = true):void{
            enqueueTexture("model_close", ".png", texturePath, true);
            enqueueTexture("dateIcon", ".png", feed_friend_path, false);

            enqueueTexture("challenge_accepted_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_lost_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_rejected_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_request_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_won_icon", ".png", challengesPath, false);
            enqueueTexture("vs_small", ".png", challengesPath, false);
            enqueueTexture("accept_btn_bg", ".png", challengesPath, false);
            enqueueTexture("decline_btn_bg", ".png", challengesPath, false);
            enqueueTexture("challenge_user_rating_bg", ".png", challengesPath, false);
            enqueueTexture("challenge_tuning_rating_bg", ".png", challengesPath, false);
            enqueueTexture("weekly-awards-img", ".png", rewardsPath, false);

            if(loadRequest){
                _assetManager.loadQueue(function(ratio : Number) : void{
                    if (ratio == 1 && completeHandler!=null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                    }
                });
            }
        }

        public function loadChallengeTuningViewPopupAssets(completeHandler:Function = null):void{
            loadChallengeUI();

            enqueueTexture("garage_close", ".png", feed_friend_path, false);
            enqueueTexture("challenge_like_blue", ".png", challengesPath, false);
            enqueueTexture("challenge_like_red", ".png", challengesPath, false);
            enqueueTexture("vs_large", ".png", challengesPath, false);
            enqueueTexture("challenge_clock_background", ".png", challengesPath, false);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("a_arrow_right_button", ".png", texturePath, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);

            enqueueTexture("slide_arr_lt", ".png", texturePath, true);
            enqueueTexture("pageIndicator", ".png", texturePath, true);
            enqueueTexture("pageIndicatorSelected", ".png", texturePath, true);
            enqueueTexture("spinner", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    completeHandler.call();
                }
            });
        }

        public function loadChallengeLeaderBoardPopupAssets(completeHandler:Function = null):void{
            enqueueTexture("timeline_world_icon" ,".png", feed_friend_path, false);
            enqueueTexture("spinner", ".png", texturePath, true);

            enqueueTexture("leaderboard_arrows_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_car_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_crown_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_cup_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_flag_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_top_bg", ".png", challengesPath, false);
            enqueueTexture("leaderboard_bg", ".png", challengesPath, false);

            enqueueTexture("gallery_clock", ".png", galleryPath, false);
            enqueueTexture("menu_background", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_default", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_selected", ".png", galleryPath, false);
            enqueueTexture("drop_down_arrow", ".png", galleryPath, false);


            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadCustomColorAssets(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("popUpTitleBackground", ".png", texturePath, true);
            enqueueTexture("colorBrightness", ".png", texturePath, true);
            enqueueTexture("colorHandle", ".png", texturePath, true);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadTuningScreenAssets(completeHandler:Function = null):void{
            enqueueTexture("simple_shadow", ".png", texturePath, false);
            enqueueTexture("a_circle_button_bg", ".png", texturePath, false);
            enqueueTexture("info-bar", ".png", texturePath, true);
            enqueueTexture("ebay_info_icon", ".png", texturePath, false);
            enqueueTexture("spec-def", ".png", texturePath, false);
            enqueueTexture("official-def", ".png", texturePath, false);
            enqueueTexture("deal-loc", ".png", texturePath, false);
            enqueueTexture("shop-def", ".png", texturePath, false);
            enqueueTexture("No-Info-Image-for-Buy", ".png", texturePath, true);

            enqueueTexture("ebay-close", ".png", texturePath, false);
            enqueueTexture("ebay-full", ".png", texturePath, false);
            enqueueTexture("ebay-full-min", ".png", texturePath, false);
            enqueueTexture("ebay-navi", ".png", texturePath, false);

            enqueueTexture("a_disk_set_default", ".png", texturePath, false);
            enqueueTexture("a_disk_set_select", ".png", texturePath, false);
            enqueueTexture("color_picker_border", ".png", texturePath, false);
            enqueueTexture("engine_sound_rev_start", ".png", texturePath, false);
            enqueueTexture("engine_sound_rev_stop", ".png", texturePath, false);

            enqueueTexture("a_camera_screenshot", ".png", texturePath, false);
            enqueueTexture("a_screenshot_ar_con", ".png", texturePath, false);
            enqueueTexture("a_video_save_icon", ".png", texturePath, false);
            enqueueTexture("video_icon", ".png", texturePath, false);
            enqueueTexture("video_icon_1", ".png", texturePath, false);
            enqueueTexture("video_icon_2", ".png", texturePath, false);

            enqueueTexture("a_car_fast_mode", ".png", texturePath, false);
            enqueueTexture("a_car_fast_mode_selected", ".png", texturePath, false);
            enqueueTexture("a_fast_mode_help", ".png", texturePath, false);

            enqueueTexture("c_selector_right", ".png", texturePath, false);

            enqueueTexture("a_car_settings_button", ".png", texturePath, false);
            enqueueTexture("slider_minus", ".png", texturePath, false);
            enqueueTexture("slider_plus", ".png", texturePath, false);

            enqueueTexture("a_drag_default_button", ".png", texturePath, false);
            enqueueTexture("a_drag_selected_button", ".png", texturePath, false);

            enqueueTexture("turn5_americantrucks_selected", ".png", turn5_path, false);
            enqueueTexture("turn5_americantrucks", ".png", turn5_path, false);
            enqueueTexture("turn5_extrime_selected", ".png", turn5_path, false);
            enqueueTexture("turn5_extrime", ".png", turn5_path, false);
            enqueueTexture("custom_shop_icon", ".png", turn5_path, false);
            enqueueTexture("custom_shop_icon_selected", ".png", turn5_path, false);

            enqueueTexture("stepper_left", ".png", stepper_path, false);
            enqueueTexture("stepper_right", ".png", stepper_path, false);
            enqueueTexture("stepper_minus", ".png", stepper_path, false);
            enqueueTexture("stepper_plus", ".png", stepper_path, false);
            enqueueTexture("stepper_border", ".png", stepper_path, false);

            enqueueTexture("save_lock_big_icon", ".png", texturePath, true);
            enqueueTexture("material_select", ".png", texturePath, false);

            enqueueTexture("a_open_menu", ".png", texturePath, false);
            enqueueTexture("a_close_menu", ".png", texturePath, false);

            enqueueTexture("button2", ".png", texturePath, true);
            enqueueTexture("a_selected_bg_icon", ".png", texturePath, false);

            enqueueTexture("a_seporator_1",".png", texturePath, false);
            enqueueTexture("a_show_all_disks",".png", texturePath, false);
            enqueueTexture("a_part_info_icon",".png", texturePath, false);
            enqueueTexture("a_color_rect",".png", texturePath, false);
            enqueueTexture("a_custom_color_button",".png", texturePath, false);

            enqueueTexture("new_icon",".png", texturePath, false);
            enqueueTexture("new_and_profile_icon",".png", texturePath, false);
            enqueueTexture("profile_icon",".png", texturePath, false);

            enqueueTexture("a_save_button",".png", texturePath, false);
            enqueueTexture("a_photo_accept_button",".png", texturePath, false);
            enqueueTexture("a_photo_cancel_button",".png", texturePath, false);
            enqueueTexture("engine_inactive",".png", texturePath, false);
            enqueueTexture("gas",".png", texturePath, false);
            enqueueTexture("a_paint_button",".png", texturePath, false);
            enqueueTexture("a_partslot_button",".png", texturePath, false);
            enqueueTexture("a_part_color",".png", texturePath, false);
            enqueueTexture("a_background_button",".png", texturePath, false);
            enqueueTexture("a_front_light_effect",".png", texturePath, true);
            enqueueTexture("a_new_suspension_handler",".png", texturePath, false);
            enqueueTexture("a_effect_bg", ".png", texturePath, true);
            enqueueTexture("a_disk_neon_effect", ".png", texturePath, false);
            enqueueTexture("a_color_bg_button", ".png", texturePath, false);
            enqueueTexture("a_upload_bg_button", ".png", texturePath, false);

            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);

            enqueueTexture("a_back_icon", ".png", texturePath, false);
            enqueueTexture("a_arrow_right_button", ".png", texturePath, false);
            enqueueTexture("engine_active", ".png", texturePath, false);
            enqueueTexture("a_neon_effect", ".png", texturePath, true);

            enqueueTexture("a_fb_icon2", ".png", texturePath, false);
            enqueueTexture("a_instagram_icon2", ".png", texturePath, false);

            enqueueTexture("a_disk_settings_icon", ".png", texturePath, false);
            enqueueTexture("a_plus_icon", ".png", texturePath, false);
            enqueueTexture("a_disk_radius_icon", ".png", texturePath, false);
            enqueueTexture("a_minus_icon", ".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);

            enqueueTexture("a_bottom_right_menu", ".png", texturePath, false);
            enqueueTexture("a_top_right_menu", ".png", texturePath, false);
            enqueueTexture("wheel_settings", ".png", texturePath, false);
            enqueueTexture("a_part_select_left", ".png", texturePath, false);

            enqueueTexture("challenge_submitted_popup_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_requirement_popup_icon", ".png", challengesPath, false);

            enqueueTexture("req_wide_body", ".png", challengesPath, false);
            enqueueTexture("req_stance", ".png", challengesPath, false);
            enqueueTexture("req_background", ".png", challengesPath, false);
            enqueueTexture("req_camber", ".png", challengesPath, false);
            enqueueTexture("req_offset", ".png", challengesPath, false);
            enqueueTexture("req_decals", ".png", challengesPath, false);
            enqueueTexture("req_racing_strip", ".png", challengesPath, false);
            enqueueTexture("req_two_tone_vinyl", ".png", challengesPath, false);


            enqueueTexture("close_btn_texture", ".png", challengesPath, false);
            enqueueTexture("component_level_bg", ".png", challengesPath, false);
            enqueueTexture("material_lock_icon", ".png", challengesPath, false);

            enqueueTexture("border_line", ".png", texturePath, false);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadComponentIcon(textureId:String, completeHandler:Function, errorHandler:Function = null):void{
            if(_assetManager.isEnqueued(textureId)){
                _delayedCompleteHandlers ||= {};
                _delayedCompleteHandlers[textureId] ||= [];
                _delayedCompleteHandlers[textureId].push(completeHandler);
            }else{
                if(enqueueTexture(textureId, ".png", componentIconPath, false)){
                    _assetManager.loadQueue(function(progress : Number) : void{
                        if (progress == 1 && completeHandler!=null) {
                            if (completeHandler) {
                                completeHandler.call();
                            }
                            if(_delayedCompleteHandlers && _delayedCompleteHandlers[textureId]){
                                for(var i:int = 0; i < _delayedCompleteHandlers[textureId].length; i++){
                                    _delayedCompleteHandlers[textureId][i].call();
                                }
                                delete _delayedCompleteHandlers[textureId];
                            }
                        }
                    });
                }else if(errorHandler !== null){
                    errorHandler();
                }
            }
        }

    public function loadMaterialIcon(textureId:String, completeHandler:Function):void{
            enqueueTexture(textureId, ".png", materialIconPath, false);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadChallengeUI(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("home_screen_page_indicator_def", ".png", texturePath, false);
            enqueueTexture("request_challenge_btn", ".png", challengesPath, false);
            enqueueTexture("challenge-countdown-challenge", ".png", challengesPath, false);
            enqueueTexture("vs_big", ".png", challengesPath, false);
            enqueueTexture("challenge-like-1", ".png", challengesPath, false);
            enqueueTexture("win", ".png", challengesPath, false);
            enqueueTexture("back_to_top", ".png", challengesPath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadMailScreenTextures(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadSaveTuningAssets(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("a_blue_bg_button", ".png", texturePath, false);
            enqueueTexture("a_transparent_bg_button", ".png", texturePath, false);
            enqueueTexture("a_text_input_bg", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadSharingPopupAssets(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("a_blue_bg_button", ".png", texturePath, false);
            enqueueTexture("a_transparent_bg_button", ".png", texturePath, false);
            enqueueTexture("a_text_input_bg", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }
		
		public function loadHomeScreenAssets(completeHandler:Function = null, load:Boolean = true) : void {
            enqueueTexture("home_screen_page_indicator_sel", ".png", texturePath, false);
            enqueueTexture("home_screen_main_menu", ".png", texturePath, false);
            enqueueTexture("avatar_background", ".png", texturePath, false);
            enqueueTexture("avatar_border", ".png", texturePath, false);
            enqueueTexture("button", ".png", texturePath, true);
            enqueueTexture("button_gradient", ".png", texturePath, true);
            enqueueTexture("popUpBackground", ".png", texturePath, true);
            enqueueTexture("emptyButton", ".png", texturePath, true);
            enqueueTexture("rewards_icon", ".png", texturePath, true);
            // ********** top button textures ***************
            enqueueTexture("notification", ".png", texturePath, true);
            enqueueTexture("news_btn", ".png", texturePath, true);
            enqueueTexture("login", ".png", texturePath, true);
            enqueueTexture("profile", ".png", texturePath, true);
            enqueueTexture("users-solid", ".png", texturePath, true);
            enqueueTexture("globe", ".png", texturePath, true);
            enqueueTexture("home_btn", ".png", texturePath, true);
            enqueueTexture("circle_button_bg", ".png", texturePath, true);
            enqueueTexture("logout", ".png", texturePath, true);
            // ********** Main menu texture *****************
            enqueueTexture("messages_btn", ".png", texturePath, true);
            enqueueTexture("clock-menu", ".png", texturePath, true);
            enqueueTexture("challenges_btn", ".png", texturePath, true);
            enqueueTexture("garage_icon", ".png", texturePath, true);
            enqueueTexture("gallery_icon", ".png", texturePath, true);
            enqueueTexture("buy_car_icon", ".png", texturePath, true);
            enqueueTexture("shed_btn", ".png", texturePath, true);
            //
            enqueueTexture("firstScreenBg", ".jpg", texturePath, true);
            enqueueTexture("challenge", ".jpg", texturePath, true);
            enqueueTexture("configurator", ".jpg", texturePath, true);
            //
            enqueueTexture("home_screen_page_indicator_def", ".png", texturePath, false);
            enqueueTexture("request_challenge_btn", ".png", challengesPath, false);
            enqueueTexture("challenge-countdown-challenge", ".png", challengesPath, false);
            enqueueTexture("spinner", ".png", texturePath, true);
            enqueueTexture("car_unlock_big_icon", ".png", texturePath, true);

            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("sound_on_icon", ".png", texturePath, false);
            enqueueTexture("sound_off_icon", ".png", texturePath, false);
            //
            enqueueTexture("challenge_rewards_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_keys_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_stars_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_rewards_btn_icon", ".png", challengesPath, false);
            enqueueTexture("rewards_watch_btn_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_rewards_popup_icon", ".png", challengesPath, false);

            enqueueTexture("popUpContentBackground", ".png", texturePath, true);
            enqueueTexture("button_border", ".png", texturePath, true);

            enqueueTexture("details_close",".png", texturePath, false);
            enqueueTexture("a_bg_red_button", ".png", texturePath, false);
            enqueueTexture("timeline_feed_border", ".png", feed_friend_path, false);

            enqueueTexture("challenges_leaderboard_icon", ".png", challengesPath, false);
            enqueueTexture("challenges_likes_icon", ".png", challengesPath, false);
            enqueueTexture("challenges_users_icon", ".png", challengesPath, false);

            enqueueTexture("challenge_submitted_popup_icon", ".png", challengesPath, false);
            //
            enqueueTexture("lights_effect", ".jpg", rewardsPath, false);
            enqueueTexture("lights_effect_2", ".jpg", rewardsPath, false);
            enqueueTexture("lights_effect_2_lines", ".jpg", rewardsPath, false);
            enqueueTexture("anim_button_texture", ".png", rewardsPath, false);
            enqueueTexture("collect_gift_icon", ".png", rewardsPath, false);
            enqueueTexture("anim_popup_icon_border", ".png", rewardsPath, false);
            enqueueTexture("reward_check_sign", ".png", rewardsPath, false);

            enqueueTexture("gold_nums", "", rewardsPath, false);
            enqueueTexture("resource_icons", "", rewardsPath, false);
            enqueueTexture("a_close_icon", ".png", texturePath, false);


            enqueueTexture("anim_content_background", ".png", rewardsPath, true);
            enqueueTexture("anim_content_border", ".png", rewardsPath, true);
            enqueueTexture("reward_list_item_border", ".png", rewardsPath, true);


            enqueueTexture("level_up_icon", ".png", levelsPath, false);
            enqueueTexture("level_icons", "", levelsPath, false);

            enqueueTexture("a_fast_mode_help", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
		}

        public function loadFriendsAssets(completeHandler:Function = null, load:Boolean = true) : void {
            enqueueTexture("add_friend_icon", ".png", feed_friend_path, false);
            enqueueTexture("timeline_friends_activities_icon", ".png", feed_friend_path, false);
            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);

            enqueueTexture("add_friend", ".png", feed_friend_path, false);
            enqueueTexture("friend", ".png", feed_friend_path, false);
            enqueueTexture("swipe_remove", ".png", feed_friend_path, false);
            enqueueTexture("undo_friend", ".png", feed_friend_path, false);
            enqueueTexture("accept", ".png", feed_friend_path, false);
            enqueueTexture("decline", ".png", feed_friend_path, false);

            loadGarageSocialAssets(false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadPreviewVideoAssets(completeHandler:Function = null, load:Boolean = true) : void {
            enqueueTexture("a_bg_red_button", ".png", texturePath, false);
            enqueueTexture("a_transparent_bg_button", ".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }



        public function loadGalleryScreenAssets(completeHandler:Function = null):void{
            loadFeedAssets(false);
            loadBrandScreenAssets(false);


            enqueueTexture("gallery_background", ".png", galleryPath, false);
            enqueueTexture("gallery_clock", ".png", galleryPath, false);
            enqueueTexture("gallery_comments", ".png", galleryPath, false);
            enqueueTexture("gallery_date", ".png", galleryPath, false);
            enqueueTexture("gallery_dir_button", ".png", galleryPath, false);
            enqueueTexture("gallery_eye", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_1", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_4", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_9", ".png", galleryPath, false);
            enqueueTexture("gallery_like", ".png", galleryPath, false);
            enqueueTexture("menu_background", ".png", galleryPath, false);

            enqueueTexture("gallery_radio_default", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_selected", ".png", galleryPath, false);

            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);

            enqueueTexture("a_open_menu", ".png", texturePath, false);
            enqueueTexture("a_close_menu", ".png", texturePath, false);

            enqueueTexture("timeline_world_icon" ,".png", feed_friend_path, false);

            enqueueTexture("header_bg", ".jpg", texturePath, true);

            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadProfileScreenAssets(completeHandler:Function = null):void{
            enqueueTexture("profile_screen_background", ".png", texturePath, true);
            enqueueTexture("profile_field_bg", ".png", texturePath, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("profile_yes", ".png", texturePath, false);

            enqueueTexture("sound_on_icon", ".png", texturePath, false);
            enqueueTexture("sound_off_icon", ".png", texturePath, false);

            enqueueTexture("a_fb_icon", ".png", texturePath, false);
            enqueueTexture("a_vk_icon", ".png", texturePath, false);
            enqueueTexture("a_game_service_icon", ".png", texturePath, false);
            enqueueTexture("a_game_center_icon", ".png", texturePath, false);
            enqueueTexture("a_logout_icon", ".png", texturePath, false);

            enqueueTexture("check_new", ".png", texturePath, true);
            enqueueTexture("check_sel_new", ".png", texturePath, true);
            enqueueTexture("restoreButton", ".png", texturePath, true);
            enqueueTexture("restore", ".png", texturePath, true);

            enqueueTexture("button", ".png", texturePath, true);
            enqueueTexture("closeButton", ".png", texturePath, true);
            enqueueTexture("model_close", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);

            enqueueTexture("popUpContentBackground", ".png", texturePath, true);
            enqueueTexture("a_apple_icon2", ".png", texturePath, false);
            enqueueTexture("delete_account_icon", ".png", feed_friend_path, false);
            enqueueTexture("controlBackground", ".png", texturePath, true);
            enqueueTexture("ebay-close", ".png", texturePath, false);

            enqueueTexture("simple_radio_default", ".png", texturePath, false);
            enqueueTexture("simple_radio_selected", ".png", texturePath, false);

            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadLevelInfoAssets(completeHandler:Function = null):void{
            enqueueTexture("garage_close", ".png", feed_friend_path, false);
            enqueueTexture("material_lock_icon", ".png", challengesPath, false);
            enqueueTexture("car_unlock_big_icon", ".png", texturePath, true);
            enqueueTexture("avatar_border", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadChallengeListAssets(completeHandler:Function = null):void{
            enqueueTexture("header_bg", ".jpg", texturePath, true);
            enqueueTexture("timeline_my_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("leaderboard_icon", ".png", texturePath, true);

            enqueueTexture("care_btn", ".png", texturePath, true);
            enqueueTexture("truck_icon", ".png", texturePath, true);
            enqueueTexture("muscle_icon", ".png", texturePath, true);

            enqueueTexture("location_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_key_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_earn_icon", ".png", challengesPath, false);

            /**
             * New challenges
             */
            enqueueTexture("challenge_rewards_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_keys_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_stars_icon", ".png", challengesPath, false);

            enqueueTexture("challenges_leaderboard_icon", ".png", challengesPath, false);
            enqueueTexture("challenges_likes_icon", ".png", challengesPath, false);
            enqueueTexture("challenges_users_icon", ".png", challengesPath, false);
            enqueueTexture("challenges_home_icon", ".png", challengesPath, false);
            enqueueTexture("challenges_mails_icon", ".png", challengesPath, false);
            enqueueTexture("challenges_help_icon", ".png", challengesPath, false);

            enqueueTexture("challenges_time_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_submit_tuning", ".png", challengesPath, false);
            enqueueTexture("vote_equal_icon", ".png", challengesPath, false);
            enqueueTexture("vote_start_borders", ".png", challengesPath, false);
            enqueueTexture("you_voted_for_callout", ".png", challengesPath, false);
            enqueueTexture("challenges_vote_count_bg", ".png", challengesPath, false);
            enqueueTexture("close_btn_texture", ".png", challengesPath, false);
            enqueueTexture("challenge_user_rating_bg", ".png", challengesPath, false);

            enqueueTexture("time_label_in_challenge", ".png", challengesPath, false);
            enqueueTexture("time_label_in_voting", ".png", challengesPath, false);
            enqueueTexture("time_label_finished", ".png", challengesPath, false);

            enqueueTexture("arrow_left_challenge", ".png", challengesPath, false);
            enqueueTexture("arrow_right_challenge", ".png", challengesPath, false);

            enqueueTexture("gallery_radio_default", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_selected", ".png", galleryPath, false);

            enqueueTexture("a_circle_button_bg", ".png", texturePath, false);
            enqueueTexture("button", ".png", texturePath, true);

            enqueueTexture("challenge_won_icon", ".png", challengesPath, false);
            enqueueTexture("slide_lt_arr", ".png", challengesPath, false);
            enqueueTexture("dateIcon", ".png", feed_friend_path, false);

            enqueueTexture("popUpContentBackground", ".png", texturePath, true);
            enqueueTexture("details_close",".png", texturePath, false);
            enqueueTexture("a_bg_red_button", ".png", texturePath, false);

            enqueueTexture("rewards_icon", ".png", texturePath, true);
            enqueueTexture("button_border", ".png", texturePath, true);
            enqueueTexture("challenge_rewards_btn_icon", ".png", challengesPath, false);

            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("border_line", ".png", texturePath, false);
            enqueueTexture("circle_button_bg", ".png", texturePath, true);
            enqueueTexture("button_underline", ".png", texturePath, false);


            enqueueTexture("challenge_time_trails", ".png", challengesPath, false);
            enqueueTexture("profile_yes", ".png", texturePath, false);
            enqueueTexture("weekly-awards-img", ".png", rewardsPath, false);



            loadChallengeUI();
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadNewsAssets(completeHandler:Function = null):void{
            enqueueTexture("icon_border", ".png", newsPath, false);
            enqueueTexture("news_tuning_icon", ".png", newsPath, false);
            enqueueTexture("news_truck_icon", ".png", newsPath, false);
            enqueueTexture("news_muscle_icon", ".png", newsPath, false);
            enqueueTexture("model_close", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            enqueueTexture("closeButton", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadRewardsInfoAssets(completeHandler:Function = null):void{
            enqueueTexture("text", ".png", texturePath, true);
            enqueueTexture("watch", ".png", texturePath, true);
            enqueueTexture("ok", ".png", texturePath, true);
            enqueueTexture("no", ".png", texturePath, true);
            enqueueTexture("later", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            enqueueTexture("cancel", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadRewardsConfirmAssets(completeHandler:Function = null):void{
            enqueueTexture("confirm", ".png", texturePath, true);
            enqueueTexture("frame", ".png", texturePath, false);
            enqueueTexture("cancel", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadRewardsNoCoinAssets(completeHandler:Function = null):void{
            enqueueTexture("cancel", ".png", texturePath, true);
            enqueueTexture("watch", ".png", texturePath, true);
            enqueueTexture("frame", ".png", texturePath, false);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadGarageSocialAssets(load : Boolean = true, completeHandler:Function = null) : void {
            enqueueTexture("garage_vk", ".png", feed_friend_path, false);
            enqueueTexture("garage_fb", ".png", feed_friend_path, false);
            enqueueTexture("garage_close", ".png", feed_friend_path, false);

            enqueueTexture("garage_add_friend", ".png", feed_friend_path, false);
            enqueueTexture("garage_already_friend", ".png", feed_friend_path, false);
            enqueueTexture("garage_pending_friend", ".png", feed_friend_path, false);

            enqueueTexture("garage_like", ".png", feed_friend_path, false);
            enqueueTexture("garage_liked", ".png", feed_friend_path, false);
            enqueueTexture("garage_comment", ".png", feed_friend_path, false);
            enqueueTexture("garage_settings", ".png", texturePath, false);

            enqueueTexture("tuning_popup_share", ".png", texturePath, false);
            enqueueTexture("gone_to_challenge_lable", ".png", challengesPath, false);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("header_bg", ".jpg", texturePath, true);

            enqueueTexture("pageIndicator", ".png", texturePath, true);
            enqueueTexture("pageIndicatorSelected", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);

            enqueueTexture("a_effect_bg", ".png", texturePath, true);
            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("a_seporator_1",".png", texturePath, false);
            enqueueTexture("a_open_menu",".png", texturePath, false);
            enqueueTexture("a_close_menu",".png", texturePath, false);

            enqueueTexture("gallery_grid_1", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_4", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_9", ".png", galleryPath, false);
            enqueueTexture("gallery_clock", ".png", galleryPath, false);

            enqueueTexture("gallery_radio_default", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_selected", ".png", galleryPath, false);
            enqueueTexture("drop_down_arrow", ".png", galleryPath, false);

            enqueueTexture("gallery_comments", ".png", galleryPath, false);
            enqueueTexture("gallery_date", ".png", galleryPath, false);
            enqueueTexture("gallery_eye", ".png", galleryPath, false);
            enqueueTexture("gallery_like", ".png", galleryPath, false);
            enqueueTexture("garage-winner", ".png", challengesPath, false);

            enqueueTexture("time_label_in_voting", ".png", challengesPath, false);

            if(load) {
                _assetManager.loadQueue(function(ratio : Number) : void {
                    if (ratio == 1) {
                        if(completeHandler) {
                            completeHandler();
                        }
                    }
                });

            }

        }



        public function loadFeedAssets(load:Boolean = true, completeHandler:Function = null):void {
            loadGarageSocialAssets(false);

            enqueueTexture("vs_small", ".png", challengesPath, false);
            enqueueTexture("challenge_winner", ".png", challengesPath, false);
            enqueueTexture("timeline_filter_default", ".png", feed_friend_path, false);
            enqueueTexture("timeline_filter_selected", ".png", feed_friend_path, false);
            enqueueTexture("sendIcon", ".png", feed_friend_path, false);
            enqueueTexture("timeline_rate_filter_bg", ".png", feed_friend_path, false);
            enqueueTexture("timeline_feed_border", ".png", feed_friend_path, false);

            enqueueTexture("profile_background", ".png", challengesPath, false);


            enqueueTexture("commentIcon", ".png", feed_friend_path, false);//feed
            enqueueTexture("likeIcon", ".png", feed_friend_path, false);//feed
            enqueueTexture("post_friend_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_icon" ,".png", feed_friend_path, false);//feed
            //_assetManager.enqueufeed_friend_pathth("post_like_icon.png"		,false));//feed
            enqueueTexture("post_like_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_photo_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_tuning_icon" ,".png", feed_friend_path, false);//feed

            enqueueTexture("post_challenge_accept_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_challenge_win_icon" ,".png", feed_friend_path, false);//feed

            enqueueTexture("postRectangle" ,".png", feed_friend_path, false);//feed
            enqueueTexture("back_to_top", ".png", challengesPath, false);


            enqueueTexture("dateIcon" ,".png", feed_friend_path, false);
            enqueueTexture("timelineComment" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_like_big" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_car" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_photo" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_edit_rect" ,".png", feed_friend_path, false);

            enqueueTexture("timeline_my_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_friends_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("a_open_menu_iphonex",".png", texturePath, false);


            enqueueTexture("round_btn_border",".png", texturePath, false);
            enqueueTexture("round_btn_border_sel",".png", texturePath, false);
            enqueueTexture("cancel_button_bg",".png", texturePath, false);
            enqueueTexture("tuning_del_icon",".png", texturePath, false);
            enqueueTexture("frame_del_icon",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("a_edit_bg_button",".png", texturePath, false);

            enqueueTexture("header_bg", ".jpg", texturePath, true);

            enqueueTexture("tuning_new_btn", ".png", texturePath, false);
            enqueueTexture("tuning_edit_btn", ".png", texturePath, false);

            enqueueTexture("create_new_build_btn", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

		public function loadUpdateText(callBack : Function) : void {
			httpClient.loadPath("", URLRequestMethod.GET, null, HttpCachePolicy.INTERNET_FIRST, false, function (success : Boolean, result : Object) : void {
				if(success) {
					var obj : Object;
                    try{
                        obj = JSONer.parse(result);
                        HomeScreenPopUp.UPDATE_OBJECT = ObjectUtils.getProperty(obj, "new.app");
                    }catch (e:Error) {

                    }
				}

				if(callBack) {
					callBack.call();
				}
            }, HttpClient.CDN_CACHE_DOMAIN + "/api/v1/update-texts?lang=en-US");
		}

		private function texturePath(texture : String, hasScales : Boolean = true) : File {
			var appDirectory : File = File.applicationDirectory;
			var path : File;
			
			if(hasScales) {
				var scale : Number = _imageScaleFactor; // _assetManager.scaleFactor
				path = appDirectory.resolvePath(StringUtil.format("assets/textures/{0}x/{1}", scale, texture));
			} else {
				path = appDirectory.resolvePath(StringUtil.format("assets/textures/{1}", scale, texture));
			}
			path.preventBackup = true;
			
			return path;
		}

        private function feed_friend_path(texture:String, hasScales : Boolean = true) : File {
            texture = 'feed-friends/' + texture;
            return texturePath(texture, false);
        }

        private function turn5_path(texture:String, hasScales : Boolean = true) : File {
            texture = 'turn5_logos/' + texture;
            return texturePath(texture, false);
        }

        private function stepper_path(texture:String, hasScales : Boolean = true) : File {
            texture = 'value_stepper/' + texture;
            return texturePath(texture, false);
        }

        private function flagPath(texture:String, hasScale:Boolean = false) : File {
            texture = 'flags/' + texture;
            return texturePath(texture, false);
        }

        private function galleryPath(texture:String, hasScales : Boolean = true) : File {
            texture = 'gallery/' + texture;

            return texturePath(texture, false);
        }

        private function challengesPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'challenges/' + texture;
            return texturePath(texture, hasScales);
        }

        private function rewardsPath(texture:String, hasScales : Boolean = false) : File {
            return folderPath("rewards", texture, hasScales);
        }

        private function levelsPath(texture:String, hasScales : Boolean = false) : File {
            return folderPath("levels", texture, hasScales);
        }

        private function newsPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'news/' + texture;
            return texturePath(texture, hasScales);
        }

        private function componentIconPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'component_icons/' + texture;
            return texturePath(texture, hasScales);
        }

        private function materialIconPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'finish_type_icons/' + texture;
            return texturePath(texture, hasScales);
        }

        private function backgroundsPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'bgs/' + texture;
            return texturePath(texture, hasScales);
        }

        private function folderPath(pathName:String, texture:String, hasScales : Boolean = false) : File {
            texture = pathName + '/' + texture;
            return texturePath(texture, hasScales);
        }

		public function get assetManager() : AssetManager {
			return _assetManager;
		}

        private function enqueueTexture(textureId:String, fileFormat:String, pathMethod:Function, hasScale:Boolean = true):Boolean{
            if(!_assetManager.getTexture(textureId) && !_assetManager.isEnqueued(textureId)){
                _assetManager.enqueue(pathMethod(textureId + fileFormat, hasScale));
            }
            return _assetManager.isEnqueued(textureId);
        }

    public function set imageScaleFactor(value:Number):void {
        _imageScaleFactor = value;
    }
}
}