package com.despark.tuning3d.model.assets
{
	import com.despark.tuning3d.model.core.Device;

	public class AssetsScaleFinder
	{
		public function roundScale(scale:Number):Number{
			var scaleList:Array = [1, 1.5, 2, 3, 3.375, 4];
			var diff:Number = Number.MAX_VALUE;
			var result:Number;
			for(var i:int = 0; i < scaleList.length; i++){
				if(Math.abs(scaleList[i] - scale) < diff){
					diff = Math.abs(scaleList[i] - scale);
					result = scaleList[i];
				}
			}
			return result;
		}

		public function getContentScale(width : int, height : int) :Number 
		{
			var referenceSizes : Array;
			
			
			if(Device.isIos()){
				
				referenceSizes= 
				[
						{width: 480,  height: 320,  scale: 1}, // iPhone 2, 3
						{width: 800,  height: 480,  scale: 1.5}, 
						{width: 960,  height: 540,  scale: 1.5},   
						{width: 960,  height: 640,  scale: 2}, // iPhone 4
						//{width: 960, height: 540, scale: 3},  // iPad 3
						{width: 1024,  height: 768, scale: 2}, // iPad 1
						{width: 1136,  height: 640, scale: 2}, // iPhone 5
						//{width: 1136,  height: 640, scale: 2}, // iPhone 5
						{width: 1920, height: 1080, scale: 3.375},    
						{width: 2048, height: 1536, scale:4}  // iPad 3                     
						
				];  
			}else{
				referenceSizes= 
				[
					{width: 480,  height: 320,  scale: 1}, // iPhone 2, 3
					{width: 800,  height: 480,  scale: 1.5}, 
					{width: 960,  height: 540,  scale: 1.5},   
					{width: 960,  height: 640,  scale: 2}, // iPhone 4
					//{width: 960, height: 540, scale: 3},  // iPad 3
					{width: 1024,  height: 768, scale: 2}, // iPad 1
					{width: 1136,  height: 640, scale: 2}, // iPhone 5
					//{width: 1280,  height: 720, scale: 3.375}, // iPhone 5
					//{width: 1136,  height: 640, scale: 2}, // iPhone 5
					{width: 1920, height: 1080, scale: 3.375},    
					{width: 2048, height: 1536, scale: 4}  // iPad 3       
					              
				];  
			}
						
			var epsilon : int = int.MAX_VALUE;
			var scale :Number = 1;
			
			for each(var referenceSize : Object in referenceSizes) 
			{
				var dSides : int = Math.abs(referenceSize.width - width) + Math.abs(referenceSize.height - height);
				
				if(dSides <= epsilon) 
				{
					epsilon = dSides;
					scale = referenceSize.scale;
				}
			}
			
			trace("getContentScale:", scale, width, height)
			
			return scale;
			//return 4;
		}
	}
}