package com.despark.tuning3d.model.cars
{
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.images.PersistentImageProvider;
	import com.despark.tuning3d.model.parts.Material3dtProvider;

	public class CarBackground implements PersistentImageProvider {
		public static const DEFAULT_ID:String = "58e6705efbf756040095bb34";
		public static const DEFAULT_WIDTH:int = 1920;
		public static const DEFAULT_HEIGHT:int = 1080;
		//
		public var id : String;
		public var isCustom : Boolean;
		public var thumbnailUrl : String;
		public var mainUrl : String;
		public var showThumbnailUrl : Boolean = true;
		public var isLocalFile:Boolean = false;
		public var imagePathSecondCam:String;
		private var _isEncrypted : Boolean = false;
		public var customSnapshotsCamera:int = 0;
		public var selectedCamera:int = 0;
		private var _isDefault : Boolean;

		private var _animatedObjects:Vector.<CarBackgroundAnimatedObject>;
		private var _animatedDefaults:Vector.<String>;
		public function CarBackground() {
			super();
		}
		
		public function copyWithShowMainUrl() : CarBackground {
			var copyOfCarBackground : CarBackground = new CarBackground();
			copyOfCarBackground.id = id;
			copyOfCarBackground.isCustom = isCustom;
			copyOfCarBackground.thumbnailUrl = thumbnailUrl;
			copyOfCarBackground.mainUrl = mainUrl;
			copyOfCarBackground.showThumbnailUrl = false;
			copyOfCarBackground.imagePathSecondCam = imagePathSecondCam;
			copyOfCarBackground._animatedObjects = _animatedObjects;
			copyOfCarBackground._animatedDefaults = _animatedDefaults;
			return copyOfCarBackground;
		}
		
		private function get url() : String {
			if(showThumbnailUrl){
				if(selectedCamera==0)
				return "http:" + thumbnailUrl.replace(/https?:/i, '');
				else return imagePathSecondCam;
			}else{
				if(selectedCamera==0){
					if(!isLocalFile){
						mainUrl = "http:" + mainUrl.replace(/https?:/i, '');
						return mainUrl;
					}else{
						return mainUrl;
					}
				}else{
					return imagePathSecondCam;
				}
			}
		}
		
		public function get frameIndeX() : int 
		{
			return -1;
		}
		
		public function get isDefault() : Boolean 
		{
			return _isDefault;
		}
		
		public function set isDefault(value : Boolean) : void
		{
			_isDefault = value;
		}
		
		public function get localFile() : String
		{
			var localPath : String;
			
			if(isCustom)
			{
				//localPath = "Cars/Backgrounds/Custom/" + url;
				localPath = String(url).replace(Constants.BACKGROUNDS_URL, "Cars/Backgrounds/");
			}
			else
			{
				localPath = String(url).replace(Constants.BACKGROUNDS_URL, "Cars/Backgrounds/");
			}
			
			//var file1: File = File.cacheDirectory.resolvePath(localPath);
			//file1.preventBackup = true;
			return localPath;
		}
		
		public function get remoteUrl() : String
		{
			return url;
		}
        public function set isEncrypted(value : Boolean) : void
        {
            _isEncrypted = value;
        }

        public function get isEncrypted() : Boolean
		{
			return false;
		}
		
		public function get ignoresTransparentPixelsOnTouch() : Boolean 
		{
			return false;
		}
		
		public function get touchable() : Boolean 
		{
			return true;
		}
		
		public function get important() : Boolean
		{
			return true;
		}
		
		public function get brightness() : Number
		{
			return 1.0;
		}
		
		public function set brightness(value : Number) : void
		{
			
		}
		
		public function get material3dtProvider() : Material3dtProvider
		{
			return null;
		}

		public function addAnimatedObject(source:Object):void{
			_animatedObjects ||= new <CarBackgroundAnimatedObject>[];
			_animatedObjects.push(new CarBackgroundAnimatedObject(source));
		}

		public function updateAnimatedObjectIndices():void{
			_animatedObjects.sort(function (a:CarBackgroundAnimatedObject, b:CarBackgroundAnimatedObject):Number {
				return a.layerPosition - b.layerPosition;
			})
			for(var i:int = 0; i < _animatedObjects.length; i++){
				_animatedObjects[i].index = i;
			}
		}

		public function get animatedObjects():Vector.<CarBackgroundAnimatedObject> {
			return _animatedObjects;
		}

		public function addAnimatedDefaults(url:String):void{
			_animatedDefaults ||= new Vector.<String>();
			_animatedDefaults.push(url);
		}

		public function get animatedDefaults():Vector.<String> {
			return _animatedDefaults;
		}
	}
}


