package com.despark.tuning3d.model.cars
{
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.Parser;

	public class CarBackgroundsParser extends Parser
	{
		public override function parseObject(backgroundJSON : Object, key : String, ...args) : Object
		{
			var carBackground : CarBackground = new CarBackground();
				
			carBackground.id = backgroundJSON._id;
			carBackground.mainUrl = backgroundJSON.imagePath;
			carBackground.thumbnailUrl = backgroundJSON.thumbnailPath;
			carBackground.isCustom = backgroundJSON.user != null;
			
			if(backgroundJSON.hasOwnProperty("imagePathSecondCam"))
				carBackground.imagePathSecondCam = backgroundJSON.imagePathSecondCam.indexOf("http:")<0 ? "http:"+backgroundJSON.imagePathSecondCam : backgroundJSON.imagePathSecondCam;
			
			/*if(backgroundJSON.hasOwnProperty("customSnapshotsCamera")){
				trace("backgroundJSON.customSnapshotsCamera:", backgroundJSON.customSnapshotsCamera)
				carBackground.customSnapshotsCamera = backgroundJSON.customSnapshotsCamera;
			}*/
			if(backgroundJSON.hasOwnProperty("animatedDefaultBkg")){
				carBackground.addAnimatedDefaults(backgroundJSON.animatedDefaultBkg.cam1);
				carBackground.addAnimatedDefaults(backgroundJSON.animatedDefaultBkg.cam2);
			}
				
			if(carBackground.mainUrl) carBackground.mainUrl=carBackground.mainUrl.replace("https","http");
			if(carBackground.thumbnailUrl) carBackground.thumbnailUrl=carBackground.thumbnailUrl.replace("https","http");

			if(backgroundJSON.hasOwnProperty("animatedObjects") && backgroundJSON.animatedObjects.length){
				for(var i:int = 0; i < backgroundJSON.animatedObjects.length; i++){
					carBackground.addAnimatedObject(backgroundJSON.animatedObjects[i]);
				}
				carBackground.updateAnimatedObjectIndices();
			}
			
			return carBackground;
		}
	}
}