package com.despark.tuning3d.model.challenges {
    import com.utils.ObjectUtils;

    public class ChallengeRequirement {
        private var _componentType:String;
        private var _colors:Vector.<uint>;
        private var _materials:Vector.<String>;
        private var _stance:Vector.<String>;
        private var _radius:Vector.<int>;
        private var _ids:Vector.<String>;
        public function ChallengeRequirement(data:Object) {
            _componentType = ObjectUtils.getValue(data, "type", null);
            var i:int;
            var valueStr:String;

            valueStr = ObjectUtils.getValue(data, "color", null);
            if(valueStr && valueStr.length){
                var colorList:Array = valueStr.split(",");
                _colors = new Vector.<uint>(colorList.length);
                for(i = 0; i < _colors.length; i++){
                    _colors[i] = parseInt(colorList[i].replace("#", ""), 16);
                }
            }

            valueStr = ObjectUtils.getValue(data, "id", null);
            if(valueStr && valueStr.length){
                var idList:Array = valueStr.split(",");
                _ids = new Vector.<String>(idList.length);
                for(i = 0; i < _ids.length; i++){
                    _ids[i] = idList[i];
                }
            }

            valueStr = ObjectUtils.getValue(data, "material", null);
            if(valueStr && valueStr.length){
                var materialList:Array = valueStr.split(",");
                _materials = new Vector.<String>(materialList.length);
                for(i = 0; i < _materials.length; i++){
                    _materials[i] = materialList[i];
                }
            }

            valueStr = ObjectUtils.getValue(data, "stance", null);
            if(valueStr && valueStr.length){
                var stanceList:Array = valueStr.split(",");
                _stance = new Vector.<String>(stanceList.length);
                for(i = 0; i < _stance.length; i++){
                    _stance[i] = stanceList[i];
                }
            }

            valueStr = ObjectUtils.getValue(data, "radius", null);
            if(valueStr && valueStr.length){
                var radiusList:Array = valueStr.split(",");
                _radius = new Vector.<int>(radiusList.length);
                for(i = 0; i < _radius.length; i++){
                    _radius[i] = parseInt(radiusList[i].replace("R", ""));
                }
            }
        }

        public function get componentType():String {
            return _componentType;
        }

        public function get colors():Vector.<uint> {
            return _colors;
        }

        public function get materials():Vector.<String> {
            return _materials;
        }

        public function get stance():Vector.<String> {
            return _stance;
        }

        public function get radius():Vector.<int> {
            return _radius;
        }

        public function get ids():Vector.<String> {
            return _ids;
        }
    }
}
