package com.despark.tuning3d.model.challenges.feed {
    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.tunings.TuningsProxy;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeLabel;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeNotificationItemRenderer;
    import com.despark.tuning3d.view.components.challenges.controls.TuningLabel;
    import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;

    import feathers.controls.LayoutGroup;
    import feathers.layout.FlowLayout;

    import starling.display.DisplayObject;

    import starling.display.Quad;

    public class ChallengeNotificationData{
    private static const CHALLENGE_WIN:String = "challenge_new_diamond";
    private static const CHALLENGE_WIN_WEEKLY:String = "challenge_new_weekly_reward";
    public static var NOTIFICATION_TYPES:Array = [
        CHALLENGE_WIN, CHALLENGE_WIN_WEEKLY
    ];
    protected var _id:String;
    protected var _time:Number;
    protected var _iconTextureId:String;
    protected var _messageLabel:LayoutGroup;
    protected var _tuningView:DisplayObject;
    protected var _challengeLabel:ChallengeLabel;
    protected var _avatar:UserCircularAvatar;
    protected var _buttonGroup:LayoutGroup;
    protected var _holder:ChallengeNotificationItemRenderer;
    protected var _data:Object;

    protected var _disposed:Boolean;
    private var _leftMargin:Number;
        //
    protected var rendererWidth:Number;
    protected var rendererHeight:Number;
    public function ChallengeNotificationData(data:Object) {
        _data = data;
        _id = _data._id;
        _disposed = true;
    }

    public function createView(width:Number, height:Number):void{
        rendererWidth = width;
        rendererHeight = height;
        if(!_disposed){
            return;
        }
        _messageLabel = new LayoutGroup();
        var layout:FlowLayout = new FlowLayout();
        layout.horizontalGap = 5;
        layout.verticalGap = 3;
        _messageLabel.layout = layout;
        _disposed = false;
    }

    public function layout(rendererWidth:Number, rendererHeight:Number):void{

    }

    public static function createInstance(data:Object):ChallengeNotificationData{
        var instance:ChallengeNotificationData;
        switch(data.type){
            case CHALLENGE_WIN:
                instance = new ChallengeWonNoteData(data);
                break;
            case CHALLENGE_WIN_WEEKLY:
                instance = new ChallengeWeeklyWonNoteData(data);
                break;
        }
        return instance;
    }

    public function destroy():void{
        dispose();
        _data = null;
        _holder = null;
    }

    public function dispose():void{
        if(_messageLabel){
            _messageLabel.removeFromParent(true);
            _messageLabel = null;
        }
        if(_tuningView){
            _tuningView.removeFromParent(true);
            _tuningView = null;
        }
        if(_avatar){
            _avatar.removeFromParent(true);
            _avatar = null;
        }
        if(_buttonGroup){
            _buttonGroup.removeFromParent(true);
            _buttonGroup = null;
        }
        if(_challengeLabel){
            _challengeLabel.removeFromParent(true);
            _challengeLabel = null;
        }
        _disposed = true;
    }

    public function remove():void{
        if(_messageLabel){
            _messageLabel.removeFromParent();
        }

        if(_tuningView){
            _tuningView.removeFromParent();
        }

        if(_avatar){
            _avatar.removeFromParent();
        }

        if(_buttonGroup){
            _buttonGroup.removeFromParent();
        }

        if(_challengeLabel){
            _challengeLabel.removeFromParent();
        }
    }

    public function get id():String {
        return _id;
    }

    public function get time():Number {
        return _time;
    }

    public function get iconTextureId():String {
        return _iconTextureId;
    }

    public function get messageLabel():LayoutGroup {
        return _messageLabel;
    }

    public function get tuningView():DisplayObject {
        return _tuningView;
    }

    public function get challengeLabel():ChallengeLabel {
        return _challengeLabel;
    }

    public function get avatar():UserCircularAvatar {
        return _avatar;
    }

    public function get buttonGroup():LayoutGroup {
        return _buttonGroup;
    }

    public function set holder(value:ChallengeNotificationItemRenderer):void {
        _holder = value;
        _holder.setRequiresRedraw();
    }

    public function get disposed():Boolean {
        return _disposed;
    }

    public function get source():Object{
        return _data;
    }

        public function set leftMargin(leftMargin:Number):void {
            _leftMargin = leftMargin;
        }

        public function get leftMargin():Number {
            return _leftMargin;
        }
    }
}
