package com.despark.tuning3d.model.core {
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.brands.BrandsProxy;
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;

import starling.events.Event;
import starling.events.EventDispatcher;

public class AppMode extends EventDispatcher{

    public static const MODE_HOME : String  = "modeHome";
    public static const MODE_TUNING : String  = "modeTuning";
    private static var _self : AppMode;

    private var _mode : String = MODE_HOME;
    private var _tracer : Tracer;

    public function AppMode() {
        if(_self) {
            throw new Error("AppMode singleton class bad usage");
        }
        _tracer = new Tracer("AppMode");
    }

    public static function get self() : AppMode {
        if(!_self) {
            _self = new AppMode();
        }
        return _self;
    }

    public function set mode(value : String ) : void {
         if(value == this._mode) {
             this.dispatchEventWith(Event.CHANGE, false, value);
             return;
         }
        this._tracer.print("mode : " + value.toString());
        this._mode = value;
        var user : User  = (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser;
        switch (value) {
            case MODE_TUNING:
                Constants.update_API_URLS(user ? user.isSuperAdmin : false);
                break;
            case MODE_HOME:
                break;
            default:
                _tracer.print("Wrong app mode");
                return;
        }
        this.dispatchEventWith(Event.CHANGE, false, value);
    }

    public function setModeValues(value : String ) : void {
        this._mode = value;
        var user : User  = (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser;
        switch (value) {
            case MODE_TUNING:
                Constants.update_API_URLS(user ? user.isSuperAdmin : false);
                break;
            case MODE_HOME:
                break;
            default:
                _tracer.print("Wrong app mode");
                return;
        }
    }

    public function get mode():String
    {
        return this._mode;
    }

    public static function getModeForCar(car:Car):String{
        return MODE_TUNING;
    }

    public static function getCarTypeForMode():String{
        return "";
    }


    /**
     * Helping functions
     */
    public function setModeTuning():void {
        mode = MODE_TUNING;
    }

    public function setModeHome():void {
        mode = MODE_HOME;
    }
}
}
