package com.despark.tuning3d.model.core {
    import com.distriqt.extension.camerarollextended.Asset;
    import com.distriqt.extension.camerarollextended.CameraRollExtended;
    import com.distriqt.extension.camerarollextended.events.CameraRollExtendedEvent;
    import com.utils.Console;

    import flash.events.Event;
    import flash.filesystem.File;
    import flash.filesystem.FileMode;
    import flash.filesystem.FileStream;
    import flash.net.URLRequest;
    import flash.net.URLStream;
    import flash.utils.ByteArray;

    import starling.events.Event;
    import starling.events.EventDispatcher;

    public class PromoVideoManager extends EventDispatcher{
        private var urlStream:URLStream;
        private var fileName:String;
        public static const SAVE_COMPLETE:String = "video_save_complete";
        public static const SAVE_FAILED:String = "video_save_failed";
        private static var _instance:PromoVideoManager;
        private static var _inProcess:Boolean = false;
        public function PromoVideoManager() {
        }

        public static function get instance():PromoVideoManager{
            _instance ||= new PromoVideoManager();
            return _instance;
        }

        public function downloadAndSaveVideo(fileName:String):void{
            CameraRollExtended.service.requestAccess();
            //
            this.fileName = fileName;
            var videoHost:String = "https://tuningvideomakerfiles.s3.amazonaws.com/";
            var urlReq:URLRequest = new URLRequest(videoHost + fileName);
            if(urlStream){
                urlStream.stop();
                urlStream.removeEventListener(flash.events.Event.COMPLETE, videoDownloadCompleteHandler);
            }
            urlStream = new URLStream();
            urlStream.addEventListener(flash.events.Event.COMPLETE, videoDownloadCompleteHandler);
            urlStream.load(urlReq);
        }

        private function videoDownloadCompleteHandler(event:flash.events.Event):void {
            var fileData:ByteArray = new ByteArray();
            urlStream.readBytes(fileData, 0, urlStream.bytesAvailable);
            var file:File = File.applicationStorageDirectory.resolvePath(fileName);
            var fileStream:FileStream = new FileStream();
            fileStream.open(file, FileMode.WRITE);
            fileStream.writeBytes(fileData, 0, fileData.length);
            fileStream.close();

            CameraRollExtended.service.addEventListener(CameraRollExtendedEvent.ADD_FILE_COMPLETE, addFile_completeHandler );
            CameraRollExtended.service.addEventListener(CameraRollExtendedEvent.ADD_FILE_ERROR, addFile_errorHandler );
            var success:Boolean = CameraRollExtended.service.addFile(file, Asset.VIDEO);
            if(success){
                dispatchEvent(new starling.events.Event(SAVE_COMPLETE));
            }else{
                dispatchEvent(new starling.events.Event(SAVE_FAILED));
            }
            inProcess = false;
            Console.log(file.url);
        }

        private function addFile_completeHandler( event:CameraRollExtendedEvent ):void {
            dispatchEvent(new starling.events.Event(SAVE_COMPLETE));
            CameraRollExtended.service.removeEventListener(CameraRollExtendedEvent.ADD_FILE_COMPLETE, addFile_completeHandler );
            CameraRollExtended.service.removeEventListener(CameraRollExtendedEvent.ADD_FILE_ERROR, addFile_errorHandler );
        }

        private function addFile_errorHandler( event:CameraRollExtendedEvent ):void {
            dispatchEvent(new starling.events.Event(SAVE_FAILED));
            CameraRollExtended.service.removeEventListener(CameraRollExtendedEvent.ADD_FILE_COMPLETE, addFile_completeHandler );
            CameraRollExtended.service.removeEventListener(CameraRollExtendedEvent.ADD_FILE_ERROR, addFile_errorHandler );
        }

        public static function get inProcess():Boolean {
            return _inProcess;
        }

        public static function set inProcess(value:Boolean):void {
            _inProcess = value;
        }
    }
}
