/**
 * Created by Vardan on 5/19/2017.
 */
package com.despark.tuning3d.model.core
{
import flash.desktop.Clipboard;
import flash.desktop.ClipboardFormats;

public class Tracer {

    private static var ENABLE : Boolean  = Constants.IS_DEBUG;
    private static var ENABLE_FOR : Array = ["ADS_MANAGER","Facebook"];
    private static var _tagTimeStampMeasureMap : Object;
    private var _className : String = "";


    public static function timeStamp(tag : String, message : String, reset: Boolean = false) : void {
        if (!_tagTimeStampMeasureMap) {
            _tagTimeStampMeasureMap = {};
            print('initializing', 'TimeStamp');
        }
        reset=  false;

        if (reset || !_tagTimeStampMeasureMap.hasOwnProperty(tag)){
            _tagTimeStampMeasureMap[tag] = [{
                time: (new Date).getTime(),
                message: message
            }];
            print('reseting tag, message: ' + message, 'TimeStamp', tag);
        } else {
            var time : Number = (new Date).getTime();
            var timeline : Array = _tagTimeStampMeasureMap[tag];
            _tagTimeStampMeasureMap[tag].push({time: time, message: message});
            time = time - timeline[timeline.length - 2].time;
            time /= 1000;
            print('time: ' + time + 's' + ' (message: ' + message + ')', 'TimeStamp', tag, true);
//            AlertView.show('TimeStamp(' + tag + '): ' + time,3)
        }
    }

    public static function copyTimeStampToClipBoard() : void{
        var message : String = '';
        for (var tag : String in _tagTimeStampMeasureMap) {
            var timeline : Array = _tagTimeStampMeasureMap[tag];

            message += '[' + tag + ']\n';

            if(timeline && timeline.length > 1) {
                for (var i : int = 0; i < timeline.length - 1; i ++ ) {
                    var time : Number = timeline[i+1].time - timeline[i].time;
                    time /= 1000;

                    message += 'time: ' + time + 's message ' + timeline[i].message + ' -> ' + timeline[i+1].message + '\n';
                }
            }
            message += '***********************************************\n';
        }

//        return message;
        Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, message);
    }

    /**
     *  <p> This is a base class for tracing. </p>
     *
     * @param className is the name of the class which will trace message
     */
    public function Tracer(className : String ) {
        _className = className;
    }

    /**
     * Traces static message, which is not depended from tracerState
     *
     * <p>Traces static message, which is not depended from tracerState.</p>
     * @param separate. If separate is true, then message will be separated from others by stars (*)
     */
    public function printStatic(message : String, functionName : String = "", separate : Boolean = false) : void
    {
        Tracer.printStatic(message, _className, functionName, separate);
    }


    /**
     * Traces a message, which is not depended from tracerState
     *
     * <p>Traces a  message, which is depended from tracerState.</p>
     * @param separate. If separate is true, then message will be separated from others by stars (*)
     */
    public function print(message : String, functionName = "", separate : Boolean = false) : void
    {
        Tracer.print(message, _className, functionName, separate);
    }
    /**
     * Traces static message, which is not depended from tracerState
     *
     * <p>Traces static message, which is not depended from tracerState.</p>
     * @param separate. If separate is true, then message will be separated from others by stars (*)
     */
    public static function printStatic(message : String, className : String= "", functionName : String = "", separate : Boolean = false) : void
    {
        traceMessage(message, className, functionName, separate);
    }

    /**
     * Traces a message, which is not depended from tracerState
     *
     * <p>Traces a  message, which is depended from tracerState.</p>
     * @param separate. If separate is true, then message will be separated from others by (*)stars
     */
    public static function print(message : String, className : String="", functionName : String="", separate : Boolean = false) : void
    {
        if(ENABLE || (className && className.length && ENABLE_FOR.indexOf(className)> -1))
            traceMessage(message, className, functionName, separate);

    }

    private static function traceMessage(message : String, className : String, functionName : String, separate:Boolean) : void{
        var m : String = "";
        if(className != "")
            m =m + "[" +  className + "] ";
        if(functionName != "")
            m = m + "(" + functionName + ") ";
        m += message;
        if(separate)
        {
            trace("**********************************************************************************************");
            trace(m);
            trace("**********************************************************************************************");
        }else{
            trace( m );
        }
    }
}
}
