package com.despark.tuning3d.model.core {
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.challenges.ChallengeData;
    import com.despark.tuning3d.model.tunings.Tuning;

    public class UIStrings {
        public static const NO_RESULT_LABEL:String = 'No results found';

        public static function getCarName(carObj:*):String{
            var result:String = "";
            var startYear:String;
            var endYear:String;
            if(carObj is Car){
                var car:Car = carObj as Car;
                car.model = ChallengeData.initCarName(car.model);
                startYear = car.startYear?car.startYear.toString().substr(2):null;
                endYear = car.endYear?car.endYear.toString().substr(2):null;
                result = ((startYear && endYear)?(startYear + "-" + endYear + " "):"") + car.name + " " + car.model;
            }else if(carObj is Object){
                startYear = carObj.start_year?carObj.start_year.toString().substr(2):null;
                endYear = carObj.end_year?carObj.end_year.toString().substr(2):null;
                carObj.model = ChallengeData.initCarName(carObj.model);
                result = ((startYear && endYear)?(startYear + "-" + endYear + " "):"") + carObj.make + " " + carObj.model;
            }
            return result;
        }

        public static function getDiamondChar(size:int = 10):String{
            return "<font color='#14ade3' size='"+size.toString()+"'><b><i>\ue900</i></b></font>";
        }

        public static function getKeyChar(size:int = 10):String{
            return "<font color='#33c604' size='"+size.toString()+"'><b><i>\ue901</i></b></font>";
        }

        public static function getStarChar(size:int = 10, color:String = "#FFFFFF"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue903</i></b></font>";
        }

        public static function getLightBulbChar(size:int = 10):String{
            return "<font color='#edb800' size='"+size.toString()+"'><b><i>\ue902</i></b></font>";
        }

        public static function getFinishedChar(size:int = 10, color:String = null):String{
            color ||= "#000000";
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue904</i></b></font>";
        }

        public static function getTimeLimitChar(size:int = 10, color:String = null):String{
            color ||= "#ff9000";
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue905</i></b></font>";
        }

        public static function getCarIconChar(size:int = 14, color:String = "#FFFFFF"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue906</i></b></font>";
        }

        public static function getGiftIconChar(size:int = 9, color:String = "#535353"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue909</i></b></font>";
        }

        public static function getPartsIconChar(size:int = 9, color:String = "#535353"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue90b</i></b></font>";
        }

        public static function getColorPaletteIconChar(size:int = 9, color:String = "#535353"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue908</i></b></font>";
        }

        public static function getKeyLimitIconChar(size:int = 9, color:String = "#535353"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue90a</i></b></font>";
        }

        public static function getLevelUpIconChar(size:int = 16, color:String = "#535353"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue907</i></b></font>";
        }

        public static function getCheckIconChar(size:int = 16, color:String = "#FFFFFF"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue910</i></b></font>";
        }

        public static function getLockIconChar(size:int = 16, color:String = "#FFFFFF"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue911</i></b></font>";
        }

        public static function getUnlockIconChar(size:int = 16, color:String = "#FFFFFF"):String{
            return "<font color='"+color+"' size='"+size.toString()+"'><b><i>\ue912</i></b></font>";
        }
}
}