package com.despark.tuning3d.model.core.http
{
	import by.blooddy.crypto.serialization.JSONer;

import com.despark.tuning3d.model.cars.CarsProxy;
import com.despark.tuning3d.model.core.AppMode;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.core.ErrorTracker;
	import com.despark.tuning3d.model.core.Tracer;
import com.despark.tuning3d.model.core.http.caching.HttpCache;
import com.despark.tuning3d.model.core.http.caching.HttpCachePolicy;
import com.despark.tuning3d.model.core.http.caching.HttpNullCache;
import com.despark.tuning3d.model.core.images.ImageWatermarker;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.users.DASURLLoader;
	import com.despark.tuning3d.view.components.auth.AuthScreen;
	import com.despark.tuning3d.view.components.auth.LoginScreen;
	import com.utils.Console;
	import com.utils.ObjectUtils;

	import feathers.controls.Label;

	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.JPEGEncoderOptions;
	import flash.display.PNGEncoderOptions;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.geom.Matrix;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.net.URLRequestHeader;
	import flash.net.URLRequestMethod;
	import flash.net.URLVariables;
	import flash.system.Capabilities;
	import flash.utils.ByteArray;

	import ru.inspirit.net.MultipartURLLoader;

	import starling.core.Starling;

	public class HttpClient
	{
		//public var baseURL : String;
		public var onError : Function;
		public var lastErrorStatusCode : int;
		public var isUserSigned : Boolean;
		public var userToken: String;
		public var language : Language;
		
		private var httpRequestLoaders : Array;
		private var _httpCache : HttpCache;
		
		private var multipartURLLoader : MultipartURLLoader;
		
		public static var TOKEN:String=null;

		public static const API_DOMAIN:String = "http://api.3dtuning.com";
		public static const CDN_CACHE_DOMAIN:String = "http://assets2.3dtuning.com";
		public static const TUNING_DOMAIN:String = "http://tuning.api.3dtuning.com";

		public static const CHALLENGE_DOMAIN:String = "http://coins.challenge.api.3dtuning.com";
		public static const LEADERBOARD_DOMAIN:String = "http://leaderboard.3dtuning.com";
		public static const CHALLENGE_ROOT_URL:String = CHALLENGE_DOMAIN + "/api/v1/challenge/";
		public static const PROFILE_ROOT:String = "http://api.3dtuning.com/api/v1/accounts/my";
		public static const DELETE_ACCOUNT_URL:String = "http://api.3dtuning.com/api/v1/accounts/delete/"; //"http://mailer.3dtuning.com/api/v1/remove-account";
		// New Challenges
		public static const NEW_CHALLENGE_DOMAIN:String = "http://challengenew.3dtuning.com"; //"http://challengenew.3dtuning.com";
		public static const CHALLENGES_LIST_URL:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem";
		public static const CHALLENGES_LEADERBOARD_URL:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/leaderboard";
		public static const CHALLENGES_USER_TUNINGS:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/garage";
		public static const CHALLENGES_RANDOM_PAIR:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/getRandomPair";
		public static const CHALLENGES_VOTE_LIST:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/vote";
		public static const CHALLENGES_ADD_KEY:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/keys";
		public static const CHALLENGES_ADD_DIAMOND:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/diamonds";
		public static const CHALLENGES_ADD_BOTH:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/keysDiamonds";
		public static const CHALLENGES_ADD_VOTE_KEY:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/votingGroup";
		public static const CHALLENGES_DAILY_REWARDS_LIST:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/rewards";
		public static const CHALLENGES_LEVELS:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/levels";
		//
		public static const CHALLENGES_USER_DAILY_REWARDS:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/userDaily";
		public static const CHALLENGES_GUEST_DAILY_WELCOME:String = NEW_CHALLENGE_DOMAIN + "/api/v1/challengeNewSystem/deviceDaily";
		//
		private var failedCallback:Function;
		//
        public function set httpCache(cache : HttpCache):void {
			_httpCache = cache;
		}
		public function get httpCache() : HttpCache {
			return _httpCache;
		}
        public function HttpClient( cache : HttpCache = null)
		{
			super();
			
			//baseURL = aBaseURL;
			httpRequestLoaders = [];
			httpCache = cache || new HttpNullCache();    
		}
		
		public function getPathCached(path : String, params : Object, cachePolicy : String, resultHandler : Function, dontManageCookiesAnyway : Boolean = false, customUrl : String = null, __dontShowErrorMessage : Boolean = false) : void
		{
			loadPath(path, URLRequestMethod.GET, params, cachePolicy, true, resultHandler, customUrl,dontManageCookiesAnyway,__dontShowErrorMessage);
		}
		
		public function getPath(path : String, params : Object, resultHandler : Function) : void {
			loadPath(path, URLRequestMethod.GET, params, HttpCachePolicy.NONE, true, resultHandler);
		}
		
		public function postPath(path : String, params : Object, resultHandler : Function, customUrl : String = null, __method : String = null) : void {
			var method : String = null;
			if(__method){
				method = __method;
			}else{
				method = URLRequestMethod.POST;
			}
			loadPath(path, method, params, HttpCachePolicy.NONE, true, resultHandler,customUrl);
		}
		
		public function putPath(path : String, params : Object, resultHandler : Function,customUrl : String = null) : void {
			loadPath(path, URLRequestMethod.PUT, params, HttpCachePolicy.NONE, true, resultHandler, customUrl);
		}
		
		public function deletePath(path : String, params : Object, resultHandler : Function, customUrl : String = null) : void {
			loadPath(path, URLRequestMethod.DELETE, params, HttpCachePolicy.NONE, true, resultHandler, customUrl);
		}
		
		public function hasCache(path : String) : Boolean {
			var url : String = urlForPath(path);
			return httpCache.contains(url);
		}
		
		public function loadPath(
			path : String, 
			method : String, 
			params : Object, 
			cachePolicy : String, 
			useErrorHandler : Boolean, 
			resultHandler : Function, 
			customUrl : String = null, 
			dontManageCookiesAnyway : Boolean = false, __dontShowErrorMessage : Boolean = false) : void
		{	
			var url : String = null;
			
			if(customUrl){
				url = customUrl;
			}else{
				url  = urlForPath(path);
			}
			
			var urlForTrace: String = "";
			if(params && method==URLRequestMethod.GET){
				
				if(url.indexOf("?")<0){
					urlForTrace+="?";
				}else{
					urlForTrace+="&";
				}
				/*for(var key:String in params){
					urlForTrace += key + "=" + params[key] + "&";
				}*/
				urlForTrace += ObjectUtils.toURL(params);
				urlForTrace=urlForTrace.substr(0, urlForTrace.length-1);
			}
			
			url=url+urlForTrace;

			var file:File=httpCache.cachedFile(url);
			
			if(path && path.indexOf("cars")>-1 && httpCache.contains(url) ){
				if(file.exists){
					
					var creationDate:Date=new Date();
					creationDate.setTime(Date.parse(file.creationDate));
					
					var nowDate:Date=new Date();
					
					var interval:int=(nowDate.getTime()/1000)-(creationDate.getTime()/1000);
					
					//trace("interval:", interval);
					
					
					if(interval>60*60/2){
						
						file.deleteFile();
					}
					
					
					if(Tuning3D.CAR_UPDATE_DATE/1000>creationDate.getTime()/1000){
						
						trace("CAR DELETE CACHE FILE");
						try{
							file.deleteFile();
						}catch(e:Error){
							
							
						}
						
					}
				}
			}
			//
			if( method == URLRequestMethod.GET && cachePolicy == HttpCachePolicy.CACHE_FIRST && httpCache.contains(url)) {
				httpCache.load(url, resultHandler);
			}else {
				if(method == URLRequestMethod.GET) {
					params = null;
				}
				var request : URLRequest = createRequest(url, method, params,dontManageCookiesAnyway);
				request.cacheResponse=false;
				request.useCache=false;
				request.idleTimeout = 30000;
				startRequest(request, cachePolicy, useErrorHandler, resultHandler,__dontShowErrorMessage);
			}
		}
		
		public function sentBitmapData(__complete_fun : Function,iii: int, __bitmapData: BitmapData, __url: String, __height: int = -1, __width: int = -1, isJpeg: Boolean = false, addLogo : Boolean = false, _failedCallback:Function = null) : void{
            failedCallback = _failedCallback;
			var deleteBD : Boolean = false;
			if(__height>-1){
				var scale:Number = 1;
				scale = __height / __bitmapData.rect.height;

				
				var matrix:Matrix = new Matrix();
				matrix.scale(scale, scale);
				
				if(__width>-1){
					matrix.tx = (  __width -  __bitmapData.width * scale )/2;
				}else{
					__width = __bitmapData.width * scale
				}
				
				
				var smallBMD:BitmapData = new BitmapData(__width, __bitmapData.height * scale, true, 0x000000);
				smallBMD.draw(__bitmapData, matrix, null, null, null, true);
				
				__bitmapData = smallBMD;
				deleteBD = true;
			}

			if(addLogo){
				var logo : Bitmap = new AuthScreen.WATERMARK_FOR_SNAPSHOTS();
				var imageWatermarker : ImageWatermarker = new ImageWatermarker();
				imageWatermarker.addWatermark(__bitmapData, logo, 1,27,12);
				
			}

			var bytes : ByteArray;
			var extension:String; 
			if(isJpeg){
				extension= ".jpeg"; 
				bytes = __bitmapData.encode(__bitmapData.rect, new JPEGEncoderOptions(100));
			}else{
				extension= ".png"; 
				bytes = __bitmapData.encode(__bitmapData.rect, new PNGEncoderOptions(true));
			}
			
			
			
			{//добавим доп инфу
				var name:String = "a new picture";
				var author:String = "tuning3D";
				
				// write the image name
				bytes.writeUTF(name);
				
				// write author
				bytes.writeUTF(author);
				
				// write image width and height
				bytes.writeInt(__bitmapData.width);
				bytes.writeInt(__bitmapData.height);
				
				// write bitmap data length
				bytes.writeInt(bytes.length);
			}
			
			if(deleteBD){
				
				__bitmapData.dispose();
			}
			
			
			if(1)
			{//для теста сохраним это в файл
				
				// set a file extension - could be what ever you want it to be
				
				
				// create the file on the desktop
				var myFile:File = File.cacheDirectory.resolvePath("superImage_iii"+iii+ "_"+__height + extension);
				
				// create a FileStream to write the file
				var fs:FileStream = new FileStream();
				
				// add a listener so you know when its finished saving
				fs.addEventListener(Event.CLOSE, fileWritten);
				
				// open the file
				fs.openAsync(myFile, FileMode.WRITE);   
				
				// write the bytearray to it
				fs.writeBytes(bytes);
				
				// close the file
				fs.close();
				
				
			}
			
			var url_request:URLRequest = new URLRequest();
			url_request.url = __url;//"http://server.com/upload.php";
			url_request.contentType = "binary/octet-stream";
			url_request.method = URLRequestMethod.PUT;//URLRequestMethod.POST;
			url_request.data = bytes;
			url_request.requestHeaders.push(new URLRequestHeader('Content-Length', bytes.length.toString()));
			
			if(isJpeg){
				url_request.requestHeaders.push(new URLRequestHeader('Content-Type', 'image/jpg'));
			}else{
				url_request.requestHeaders.push(new URLRequestHeader('Content-Type', 'image/png'));
			}
			
			
			url_request.requestHeaders.push(new URLRequestHeader('x-ms-blob-type', 'BlockBlob'));
			
			var loader:DASURLLoader = new DASURLLoader();
			loader.addObject = __complete_fun;
			loader.dataFormat = URLLoaderDataFormat.BINARY;
			// attach complete/error listeners
			loader.addEventListener(Event.COMPLETE, multipartURLLoaderCompleteHandler);
			loader.addEventListener(IOErrorEvent.IO_ERROR, multipartURLLoaderIoErrorHandler);
			
			loader.load(url_request);
			
			//			Starling.juggler.delayCall(function() : void
			//			{
			//				
			//				
			//				
			//			}, 1);
			
			
			
			/*
			var bytes : ByteArray = __bitmapData.encode(__bitmapData.rect, new JPEGEncoderOptions(80));
			
			multipartURLLoader = new MultipartURLLoader();
			multipartURLLoader.dataFormat = URLLoaderDataFormat.BINARY;
			multipartURLLoader.addVariable("files", "photo.jpg");
			multipartURLLoader.addFile(bytes, "photo.jpg", "files", "application/octet-stream");
			multipartURLLoader.loader.addEventListener(Event.COMPLETE, multipartURLLoaderCompleteHandler);
			multipartURLLoader.loader.addEventListener(IOErrorEvent.IO_ERROR, multipartURLLoaderIoErrorHandler);
			
			multipartURLLoader.load(__url);
			*/
		}
		
		public static function saveTestFile(__name : String, __bitmapData: BitmapData) : void
		{
			var bytes : ByteArray = __bitmapData.encode(__bitmapData.rect, new PNGEncoderOptions(true));
			{//добавим доп инфу
				
				var author:String = "tuning3D";
				
				// write the image name
				bytes.writeUTF(__name);
				
				// write author
				bytes.writeUTF(author);
				
				// write image width and height
				bytes.writeInt(__bitmapData.width);
				bytes.writeInt(__bitmapData.height);
				
				// write bitmap data length
				bytes.writeInt(bytes.length);
			}
			
			var myFile:File = File.cacheDirectory.resolvePath(__name);
			
			// create a FileStream to write the file
			var fs:FileStream = new FileStream();
			
			// add a listener so you know when its finished saving
			//fs.addEventListener(Event.CLOSE, fileWritten);
			
			// open the file
			fs.openAsync(myFile, FileMode.WRITE);   
			
			// write the bytearray to it
			fs.writeBytes(bytes);
			
			// close the file
			fs.close();
		}
		
		private function fileWritten(e:Event):void
		{
		}
		
		private function multipartURLLoaderCompleteHandler(event : Event) : void
		{
			var loader:DASURLLoader =  (DASURLLoader)(event.target);
			if(loader.addObject){
				loader.addObject.call();
			}
		}
		
		private function multipartURLLoaderIoErrorHandler(event : IOErrorEvent) : void {
            if(failedCallback!=null){
                failedCallback.call();
			}
			//var result : String = multipartURLLoader.loader.data;
			//sendNotification(Notifications.CAR_BACKGROUND_UPLOADING_FAILED, result);
			//Logger.e("multipartURLLoaderCompleteHandler fail:"+event.text, this);
			//multipartURLLoader = null;
		}


        public function urlForPath(path : String) : String
        {
            var baseUrl_temp : String = null;
            if(!path){
                return Constants.API_URL_api;
            }

            if (path.indexOf("feedtuning") >= 0) {
                path = path.replace("feedtuning", "tuning");
                return "http://feed-staging.api.3dtuning.com/api/v1/" + path;

            }

            if(path.indexOf("feed") == 0){
                return "http://feed-staging.api.3dtuning.com/api/v1/" + path;
//				return "http://localhost:3003/api/v1/" + path;
            }
            if(path.indexOf("notifications") >= 0)
            {
                return "http://mailer.3dtuning.com/api/v1/" + path;
            }

            if(path.indexOf("rating") >= 0 && path.indexOf("http://ratings.3dtuning.com/api/v1") < 0)
            {
                return "http://ratings.3dtuning.com/api/v1";
            }

            if(path.indexOf("voting/")>=0){
                return API_DOMAIN + "/api/v1/"+path;
            }
			if(path.indexOf("tunings")==0){
                return TUNING_DOMAIN + "/api/v1/" + path;
            }

            if(path=="voting"){

                return API_DOMAIN + "/api/v1/voting";
            }

            if(path == "componentsInfo"){

                baseUrl_temp=Constants.API_URL_api;
            }else
            if(path == 'manufacturers'){

                baseUrl_temp = Constants.API_URL_assets2;

            }else
            if(path == 'recent'){
                baseUrl_temp = Constants.API_URL_assets2_recent;

            }else
            if(
                    (path.indexOf("regions/langs") == 0)||
                    (path.indexOf("tunings/top") == 0)||
                    (path.indexOf("tunings/stats/popular") == 0)||
                    (path.indexOf("accounts/count") == 0)||
                    (path.indexOf("news/recent") == 0)//||
            ){
                baseUrl_temp = Constants.API_URL_assets;
            }else if((path.indexOf("cars/") == 0)){
                baseUrl_temp = Constants.API_URL_assets2;
            } else if((path.indexOf("translations/") == 0) || (path == "cars" )/*||вернуть*/ ){
                baseUrl_temp = Constants.API_URL_assets2;
            } /*else if(path.indexOf("components/") == 0){
                baseUrl_temp = Constants.API_URL_assets2;
            }*/else {
                baseUrl_temp = Constants.API_URL_api;
            }

            var url : String = path.indexOf("://") < 0 ? baseUrl_temp + path : path;

            if(path == 'recent'){

                url=path.indexOf("://") < 0 ? baseUrl_temp : path;
            }
			var platform:String;
            if(path == "carsAll"){
				platform = "ios";
                if(!Device.isIos()) platform = "android";
                url="http://assets2.3dtuning.com/api/v1/cars/?all=true&platform="+platform;
            }

            if(path=='cars'){

                ////////////////для прода////////////////
                if(!CarsProxy.IS_FULL){
					platform = "ios";

                    if(!Device.isIos()) platform = "android";
                    url+="/?all=true&platform="+platform;
                }else{
                    url+="/fullcars/?fullcars=true";
                }
            }else if(path.indexOf("cars/") == 0){
				platform = "ios";
                if(!Device.isIos()) platform = "android";
                url+="/?platform="+platform;
                if(Constants.ALL_CARS_AND.length>0)
                    url+="&all=true";
            }

            if(path.indexOf("tunings?userId=")>=0){
                if(Constants.ALL_CARS_AND.length>0)
                    url+="&all=true"
            }

            if(path.indexOf("components/")>=0){
                url = Constants.API_URL_assets2 + path;
            }else if(path.indexOf("components")>=0 && path != "componentsInfo"){
                url+="&forSite=yes";
            } //вернуть
            if(path.indexOf("tuning/")==0){
                url = url+"?all=true&withDeleteds=true";
            }
            return url;
        }


        public function createRequest(url : String, method : String, params : Object, dontManageCookiesAnyway : Boolean = false) : URLRequest
		{
			var request : URLRequest = new URLRequest(url);
			
			request.manageCookies = isAuthRequest(request) || isUserSigned;

			request.requestHeaders.push(new URLRequestHeader("ACCEPT", "*/*"));

			
			request.userAgent = Capabilities.manufacturer;
			request.method = method;
			
			if(params is String)
			{
				request.data = params;
				request.contentType = "application/json";
			}
			else if(params)
			{
				var variables : URLVariables = new URLVariables(); 
				
				for(var key : String in params)
				{
					variables[key] = params[key];
				}
				
				request.data = variables;
			}
			return request;
		}
		
		private function isAuthRequest(request : URLRequest) : Boolean {
			return request.url.indexOf("accounts") != -1;
		}
		
		public function startRequest(request : URLRequest, cachePolicy : String, useErrorHandler : Boolean, resultHandler : Function, __dontShowErrorMessage : Boolean = false) : void
		{
			var httpRequestLoader : HttpRequestLoader = new HttpRequestLoader();
			trace(request.url);
			httpRequestLoader.start(request, function(success : Boolean, result : Object, responseHeader:Array=null) : void {
				removeUrlLoader(httpRequestLoader);
				
				if(!success) {
					if(request.method == URLRequestMethod.GET && cachePolicy == HttpCachePolicy.INTERNET_FIRST && httpCache.contains(request.url)) {
						httpCache.load(request.url, resultHandler);
					} else {
						var error : Object;
						var isJSON : Boolean = true;
						var isGeneralJSONError : Boolean = false;
						var code : String;
						
						try {
							error = JSONer.parse(result.errorText as String);
							
							if(error.error) {
								code = error.error;
								isGeneralJSONError = true;
							}
						}catch(ex : *) {
							isJSON = false;
							error = result.errorText as String;
						}
						
						if(!isJSON) {
							error = result.errorText;
						}else if(isGeneralJSONError) {
							var code_i : int = int(code);
							//if(code == "103"){
							language ||= Language.createInstance("en-US");
							if((code_i>=100) && (code_i<=200)){
								//signUp.invalid_username_password  
								error = language.translate("signUp", "invalid_username_password");//"Invalid email or username";
							}else{
								error = language.translate("errorCodes", code);
							}
						}
						
						lastErrorStatusCode = result.statusCode;
						var errorObj:Object;
						try{
							errorObj = JSON.parse(result.errorText);
						}catch (e:Error) {

						}
						if(lastErrorStatusCode == 400 && code_i == 103 && errorObj && errorObj.msg == 'duplicate_email'){
							result.success = false;
							result.errorMessage = "An account with this email already exists.";
							resultHandler(false, result);
						}else{
							resultHandler(false, error);
						}

						if(useErrorHandler && error is String && !__dontShowErrorMessage) {
							if (onError) {
								onError(error);
							}
						}
					}
				}else {
					if(cachePolicy != HttpCachePolicy.NONE) {
						httpCache.store(request.url, result as String);
					}

					try{
						resultHandler(success, result, responseHeader);
					}catch(e:Error){
						try{
							resultHandler(success, result);
						}catch(e:Error){
							Tracer.print("Error:"+e.getStackTrace()/*+" stack:"+e.getStackTrace()*/)
						}
					}
				}
			});
			
			httpRequestLoaders.push(httpRequestLoader);
		}
		
		
		
		private function removeUrlLoader(httpLoader : HttpRequestLoader) : void
		{			
			var index : int = httpRequestLoaders.indexOf(httpLoader);
			
			if(index >= 0)
			{
				httpRequestLoaders.splice(index, 1);
			}
		}
		
		public function cancelAllRequests(path : String = null) : void
		{
			trace("cancelAllRequests");
			var url : String = null;
			if(path)
			{
				url = urlForPath(path);
			}
			
			var indicesToRemove : Array = [];
			
			for(var i : int = 0; i < httpRequestLoaders.length; i++)
			{
				var httpLoader : HttpRequestLoader = httpRequestLoaders[i];
				
				if(!url || url == httpLoader.urlRequest.url)
				{
					httpLoader.cancel();
					indicesToRemove.push(i);
				}
			}
			
			for each(var index : int in indicesToRemove) 
			{
				httpRequestLoaders.splice(index, 1);
			}
		}
	}
}


