package com.despark.tuning3d.model.core.http {
    import feathers.core.FeathersControl;

    import flash.display.Loader;
    import flash.events.Event;
    import flash.events.HTTPStatusEvent;
    import flash.events.IEventDispatcher;
    import flash.events.IOErrorEvent;
    import flash.net.URLRequest;

    public class URLLoadCheck extends FeathersControl {
        public static const NOT_FOUND:String = "url_notFound";
        public static const FOUND:String = "url_found";
        private var _loader:Loader;
        private var _url:String;
        public function URLLoadCheck(url:String) {
            super();
            _url = url;
            _loader = new Loader();
            configureListeners(_loader.contentLoaderInfo);

            var request:URLRequest = new URLRequest(_url);
            _loader.load(request);
        }

        private function configureListeners(dispatcher:IEventDispatcher):void {
            dispatcher.addEventListener(Event.COMPLETE, completeHandler);
            dispatcher.addEventListener(HTTPStatusEvent.HTTP_STATUS, httpStatusHandler);
            dispatcher.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
        }
        private function removeListeners(dispatcher:IEventDispatcher):void {
            dispatcher.removeEventListener(Event.COMPLETE, completeHandler);
            dispatcher.removeEventListener(HTTPStatusEvent.HTTP_STATUS, httpStatusHandler);
            dispatcher.removeEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
        }

        public function close():void{
            return;
            if(_loader){
                try{
                    _loader.close();
                    _loader.unload();
                }catch (e:Error) {

                }
                removeListeners(_loader.contentLoaderInfo);
                _loader = null;
            }
            dispose();
        }

        private function completeHandler(event:Event):void {
            trace("completeHandler: " + _url);
        }

        private function httpStatusHandler(event:HTTPStatusEvent):void {
            if(event.status == 404){
                dispatchEventWith(NOT_FOUND, false, {url: _url});
                close();
            }else if(event.status == 200){
                dispatchEventWith(FOUND, false, {url: _url});
                close();
            }
        }

        private function ioErrorHandler(event:IOErrorEvent):void {
            trace("ioErrorHandler: " + _url);
        }

        private function openHandler(event:Event):void {
            trace("openHandler: " + _url);
        }
    }
}
