package com.despark.tuning3d.model.core.http.caching
{
	import com.despark.tuning3d.model.core.http.HttpRequestLoader;
	
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.net.URLRequest;

	public class HttpFileCache implements HttpCache
	{
		private var cacheDirectory : File;
		private var httpRequestLoader : HttpRequestLoader;
		
		public var cacheDirectoryHandler : Function;
		
		public function HttpFileCache(directory : File)
		{
			super();
			
			cacheDirectory = directory;
			
			cacheDirectoryHandler = function(remoteUrl : String) : File 
			{
				return cacheDirectory;
			}
		}
		
		public function contains(remoteUrl : String) : Boolean
		{
			return getCachedFile(remoteUrl).exists;
		}
		
		public function store(url : String, data : String) : void
		{
			try {
                var file:File = getCachedFile(url);
                var fileStream:FileStream = new FileStream();

                fileStream.open(file, FileMode.WRITE);
                fileStream.writeUTFBytes(data);

                fileStream.close();
            }
			catch(e:Error){

			}
		}
		
		private function getCachedFile(remoteUrl : String) : File
		{
			var file:File = cacheDirectoryHandler(remoteUrl).resolvePath(remoteUrl + ".cache");
			file.preventBackup = true;
			return file;
		}
		
		public function cachedFile(remoteUrl : String) : File   
		{
			var file:File = cacheDirectoryHandler(remoteUrl).resolvePath(remoteUrl + ".cache");
			file.preventBackup = true;
			return file;
		}

		
		public function load(remoteUrl : String, resultHandler : Function) : void
		{
			var localFile : File = getCachedFile(remoteUrl);
						
			httpRequestLoader = new HttpRequestLoader();
			httpRequestLoader.start(new URLRequest(localFile.url), resultHandler);
		} 
		
		public function clean() : void
		{
			
		}
	}
}