package com.despark.tuning3d.model.core.images
{
	import com.despark.tuning3d.model.core.Constants;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.system.ImageDecodingPolicy;
	import flash.system.LoaderContext;
	import flash.utils.ByteArray;
	
	

	public class DASBitmapDataLoader
	{
		private static const LOADER_CONTEXT:LoaderContext = new LoaderContext(true);
		LOADER_CONTEXT.imageDecodingPolicy = ImageDecodingPolicy.ON_LOAD;
		LOADER_CONTEXT.checkPolicyFile = false;
		
		private var url: String;
		private var comlete_fun: Function;
		
		protected var urlLoader : URLLoader;
		protected var loader : Loader;
		
		public function DASBitmapDataLoader()
		{
		}
		
		
		public function download(__url : String, __complete : Function): void
		{
			url = __url;
			comlete_fun = __complete;
			
			
			
			urlLoader = new URLLoader();
			urlLoader.dataFormat = URLLoaderDataFormat.BINARY;
			urlLoader.addEventListener(flash.events.Event.COMPLETE, urlLoader_completeHandler);
			urlLoader.addEventListener(IOErrorEvent.IO_ERROR, urlLoader_errorHandler);
			urlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoader_errorHandler);
			
			var request : URLRequest = new URLRequest(url);
			request.idleTimeout = Constants.IMAGE_REQUESTS_TIMEOUT;
			
			urlLoader.load(request);
		}
		
		public function cancel() : void
		{
			if(urlLoader)
			{
				urlLoader.removeEventListener(flash.events.Event.COMPLETE, urlLoader_completeHandler);
				urlLoader.removeEventListener(IOErrorEvent.IO_ERROR, urlLoader_errorHandler);
				urlLoader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, urlLoader_errorHandler);
				
				try
				{
					urlLoader.close();
				}
				catch(error : Error)
				{
					//no need to do anything in response
				}
				
				urlLoader = null;
			}
			
			if(loader) 
			{
				loader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, loaderCompleteHandler);
				loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, loaderErrorHandler);
				
				try
				{
					loader.close();
				}
				catch(error : Error)
				{
					//no need to do anything in response
				}
				
				loader = null;
			}
		}
		
		protected function urlLoader_completeHandler(event:flash.events.Event):void
		{
			var imageBytes : ByteArray = urlLoader.data;
			cancel();
			
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loaderCompleteHandler);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loaderErrorHandler);
			loader.loadBytes(imageBytes, LOADER_CONTEXT);
			
		}
		
		private function loaderCompleteHandler(event : Event) : void
		{
			var bitmap : Bitmap = Bitmap(loader.content);
			
			
			comlete_fun(bitmap,url);		
			cancel();
		}
		
		private function loaderErrorHandler(event : IOErrorEvent) : void
		{
			comlete_fun(null,url);
			cancel();
		}
		
		protected function urlLoader_errorHandler(event:flash.events.ErrorEvent):void
		{	
			comlete_fun(null,url);
			cancel();			
		}
		
		
		
		
	}
}