package com.despark.tuning3d.model.mails
{
    import by.blooddy.crypto.serialization.JSONer;

    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.http.HttpClient;
    import com.despark.tuning3d.model.core.http.caching.HttpCachePolicy;

    import flash.net.URLRequestMethod;

    import org.puremvc.as3.patterns.proxy.Proxy;

    public class MailsProxy extends Proxy {
    public static const NAME:String = "MailsProxy";
    public var httpClient:HttpClient;
    public function MailsProxy(){
        super(NAME);
    }

    public function loadMails(skip:int = 0, limit:int = 10):void {
        var url : String = "http://friends.3dtuning.com/api/v1/messages/interlocutors?limit=" + limit .toString() + "&skip=" + skip.toString();
        var params : Object = {};
        httpClient.loadPath("", URLRequestMethod.GET, params, HttpCachePolicy.NONE,true,function(success:Boolean,result:Object):void {
            if(success) {
                var mailsJSON : Object = JSONer.parse(String(result));
                sendNotification(Notifications.MAILS_LOADED, {mails: mailsJSON});
            } else {
                sendNotification(Notifications.MAILS_LOADING_FAILED);
            }
        },url);
    }

    public function loadUserMessages(userId:String, skip:int = 0, limit:int = 10, isPushing:Boolean = true):void {
        var url : String = "http://friends.3dtuning.com/api/v1/messages/" + userId + "?limit=" + limit .toString() + "&skip=" + skip.toString();
        var params : Object = {};
        httpClient.loadPath("", URLRequestMethod.GET, params, HttpCachePolicy.NONE,true,function(success:Boolean,result:Object):void {
            if(success) {
                var mailsJSON : Object = JSONer.parse(String(result));
                sendNotification(Notifications.USER_MAILS_LOADED, {messages: mailsJSON, isPushing:isPushing});
                makeReadMessage(userId);
            } else {
                sendNotification(Notifications.USER_MAILS_LOAD_FAILED);
            }
        },url);
    }



        public function makeReadMessage(userId:String):void {
            var url : String = "http://friends.3dtuning.com/api/v1/messages/" + userId;
            httpClient.putPath("", null, function(success:Boolean,result:Object):void {
                if(success) {
                    sendNotification(Notifications.MAIL_READ_SUCCESS);
                } else {
                    sendNotification(Notifications.MAIL_READ_FAIL);
                }
            },url);
        }

        public function getUnreadCount(completeFunction:Function):void{
            var url:String = "http://friends.3dtuning.com/api/v1/messages/unread";
            httpClient.getPath(url, null,function(success:Boolean,result:Object):void {
                if(success) {
                    var obj : Object = JSONer.parse(result);
                    Constants.UNREAD_EMAILS = obj.unread;
                    completeFunction(obj.unread);
                } else {

                }
            });
        }

        public function deleteMessage(messageId:String):void {
            var url : String = "http://friends.3dtuning.com/api/v1/messages/" + messageId;
            httpClient.deletePath("", null, function(success:Boolean,result:Object):void {
                if(success) {
                    sendNotification(Notifications.MAIL_DELETE_SUCCESS);
                } else {
                    sendNotification(Notifications.MAIL_DELETE_FAIL);
                }
            },url);
        }

        public function sendMessageTo(userId:String, message:String, images:Array = null):void{
            var url : String = "http://friends.3dtuning.com/api/v1/messages/" + userId;
            var params : Object = {"id":userId, "text":message};
            if(images){
                var urls : Array = [];
                for(var i : int = 0; i < images.length; i ++){
                    var imageUrlToPost : String = images[i].url;
                    if(imageUrlToPost){
                        urls.push(imageUrlToPost);
                    }
                }
                if(urls.length){
                    if(!params.metadata){
                        params.metadata = [];
                    }
                    params.metadata.push({
                        type: 'images',
                        photos: urls
                    });
                }
            }

            httpClient.postPath("", JSONer.stringify(params), function(success:Boolean,result:Object):void {
                if(success) {
                    var resultData:Object;
                    if(result is String){
                        resultData = JSON.parse(result as String);
                    }else if(result is Object){
                        resultData = result;
                    }
                    sendNotification(Notifications.MAIL_SEND_SUCCESS, resultData);
                } else {
                    sendNotification(Notifications.MAIL_SEND_FAILED);
                }
            }, url);
        }
}
}