package com.despark.tuning3d.model.parts {
    public class PartMaterialImagePool {
        private static const _instanceList:Array = [];
        public static function getInstance(aUrl : String, index : String, __material3dtProvider : Material3dtProvider, material:PartMaterial):PartMaterialImage{
            var result:PartMaterialImage;
            if(_instanceList.length){
                result = _instanceList.pop() as PartMaterialImage;
                result.parentMaterial = material;
                if(index){
                    result.frameIndex = int(index);
                    result.x = 0;
                    result.y = 0;
                }else if(aUrl) {
                    result.initWithUrl(aUrl);
                }
                return result;
            }
            return new PartMaterialImage(aUrl, index, __material3dtProvider, material);
        }

        public static function holdInstance(value:PartMaterialImage):void{
            value.parentMaterial = null;
            value.x = value.y = value.frameIndex = 0;
            _instanceList.push(value);
        }

        public static function clearAll():void {
            while (_instanceList.length){
                _instanceList.pop();
            }
        }
    }
}
