package com.despark.tuning3d.model.rewards {
    import com.utils.ObjectUtils;

    import flash.utils.Proxy;
    import flash.utils.flash_proxy;

    dynamic public class DailyRewardsData extends Proxy{
        private var _day:int;
        private var _diamonds:int;
        private var _keys:int;
        private var _carId:String;
        private var _carType:String;
        private var _rewardsMultiplier:Number;
        private static const _dailyRewardsList:Vector.<DailyRewardsData> = new <DailyRewardsData>[];
        private var _length:uint;
        //
        private var _properties:Array = [];
        private var _source:Object;
        public function DailyRewardsData(value:Object, archiveSource:Boolean = false) {
            if(archiveSource){
                _source = value;
            }
            _day = ObjectUtils.getValue(value, "day", 0);
            _diamonds = ObjectUtils.getValue(value, "bonus.diamond", 0);
            _keys = ObjectUtils.getValue(value, "bonus.key", 0);
            _carType = ObjectUtils.getValue(value, "bonus.carType", null);
            if(_carType == "S.SPORT"){
                _carType = "S. SPORT";
            }
            _rewardsMultiplier = ObjectUtils.getValue(value, "bonus.multiplier", 0);
            _carId = ObjectUtils.getValue(value, "bonus.carId", null);
            if(_diamonds){
                _length++;
                _properties.push("diamonds");
            }
            if(_keys){
                _length++;
                _properties.push("keys");
            }
            if(_carType){
                _length++;
                _properties.push("carType");
            }
            if(_carId){
                _length++;
                _properties.push("carId");
            }
            if(_rewardsMultiplier){
                _length++;
                _properties.push("rewardsMultiplier");
            }
        }

        override flash_proxy function getProperty(name:*):* {
            return _properties[name];
        }

        override flash_proxy function hasProperty(name:*):Boolean{
            return (_properties.indexOf(name) != -1);
        }

        override flash_proxy function nextNameIndex (index:int):int {
            if (index < _properties.length) {
                return index + 1;
            } else {
                return 0;
            }
        }
        override flash_proxy function nextName(index:int):String {
            return _properties[index - 1];
        }

        public function get day():int {
            return _day;
        }

        public function get diamonds():int {
            return _diamonds;
        }

        public function get keys():int {
            return _keys;
        }

        public function get carId():String {
            return _carId;
        }

        public function get carType():String {
            return _carType;
        }

        public function get rewardsMultiplier():Number {
            return _rewardsMultiplier;
        }

        public static function loadRewardsList(value:Array):void{
            for(var i:int = 0; i < value.length; i++){
                _dailyRewardsList.push(new DailyRewardsData(value[i]))
            }
        }

        public static function getRewardsData(index:int):DailyRewardsData {
            if(_dailyRewardsList && index >=0 && index < _dailyRewardsList.length){
                return _dailyRewardsList[index];
            }
            return null;
        }

        public static function get dailyRewardsList():Vector.<DailyRewardsData> {
            return _dailyRewardsList;
        }

        public function get length():uint {
            return _length;
        }

        public function get source():Object {
            return _source;
        }
    }
}
