package com.despark.tuning3d.model.sharing
{
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.http.HttpClient;
	import com.despark.tuning3d.model.settings.SettingsProxy;
	import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.components.core.AlertView;
import com.distriqt.FacebookManager;
import com.org.iotashan.utils.URLEncoding;
	import com.utils.Tracker;

	import flash.data.EncryptedLocalStore;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.events.ErrorEvent;
import flash.events.IOErrorEvent;
import flash.events.LocationChangeEvent;
import flash.geom.Rectangle;
import flash.media.StageWebView;
import flash.net.URLRequest;
import flash.net.URLVariables;
import flash.net.navigateToURL;
import flash.utils.ByteArray;

import org.puremvc.as3.patterns.proxy.Proxy;

import ru.inspirit.net.MultipartURLLoader;

public class SharingProxy extends Proxy
	{
		public static var LAST_USER_PAGE:String=null;
		public static var FB_URL_AUTH:String = 'https://www.facebook.com/dialog/oauth?client_id='+ 
			Constants.FACEBOOK_APP_ID_SHARE +'&redirect_uri=fb'+ Constants.FACEBOOK_APP_ID_SHARE +
			'://authorize&scope=user_birthday,read_stream,publish_stream,publish_actions&response_type=token';
		
		public static const NAME : String = "SharingProxy";
		public var logoBitmap : Bitmap;
		
		private var access_token: String;
		public var Preparing:Boolean = false;
		
		//private var facebook : Facebook;
		private var currentBitmapData : BitmapData;
		private var multipartURLLoader : MultipartURLLoader;
		
		private var alertView:AlertView;
		
		public var screenScale : int;
		
		private var _webView:StageWebView=null;

		public static var TUNING_FOR_SHARE : Tuning;
		
		public function SharingProxy()
		{
			super(NAME);
		}

        public static function generateURLForFbShare( user : User, languageCode : String) : void {
			if(!TUNING_FOR_SHARE || !languageCode) {
				AlertView.show("Sharing failed");
				return;
			}
            var car : Car = TUNING_FOR_SHARE.car;
			var tuningUsername:String;
			if(TUNING_FOR_SHARE && TUNING_FOR_SHARE.userObj && TUNING_FOR_SHARE.userObj.hasOwnProperty("username") && TUNING_FOR_SHARE.userObj.username){
				tuningUsername = TUNING_FOR_SHARE.userObj.username;
			}else {
				tuningUsername = user.username;
			}
            var sharingURL : String = "http://www.3dtuning.com/" + languageCode + "/" + tuningUsername + "/" + car.name + "/" + car.model + "/" + car.type;
			if(car.body && car.body.length) {
				sharingURL +=  "-" + car.body;
			}

			sharingURL+= "." + car.year + "/";
            //sharingURL+= user != null ? user.username : "3DT-Share-4";
            sharingURL+= TUNING_FOR_SHARE.shortId;
            var reg : RegExp = /\s/g;
			sharingURL = sharingURL.replace(reg, '.');
			if(FacebookManager.$.isLoggedIn()) {
				FacebookManager.$.shareURL(sharingURL);
				Tracker.trackEvent("Tuning", "share", "facebook");
			} else {
				FacebookManager.$.login(function (obj : Object) : void {
					FacebookManager.$.shareURL(sharingURL);
					Tracker.trackEvent("Tuning", "share", "facebook");
                });
			}
        }

		public static function shareUrlOnFacebook(url:String) : void {
			HttpClient.TOKEN = null;
			SharingProxy.LAST_USER_PAGE = null;
			if(FacebookManager.$.isLoggedIn()) {
				FacebookManager.$.shareURL(url);
			} else {
				FacebookManager.$.login(function (obj : Object) : void {
					FacebookManager.$.shareURL(url);
                });
			}
        }

		/*public static function shareUrlOnInstagram(url:String) : void {
			if(SharingInstagramProxy.$.isLoggedIn()) {
				FacebookManager.$.shareURL(url);
				FacebookManager.$.shareURL(url);
			} else {
				FacebookManager.$.login(function (obj : Object) : void {
					FacebookManager.$.shareURL(url);
                });
			}
        }*/
		
		public function prepare() : void {
			var userProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
			SharingProxy.generateURLForFbShare(userProxy.currentUser, settingsProxy.currentSettings.selectedLanguageCode)
			return;




			if(access_token){
				getNextData();   
				return;
			}
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.loginThroughSN = UsersProxy.typeOfSN_shareInFB;
			Preparing = true;
			if(EncryptedLocalStore.isSupported){
				var byte:ByteArray=EncryptedLocalStore.getItem("fb_share_data");
				if(byte){
					var object:Object=byte.readObject();
					//if(object.loginThroughSN==UsersProxy.typeOfSN_shareInFB){
					//trace("USE SCHEMES FB TOKEN:", JSON.stringify(object));
						if(object.hasOwnProperty("current_time") && object.hasOwnProperty("expires_in")){
							var now_time:int=(new Date().valueOf()/1000);
							if(now_time<int(object.current_time)+int(object.expires_in-86400)){
								var urlVars:URLVariables=new URLVariables();
								for(var key:String in object){
									urlVars[key]=object[key];
								}
								//trace("USE SCHEMES FB TOKEN:", JSON.stringify(object));
								Tuning3D.handleInvoke(object.loginThroughSN, urlVars );
								return;
							}
						}
						
					//}else{
						
					//	handleSNlogged(object);
					//	return;
				//	}
					
				}
				
			}
			// userVkView  = UserVkView.show(VK_URL_AUTH,sharing_ready,sharing_preparing_error,sharing_photo_uploaded,sharing_photo_uploaded_error);
			
			
			
			
			//if(!Device.isIos()){
			
			//	navigateToURL(new URLRequest(FB_URL_AUTH));
			
			//}else{

				
			alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
			
			if(_webView){
				_webView.dispose();
				_webView=null;
			}
			
			_webView=new StageWebView(true);
			
			_webView.viewPort=new Rectangle(0,0, Constants.STAGE.stageWidth, Constants.STAGE.stageHeight);
			
			
			_webView.addEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewFBLocationChange);
			
			_webView.addEventListener(ErrorEvent.ERROR, onWebViewFBError);
			
			_webView.loadURL(FB_URL_AUTH);
			//}
			
		
		}
		
		protected function onWebViewFBLocationChange(event:LocationChangeEvent):void{
			
			//trace("locationChange:", _webView.location);
			
			if(_webView.location.indexOf("https://m.facebook.com/login.php")>=0 ||
				_webView.location.indexOf("/dialog/oauth?redirect_uri")>=0
			){
				
				_webView.stage=Constants.STAGE;
				
				
			}
			
			
		}
		
		protected function onWebViewFBError(event:ErrorEvent):void{
			
			//trace("error:", event.text);
			
			if(event.text.indexOf("fb"+Constants.FACEBOOK_APP_ID_SHARE+"://")>=0){
				
				var startIndex:int=event.text.indexOf("fb"+Constants.FACEBOOK_APP_ID_SHARE+"://");
				
				var url:String=event.text.substr(startIndex);
				
				var seporator:String="?";
				
				if(url.indexOf(seporator)<=0){
					
					seporator="#";
				}
				
				var mas:Array=url.split(seporator);
				
				
				
				if(mas && mas.length>1){
					
					_webView.removeEventListener(ErrorEvent.ERROR, onWebViewFBError);
					_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewFBLocationChange);
					
					_webView.stage=null;
					
					_webView.dispose();
					_webView=null;
					
					
					url=mas[1];
					
					var urlVars:URLVariables=new URLVariables(url);
					
					if(urlVars.hasOwnProperty("error") || urlVars.hasOwnProperty("error_code") ){
						Tuning3D.resetLogin();
						
						if(alertView){
							alertView.hide();
							alertView=null;
						}
					}else{
						if(alertView){
							alertView.hide();
							alertView=null;
						}
						
						var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;  
						
						var object:Object={};
						for(var key:String in urlVars){
							
							object[key]=urlVars[key];
						}
						
						object.loginThroughSN=usersProxy.loginThroughSN;
						var now_time:int=(new Date().valueOf()/1000);
						object.current_time=now_time;
						
						if(EncryptedLocalStore.isSupported){
							
							var byte:ByteArray=new ByteArray();
							
							byte.writeObject(object);
							
							EncryptedLocalStore.setItem("fb_share_data", byte);
						}
						
						Tuning3D.handleInvoke(usersProxy.loginThroughSN, urlVars);
						
						
					
					}
					
					
				}else{
					
					if(alertView){
						alertView.hide();
						alertView=null;
					}
					
					_webView.removeEventListener(ErrorEvent.ERROR, onWebViewFBError);
					_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewFBLocationChange);
					
					_webView.stage=null;
					
					_webView.dispose();
					_webView=null;
					
					AlertView.show("Error", -1, false);
					
					Tuning3D.resetLogin();
					
				}
				
				
			}else{
				
				if(alertView){
					alertView.hide();
					alertView=null;
				}
				
				_webView.removeEventListener(ErrorEvent.ERROR, onWebViewFBError);
				_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewFBLocationChange);
				
				_webView.stage=null;
				
				_webView.dispose();
				_webView=null;
				
				AlertView.show("Error", -1, false);
				
				Tuning3D.resetLogin();
			}
		}
		
		
		
		
		public function finish_autorize(__access_token: String) : void
		{
			//if(!Preparing)return;
			Preparing = false;
			access_token = __access_token;
			
			
			getNextData();
			
			
		}
		
		private function getNextData(): void {
			
			if(access_token){
				sendNotification(Notifications.SHARING_READY,null);
			}else{
				sendNotification(Notifications.SHARING_PREPARING_ERROR, null);
			}
			
			
		}
		
//		private function basicInfoGranted(success : Boolean, userCancelled : Boolean, error : String = null):void
//		{		
//			if(success)
//			{
//				//facebook.openSessionWithPublishPermissions(["publish_stream"], sessionCreatedOpenedHandler, false);
//				facebook.openSessionWithPublishPermissions(["publish_actions"], sessionCreatedOpenedHandler, false);
//			}
//			else if(!userCancelled)
//			{
//				facebook.closeSessionAndClearTokenInformation();
//				sendNotification(Notifications.SHARING_PREPARING_ERROR, error);
//			}
//		}
//		
//		private function sessionCreatedOpenedHandler(success : Boolean, userCancelled : Boolean, error : String = null):void
//		{			
//			if(success)
//			{
//				sendNotification(Notifications.SHARING_READY,null);
//			}
//			else if(!userCancelled)
//			{
//				facebook.closeSessionAndClearTokenInformation();
//				sendNotification(Notifications.SHARING_PREPARING_ERROR, error);
//			}
//		}
		
		private var alertViewOfFB : AlertView = null;
		
		private var _completeSharePhoto:Function=null;
		
		private function loginHandler(p1, p2) :void{
			
			if(p1 && p1.user && p1.user.link){
				
				LAST_USER_PAGE=p1.user.link;
			}

		}
		
		private function testcallback():void
		{
			// TODO Auto Generated method stub
			
		}
		
		private function multipartURLLoaderCompleteHandler(p1, p2) : void
		{
			if(_completeSharePhoto){
				
				_completeSharePhoto();
				_completeSharePhoto=null;
			}
			
			if(alertViewOfFB)alertViewOfFB.hide();
			alertViewOfFB = null;
			multipartURLLoader = null;
			sendNotification(Notifications.SHARING_PHOTO_UPLOADED);
		}
		
		private function multipartURLLoaderIoErrorHandler(event : IOErrorEvent) : void
		{
			if(_completeSharePhoto){
				
				_completeSharePhoto();
				_completeSharePhoto=null;
			}
			
			
			if(alertViewOfFB)alertViewOfFB.hide();
			alertViewOfFB = null;
			multipartURLLoader = null;
			access_token = null;
			sendNotification(Notifications.SHARING_PHOTO_UPLOADING_ERROR);
			
		}
		
		private function multipartURLLoaderIoSecurityErrorHandler(event : IOErrorEvent) : void
		{
			multipartURLLoader = null;
			access_token = null;
			sendNotification(Notifications.SHARING_PHOTO_UPLOADING_ERROR);
		}
		
		public function endUpload() : void
		{
			try
			{
				multipartURLLoader.close();
			}
			catch(error : *) {}
			
			multipartURLLoader = null;
		}
	}
}