package com.despark.tuning3d.view
{
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.sharing.SharingVkProxy;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.model.users.UsersProxy;
	import com.despark.tuning3d.view.components.auth.AuthScreen;
	import com.despark.tuning3d.view.components.auth.LoginScreen;
import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.CustomAlertView;
	import com.despark.tuning3d.view.components.core.StackedScreen;
	import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
	import com.despark.tuning3d.view.core.StackedScreenMediator;
	import com.distriqt.AdsManager;
	import com.distriqt.FacebookManager;
	import com.distriqt.GameServiceManager;
	import com.distriqt.extension.applesignin.AppleSignIn;
	import com.distriqt.extension.applesignin.AppleSignInOptions;
	import com.distriqt.extension.applesignin.AppleSignInScopes;
	import com.distriqt.extension.applesignin.events.AppleSignInErrorEvent;
	import com.distriqt.extension.applesignin.events.AppleSignInEvent;
	import com.org.iotashan.oauth.OAuthConsumer;
import com.org.iotashan.oauth.OAuthRequest;
import com.org.iotashan.oauth.OAuthSignatureMethod_HMAC_SHA1;
import com.org.iotashan.oauth.OAuthToken;
import com.org.iotashan.utils.OAuthUtil;
import com.utils.ArrayUtil;

import feathers.events.FeathersEventType;

import flash.data.EncryptedLocalStore;
import flash.events.ErrorEvent;
import flash.events.IOErrorEvent;
import flash.events.LocationChangeEvent;
import flash.events.StatusEvent;
import flash.geom.Rectangle;
import flash.media.StageWebView;
import flash.net.URLLoader;
import flash.net.URLRequest;
import flash.net.URLVariables;
import flash.utils.ByteArray;

import org.puremvc.as3.interfaces.INotification;

import starling.events.Event;
	import starling.textures.Texture;

	public class LoginScreenMediator extends StackedScreenMediator
	{		
		
		private var _webView:StageWebView=null;
		
		public function LoginScreenMediator(stackedScreen : StackedScreen)
		{
			super(stackedScreen);
			
			//Tuning3D.memLeakTest.addEventListener(MemLeakTest.GLOBAL_EVENT, onGlobalEventMemLeakTest2,false, 0, true);
		}
		
		protected function onGlobalEventMemLeakTest2(event:*):void{
			
		}
		
		public function get loginScreen() : LoginScreen
		{
			return stackedScreen as LoginScreen;
		}
		
		override public function onRegister() : void
		{
			super.onRegister();

			stackedScreen.addEventListener(FeathersEventType.INITIALIZE, loginScreenInitializeHandler);
			stackedScreen.addEventListener(LoginScreen.REGISTER_SELECTED, loginScreenRegisterSelectedHandler);
			stackedScreen.addEventListener(LoginScreen.USERNAME_CHANGED, loginScreenUsernameChangedHandler);
			stackedScreen.addEventListener(LoginScreen.PASSWORD_CHANGED, loginScreenPasswordChangedHandler);
			stackedScreen.addEventListener(LoginScreen.LOGIN_SELECTED, loginScreenLoginSelectedHandler);
			stackedScreen.addEventListener(LoginScreen.PASSWORD_RESET_SELECTED, loginScreenPasswordResetSelectedHandler);
			stackedScreen.addEventListener(LoginScreen.BACK_BUTTON_SELECTED, loginScreenBackButtonSelectedHandler);

			stackedScreen.addEventListener(AuthScreen.GAME_SERVICE_LOGIN_SELECTED, gameServiceLoginScreenLoginSelectedHandler);
			stackedScreen.addEventListener(AuthScreen.FB_LOGIN_SELECTED, FbLoginScreenLoginSelectedHandler);
			stackedScreen.addEventListener(AuthScreen.TW_LOGIN_SELECTED, TwLoginScreenLoginSelectedHandler);
			stackedScreen.addEventListener(AuthScreen.APPLE_LOGIN_SELECTED, AppleLoginScreenLoginSelectedHandler);

			stackedScreen.addEventListener(LoginScreen.CLOSE_WEBVIEW, closeWebviewSelectedHandler);

			AdsManager.$.bannerHide();
		}
		
		override public function onRemove() : void
		{
			super.onRemove();

			stackedScreen.removeEventListener(FeathersEventType.INITIALIZE, loginScreenInitializeHandler);
			stackedScreen.removeEventListener(LoginScreen.REGISTER_SELECTED, loginScreenRegisterSelectedHandler);
			stackedScreen.removeEventListener(LoginScreen.USERNAME_CHANGED, loginScreenUsernameChangedHandler);
			stackedScreen.removeEventListener(LoginScreen.PASSWORD_CHANGED, loginScreenPasswordChangedHandler);
			stackedScreen.removeEventListener(LoginScreen.LOGIN_SELECTED, loginScreenLoginSelectedHandler);
			stackedScreen.removeEventListener(LoginScreen.PASSWORD_RESET_SELECTED, loginScreenPasswordResetSelectedHandler);
			stackedScreen.removeEventListener(LoginScreen.BACK_BUTTON_SELECTED, loginScreenBackButtonSelectedHandler);

			stackedScreen.removeEventListener(AuthScreen.GAME_SERVICE_LOGIN_SELECTED, gameServiceLoginScreenLoginSelectedHandler);
			stackedScreen.removeEventListener(AuthScreen.FB_LOGIN_SELECTED, FbLoginScreenLoginSelectedHandler);
			stackedScreen.removeEventListener(AuthScreen.TW_LOGIN_SELECTED, TwLoginScreenLoginSelectedHandler);
			stackedScreen.removeEventListener(AuthScreen.APPLE_LOGIN_SELECTED, AppleLoginScreenLoginSelectedHandler);

			stackedScreen.removeEventListener(LoginScreen.CLOSE_WEBVIEW, closeWebviewSelectedHandler);

			stackedScreen.removeFromParent(true);
			
			//viewComponent=null;
		}
		
		public override function listNotificationInterests() : Array 
		{
            return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
				Notifications.USER_LOGGED_IN,
				Notifications.USER_LOGIN_FAILED,
				Notifications.SN_USER_LOGGED_IN,
				Notifications.APPLICATION_BECAME_ACTIVE,
				Notifications.OPEN_FACEBOOK_LOGIN_DIALOG
			]);
		}
		
		public override function handleNotification(note : INotification) : void
		{
			switch(note.getName())
			{
				case Notifications.SN_USER_LOGGED_IN:
					handleSNlogged(note.getBody());
					break;
				case Notifications.USER_LOGGED_IN:    
					handleUserLoggedIn();
					break;
				
				case Notifications.USER_LOGIN_FAILED:
					handleUserLoginFailed("Incorrect username or password");
					break;
				
				case Notifications.USER_LOGGED_OUT:
					handleUserLoggedOut();
					break;
				
				case Notifications.APPLICATION_BECAME_ACTIVE:{
					
					handleApplicationBecameActive();
				}
					break;
				case Notifications.OPEN_FACEBOOK_LOGIN_DIALOG:{
					handleOpenFacebookLoginDialog();
				}
			}
			
			super.handleNotification(note);
		}
		
		private function handleApplicationBecameActive() : void
		{
			//if(Device.isIos())
			return;
			
			
			if(this.loginScreen){
				
				loginScreen.invalidate();
			}
		}
		
		private function handleUserLoggedIn() : void {
			hideAlert();
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			if(usersProxy.loginThroughSN == UsersProxy.typeOfSN_GS){
				GameServiceManager.instance.loadUserIcon();
				GameServiceManager.instance.iconCompleteCallback = function(texture:Texture):void{
					UserCircularAvatar.setIconTexture(usersProxy.currentUser.id, texture);
				}
			}
		}
		
		private function handleUserLoginFailed(errorText : String) : void {
			hideAlert();
			SoundManager.playSound(SoundManager.DISABLED_PART);
			/*CustomAlertView.show(errorText, "Close", null, null, function():void{
				if(loginScreen){
					loginScreen.setLoginButtonEnabled(true);
				}
			});*/

			CustomAlertView.show(errorText, {label: "Close", isDefault:true, callback: function():void{
					if(loginScreen){
						loginScreen.setLoginButtonEnabled(true);
					}
				}});
		} 
		
		private function loginScreenRegisterSelectedHandler(event : Event) : void {
			if(stackedScreen is LoginScreen){
				sendNotification(Notifications.DISPLAY_REGISTER_SCREEN);
			}
		}
		
		private function loginScreenInitializeHandler(event : Event) : void {
			if(loginScreen){
				loginScreen.setLoginButtonEnabled(false);
			}
		}
		
		private function loginScreenUsernameChangedHandler(event : Event) : void
		{
			updateLoginButton();
		}
		
		private function loginScreenPasswordChangedHandler(event : Event) : void
		{
			
			updateLoginButton();
		}
		
		private function updateLoginButton() : void {
			if(loginScreen){
				var enabled : Boolean = loginScreen.username.length > 0 && loginScreen.password.length > 0;
				loginScreen.setLoginButtonEnabled(enabled);
			}
		}
		
		private function closeWebviewSelectedHandler(event:Event):void{
			closeWebview();
		}

		private function appleSignSuccessHandler( event:AppleSignInEvent ):void {
			var data: Object = {};
			if (event.appleIdCredential.fullName) {
				data.name = event.appleIdCredential.fullName.toString();
			}

			if (event.appleIdCredential.email) {
				data.email = event.appleIdCredential.email;
			}

			if (event.appleIdCredential.accessToken) {
				data.token = event.appleIdCredential.accessToken;
			}

			if (event.appleIdCredential.authorizationCode) {
				data.code = event.appleIdCredential.authorizationCode;
			}

			if (event.appleIdCredential.clientSecret) {
				data.secret = event.appleIdCredential.clientSecret;
			}

			if (event.appleIdCredential.user) {
				data.user = event.appleIdCredential.user;
			}

			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.login(null, null, data, 'accounts/signin/apple')

		}

		private function appleSignErrorHandler( event:AppleSignInErrorEvent ):void
		{
			AlertView.show(event.text + ' = ' + event.errorID);
		}

		private function VkLoginScreenLoginSelectedHandler(event : Event) : void {
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.loginThroughSN = UsersProxy.typeOfSN_VK;
			if(EncryptedLocalStore.isSupported){
				var byte:ByteArray=EncryptedLocalStore.getItem("vkdata");
				if(byte){
					var object:Object=byte.readObject();
					handleSNlogged(object);
					return;
				}

			}


			//if(!Device.isIos()){

			//	navigateToURL(new URLRequest(SharingVkProxy.VK_URL_LOGIN));

			//}else{


			hideAlert();

			alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);

			if(_webView){
				_webView.dispose();
				_webView=null;
			}

			_webView=new StageWebView(true);
			var viewPortPaddingTop:Number = 80*(Constants.SCALE_FACTOR/2);
			_webView.viewPort=new Rectangle(0,viewPortPaddingTop, Constants.STAGE.stageWidth, Constants.STAGE.stageHeight-viewPortPaddingTop);


			_webView.addEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewVKLocationChange);

			_webView.addEventListener(ErrorEvent.ERROR, onWebViewVKError);

			_webView.loadURL(SharingVkProxy.VK_URL_LOGIN);

			//}
			
			
		}
		

		private function gameServiceLoginScreenLoginSelectedHandler(event : Event) : void {
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.loginThroughSN = UsersProxy.typeOfSN_GS;
			if(GameServiceManager.instance){
				GameServiceManager.instance.loginCallback = handleSNlogged;
				GameServiceManager.instance.loginUnableCallback = function():void{
					AlertView.show("Unable to Login with Game Center.\nRelaunch the application and try again, please.", 8, false);
				};
				GameServiceManager.instance.signIn();
			}else{
				AlertView.show("Game Center Login is not available.", 8, false);
			}
		}


		
		protected function onWebViewVKLocationChange(event:LocationChangeEvent):void{
			
			if(_webView.location.indexOf("https://oauth.vk.com/authorize?client_id=")>=0
				
			){
				
				showWebview();

			}
			
			
		}
		
		protected function onWebViewVKError(event:ErrorEvent):void{
			

			if(event.text.indexOf("vk"+Constants.VK_API_ID+"://")>=0){
				
				var startIndex:int=event.text.indexOf("vk"+Constants.VK_API_ID+"://");
				
				var url:String=event.text.substr(startIndex);
				
				var seporator:String="?";
				
				if(url.indexOf(seporator)<=0){
					
					seporator="#";
				}
				
				var mas:Array=url.split(seporator);
				
				
				
				if(mas && mas.length>1){
					
					_webView.removeEventListener(ErrorEvent.ERROR, onWebViewVKError);
					_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewVKLocationChange);
					
					closeWebview();
					
					
					url=mas[1];
					
					var urlVars:URLVariables=new URLVariables(url);
					
					if(urlVars.hasOwnProperty("error")){
						Tuning3D.resetLogin();
						hideAlert();
					}else{
						
						hideAlert();
						var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;  
						Tuning3D.handleInvoke(usersProxy.loginThroughSN, urlVars);
					}
					
					
				}else{
					
					_webView.removeEventListener(ErrorEvent.ERROR, onWebViewVKError);
					_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewVKLocationChange);
					
					closeWebview();
					
					AlertView.show("Error", 4, false);
				}
				
				
			}else{
				
				_webView.removeEventListener(ErrorEvent.ERROR, onWebViewVKError);
				_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewVKLocationChange);
				
				closeWebview();
				
				AlertView.show("Error", 4, false);
			}
		}
		
		private function handleOpenFacebookLoginDialog():void{
			
			FbLoginScreenLoginSelectedHandler();
		}
		   
		private function FbLoginScreenLoginSelectedHandler(event : Event = null) : void
		{
            var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
            usersProxy.loginThroughSN = UsersProxy.typeOfSN_FB;
            FacebookManager.$.login(handleSNlogged);
        }

		private var webView:StageWebView;

		private var fisrt:Boolean=true;
		protected function onComplete(event : Event):void{

			if(!fisrt)
				return;

			fisrt=false;
			var url:String = webView.location;
			url = url.replace("http%3A%2F%2Fwww%2Efacebook%2Ecom%2Fconnect%2Flogin%5Fsuccess%2Ehtml", "https://www.facebook.com/connect/login_success.html");
			webView.loadURL(url);
		}

		private function hideAlert():void{
            if(alertView)
            {
                alertView.hide();
                alertView = null;
            }
		}

		private function handleSNlogged(object : Object) : void {
			var typeOfSN : String = object.typeOfSN;
			var user_id : String = object.user_id;
			var user_name : String = object.user_name;
			var access_token : String = object.access_token;
			var oauth_token : String = object.oauth_token;
			var oauth_token_secret : String = object.oauth_token_secret;
			var oauth_verifier : String = object.oauth_verifier;
			var byte : ByteArray;
			if(EncryptedLocalStore.isSupported && typeOfSN == UsersProxy.typeOfSN_FB){
				byte=new ByteArray();
				byte.writeObject(object);
				EncryptedLocalStore.setItem("fbdata", byte);
			}else if(EncryptedLocalStore.isSupported && typeOfSN == UsersProxy.typeOfSN_VK){
                byte=new ByteArray();
				byte.writeObject(object);
				EncryptedLocalStore.setItem("vkdata", byte);
			}else if(EncryptedLocalStore.isSupported && typeOfSN == UsersProxy.typeOfSN_GS){
                byte=new ByteArray();
				byte.writeObject(object);
				EncryptedLocalStore.setItem("gsdata", byte);
			}

			if(loginScreen){
				loginScreen.setLoginButtonEnabled(false);
			}
			hideAlert();
			alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
			
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.loginThroughSN = typeOfSN;
			if(typeOfSN == UsersProxy.typeOfSN_FB){
				usersProxy.login(null, null,{token: access_token, facebook_app_id:Constants.FACEBOOK_APP_ID },"accounts/signin/facebook");
			}else if(typeOfSN == UsersProxy.typeOfSN_GS){
				usersProxy.login(null, null,{id: user_id, displayName: user_name},"accounts/signin/gameservice");
			}else if(typeOfSN == UsersProxy.typeOfSN_VK){
				usersProxy.login(null, null,{token: access_token, userId:user_id},"accounts/signin/vk");
			}else if(typeOfSN == UsersProxy.typeOfSN_TW){
				usersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
				usersProxy.loginThroughSN = UsersProxy.typeOfSN_TW;
				var seconds : uint = new Date().valueOf()/1000;//miliseconds/1000;
						
				_consumer = new OAuthConsumer(Constants.TW_CONSUMER_KEY,Constants.TW_CONSUMER_SECRET);
				_authRequest = new OAuthRequest(OAuthRequest.HTTP_MEHTOD_GET,ACCESS_TOKEN_URL,{oauth_verifier:oauth_verifier,oauth_token:oauth_token},_consumer,_requestToken);

				var urlRequest:URLRequest = new URLRequest(_authRequest.buildRequest(SIGNATURE,OAuthRequest.RESULT_TYPE_URL_STRING,"",seconds));
				var loader:URLLoader = new URLLoader(urlRequest);
				loader.addEventListener(Event.COMPLETE,onRequestComplete2);
				loader.addEventListener(IOErrorEvent.IO_ERROR, onRequestError2);
			}
		}
		
		private function loginScreenLoginSelectedHandler(event : Event) : void {
			if(loginScreen){
				loginScreen.setLoginButtonEnabled(false);
			}
			hideAlert();
			alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
			
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.login(loginScreen.username, loginScreen.password);
		}

		private function handleUserLoggedOut() : void {
			if(loginScreen){
				loginScreen.clearTextInputViews();
				loginScreen.setLoginButtonEnabled(false);
			}
            sendNotification(Notifications.PENDING_FRIENDS_LOADED, {friends: null, unread:false});
		}
		
		private function loginScreenPasswordResetSelectedHandler(event : Event) : void
		{
			sendNotification(Notifications.DISPLAY_FORGOTTEN_PASSWORD_SCREEN);
		}
		
		private function loginScreenBackButtonSelectedHandler(event : Event) : void
		{
			sendNotification(Notifications.USER_LOGIN_CANCELLED);
		}

		private static var REQUEST_TOKEN_URL:String = "https://api.twitter.com/oauth/request_token";
		private static var ACCESS_TOKEN_URL:String = "https://api.twitter.com/oauth/access_token";
		private static var AUTHORIZE_URL:String = "https://api.twitter.com/oauth/authorize";
		private static var API_URL:String = "https://api.twitter.com";
		private static var SIGNATURE:OAuthSignatureMethod_HMAC_SHA1 = new OAuthSignatureMethod_HMAC_SHA1();
		
		// Consumers and Request objects for making calls
		private var _consumer:OAuthConsumer;
		private var _authRequest:OAuthRequest;
		private var _accessRequest:OAuthRequest;
		
		// Tokens for passing information back and forth
		private var _requestToken:OAuthToken;
		private var _accessToken:OAuthToken;
		private var alertViewOfTW : AlertView = null;

		private function AppleLoginScreenLoginSelectedHandler(event : Event): void {
			AppleSignIn.instance.addEventListener( AppleSignInErrorEvent.ERROR, appleSignErrorHandler );
			AppleSignIn.instance.addEventListener( AppleSignInEvent.SUCCESS, appleSignSuccessHandler );

			var options:AppleSignInOptions = new AppleSignInOptions()
					.setRequestedScopes([
						AppleSignInScopes.FULL_NAME,
						AppleSignInScopes.EMAIL
					])
			AppleSignIn.instance.loginWithAppleId( options );
		}

		private function TwLoginScreenLoginSelectedHandler(event : Event) : void
		{
			if(alertViewOfTW)return;

			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			usersProxy.loginThroughSN = UsersProxy.typeOfSN_TW;

			var titleOfMessage : String = usersProxy.httpClient.language.translate("mob_alertsAndOverlays", "loading");
			alertViewOfTW = AlertView.show(titleOfMessage, -1);

			nextFuncionOfTwitter();
		}
		
		protected function nextFuncionOfTwitter():void{
			var date:Date=new Date();
			var seconds : uint = date.time/1000; //resultObject.time;//miliseconds/1000;

			// creating the consumer and the authRequest based on the info from Twitter
			_consumer = new OAuthConsumer(Constants.TW_CONSUMER_KEY,Constants.TW_CONSUMER_SECRET);
			_authRequest = new OAuthRequest(OAuthRequest.HTTP_MEHTOD_GET,REQUEST_TOKEN_URL,{oauth_callback:Constants.TW_CALLBACK},_consumer);

			var urlRequest:URLRequest = new URLRequest(_authRequest.buildRequest(SIGNATURE,OAuthRequest.RESULT_TYPE_URL_STRING,"",seconds));
			
			var loader:URLLoader = new URLLoader(urlRequest);
			loader.addEventListener(Event.COMPLETE,onRequestComplete);
			loader.addEventListener(IOErrorEvent.IO_ERROR, onRequestError);
		}

		protected function onRequestError(event:IOErrorEvent):void
		{
			if(alertViewOfTW)alertViewOfTW.hide();
			alertViewOfTW = null;
			// TODO Auto-generated method stub
			var resultError : String = event.currentTarget.data;
			AlertView.show("token twitter request error:" + resultError, 10);

		}
		
		protected function onRequestComplete(event:Object):void
		{
			// build our requestToken based on the response from Twitter
			if(alertViewOfTW)alertViewOfTW.hide();
			alertViewOfTW = null;
			
			_requestToken = OAuthUtil.getTokenFromResponse(event.currentTarget.data);
			var url : String = 'https://api.twitter.com/oauth/authorize?oauth_token='+_requestToken.key;
			var authRequest:URLRequest = new URLRequest(url);
			
			if(_webView){
				_webView.dispose();
				_webView=null;
			}
			
			_webView=new StageWebView(true);
			var viewPortPaddingTop:Number = 80*(Constants.SCALE_FACTOR/2);
			_webView.viewPort=new Rectangle(0,viewPortPaddingTop, Constants.STAGE.stageWidth, Constants.STAGE.stageHeight-viewPortPaddingTop);
			_webView.addEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewTWLocationChange);
			_webView.addEventListener(ErrorEvent.ERROR, onWebViewTWError);
			_webView.loadURL(authRequest.url);
		}
		
		private function showWebview():void{
			_webView.stage=Constants.STAGE;
			if(loginScreen){
				loginScreen.closeWebviewButton.visible = true;
				loginScreen.scrollContainer.visible = false;
				loginScreen.backButton.visible = false;
			}
		}
		
		private function closeWebview():void{
			if(_webView){
				_webView.stage=null;
				_webView.dispose();
				_webView = null;
			}
			if(loginScreen){
				loginScreen.closeWebviewButton.visible = false;
				loginScreen.scrollContainer.visible = true;
				loginScreen.backButton.visible = true;
			}

			hideAlert();
		}
		
		
		protected function onWebViewTWLocationChange(event:LocationChangeEvent):void{
			
			if(_webView.location.indexOf("https://api.twitter.com/oauth/authorize?oauth_token=")>=0 ||
				_webView.location.indexOf("https://api.twitter.com/oauth/authorize")>=0
			){
				showWebview();
			}
		}
		
		protected function onWebViewTWError(event:ErrorEvent):void{
			if(event.text.indexOf("twitter"+"://")>=0){
				
				var startIndex:int=event.text.indexOf("twitter://");
				var url:String=event.text.substr(startIndex);
				var seporator:String="?";
				if(url.indexOf(seporator)<=0){
					seporator="#";
				}
				
				var mas:Array=url.split(seporator);
				if(mas && mas.length>1){
					
					_webView.removeEventListener(ErrorEvent.ERROR, onWebViewTWError);
					_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewTWLocationChange);
					
					closeWebview();

					url=mas[1];
					
					var urlVars:URLVariables=new URLVariables(url);
					
					if(urlVars.hasOwnProperty("denied")){
						Tuning3D.resetLogin();
						hideAlert();
					}else{
						
						hideAlert();
						var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;  
						Tuning3D.handleInvoke(usersProxy.loginThroughSN, urlVars);
					}
				}else{
					
					_webView.removeEventListener(ErrorEvent.ERROR, onWebViewTWError);
					_webView.removeEventListener(LocationChangeEvent.LOCATION_CHANGE, onWebViewTWLocationChange);
					
					closeWebview();
					
					AlertView.show("Error", 3, false);
				}
			}
		}

		protected function onRequestError2(event:IOErrorEvent):void
		{
			// TODO Auto-generated method stub
			var resultError : String = event.currentTarget.data;
			AlertView.show("token twitter onRequestError2 error:" + resultError, 10);
		}
		
		protected function onRequestComplete2(event:Object):void
		{
			var result : Object = OAuthUtil.getObjectFromResponse(event.currentTarget.data);
			
			var resultOK : String = event.currentTarget.data;
			var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			//var user_str : String = "{user_id:"+result.user_id+",screen_name:"+result.screen_name+"}";
			var param : Object = {};
			param["token"] = result.oauth_token;
			param["secret"] = result.oauth_token_secret;
			param["user[user_id]"] = result.user_id;
			param["user[screen_name]"] = result.screen_name;
			
			usersProxy.login(null, null,param,"accounts/signin/twitter");
		}
	}
}