package com.despark.tuning3d.view {
import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.challenges.ChallengesProxy;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.brands.RewardInfoPopUp;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.core.PopUpMediator;
import com.utils.Tracker;

    import starling.events.Event;

    public class RewardInfoPopUpMediator  extends PopUpMediator{
    public function RewardInfoPopUpMediator(popUp : PopUp) {
        super(popUp);
    }
    public function get rewardInfoPopUp() : RewardInfoPopUp
    {
        return RewardInfoPopUp(popUp);
    }

    override public function onRegister() : void
    {
        super.onRegister();
        rewardInfoPopUp.addEventListener(RewardInfoPopUp.OPEN_NO_ADS_POP_UP, openNoAdsPopUpHandler);
        rewardInfoPopUp.addEventListener(RewardInfoPopUp.REQUEST_REWARDS_DATA, requestRewardData);
    }

    override public function onRemove() : void
    {
        rewardInfoPopUp.removeEventListener(RewardInfoPopUp.OPEN_NO_ADS_POP_UP, openNoAdsPopUpHandler);
        rewardInfoPopUp.removeEventListener(RewardInfoPopUp.REQUEST_REWARDS_DATA, requestRewardData);
        super.onRemove();
    }

    private function openNoAdsPopUpHandler(event:Event): void {
        Tracker.getInstance().trackEvent("click_watch_reward", 'click_watch_reward', 'click_watch_reward');
        sendNotification(Notifications.DISPLAY_REWARD_NOADS_POPUP);
    }


    private function requestRewardData(event:Event):void{
        if(UsersProxy.loggedInUser()){
            var challengeProxy : ChallengesProxy = facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
            challengeProxy.getUserRewardData(UsersProxy.loggedInUser().id, function(rewardsData:Object):void{
                rewardInfoPopUp.setUserRewardsData(rewardsData);
            });
        }
    }
}
}
