/**
 * Created by Render-2 on 8/8/2017.
 */
package com.despark.tuning3d.view {
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.brands.BrandsParser;
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.challenges.ChallengeEvent;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.friend.FriendProxy;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.LanguagesProxy;
import com.despark.tuning3d.model.parts.Part;
import com.despark.tuning3d.model.parts.PartMaterial;
import com.despark.tuning3d.model.parts.PartMaterialImageTest;
import com.despark.tuning3d.model.parts.PartSlot;
import com.despark.tuning3d.model.settings.Settings;
import com.despark.tuning3d.model.settings.SettingsProxy;
import com.despark.tuning3d.model.sharing.SharingInstagramProxy;
import com.despark.tuning3d.model.sharing.SharingProxy;
import com.despark.tuning3d.model.sharing.SharingVkProxy;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.timeline.TimelineProxy;
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.tunings.TuningsProxy;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.auth.UserDetailsPopup;
    import com.despark.tuning3d.view.components.brands.BrandsScreen;
import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.MainMenuItem;
import com.despark.tuning3d.view.components.core.StackedScreen;
import com.despark.tuning3d.view.components.core.StackedScreenNavigator;
import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
import com.despark.tuning3d.view.components.instructions.TutorialView;
import com.despark.tuning3d.view.components.timeline.FeedData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Abstract.ATimelineCommentLikeItemRender;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentData;
import com.despark.tuning3d.view.components.timeline.TimelineScreen;
    import com.despark.tuning3d.view.components.tunings.TuningsListMenuView;
    import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
    import com.despark.tuning3d.view.core.StackedScreenMediator;
    import com.distriqt.AdsManager;
    import com.utils.ArrayUtil;
import com.utils.DateParser;
import com.utils.RandomSplashManager;

import feathers.events.FeathersEventType;

import flash.display.BitmapData;
import flash.events.TimerEvent;
import flash.filesystem.File;
import flash.utils.Timer;
import flash.utils.getTimer;
import flash.utils.setTimeout;

import org.puremvc.as3.interfaces.INotification;

import starling.core.Starling;

import starling.core.Starling;
import starling.events.Event;
import starling.utils.ScaleMode;

public class TimelineScreenMediator extends StackedScreenMediator{


    private var _isFeedUpdating : Boolean = false;
    private var _feedFirstData: String;
    private var _addCommentModel : FeedData;
    private var _loadingAlert:AlertView;
    private var _moreCommentsStack : Array = [];
    private var _lastRequest:Number;
    private var _firstPost:String;
    private var requestId:String;
    private var showAlertConnectionLost:Boolean;



    public function TimelineScreenMediator(stackedScreen:StackedScreen) {
        super(stackedScreen);
        FeedData.CURRENT_USER = UsersProxy.loggedInUser();
    }


    override public function onRegister() : void
    {
        super.onRegister();

        timelineScreen.addEventListener(TimelineScreen.CAR_SELECTED, timelineScreenCarSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.HOME_SELECTED, timelineScreenHomeSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.BRANDS_SELECTED, timelineScreenBrandsSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.VOTE_SELECTED, timelineScreenVotesSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.POST_TUNING_SELECTED, postTuningSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.GARAGE_SELECTED, timelineScreenGarageSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.USER_DETAILS_SELECTED, timelineScreenGarageSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.FRIENDS_SELECTED, timelineScreenFriendsSelectedHandler);
        timelineScreen.addEventListener(StackedScreen.GALLERY_SELECTED, gallerySelectHandler);
        timelineScreen.addEventListener(StackedScreen.MAILS_SELECTED, mailSelectedHandler);

        timelineScreen.addEventListener(BrandsScreen.CLEANUP_MEMORY, timelineScreenCleanUpMemoryHandler);
        timelineScreen.addEventListener(BrandsScreen.LANGUAGE_CHANGED,timelineScreenLanguageChangedHandler);
        timelineScreen.addEventListener(BrandsScreen.LOGOUT_SELECTED, timelineScreenLogoutSelectedHandler);
        timelineScreen.addEventListener(BrandsScreen.INSTRUCTION_SELECTED, timelineScreenInstructionSelectedHandler);

        timelineScreen.addEventListener(StackedScreenNavigator.BACK_TO_SCREEN, backToPreviousScreen);


        timelineScreen.addEventListener(FeathersEventType.INITIALIZE, timelineScreenInitializeStageHandler);

        timelineScreen.addEventListener(TimelineScreen.UPDATE_FEED, timelineScreenUpdatedFeedHandler);

        timelineScreen.addEventListener(FeedData.COMMENT_SEND, sendCommentHandler);
        timelineScreen.addEventListener(FeedData.COMMENT_DELETE, deleteCommentHandler);
        timelineScreen.addEventListener(FeedData.COMMENT_EDIT, editCommentHandler);
        timelineScreen.addEventListener(FeedData.COMMENT_MORE, moreCommentsRequestHandler);
        timelineScreen.addEventListener(FeedData.NEW_POST, newPostHandler);
        timelineScreen.addEventListener(FeedData.LIKE, likePostHandler);

        timelineScreen.addEventListener(TimelineScreen.FEED_PULLING, timelineScreenFulling);
        timelineScreen.addEventListener(ChallengeEvent.CHALLENGE_REQUEST, handleChallengeRequest);
        timelineScreen.addEventListener(StackedScreen.IN_APP_NOTIFICATIONS_SELECTED, challengeNotesSelectHandler);
        timelineScreen.addEventListener(TimelineScreen.FEED_PULLING, timelineScreenFulling);

        timelineScreen.addEventListener(TimelineScreen.FILTER_CHANGED, timelineScreenFilterChangeHandler);
        timelineScreen.addEventListener(TimelineScreen.TUNING_SELETCED, tuningPopupSelectedHandler);

        Starling.juggler.delayCall(initialize, 1);
    }



    private function initialize():void{
        var friendProxy:FriendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
        friendProxy.loadPendings();
    }

    override public function onRemove() : void {
        super.onRemove();
        _feedFirstData = null;
        timelineScreen.removeEventListener(TimelineScreen.CAR_SELECTED, timelineScreenCarSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.HOME_SELECTED, timelineScreenHomeSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.BRANDS_SELECTED, timelineScreenBrandsSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.VOTE_SELECTED, timelineScreenVotesSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.POST_TUNING_SELECTED, postTuningSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.GARAGE_SELECTED, timelineScreenGarageSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.USER_DETAILS_SELECTED, timelineScreenGarageSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.FRIENDS_SELECTED, timelineScreenFriendsSelectedHandler);
        timelineScreen.removeEventListener(StackedScreen.GALLERY_SELECTED, gallerySelectHandler);
        timelineScreen.removeEventListener(StackedScreen.MAILS_SELECTED, mailSelectedHandler);

        timelineScreen.removeEventListener(BrandsScreen.CLEANUP_MEMORY, timelineScreenCleanUpMemoryHandler);
        timelineScreen.removeEventListener(BrandsScreen.LANGUAGE_CHANGED,timelineScreenLanguageChangedHandler);
        timelineScreen.removeEventListener(BrandsScreen.LOGOUT_SELECTED, timelineScreenLogoutSelectedHandler);
        timelineScreen.removeEventListener(BrandsScreen.INSTRUCTION_SELECTED, timelineScreenInstructionSelectedHandler);

        timelineScreen.removeEventListener(StackedScreenNavigator.BACK_TO_SCREEN, backToPreviousScreen);

        timelineScreen.removeEventListener(FeathersEventType.INITIALIZE, timelineScreenInitializeStageHandler);

        timelineScreen.removeEventListener(TimelineScreen.UPDATE_FEED, timelineScreenUpdatedFeedHandler);
        timelineScreen.removeEventListener(FeedData.COMMENT_SEND, sendCommentHandler);
        timelineScreen.removeEventListener(FeedData.COMMENT_DELETE, deleteCommentHandler);
        timelineScreen.removeEventListener(FeedData.COMMENT_EDIT, editCommentHandler);
        timelineScreen.removeEventListener(FeedData.COMMENT_MORE, moreCommentsRequestHandler);
        timelineScreen.removeEventListener(FeedData.NEW_POST, newPostHandler);
        timelineScreen.removeEventListener(FeedData.LIKE, likePostHandler);

        timelineScreen.removeEventListener(TimelineScreen.FEED_PULLING, timelineScreenFulling);
        timelineScreen.removeEventListener(ChallengeEvent.CHALLENGE_REQUEST, handleChallengeRequest);
        timelineScreen.removeEventListener(StackedScreen.IN_APP_NOTIFICATIONS_SELECTED, challengeNotesSelectHandler);
        timelineScreen.removeEventListener(TimelineScreen.FEED_PULLING, timelineScreenFulling);

        timelineScreen.removeEventListener(TimelineScreen.FILTER_CHANGED, timelineScreenFilterChangeHandler);
        timelineScreen.removeEventListener(TimelineScreen.TUNING_SELETCED, tuningPopupSelectedHandler);

        timelineScreen.dispose();
    }

    private function tuningPopupSelectedHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        var data:Object = event.data;
        data.deleteOtherScreens = false;
        data.enableCloseButton = true;
        data.eventDispatcher = timelineScreen;

        var selectedUser:User = data.user;
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        var currentUser:User = usersProxy.currentUser;
        if((currentUser && selectedUser && selectedUser.id != currentUser.id) || !currentUser){
            Constants.selectedUser = selectedUser;
        }else{
            Constants.selectedUser = null;
        }
        BannerStackedScreen.hideAdBanner(false);
        data.showBannerAfterExit = timelineScreen.showAdBanner;
        sendNotification(Notifications.DISPLAY_GALLERY_TUNING_POPUP, data);
    }

    private function backToPreviousScreen(event:Event):void {
        sendNotification(Notifications.DISPLAY_PREVIOUS_SCREEN);
    }

    private function handleChallengeRequest(event:Event):void {
        sendNotification(Notifications.DISPLAY_START_CHALLENGE_POPUP, event.data);
    }

    private function gallerySelectHandler(event : Event) : void {
        sendNotification(Notifications.DISPLAY_GALLERY_SCREEN);
    }

    private function timelineScreenFilterChangeHandler(event:Event):void {
        if(!timelineScreen.isInitialized){
            return;
        }
        timelineScreen.clearContent();
        requestId = getTimer().toString();
        if(!_loadingAlert || !_loadingAlert.parent){
            _loadingAlert = AlertView.show("feed loading ...", 4, true);
        }
        timelineScreen.firstPost = null;
        _firstPost = timelineScreen.firstPost;
        _lastRequest = getTimer();
        _isFeedUpdating = true;
        _feedFirstData = null;
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        timelineProxy.loadFeed(timelineScreen.selectedUser, 0, 10, _feedFirstData, _firstPost, true, requestId, timelineScreen.ownTimeline);
    }

    private function timelineScreenFulling(event: Event): void {
        if (!_isFeedUpdating) {
            _firstPost = timelineScreen.firstPost;
            var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
            timelineProxy.refresh(timelineScreen.selectedUser, _feedFirstData, _firstPost, timelineScreen.ownTimeline);
            _isFeedUpdating = true;
        }
    }

    private function timelineScreenCarSelectedHandler(event:Event):void {
        var selectedTuning:Tuning = TuningsProxy.parseTuning(timelineScreen.selectedFeedData.tuning);
        var data : Object = {
            car: selectedTuning.car
        };
        var userProxy:UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        if(event && event.data && event.data.isEditing && userProxy.currentUser) {
            if (selectedTuning.tuningUserID == userProxy.currentUser.id || (selectedTuning.userObj && selectedTuning.userObj._id == userProxy.currentUser.id)) {
                data["tuning"] = selectedTuning;
            }
        }

        var carSplashImage:ImageLoaderWithStates = RandomSplashManager.createSplashImage(data.car as Car);
        timelineScreen.stage.addChild(carSplashImage);
        carSplashImage.completeHandler = function(image:ImageLoaderWithStates):void{
            data.carSplashImage=carSplashImage;
            sendNotification(Notifications.DISPLAY_TUNING_SCREEN, data);
            setTimeout(function():void{
                timelineScreen.dispatchEventWith(BrandsScreen.CLEANUP_MEMORY);
            },500);
        };
    }

    private function likePostHandler(event:Event):void {
        var item : FeedData = event.data as FeedData;
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;


        timelineProxy.likeFeed(item.useId, item.isTuningUse, item.iLiked);
    }

    private function newPostHandler(event:Event):void {
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        var text : String = event.data.text as String;
        var images : Array = event.data.images;

        timelineProxy.newPost(text, usersProxy.currentUser, images);
    }
    private function editCommentHandler(event:Event):void {
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        var model : FeedData = event.data.feedData;
        var commendData : CommentData= event.data.comment;
        if(!model.isTuningUse)
        {
            timelineProxy.editPostComment(model.id, commendData.comment, commendData.id);
        }
        else {
            timelineProxy.editTuningComment(model.tuning._id, commendData.comment, commendData.id);
        }

        _addCommentModel = model;
    }

    private function deleteCommentHandler(event:Event):void {
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        var commentData : CommentData = event.data.comment as CommentData;
        var feedData : FeedData = event.data.feedData;
        if(!feedData.isTuningUse)
        {
            timelineProxy.deleteCommentFromPost( commentData.id);
        }
        else {
            timelineProxy.deletCommentFromTuning(feedData.tuning._id, commentData.id);
        }
    }

    private function moreCommentsRequestHandler(event : Event) : void
    {
        var feedData : FeedData = event.data as FeedData;
        timelineScreen.selectedFeedData = feedData;
        for(var i : int = 0; i < _moreCommentsStack.length; i++)
        {
            if(_moreCommentsStack[i].id == feedData.id)
            {
                return;
            }

        }

        _moreCommentsStack.push(feedData);

        var skip : int = feedData.commentsPocket.currentLength ;
        var limit : int = (feedData.commentsPocket.currentLength + ATimelineCommentLikeItemRender.COMMENTS_MORE_CYCLE > feedData.commentsPocket.totalLength)
                ? feedData.commentsPocket.totalLength - feedData.commentsPocket.currentLength
                : ATimelineCommentLikeItemRender.COMMENTS_MORE_CYCLE;

        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;

        if(!feedData.isTuningUse)
        {
            timelineProxy.getMoreCommentsPost(feedData.id, skip, limit);
        }else {
            timelineProxy.getMoreCommentsTuning(feedData.tuning._id, skip, limit);
        }

    }

    private function sendCommentHandler(event:Event):void {

        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        var model : FeedData = event.data.data;
        var text : String = event.data.text;
        if(!model.isTuningUse) {
            timelineProxy.addCommentToPost(model.id, text);
        }
        else {
            timelineProxy.addCommentToTuning(model.tuning._id, text);
        }

        _addCommentModel = model;
    }

    private function timelineScreenUpdatedFeedHandler(event:Event):void{
        if(getTimer()-_lastRequest>5000){
            _isFeedUpdating = false;
        }
        if(!_loadingAlert || !_loadingAlert.parent){
            _loadingAlert = AlertView.show("feed loading ...", 4, true);
        }
        if(_isFeedUpdating)
            return;
        _firstPost = timelineScreen.firstPost;
        _lastRequest = getTimer();
        _isFeedUpdating = true;
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        timelineProxy.loadFeed(timelineScreen.selectedUser, timelineScreen.feedCount, 10, _feedFirstData, _firstPost, false, requestId, timelineScreen.ownTimeline);
    }

    private function timelineScreenInstructionSelectedHandler(event:Event):void{
        TutorialView.showCustomUrl();
    }

    protected function timelineScreenInitializeStageHandler( e : Event ) : void {
        requestId = getTimer().toString();
        _firstPost  = timelineScreen.firstPost;
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        timelineProxy.loadFeed(timelineScreen.selectedUser, 0, 10, _feedFirstData, _firstPost, false, requestId, timelineScreen.ownTimeline);
        timelineProxy.updateRefreshDate();

        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguages();
        //alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
    }

    public function reloadFeeds() : void {
        _firstPost  = timelineScreen.firstPost;
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        timelineProxy.loadFeed(timelineScreen.selectedUser, 0, 10, _feedFirstData, _firstPost, true, requestId, timelineScreen.ownTimeline);
        timelineProxy.updateRefreshDate();

        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguages();
        alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "loading"), -1);
    }

    private function mailSelectedHandler(event:Event):void {
        Starling.juggler.delayCall(function():void{
            sendNotification(Notifications.DISPLAY_MAIL_SCREEN);
        }, 0.2);
    }

    private function onUpdateTime(event:TimerEvent):void {

        //return;
        if(_isFeedUpdating ) return;

        //trace("Call refresh");

//        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
//        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
//        timelineProxy.refresh(usersProxy.currentUser);
    }

    private function timelineScreenLogoutSelectedHandler(e:Event):void {
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        usersProxy.logoutCurrentUser();
        AlertView.show(AlertView.language.translate("mob_saving", "loggedOut"), -1, false);
        this.timelineScreen.ShowDone();
    }

    private function timelineScreenLanguageChangedHandler(event:Event):void {
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        languagesProxy.loadLanguage(timelineScreen.selectedLanguage);
    }

    private function timelineScreenVotesSelectedHandler(event:Event):void {
        sendNotification(Notifications.DISPLAY_VOTES_LIST_SCREEN, null);
    }

    private function timelineScreenFriendsSelectedHandler(event : Event) : void {
        BannerStackedScreen.hideAdBanner(false);
        sendNotification(Notifications.DISPLAY_FRIENDS_LIST_SCREEN, {showBannerAfterExit: timelineScreen.showAdBanner});
    }

    private function challengeNotesSelectHandler(event : starling.events.Event) : void {
        BannerStackedScreen.hideAdBanner(false);
        sendNotification(Notifications.DISPLAY_CHALLENGE_NOTIFICATION_POPUP, {showBannerAfterExit: timelineScreen.showAdBanner});
    }

    private function timelineScreenGarageSelectedHandler(event : Event): void {
        if((Constants.selectedUser && FeedData.CURRENT_USER && Constants.selectedUser.id != FeedData.CURRENT_USER.id) || (event.data && event.data.enableClosing)){
            var user:User;
            if(Constants.selectedUser){
                user = Constants.selectedUser;
            }else if(UsersProxy.loggedInUser()){
                user = UsersProxy.loggedInUser();
            }else{
                user = new User();
            }
            var data:Object = {user: user, deleteOtherScreens : false, options: [UserDetailsPopup.EMAILS, UserDetailsPopup.GARAGE, UserDetailsPopup.CHALLENGE]}
            if(timelineScreen.selectedUser && user.id != timelineScreen.selectedUser.id){
                data.options.push(UserDetailsPopup.TIMELINE);
            }
            data.referrer = UserDetailsPopup.TIMELINE;
            sendNotification(Notifications.DISPLAY_USER_DETAILS_POPUP, data);
        }else {
            Starling.juggler.delayCall(function () : void{
                sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN, null);
            }, 0.1);
        }
    }

    private function postTuningSelectedHandler(event : Event): void {
        Starling.juggler.delayCall(function () : void{
            sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN, {postToTimeline:true});
        }, 0.1);
    }

    private function timelineScreenHomeSelectedHandler(event:Event):void {
        sendNotification(Notifications.DISPLAY_HOME_SCREEN_POPUP);
    }

    private function timelineScreenBrandsSelectedHandler(event:Event):void {
        if(HomeScreenPopUpMediator.isBrandScreenFirstOpen) {
            sendNotification(Notifications.DISPLAY_BRANDS_SCREEN);
        } else {
            sendNotification(Notifications.DISPLAY_ROOT_SCREEN);
        }
        HomeScreenPopUpMediator.isBrandScreenFirstOpen = false;
    }

    private function timelineScreenCleanUpMemoryHandler(event: Event):void {
        if(timelineScreen) timelineScreen.cleanupMemory();
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
            Notifications.TIMELINE_DATA_LOADED,
            Notifications.TIMELINE_COMMENT_ADDED,
            Notifications.TIMELINE_COMMENT_DELETED,
            Notifications.TIMELINE_COMMENT_EDITED,
            Notifications.TIMELINE_MORE_COMMENTS,
            Notifications.TIMELINE_POST_ADDED,
            Notifications.TIMELINE_DATA_LOADING_FAILED,
            Notifications.TIMELINE_DATA_REFRESHED,
            Notifications.TIMELINE_LIKE_SUCCESS,
            Notifications.TIMELINE_LIKE_FAILED,
            Notifications.PENDING_FRIENDS_LOADED,


            Notifications.TIMELINE_POST_IMAGE_UPLOADED,
            Notifications.TIMELINE_POST_IMAGE_UPLOADED_FAILED,

            Notifications.LANGUAGES_LOADED,
            Notifications.LANGUAGES_LOADING_FAILED,
            Notifications.LANGUAGE_LOADED,
            Notifications.LANGUAGE_LOADING_FAILED,
            Notifications.USER_LOGGED_OUT,

            Notifications.SHARING_READY,
            Notifications.TUNING_SHARING_MESSAGE_ENTERED,
            Notifications.SHARING_PREPARING_ERROR,
            Notifications.SHARING_PHOTO_UPLOADED,
            Notifications.SHARING_PHOTO_UPLOADING_ERROR,

            Notifications.SHARING_PHOTO_UPLOADING_ERROR,
            Notifications.TIMELINE_SCREEN_FEED_PREVIEW,

            Notifications.INTERNET_CONNECTED,
            Notifications.INTERNET_DISCONNECTED
        ]);
    }

    override public function handleNotification(note : INotification) : void {
        switch(note.getName()) {
            case Notifications.TIMELINE_POST_ADDED:
                handleNewPostFinishedHandler(note.getBody());
                break;
            case Notifications.TIMELINE_SCREEN_FEED_PREVIEW:
                handleDisplayTimelineScreenFeed(note.getBody());
                break;
            case Notifications.TIMELINE_COMMENT_EDITED:
                handleTimeLineCommentEdited(note.getBody());
                break;

            case Notifications.TIMELINE_MORE_COMMENTS:
                handleMoreReceivedComments(note.getBody() as Object);
                break;
            case Notifications.TIMELINE_COMMENT_DELETED:
                // nothing to do ;
                break;
            case Notifications.TIMELINE_COMMENT_ADDED:
                handleTimelineCommentAdded(note.getBody());
                break;
            case Notifications.TIMELINE_DATA_REFRESHED:
                handleTimelineDataRefreshed(note.getBody().feed as Array);
                break;
            case Notifications.TIMELINE_DATA_LOADED:
                handleTimelineDataLoaded(note.getBody().feed as Array, note.getBody().reload, note.getBody().requestId);
                break;
            case Notifications.TIMELINE_DATA_LOADING_FAILED:
                handleTimelineDataLoadingFailed();
                break;

            case Notifications.LANGUAGES_LOADED:
                handleLanguagesLoaded();
                break;

            case Notifications.LANGUAGES_LOADING_FAILED:
                handleLanguagesLoadingFailed();
                break;

            case Notifications.LANGUAGE_LOADED:
                handleLanguageLoaded(note.getBody().language);
                break;

            case Notifications.LANGUAGE_LOADING_FAILED:
                handleLanguageLoadingFailed();
                break;

            case Notifications.USER_LOGGED_OUT:
                handleUserLoggedOut();
                break;

            case Notifications.SHARING_READY:
                //handleSharingReady(note.getBody() as String);
                break;

            case Notifications.SHARING_PREPARING_ERROR:
                handleSharingPreparingError(note.getBody() as String);
                break;

            case Notifications.TUNING_SHARING_MESSAGE_ENTERED:
                handleTuningSharingMessageEntered(note.getBody() as String);
                break;

            case Notifications.SHARING_PHOTO_UPLOADED:
                handleSharingPhotoUploaded();
                break;

            case Notifications.SHARING_PHOTO_UPLOADING_ERROR:
                handleSharingPhotoUploadingError();
                break;
            case Notifications.TIMELINE_LIKE_SUCCESS:
                handleTimelineLikeSuccess();
                break;
            case Notifications.TIMELINE_LIKE_FAILED:
                handleTimelineLikeFailed();
                break;
            case Notifications.TIMELINE_POST_IMAGE_UPLOADED:
                handleTimelineImageUploaded(note.getBody());
                break;

            case Notifications.PENDING_FRIENDS_LOADED:
                handlePendingFriendsLoaded(note.getBody());
                break;

            case Notifications.INTERNET_CONNECTED:
                handleInternetConnected();
                break;

            case Notifications.INTERNET_DISCONNECTED:
                handleInternetDisconnected();
                break;

        }

        super.handleNotification(note);
    }

    private function handlePendingFriendsLoaded(friends: Object): void {
        //if(timelineScreen.stage)
            timelineScreen.dispatchEventWith(FriendsListPopUp.PENDING_FRIENDS_READ, false, friends);
    }

    private function handleDisplayTimelineScreenFeed(data:Object):void {
        sendNotification(Notifications.DISPLAY_BRANDS_SCREEN);
        Starling.juggler.delayCall(function():void {
            sendNotification(Notifications.DISPLAY_TIMELINE_SCREEN, data);
        }, .01);
        /*
        handleNewPostFinishedHandler(data);
        timelineScreen.firstPost = data.firstPost;
        reloadFeeds();*/
    }


    private function handleTimelineImageUploaded(body:Object):void {

    }


    private function handleTimelineLikeFailed():void {
        timelineScreen.likeFailed((facade.retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser);
    }

    private function handleTimelineLikeSuccess():void {
        timelineScreen.likeSuccess((facade.retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser);
    }


    private function handleSharingReady(__title:String):void {
        var link:String = "";
        try{
            link = timelineScreen.timelineTuningView.siteGarageLink
        }catch(e:Error){
            if(timelineScreen.selectedTuning && timelineScreen.selectedTuning.car){
                link = timelineScreen.selectedTuning.car.getSiteLinkGrage(timelineScreen.selectedTuning.userObj.username, timelineScreen.selectedTuning.shortId);
            }else if(timelineScreen.currentCar){
                link = timelineScreen.currentCar.getSiteLinkGrage(timelineScreen.selectedTuning.userObj.username, timelineScreen.selectedTuning.shortId);
            }
            trace("error:", e.getStackTrace());
        }
        sendNotification(Notifications.DISPLAY_TUNING_SHARING_POP_UP, {title: __title, siteLink:link});
    }

    private function handleSharingPreparingError(error:String):void {
        AlertView.show(error, -1, false);

        //_isFbChallenge = false;
    }

    private function handleTuningSharingMessageEntered(message:String):void {
        Starling.juggler.delayCall(function ():void {



            timelineScreen.timelineTuningView.beginScreenShot( function ():void {
                //tuningScreen.enableButtons(false);

                var bitmapData:BitmapData = Starling.current.stage.drawToBitmapData();

                alertView = AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "uploading"), -1);


                Starling.juggler.delayCall(function ():void {

                   if (timelineScreen.timelineTuningView.tuningsListMenuView.selectedSocial == 'instagram') {
                        var sharingInstagramProxy:SharingInstagramProxy = facade.retrieveProxy(SharingInstagramProxy.NAME) as SharingInstagramProxy;

                        sharingInstagramProxy.sharePhoto(message, bitmapData, function ():void {

                            bitmapData.dispose();
                            timelineScreen.timelineTuningView.endScreenShot();
                        }, message);

                    } else {
                        var sharingVkProxy:SharingVkProxy = facade.retrieveProxy(SharingVkProxy.NAME) as SharingVkProxy;
                        sharingVkProxy.sharePhoto(message, bitmapData, function ():void {

                            bitmapData.dispose();
                            timelineScreen.timelineTuningView.endScreenShot();

                        });
                    }


                }, 0.4);
            });
        }, 0.4);
    }


    private function handleSharingPhotoUploaded():void {




        alertView.hide();
        //tuningScreen.enableButtons(true);

        AlertView.show(AlertView.language.translate("mob_saving", "done"));

        //}
    }

    private function handleSharingPhotoUploadingError():void {
        alertView.hide();

        AlertView.show(AlertView.language.translate("mob_saving", "uploadingFailed"));
    }



    private function handleNewPostFinishedHandler(body:Object):void {
//        var item : FeedData = new FeedData(body);
//        item.creator = FeedData.CURRENT_USER.copy();
//        item.owner = FeedData.CURRENT_USER.copy();
//        item.iLiked = false;
//        item.likes = [];
//        galleryScreen.unshift(item);
        var timelineProxy : TimelineProxy = facade.retrieveProxy(TimelineProxy.NAME) as TimelineProxy;
        timelineProxy.refresh(timelineScreen.selectedUser, _feedFirstData, null, timelineScreen.ownTimeline);
    }

    private function handleMoreReceivedComments(data : Object) : void
    {
        var fData : FeedData = _moreCommentsStack.pop();
        var i:int;
        if (data) {
            var comments:Array = data.data;

            if (data.isTuning) {
                for (i = 0; i < comments.length; i++) {
                    fData.commentsPocket.addMoreComment(new CommentData(comments[i]));
                }
            } else {
                for (i = comments.length - 1; i >= 0; i--) {
                    fData.commentsPocket.addMoreComment(new CommentData(comments[i]));
                }
            }
        }
        timelineScreen.updateList(fData);
        Starling.juggler.delayCall(timelineScreen.updateSelectedItem, .03);
    }

    private function handleTimeLineCommentEdited(data:Object):void {
        var postID : String;
        var checkPostId : Function;
        if(data.hasOwnProperty("tuningId")) {
            postID = data.tuningId;
            checkPostId = function (item : FeedData, postID : String) :Boolean {
                return (item.tuning._id == postID);
            }
        }else {
            postID = data.postId;
            checkPostId = function (item : FeedData, postID : String) :Boolean {
                return (item.id == postID);
            }
        }

        var commendId : String = data.commentId;
        var feed : Array = timelineScreen.feed;

        for(var i : int = 0 ; i < feed.length; i++)
        {
            if(checkPostId(feed[i], postID))
            {
                var comments : Array = (feed[i] as FeedData).commentsPocket.comments;
                for(var j : int = 0; j < comments.length;i++)
                {
                    if(comments[j].id == commendId)
                    {
                        (comments[j] as CommentData).updatedDate = DateParser.parseDate(data.updated);
                        return
                    }
                }
                return;
            }
        }
    }

    private function handleTimelineCommentAdded(data : Object) : void {
        var comment : CommentData = new CommentData(data.comment);
        _addCommentModel.commentsPocket.generateComment(data.comment.comment);
        _addCommentModel.commentsPocket.updateComment(comment);
        _addCommentModel = null;
    }

    private function handleInternetDisconnected():void{
        if(_loadingAlert){
            _loadingAlert.hide();
            _loadingAlert = null;
        }

        if(!BrandsScreenMediator.FIRST_LOAD_COMPLETE){
            if(!showAlertConnectionLost){
                AlertView.show("Lost internet connection",-1, false);
                showAlertConnectionLost = true;
            }
        }

        if(!(timelineScreen.owner as  StackedScreenNavigator))
            return;

        if((timelineScreen.owner as  StackedScreenNavigator).activeScreen.name!=timelineScreen.name)
            return;

        if(!showAlertConnectionLost){
            AlertView.show(AlertView.language.translate("mob_alertsAndOverlays", "lostinternetconnection"),-1, false);
            showAlertConnectionLost = true;
        }
    }

    private function handleInternetConnected():void{
        trace("handleInternetConnected");
        showAlertConnectionLost = false;
        if(!(timelineScreen.owner as  StackedScreenNavigator))
            return;
        if((timelineScreen.owner as  StackedScreenNavigator).activeScreen.name!=timelineScreen.name){

        }
    }

    private function handleTimelineDataLoadingFailed():void {
        if(alertView)
        {
            alertView.hide();
            alertView =null;
        }

//        _updateTimer.stop();
//        _updateTimer.reset();
//        _updateTimer.start();
    }

    private function handleTimelineDataRefreshed(timeline: Array) : void
    {

        _isFeedUpdating = false;
        if(timeline.length > 0)
        {
//            timeline = filterFeed(timeline);
            timelineScreen.refreshFeed(timeline);
            if (timeline.length > 0) {
                _feedFirstData = timeline[0].timeLineDateTime;
            }
        }
        timelineScreen.feedListPullingEnd();
    }

    private function filterFeed(feed : Array) : Array
    {
        var newFeed : Array = [];
        var currentFeed  : Array = timelineScreen.feed;
        var limit : int = 5;
        limit = (limit > currentFeed.length) ? currentFeed.length: limit;

        for(var j : int = 0; j < feed.length; j++)
        {
            var feedIsPresent : Boolean = false;
            for(var i : int = 0; i < limit; i++ )
            {
                if(feed[j].feedType == currentFeed[i].feedType && feed[i].id == currentFeed[j].id)
                {
                    feedIsPresent = true;
                    break;
                }
            }

            if(!feedIsPresent)
            {
                newFeed.push(feed[j])
            }
        }

        return newFeed;

    }

    private function handleTimelineDataLoaded(timeline:Array, reload:Boolean = false, resultId:String = null):void {
        if(requestId != resultId){
            return;
        }
        if(_loadingAlert) {
            _loadingAlert.hide();
            _loadingAlert.dispose();
            _loadingAlert = null;
        }

        if(alertView) {
            alertView.hide();
            alertView =null;
        }

        if(reload && timelineScreen.feedCount > 0){
            timelineScreen.clearContent();
            Starling.juggler.removeDelayedCalls(setFeed);
            Starling.juggler.delayCall(setFeed, .15, timeline);
            return;
        }
        setFeed(timeline);
    }

    private function setFeed(value:Array):void{
        timelineScreen.feed = value;
        if (!_feedFirstData && timelineScreen.feed.length) {
            _feedFirstData =  timelineScreen.feed[0].timeLineDateTime;
        }
        _isFeedUpdating = false;
    }

    private function handleLanguageLoadingFailed():void {

    }

    private function handleUserLoggedOut() : void {
        sendNotification(Notifications.DISPLAY_ROOT_SCREEN);
        sendNotification(Notifications.PENDING_FRIENDS_LOADED, {friends: null, unread:false});
    }

    private function handleLanguagesLoaded():void{

        Starling.juggler.delayCall(refreshSettings, 1.5);
    }

    private function handleLanguagesLoadingFailed() : void
    {
        timelineScreen.selectedLanguage = null;
    }

    private function handleLanguageLoaded(loadedLanguage : Language) : void
    {
        if(timelineScreen)
        {
            timelineScreen.updateWithLanguage(loadedLanguage);

            updateSettings();

            sendNotification(Notifications.LANGUAGE_CHANGED);
        }
    }

    private function updateSettings() : void
    {
        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var settings : Settings = settingsProxy.currentSettings;

        if(timelineScreen.selectedLanguage)
        {
            settings.selectedLanguageCode = timelineScreen.selectedLanguage.code;
        }

        settingsProxy.update(settings);

        if(alertView) alertView.hide();
    }

    private function refreshSettings() : void
    {
        var settingsProxy : SettingsProxy = facade.retrieveProxy(SettingsProxy.NAME) as SettingsProxy;
        var languagesProxy : LanguagesProxy = facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;
        var settings : Settings = settingsProxy.currentSettings;

        if(!settings.selectedLanguageCode)
        {
            settings.selectedLanguageCode = languagesProxy.defaultLanguageCode;
        }

        timelineScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);

        if(!timelineScreen.selectedLanguage){

            settings.selectedLanguageCode="en-US";
            timelineScreen.selectedLanguage = languagesProxy.getLanguage(settings.selectedLanguageCode);
        }

        timelineScreen.languages = languagesProxy.languages;

        if(timelineScreen.languages!=null && timelineScreen.languages.length<=0){
            languagesProxy.loadLanguages();
        }else if (timelineScreen.languages==null){
            languagesProxy.loadLanguages();
        }
    }

    public function get timelineScreen() : TimelineScreen
    {
        return viewComponent as TimelineScreen;
    }
}
}
