package com.despark.tuning3d.view.components.brands
{
    import by.blooddy.crypto.serialization.JSONer;

    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.brands.Brand;
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
    import com.despark.tuning3d.model.core.AppMode;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.core.Tracer;
    import com.despark.tuning3d.model.languages.Language;
    import com.despark.tuning3d.model.languages.Multilingual;
    import com.despark.tuning3d.model.packages.PackagesProxy;
    import com.despark.tuning3d.model.packages.Packet;
    import com.despark.tuning3d.model.packages.Purchase;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.BrandsScreenMediator;
    import com.despark.tuning3d.view.components.cars.FeaturedCarItemRenderer;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
    import com.despark.tuning3d.view.components.challenges.controls.ImageLabel;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.AlertViewHL;
    import com.despark.tuning3d.view.components.core.BlockerView;
    import com.despark.tuning3d.view.components.core.BrandMenuScreen;
    import com.despark.tuning3d.view.components.core.BrandsScreenBackgroundImage;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.CustomAlertView;
    import com.despark.tuning3d.view.components.core.ExtendedLabel;
    import com.despark.tuning3d.view.components.core.IMainMenuHolder;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.MainMenuButton;
    import com.despark.tuning3d.view.components.core.MainMenuView;
    import com.despark.tuning3d.view.components.core.MultilingualButton;
    import com.despark.tuning3d.view.components.core.MultilingualLabel;
    import com.despark.tuning3d.view.components.core.MultilingualToggleSwitch;
    import com.despark.tuning3d.view.components.core.PackagesView;
    import com.despark.tuning3d.view.components.core.PurchaseView;
    import com.despark.tuning3d.view.components.core.StackedBannerScreen;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.core.StackedScreen;
    import com.despark.tuning3d.view.components.languages.LanguageItemRenderer;
    import com.despark.tuning3d.view.components.rewards.RewardType;
    import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
    import com.distriqt.AdsManager;
    import com.distriqt.GameService;
    import com.utils.Console;
    import com.utils.DateParser;
    import com.utils.FontSelector;
    import com.utils.ImageUtils;
    import com.utils.MemoryTracker;
    import com.utils.ObjectUtils;
    import com.utils.Tracker;

    import feathers.controls.Button;
    import feathers.controls.List;
    import feathers.controls.ScrollBar;
    import feathers.controls.renderers.IListItemRenderer;
    import feathers.controls.text.TextFieldTextRenderer;
    import feathers.core.FeathersControl;
    import feathers.core.ITextRenderer;
    import feathers.data.ListCollection;
    import feathers.layout.Direction;
    import feathers.layout.HorizontalAlign;
    import feathers.layout.HorizontalLayout;
    import feathers.layout.TiledRowsLayout;
    import feathers.layout.VerticalAlign;
    import feathers.layout.VerticalLayout;

    import flash.display.StageOrientation;
    import flash.filesystem.File;
    import flash.system.Capabilities;
    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;

    import starling.animation.Transitions;

    import starling.animation.Tween;

    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.display.Sprite;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;
    import starling.filters.ColorMatrixFilter;
    import starling.textures.Texture;
    import starling.utils.MathUtil;

    public class BrandsScreen extends BrandMenuScreen implements Multilingual, IMainMenuHolder
{
    public static var adsBlocker:Boolean = false;
    public static var pageRef : BrandsScreen;
    public static var carchooserOrder : int = 0;

    private static const MENU_HEIGHT : int = 105;

    public static const SELECT_CAR : String = "SelectCar";
    public static const CLEANUP_MEMORY : String = "CleenupMemory";
    public static const LOGIN_SELECTED : String = "LoginSelected";
    public static const CAR_SELECTED : String = "CarSelected";
    public static const LOGOUT_SELECTED : String = "LogoutSelected";
    public static const BUY_NOW_PACKET:String="onBuyNowPacket";
    public static const INSTRUCTION_SELECTED : String = "INSTRUCTION_SELECTED";
    public static const VS_SELECTED : String = "VS_SELECTED";
    public static const MINIFRAME_SELECTED : String = "MINIFRAME_SELECTED";
    public static const LANGUAGE_CHANGED : String = "LanguageChanged";
    public static const RESTORE_SELECTED:String = "RESTORE_SELECTED";
    public static const SLECTED_MATERIAL_WITH_RELOAD_CAR:String = "SLECTED_MATERIAL_WITH_RELOAD_CAR";

    public static const DISPLAY_REWARD_NOADS_POPUP: String = "DISPLAY_REWARD_NOADS_POPUP";

    public static const OPEN_MAIN_MENU: String = "BrandsOpenMainMenu";
    public static const CLOSE_MAIN_MENU: String = "BrandsCloseMainMenu";

    public var witeTouchEventEnded:Boolean = false;

    private var _packages:Array;
    private var _filteredPackages:Array;
    private var _ads:Object;

    private var _brands : Array;
    private var _onComplete:Function;
    private var _carChooser:BrandScreenCarChooser;

    public var featuredCarsList : List;
    private var carListIsScrolling : Boolean = false;

    private var _mainMenuView : MainMenuView;

    public var purchaseView : PurchaseView;
    public var packagesView : PackagesView;

    private var featuredButton : MultilingualButton;
    public var rewardsButton: Button;
    public var rewardsAvailable: Boolean;
    public var rewardsAdsAvailable: Boolean = false;

    private var updateTextLabel : MultilingualLabel;
    private var backgroundImage : BrandsScreenBackgroundImage;
    private var _featuredCars : Array;
    private var _userSignedIn : Boolean;
    private var featuresIcon:Image;
    private var brandsButtonIcon:Image;
    private var brandsButtonSearchIcon:Image;

    private var _selectedLanguage : Language;

    private var _languages : Array;

    private var blockerView:BlockerView;
    private var _purchasedList:Array=[];
    private var _currentCar : Car;

    public static var FIRST_SHOW_DONE:Boolean=true;
    public static var SELECTED_CAR:Car=null;
    public static var SELECTED_PACKET:Packet=null;
    public static var ONE_ALGREE:Boolean=false;
    public static var selectedMaterialName:String=null;
    public static var selectedCarId : String=null;
    public static var selectedCar:Car=null;
    public static var screenShotTexture:Texture=null;
    public static var screenShotImage:Image=null;
    public var selectedCarType:String=null;

    private var feauturedItemIndex : int = 0;

    private var lftSlidButton:Button;
    private var rgtSlidButton:Button;
    internal var brandListButton:Button;
    public  var displayImage:Image;
    private var dummyButton : MainMenuButton;

    private var touchEventTriggered : Boolean = false;


    private var _language:Language = null;
    private var carListRequestedColumns : int = 1;
    private var vertPadding : Number = 4.2;
    private var _carChooserBackgrounds:Array;
    private var _backgroundIndex:int = 0;

    private var _topButtonPadding:Number = 0;
    private var _carChoiceButton:Button;
    private static const bottomMargin:int = 5;
    private static const mainMargin:int = 10;
    private static var FirstShowDone:Boolean = true;
    public var showCollectPopup:Boolean = false;

    public function startShow() : void
    {
        _backgroundIndex = 0;
        dispatchEvent(new Event(PackagesView.UPDATE_CAR_PACKAGES))
        feauturedItemIndex = 0;
        if(!selectedMaterialName)
        {
            Starling.juggler.delayCall(function():void{

                hideBlocker();

                if(FIRST_SHOW_DONE) {
                    FIRST_SHOW_DONE = false;
                    return;
                }
                updateFeaturedCarList();
                if (_language) {
                    updateWithLanguage(_language);
                }

                if (!packagesView.dataProvider) {
                    recreateElementWithLanguage();
                }

                invalidate();
                brands = _brands;
                Starling.juggler.delayCall(function():void{
                    if (SELECTED_CAR) {
                        ONE_ALGREE = true;
                        dispatchEventWith(CAR_SELECTED, false, SELECTED_CAR);
                        SELECTED_CAR = null;
                        SELECTED_PACKET = null;
                    }
                }, 2);
            }, 0.2);
        }else{

            if(!screenShotImage)
            {
                screenShotImage = new Image(BrandsScreen.screenShotTexture);
                screenShotImage.x = 0;
                screenShotImage.y = 0;

                screenShotImage.width = actualWidth;
                screenShotImage.height = actualHeight;
                addChild(screenShotImage);

            }

            //Нужно найти тачку
            var brand:Brand;
            var car:Car;
            for (var i:int = 0; i < brands.length; i++){
                brand = brands[i];
                for (var j:int = 0; j < brand.cars.length; j++){

                    car = brand.cars[j];

                    if (car.id == BrandsScreen.selectedCarId){

                        BrandsScreen.selectedCar = car;
                        break;
                    }
                }

            }
            Starling.juggler.delayCall(function():void {dispatchEventWith(SLECTED_MATERIAL_WITH_RELOAD_CAR);},2);
        }

        MemoryTracker.gcAndCheck("BrandsScreen.startShow()");
        this.invalidate();
    }

    public function showAdBanner():void{
        AdsManager.$.bannerEnabled = true;
        AdsManager.$.showBannerAfterComplete = true;
        AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
        locateAdBanner();
    }

    public function locateAdBanner():void{
        var bannerPosition:Number = featuredButton.y + (featuredButton.height-AdsManager.$.bannerHeight)/2;
        AdsManager.$.setBannerPosition(bannerPosition * Starling.current.contentScaleFactor, BannerScreen.HOME_SCREEN);
    }

    override public function ShowDone() : void {
        hideBlocker();
        updateModeView();

        if(Constants.FIRST_BRANDS_SCREEN) {
            startShow();
        } else {
            var time : Number = (Constants.SCALE_FACTOR >= 3.375) ? .6 : .3;
            if (mainMenuView && mainMenuView.isOpened) mainMenuView.hide();
            Starling.juggler.delayCall(startShow, time);
        }

        var screenName:Object = {};
        screenName[AppMode.MODE_TUNING] = "Tunings Screen";
        Tracker.trackEvent(screenName[AppMode.self.mode], "open");
        //
        if(rewardsButton && !FirstShowDone){
            AdsManager.$.requestReward();
            GameService.$.getRewardsData(function (rewards: int): void {
                if(rewardsButton){
                    rewardsButton.label = rewards.toString();
                }
                AdsManager.$.requestReward();

                GameService.$.rewardsIsSupport(function(status: Boolean): void {
                    rewardsAvailable = status;
                    if(rewardsButton){
                        rewardsButton.visible = status;
                    }
                    if(rewardNotificationImage){
                        rewardNotificationImage.visible = (status && AdsManager.$.haveRewardAds);
                    }
                    layoutRewardsButton();
                });
            });
            GameService.$.rewardsIsSupport(function(status: Boolean): void {
                rewardsAvailable = status;
                if(rewardsButton){
                    rewardsButton.visible = status;
                }
                if(rewardNotificationImage){
                    rewardNotificationImage.visible = (status && AdsManager.$.haveRewardAds);
                }
                layoutRewardsButton();
            });
        }
        FirstShowDone = false;
    }

    private function resetPackageDefault(packagesArr:Array, completeCallback:Function):void{
        if (packagesArr) {
            for (var i:Number = 0; i < packagesArr.length; i++) {
                if(packagesArr[i].tempOpened){
                    packagesArr[i].tempOpened = false;
                    packagesArr[i].lock = true;
                }
            }

            if(_carChooser){
                _carChooser.validate();
            }
            if(packagesView){
                packagesView.updateLists();
            }
        }
        completeCallback();
    }

    private function checkPackets(packagesArr:Array, completeCallback:Function): void {
        if(!UsersProxy.loggedInUser()){
            resetPackageDefault(packagesArr, completeCallback);
            return;
        }
        GameService.$.getSaveData(function(data: String): void {
            if(!UsersProxy.loggedInUser()){
                resetPackageDefault(packagesArr, completeCallback);
                return;
            }
            var saveData: Object = JSONer.parse(data);
            var currentTime:Number = new Date().time;
            var userId:String = UsersProxy.loggedInUser().id;
            if (packagesArr) {
                var rewardsPackets:Object = (saveData.hasOwnProperty(userId) && saveData[userId].hasOwnProperty("rewardsPackets")?saveData[userId].rewardsPackets:{});
                var oneTimeUnlocked:Object = (saveData.hasOwnProperty(userId) && saveData[userId].hasOwnProperty("oneTimeUnlocked")?saveData[userId].oneTimeUnlocked:{});
                var i:int;
                for (i = 0; i < packagesArr.length; i++) {
                    var pkt:Packet = packagesArr[i] as Packet;
                    var packetId:String = pkt.id;
                    var timePassed:Number = currentTime - rewardsPackets[packetId];
                    if (rewardsPackets.hasOwnProperty(packetId)){
                        if(oneTimeUnlocked[packetId]){
                            pkt.tempOpened = true;
                            pkt.oneTimeUnlocked = true;
                            pkt.lock = false;
                        }else if(timePassed < GameService.REWARDED_PACKAGE_ACTIVE_DURATION && packagesArr[i].lock){
                            pkt.tempOpened = true;
                            pkt.oneTimeUnlocked = false;
                            pkt.lock = false;
                        }else if(timePassed >= GameService.REWARDED_PACKAGE_ACTIVE_DURATION){
                            if(pkt.tempOpened){
                                pkt.tempOpened = false;
                                pkt.oneTimeUnlocked = false;
                                pkt.lock = true;
                            }
                            delete saveData[userId].rewardsPackets[packetId];
                            GameService.$.deleteRewardPacket(packetId);
                        }
                    }else if(pkt.tempOpened){
                        pkt.tempOpened = false;
                        pkt.oneTimeUnlocked = false;
                        pkt.lock = true;
                    }
                    _carChooser.updateTempOpenPacket(pkt);
                    //
                    if(_packages){
                        for(var j:int = 0; j < _packages.length; j++){
                            if(_packages[j].id == pkt.id){
                                _packages[j].tempOpened = pkt.tempOpened;
                                _packages[j].oneTimeUnlocked = pkt.oneTimeUnlocked;
                                _packages[j].lock = pkt.lock;
                            }
                        }
                    }
                }


                GameService.$.saveGameData(JSON.stringify(saveData));

                if(_carChooser){
                    _carChooser.validate();
                }
                if(packagesView){
                    packagesView.updateLists();
                }
            }
            completeCallback();
        });
    }

    /**
     * THe UI elements, which depends on AppMode, should be updated
     */
    public function updateModeView() : void {
        if(!actualWidth || isNaN(actualWidth))
        {
            Starling.juggler.delayCall(updateModeView, 0.2);
            return;
        }
        updateArrowStates();
        rgtSlidButton.x = actualWidth - rgtSlidButton.width/2/* - vertPadding + 1*/;
        updateTextLabel.x = displayImage.x + 15;
        //
        if(brandsButtonIcon){
            try {
                brandsButtonIcon.removeFromParent(true);
            }catch (e:Error) {
                brandsButtonIcon.removeFromParent();
            }
            brandsButtonIcon = null;
        }
        if(featuresIcon){
            try {
                featuresIcon.removeFromParent(true);
            }catch (e:Error) {
                featuresIcon.removeFromParent();
            }
            featuresIcon = null;
        }
        if(Device.isIphoneXVariant()){
            setNavButtonPosition();
        }
        initIcons();
        //
        if(selectedCarType && _carChooser){
            _carChooser.open();
            Starling.juggler.delayCall(function():void{
                if(selectedCarType){
                    _carChooser.selectCarType(selectedCarType, selectedCarType != "all");
                    selectedCarType = null;
                }
            }, 1);
        }
    }

    override public function dispose():void {
        super.dispose();
    }

    public function get currentCar() : Car{
        return _currentCar;
    }

    private function featuredCarsListItemRendererFactory():IListItemRenderer {
        var renderer:FeaturedCarItemRenderer = new FeaturedCarItemRenderer();
        renderer.carBackground = carChooserBackgrounds[_backgroundIndex];
        renderer.setSize(actualWidth, actualHeight);
        _backgroundIndex++;
        if(_backgroundIndex >= carChooserBackgrounds.length){
            _backgroundIndex = 0;
        }
        return renderer;
    }

    public function showBuyPacket(packet:Packet):void{
        this.packagesView.showPacket(packet);
    }

    public function clearMemory(rebuild:Boolean=false):void
    {
        Tracer.print("memoryCleanUp", "BRANDS SCREEN");
        if (!rebuild && featuredCarsList.dataProvider) {
            featuredCarsList.dataProvider = null;
            featuredCarsList.selectedIndex = -1;
        }

        ImageUtils.clearAllTexture();
        MemoryTracker.gcAndCheck("BrandsScreen.clearMemory()");

        if (rebuild) ShowDone();
    }

    public function BrandsScreen() {
        super();
        name = "BrandsScreen";
        screenID = "BrandsScreen";
        _isRoot = true;
        BrandsScreen.pageRef = this;
    }

    public function get userSignedIn():Boolean{
        return _userSignedIn;
    }
    public function set userSignedIn(value:Boolean):void {
        _userSignedIn = value;
        if (!owner)	return;
        invalidate("userSignedIn");
    }

    public function get featuredCars() : Array{
        return _featuredCars;
    }

    private var _featuredCarsHasChanged : Boolean = false;
    public var rewardNotificationImage:Image;

    public function set featuredCars(value : Array) : void {
        if(_featuredCars == value){
            return;
        }
        _featuredCarsHasChanged = true;
        _featuredCars = value;
        if(value && value.length){
            updateArrowStates();
            updateStandText(0);

            invalidate("featuredCars");
            updateFeaturedCarList();
        }
    }

    private function updateFeaturedCarList() : void {
        if(!featuredCarsList.dataProvider || (featuredCars && featuredCarsList.dataProvider.length != featuredCars.length && featuredCarsList.dataProvider.getItemAt(0) != featuredCars[0])){
            if(_featuredCarsHasChanged && featuredCarsList && featuredCars && featuredCarsList.dataProvider) {
                featuredCarsList.dataProvider.removeAll();
            }
            featuredCarsList.dataProvider = new ListCollection(featuredCars);
            featuredCarsList.selectedIndex = -1;
        }

        var tlen : int = featuredCarsList.dataProvider.length;
        featuredCarsList.width = this.actualWidth * (tlen > 1 ? featuredCarsList.dataProvider.length / tlen : 1);
        featuredCarsList.x = (actualWidth - featuredCarsList.width) / 2;
        _featuredCarsHasChanged = false;
        refresh();
    }


    protected override function get handleTexture() : Texture {
        return null;
    }

    protected override function get menuBackgroundTexture() : Texture {
        return null;
    }

    protected override function get menuHeight() : int {
        return MENU_HEIGHT;
    }

    public function packetPurchaseSuccess(packet:Packet):void {
        var facade : ApplicationFacade = ApplicationFacade.getInstance();
        var packagesProxy : PackagesProxy;

        var i : int = 0;
        var p : Packet;

        packagesProxy = facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
        packet.lock = false;

        if (packet.type == Packet.TYPE_ALLPACKET){
            for (i = 0; i < packagesProxy.packages.length; i++){
                p = packagesProxy.packages[i];
                p.lock = false;
            }
        }

        if (packet.type == Packet.TYPE_CURRENTALLPACKET && packet.packets!=null) {
            for(i=0; i < packagesProxy.packages.length; i++){
                p = packagesProxy.packages[i];
                if (packet.packets.indexOf(p.id) >= 0){
                    p.lock = false;
                }
            }
        }

        this.packagesView.packetPurchaseSuccess(packet);

        _purchasedList.push(new  Purchase(packet.id, packet.title, true, packet.type, packet.productId));
        purchaseView.dataProvider = _purchasedList;
        try {
            purchaseView.dataProvider.updateAll();
        }catch(e:Error){

        }
        refresh();
    }

    public function adsRemoverPurchaseSuccess(ads:Object):void
    {
        AdsManager.turnOffAds();
        ads.lock = false;
        topButtonPadding = 0;


        _purchasedList.push(new Purchase(ads.id, ads.title, true, Packet.TYPE_REMOVE_ADS ));
        purchaseView.dataProvider = _purchasedList;
    }

    public function carPurchaseSuccess(car:Car):void
    {
        if (car.packet) {
            car.packet.lock = false;
        }

        _purchasedList.push(new Purchase(car.id, car.name + " " + car.model, true,Packet.TYPE_COMPONENTS));
        purchaseView.dataProvider = _purchasedList;
    }

    public function recreateElementWithLanguage():void
    {
        if (this.packagesView)
        {
            var packagesViewVisible:Boolean = packagesView.visible;
            var dataProvider:Array = packagesView.dataProvider;

            packagesView.removeEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
            packagesView.removeEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
            packagesView.removeEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
            packagesView.removeEventListener(Event.OPEN, packagesViewOpen);
            packagesView.removeEventListener(Event.CLOSE, packagesViewClose);
            packagesView.removeEventListener(PackagesView.VIEW_CAR_360, viewCar360);
            packagesView.removeEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);
            packagesView.removeEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
            packagesView.removeEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
            packagesView.removeEventListener(PackagesView.WATCH_REWARDS_ADS, showRewardAdsHandler);
            packagesView.removeEventListener(PackagesView.OPEN_CHALLENGES, challengesSelectedHandler);
            packagesView.removeFromParent(true);

            // PackagesView.PACKAGE_ITEM_WIDTH    = 262;//262;
            // PackagesView.OLD_PACKET_ITEM_WIDTH = 262; //262;
            PackagesView.PACKAGE_ITEM_WIDTH = PackagesView.getPackageItemWidth();//Device.isIos() ? 242 : Constants.SCALE_FACTOR==3.375 ? 232 : 242;
            PackagesView.OLD_PACKET_ITEM_WIDTH = PackagesView.PACKAGE_ITEM_WIDTH;

            AlertView.language = _language;
            packagesView = new PackagesView();
            packagesView.name = "packagesView";
            packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);

            PackagesView.calacItemCount = true;
            packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);

            if (!packagesViewVisible) {
                packagesView.hide();
            }

            packagesView.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
            packagesView.addEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
            packagesView.addEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
            packagesView.addEventListener(Event.OPEN, packagesViewOpen);
            packagesView.addEventListener(Event.CLOSE, packagesViewClose);
            packagesView.addEventListener(PackagesView.VIEW_CAR_360, viewCar360);


            packagesView.addEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
            packagesView.addEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
            packagesView.addEventListener(PackagesView.WATCH_REWARDS_ADS, showRewardAdsHandler);
            packagesView.addEventListener(PackagesView.OPEN_CHALLENGES, challengesSelectedHandler);

            packagesView.addEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);

            packagesView.parentActualWith = actualWidth;
            packagesView.parentActualHeight = actualHeight;
            packagesView.dataProvider = dataProvider;
            addChild(packagesView);

            packagesView.updateWithLanguage(AlertView.language);
            packagesView.x = packagesView.y = 0;
        }
    }

    public function updateWithLanguage(language:Language) : void
    {
        _language = language;

        AlertView.language = language;
        CustomAlertView.language = language;
        AlertViewHL.language = language;

        if (brandListButton){
            brandListButton.label = _language.translate("mob_home","carBrands");
        }

        if (featuredButton){
            featuredButton.label = 'FEATURED\nPACKAGES';//_language.translate("mob_home", "featured"); //AlertView.language.translate("mob_home", "featured");
            featuredButton.updateWithLanguage(language);
        }

        if (packagesView){
            packagesView.updateWithLanguage(language);
        }

        if (purchaseView)
        {
            packagesView.updateWithLanguage(language);
            //this.invalidate();
            //purchaseView.updateWithLanguage(language);
        }
    }


    override protected function initialize() : void
    {
        trace("BrandScreen initialize");

        displayImage = ButtonFactory.standTexture("up_display");

        displayImage.name = "displayImage";
        displayImage.touchable = false;
        displayImage.visible = false;
        displayImage.width = 124;
        displayImage.height = 43;


        updateTextLabel = new MultilingualLabel();
        updateTextLabel.name = "updateTextLabel";
        updateTextLabel.textRendererFactory = titleLabelRenderer;

        rgtSlidButton = ButtonFactory.arrowButton("slide_arr_lt");
        rgtSlidButton.name = "rightArrow";
        rgtSlidButton.rotation = Math.PI;

        lftSlidButton = ButtonFactory.arrowButton("slide_arr_lt");
        lftSlidButton.name = "leftArrow";
        lftSlidButton.visible = rgtSlidButton.visible = false;

        var featuredCarsLayout : HorizontalLayout = new HorizontalLayout();
        featuredCarsLayout.useVirtualLayout = false;
        featuredCarsList = new List();
        featuredCarsList.name = "featuredCarsList";
        featuredCarsList.paddingTop = 0;
        featuredCarsList.clipContent = true;
        featuredCarsList.layout = featuredCarsLayout;
        featuredCarsList.hasElasticEdges = true;
        featuredCarsList.snapToPages = true;
        featuredCarsList.itemRendererFactory = featuredCarsListItemRendererFactory;
        featuredCarsList.addEventListener(Event.CHANGE, featuredCarListChangeHandler);
        featuredCarsList.addEventListener(TouchEvent.TOUCH, handleTouch);
        featuredCarsList.addEventListener(Event.SCROLL, featuredListScrollHandler);
        featuredCarsList.addEventListener("featuredCompleteLoad", featuredCompleteLoad);


        super.initialize();

        featuredButton = ButtonFactory.featuredButton("BUY NOW");
        featuredButton.name = "featuredButton";
        featuredButton.addEventListener(Event.TRIGGERED, allCarsButtonTriggeredHandler);

        try{
            var screenRatio:Number = Starling.current.nativeStage.stage.fullScreenWidth / Capabilities.screenDPI;
            if(screenRatio < 3.5){
                displayImage.scale = updateTextLabel.scale = featuredButton.scale = 0.85;
            }
        }catch (e:Error) {
            // screen DPI is not available
        }


        dummyButton = ButtonFactory.menuBigButton("a_back_button", 0x000000);
        dummyButton.name = "dummyButton";
        dummyButton.width = dummyButton.height = 35;
        dummyButton.addEventListener(Event.TRIGGERED, onDummyButtonHandler);

        brandListButton = ButtonFactory.dropMenuButton("drop_down_menu");
        brandListButton.width = 323;
        brandListButton.name = "brandListButton";
        brandListButton.addEventListener(Event.TRIGGERED, searchMenuToggleEvent);

        //
        initIcons();
        brandsButtonSearchIcon = new Image(ButtonFactory.assetManager.getTexture("src"));
        brandsButtonSearchIcon.width = brandsButtonSearchIcon.height = 16;
        brandsButtonSearchIcon.x = brandListButton.width - (brandsButtonSearchIcon.width + 8);
        brandsButtonSearchIcon.y = (brandListButton.height - brandsButtonSearchIcon.height) / 2;
        var colorFilter:ColorMatrixFilter = new ColorMatrixFilter();
        colorFilter.tint(0x535353, 0.5);
        brandsButtonSearchIcon.filter = colorFilter;
        brandListButton.addChild(brandsButtonSearchIcon);
        //

        _carChoiceButton = ButtonFactory.transparentButton();
        _carChoiceButton.alpha =0;
        _carChoiceButton.addEventListener(Event.TRIGGERED,searchMenuToggleEvent);


        //searchMenuCloseButton.height = searchMenuCloseButton.width  = brandListButton.height;
        //searchFullCloseButton.width  = searchFullCloseButton.height = brandListButton.height;

        var brandsLayout : VerticalLayout = new VerticalLayout();
        brandsLayout.scrollPositionVerticalAlign = VerticalAlign.TOP;
        //brandsLayout.manageVisibility = true;
        brandsLayout.useVirtualLayout = true;
        brandsLayout.gap = 0;

        var carsLayout : TiledRowsLayout = new TiledRowsLayout();
        carsLayout.requestedColumnCount = carListRequestedColumns;
        carsLayout.useSquareTiles = false;
        carsLayout.verticalAlign = VerticalAlign.TOP;
        carsLayout.horizontalAlign = HorizontalAlign.LEFT;
        //carsLayout.manageVisibility = true;
        carsLayout.useVirtualLayout = true;
        carsLayout.gap = 0;





        addChild(featuredCarsList);

        addChild(displayImage);
        addChild(updateTextLabel);
        addChild(lftSlidButton);
        addChild(featuredButton);
        addChild(rgtSlidButton);

        addChild(dummyButton);
        addChild(brandListButton);
        addChild(_carChoiceButton);
        /////////////////////////////////////////////////////////////////////////////////

        purchaseView = new PurchaseView();
        purchaseView.name = "purchaseView";
        purchaseView.setSize(featuredButton.width, featuredButton.height*4);
        purchaseView.hide();
        purchaseView.addEventListener(Event.OPEN, purchaseViewOpen);
        addChild(purchaseView);

        if (!LanguageItemRenderer.SHORT_LABEL){
            LanguageItemRenderer.SHORT_LABEL={};
            LanguageItemRenderer.SHORT_LABEL['ru-RU']='RUS';
            LanguageItemRenderer.SHORT_LABEL['en-US']='ENG';
        }

        createPackagesView();

        blockerView = new BlockerView();
        blockerView.name = "blockerView";
        blockerView.visible = false;
        addChild(blockerView);

        rewardsButton = ButtonFactory.rewardsButton(0);
        rewardsButton.addEventListener(Event.TRIGGERED, diamondTriggeredHandler);
        addChild(rewardsButton);

        var rewardNotificationTexture: Texture = assetManager.getTexture('notification');
        rewardNotificationImage = new Image(rewardNotificationTexture);
        rewardNotificationImage.name = 'notificationReward';

        rewardNotificationImage.width = 8;
        rewardNotificationImage.height = 8;
        rewardNotificationImage.visible = false;
        addChild(rewardNotificationImage);

        _carChooser = new BrandScreenCarChooser();
        _carChooser.brandsScreen = this;
        addChild(_carChooser);
        _carChooser.visible = false;
        _carChooser.addEventListener(Event.OPEN, carChooserOpenHandler);
        _carChooser.addEventListener(Event.CLOSE, carChooserCloseHandler);

        updateModeView();

        rewardsAdsAvailable = AdsManager.$.haveRewardAds;
        if(rewardsAvailable && rewardsButton){
            rewardsButton.visible = true;
            rewardNotificationImage.visible = AdsManager.$.haveRewardAds;
            //
            layoutRewardsButton();
        }
        if(FirstShowDone){
            GameService.$.getRewardsData(function (rewards: int): void {
                if(rewardsButton){
                    rewardsButton.label = rewards.toString();
                }
                AdsManager.$.requestReward();

                GameService.$.rewardsIsSupport(function(status: Boolean): void {
                    rewardsAvailable = status;
                    if(rewardsButton){
                        rewardsButton.visible = status;
                    }
                    if(rewardNotificationImage){
                        rewardNotificationImage.visible = (status && AdsManager.$.haveRewardAds);
                    }
                    layoutRewardsButton();
                });
            });
        }
    }

    private function carChooserOpenHandler(event:Event):void {
        AdsManager.$.bannerHide();
        if(_carChooser.brands != _brands){
            _carChooser.brands = _brands;
        }
    }

    private function carChooserCloseHandler(event:Event):void {
        AdsManager.$.bannerShow(AdsManager.$.currentBannerScreen);
    }

    private function createPackagesView():void{
        if (!packagesView) {
            packagesView = new PackagesView();
            packagesView.name = "packagesView";

            PackagesView.calacItemCount = true;

            var startWidth:int = Device.isIos() ? 262 : Constants.SCALE_FACTOR == 3.375 ? 262 : 262;

            packagesView.setSize(startWidth, actualHeight);
            packagesView.hide();
            packagesView.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
            packagesView.parentActualWith = actualWidth;
            packagesView.parentActualHeight = actualHeight;
            packagesView.addEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
            packagesView.addEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
            packagesView.addEventListener(Event.OPEN, packagesViewOpen);
            packagesView.addEventListener(Event.CLOSE, packagesViewClose);
            packagesView.addEventListener(PackagesView.VIEW_CAR_360, viewCar360);
            packagesView.addEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);
            packagesView.addEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
            packagesView.addEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
            packagesView.addEventListener(PackagesView.WATCH_REWARDS_ADS, showRewardAdsHandler);
            packagesView.addEventListener(PackagesView.OPEN_CHALLENGES, challengesSelectedHandler);

            addChild(packagesView);
        }
    }

    private function createPurchaseView():void{
        if (!purchaseView) {
            purchaseView = new PurchaseView();
            purchaseView.name = "purchaseView";
            purchaseView.setSize(featuredButton.width, featuredButton.height*4);
            purchaseView.hide();
            purchaseView.addEventListener(Event.OPEN, purchaseViewOpen);
            addChild(purchaseView);
        }
    }

    private function initIcons():void{
        if(AppMode.self.mode == AppMode.MODE_TUNING){
            brandsButtonIcon = new Image(ButtonFactory.assetManager.getTexture("care_btn"));
            featuresIcon = new Image(ButtonFactory.assetManager.getTexture("care_btn"));
        }

        var colorFilter1:ColorMatrixFilter = new ColorMatrixFilter();
        colorFilter1.tint(0x535353, 1);
        var colorFilter2:ColorMatrixFilter = new ColorMatrixFilter();
        colorFilter2.tint(0x535353, 1);
        if(featuredButton && brandListButton && featuresIcon && brandsButtonIcon) {
            featuredButton.addChild(featuresIcon);
            brandListButton.addChild(brandsButtonIcon);

            featuresIcon.filter = colorFilter1;
            brandsButtonIcon.filter = colorFilter2;
            featuresIcon.width = featuresIcon.height = 22;
            featuresIcon.x = 18;
            featuresIcon.y = (featuredButton.height - featuresIcon.height) / 2;

            brandsButtonIcon.width = brandsButtonIcon.height = 18;
            brandsButtonIcon.x = 8;
            brandsButtonIcon.y = (brandListButton.height - brandsButtonIcon.height) / 2;
        }
    }

    public function updateArrowStates() : void
    {
        if (!_featuredCars || _featuredCars.length <= 1){
            if(lftSlidButton)
            {
                lftSlidButton.visible = rgtSlidButton.visible = false;
            }
            return;
        }

        lftSlidButton.visible = rgtSlidButton.visible = true;
        updateNavViews();

        rgtSlidButton.addEventListener(Event.TRIGGERED, feauturedListChange);
        lftSlidButton.addEventListener(Event.TRIGGERED, feauturedListChange);
    }

    private function friendRequestButtonHandler(event:Event):void
    {
        trace("friendRequestButtonHandler");
        if (!userSignedIn){
            dispatchEventWith(BrandsScreen.LOGIN_SELECTED);
        }
    }

    protected function featuredCompleteLoad(event:Event):void{
        AppMode.self.dispatchEventWith("featuredCompleteLoad");
    }

    public function updateNotifications() :void{
        if(dummyButton){
            dummyButton.updateNotification();
        }
    }



    protected function onDummyButtonHandler(event:Event):void{
        homeButtonTriggeredHandler();
    }

    protected override function layoutMenuViews() : void
    {
        super.layoutMenuViews();

        if (mainMenuView){
            mainMenuView.hide();
        }

        ////////////////////////////////////////////////////////////
        if (backgroundImage){
            backgroundImage.y = 0;
            backgroundImage.setSize(actualWidth,actualHeight);
            backgroundImage.alignCenter();
        }

        lftSlidButton.y = (actualHeight) / 2 - 11;
        lftSlidButton.x = lftSlidButton.width / 2;
        rgtSlidButton.y = lftSlidButton.y;

        brandListButton.y = vertPadding + topButtonPadding + (mainMargin + 1.5);
        brandListButton.x = (actualWidth - brandListButton.width) / 2;

        if(Device.isIphoneXVariant()){
            setNavButtonPosition();
        }

        this._carChoiceButton.x = 100;
        this._carChoiceButton.y = 0;

        this._carChoiceButton.width = actualWidth - 200;
        _carChoiceButton.height = 40;
        ///////////////////////////////////////////////
        featuredButton.x = 0;
        featuredButton.y = actualHeight - featuredButton.height - bottomMargin;

        layoutRewardsButton();

        dummyButton.x = mainMargin;
        dummyButton.y = mainMargin + topButtonPadding;

        featuredButton.x = 0;
        featuredButton.y = actualHeight - featuredButton.height - bottomMargin;
        displayImage.x = actualWidth - displayImage.width;
        displayImage.y = actualHeight - displayImage.height - bottomMargin;
        if(Device.isIphoneXVariant()){
            dummyButton.x += 6;
            setNavButtonPosition();
        }

        updateTextPosition();
    }

    private function layoutRewardsButton():void{
        if (rewardsButton) {
            rewardsButton.x = actualWidth - rewardsButton.width - mainMargin;
            rewardsButton.y = mainMargin;

            if (Device.isIphoneXVariant()) {
                rewardsButton.x -= 15;
            }
            //
            if(rewardNotificationImage){
                rewardNotificationImage.x =  rewardsButton.x +  rewardsButton.width -  rewardNotificationImage.width;
                rewardNotificationImage.y =  rewardsButton.y;
            }
        }
    }

    public function setNavButtonPosition():void{
        if(!stage){
            return;
        }
        var marginSize:Number = 24;
        if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_RIGHT){
            lftSlidButton.x = lftSlidButton.width / 2 + marginSize;
            rgtSlidButton.x = actualWidth - rgtSlidButton.width / 2;
        }else if(stage.starling.nativeStage.orientation == StageOrientation.ROTATED_LEFT){
            lftSlidButton.x = lftSlidButton.width / 2;
            rgtSlidButton.x = actualWidth - rgtSlidButton.width / 2 - marginSize;
        }else{
            lftSlidButton.x = lftSlidButton.width / 2;
            rgtSlidButton.x = actualWidth - rgtSlidButton.width / 2;
        }
    }

    private function viewCar360(event:Event):void {
        var car:Car = event.data.car;
        var packet:Packet = event.data.packet;
        dispatchEventWith(PackagesView.VIEW_CAR_360, false, {car:car, packet:packet});
    }

    private function displayRewardConfirmPopUp(event: Event): void {
        var packet: Packet = event.data.packet;
        var eventData:Object = {packet: packet};
        if(event.data){
            eventData = ObjectUtils.merge(eventData, event.data);
        }
        dispatchEventWith(PackagesView.SHOW_CONFIRM_POP_UP, false, eventData);
    }

    private function displayRewardNoCoinPopUp(event:Event):void {
        dispatchEventWith(PackagesView.SHOW_NO_COIN_POP_UP);
    }

    private function showRewardAdsHandler(event:Event):void {
        showCollectPopup = false;
        dispatchEventWith(PackagesView.WATCH_REWARDS_ADS);
    }

    private function challengesSelectedHandler(event:Event):void {
        dispatchEventWith(PackagesView.OPEN_CHALLENGES);
    }

    private function onBuyNowPacket(event:Event):void{
        dispatchEventWith(BUY_NOW_PACKET, false, {packet:event.data.packet as Packet});
    }

    protected function onPackagesViewCalcWidthEnd(event:Event=null):void
    {
        packagesView.removeEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
        packagesView.removeEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
        packagesView.removeEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
        packagesView.removeEventListener(Event.OPEN, packagesViewOpen);
        packagesView.removeEventListener(Event.CLOSE, packagesViewClose);
        packagesView.removeEventListener(PackagesView.PACKAGES_VIEW_CALC_WIDTH_END, onPackagesViewCalcWidthEnd);
        packagesView.removeEventListener(PackagesView.VIEW_CAR_360, viewCar360);

        packagesView.removeEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
        packagesView.removeEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
        packagesView.removeEventListener(PackagesView.WATCH_REWARDS_ADS, showRewardAdsHandler);
        packagesView.removeEventListener(PackagesView.OPEN_CHALLENGES, challengesSelectedHandler);

        packagesView.removeFromParent(true);

        packagesView = new PackagesView();
        packagesView.name = "packagesView";
        PackagesView.calacItemCount = false;
        packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);
        packagesView.hide();
        packagesView.parentActualWith = actualWidth;
        packagesView.parentActualHeight = actualHeight;
        packagesView.addEventListener(PacketItemRenderer.TOUCH_PACKET_INFO, touchPacketInfo);
        packagesView.addEventListener(PackagesView.BUY_NOW_PACKET, onBuyNowPacket);
        packagesView.addEventListener(PacketItemRenderer.ITEM_TOUCH_PACKET, itemTouchPacket);
        packagesView.addEventListener(Event.OPEN, packagesViewOpen);
        packagesView.addEventListener(Event.CLOSE, packagesViewClose);
        packagesView.addEventListener(PackagesView.VIEW_CAR_360, viewCar360);
        packagesView.addEventListener(PackagesView.SHOW_CONFIRM_POP_UP, displayRewardConfirmPopUp);
        packagesView.addEventListener(PackagesView.SHOW_NO_COIN_POP_UP, displayRewardNoCoinPopUp);
        packagesView.addEventListener(PackagesView.WATCH_REWARDS_ADS, showRewardAdsHandler);
        packagesView.addEventListener(PackagesView.OPEN_CHALLENGES, challengesSelectedHandler);
//			packagesView.dataProvider = _filteredPackages;
        addChild(packagesView);

        if (AlertView.language) packagesView.updateWithLanguage(AlertView.language);

        packages = _packages;

        this.invalidate(FeathersControl.INVALIDATION_FLAG_SIZE);
    }


    protected function packagesViewOpen(event:Event) : void {
        this.purchaseView.visible = false;
    }

    protected function packagesViewClose(event:Event) : void {
        AdsManager.$.showBannerAfterComplete = true;
        AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
    }

    protected function purchaseViewOpen(event:Event) : void {
        //trace("purchaseViewOpen()");
        this.packagesView.visible = false;
    }

    protected function itemTouchPacket(event:Event):void{
        this.dispatchEventWith(PacketItemRenderer.ITEM_TOUCH_PACKET, false, {packet:event.data.packet as Packet});
    }

    protected function touchPacketInfo(event:Event):void{
        this.dispatchEventWith(PacketItemRenderer.TOUCH_PACKET_INFO, false, {packet:event.data.packet as Packet});
    }

    private function  titleLabelRenderer ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 9, 0xFFFFFF);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.letterSpacing = -.1;
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.isHTML = true;
        textRenderer.wordWrap = true;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public function dispatchExternalEvent(msg:String):void {
        if (mainMenuView) mainMenuView.hide();
        dispatchEventWith(msg);
    }

    public function set ads(value:Object):void{
        _ads = value;
    }
    public function get ads():Object{
        return _ads;
    }

    public function set packages(value:Array) : void {
        var i:int;
        var j:int;
        if(_packages && value){
            for(i = 0; i < _packages.length; i++){
                for(j = 0; j < value.length; j++){
                    if(_packages[i].id == value[j].id){
                        value[j].tempOpened = _packages[i].tempOpened;
                        value[j].lock = _packages[i].lock;
                    }
                }
            }
        }
        _packages = value;
        if (_packages && _packages.length > 0){
            featuredButton.visible = true;
        }

        _filteredPackages = Packet.filteringPackages(_packages);

        createPackagesView();

        checkPackets(_filteredPackages, function ():void {
            packagesView.dataProvider = _filteredPackages;
            var car : Car;
            if (featuredCarsList) {
                if (featuredCarsList.dataProvider) {
                    for(i = 0; i < featuredCarsList.dataProvider.length; i++){
                        car = featuredCarsList.dataProvider.getItemAt(i) as Car;
                        featuredCarsList.dataProvider.updateItemAt(i);
                    }
                }
                featuredCarsList.invalidate();
            }
        });
    }

    public function get packages():Array {
        return _packages;
    }


    public function set purchases(value : Array) : void {
        _purchasedList = value;
        var allPacketsIsOpen: Boolean = false;
        var i:int;
        for (i = 0; i< value.length; i++) {
            var packetType: String = value[i].type;
            if (packetType ==  Packet.TYPE_ALLPACKET) {
                allPacketsIsOpen = true;
                break;
            }
        }

        if (allPacketsIsOpen) {
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var packagesProxy:PackagesProxy= facade.retrieveProxy(PackagesProxy.NAME) as PackagesProxy;
            var packets: Array = packagesProxy.packages;
            for (i = 0; i < packets.length; i++) {
                packets[i].lock = false;
            }
        }

        createPurchaseView();
        purchaseView.dataProvider = _purchasedList;
        if (packagesView && packagesView.dataProvider) {
            for(i = 0; i < packagesView.dataProvider.length; i++){
                if (allPacketsIsOpen) {
                    var pk: Packet = packagesView.dataProvider[i];
                    pk.lock = false;
                }
                packagesView.updateItemAt(i);
            }
        }

        packagesView.invalidate();
        var car:Car;
        if (this.featuredCarsList) {
            if (this.featuredCarsList.dataProvider) {
                for (var ii:int = 0; ii < featuredCarsList.dataProvider.length; ii++){
                    car = featuredCarsList.dataProvider.getItemAt(ii) as Car;
                    featuredCarsList.dataProvider.updateItemAt(ii);
                }
            }
            featuredCarsList.invalidate();
        }

        if(_purchasedList.length == 0){
            //packagesView.clearPurchases();
        }else{
            for(var j:int = 0; j < _purchasedList.length; j++){
                packagesView.packetPurchaseUpdate(_purchasedList[j]);
            }
        }
    }

    public function get purchases():Array{
        return _purchasedList;
    }

    public function set brands(value : Array) : void {
        _brands = value;
        if(_carChooser && _brands && _carChooser.visible){
            _carChooser.brands = _brands;
        }
        if(_onComplete != null){
            _onComplete();
            _onComplete = null;
        }
    }

    override public function transitionComplete():void{
        showAdBanner();
    }

    public function get brands() : Array {
        return _brands;
    }

    protected override function draw() : void
    {
        super.draw();
        if (!mainMenuView){
            mainMenuView = new MainMenuView();
            mainMenuView.name = "mainMenuView";
            mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight);
            mainMenuView.parentActualWidth = actualWidth;
            mainMenuView.parentActualHeight = actualHeight;
            addChildAt(mainMenuView,getChildIndex(blockerView) - 1);

            mainMenuView.addEventListener(MainMenuView.START_SHOW, menuOpenHandler);
            mainMenuView.addEventListener(Event.CLOSE, menuCloseHandler);
        }

        if(AppMode.self.mode == AppMode.MODE_TUNING) {
            if(featuredCarsList && featuredCarsList.dataProvider && featuredCarsList.dataProvider.length && featuredCarsList.horizontalPageIndex>-1){
                var car:Car = featuredCarsList.dataProvider.getItemAt(featuredCarsList.horizontalPageIndex) as Car;
                brandListButton.label = getCarLabel(car);
            }
        }else{
            if (brandListButton && _language){
                brandListButton.label = _language.translate("mob_home","carBrands");
            }
        }

        var sizeInvalid : Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SIZE);
        if (sizeInvalid) {

            lftSlidButton.y = (actualHeight) / 2 - 11;
            rgtSlidButton.y = lftSlidButton.y;

            featuredCarsList.height = actualHeight;
            featuredCarsList.y =0;
            updateFeaturedCarList();

            if (featuredCarsList.dataProvider) {
                var tlen : int = featuredCarsList.dataProvider.length;
                featuredCarsList.width = this.actualWidth * (tlen > 1 ? featuredCarsList.dataProvider.length / tlen : 1);
                featuredCarsList.x = (actualWidth - featuredCarsList.width) / 2;

                if (featuredCarsList.dataProvider.length > 1 && featuredCarsList.horizontalPageIndex == 0) {
                    updateNavViews();
                    updateStandText();
                } else {
                    if (featuredCarsList.dataProvider.length == 1){
                        updateStandText();
                    }
                }
            } else {
                featuredCarsList.width = actualWidth;
                featuredCarsList.x = (actualWidth - featuredCarsList.width) / 2;
            }

            _newFrameImageHeight = actualHeight - menuHeight;

            layoutMenuViews();

            featuredButton.x = 0;
            featuredButton.y = actualHeight - featuredButton.height - bottomMargin;

            if (packagesView) {
                packagesView.setSize(PackagesView.PACKAGE_ITEM_WIDTH, actualHeight);
                packagesView.x = 0;
                packagesView.y = 0;
                packagesView.parentActualWith = actualWidth;
                packagesView.parentActualHeight = actualHeight;
                purchaseView.setSize(packagesView.width, ((actualHeight - menuHeight - 70)));
                purchaseView.x = 10;
                purchaseView.y = 10 + topButtonPadding;
            }

            if (mainMenuView){
                mainMenuView.y = topButtonPadding;
                mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight - topButtonPadding);
                mainMenuView.parentActualWidth = actualWidth;
                mainMenuView.parentActualHeight = actualHeight - topButtonPadding;
            }

            blockerView.setSize(this.actualWidth, this.actualHeight);

            dummyButton.x = mainMargin;
            dummyButton.y = topButtonPadding + mainMargin;
            if(Device.isIphoneXVariant()){
                dummyButton.x += 6;
            }
        }

        if(Device.isIphoneXVariant()){
            setNavButtonPosition();
        }
    }

    private function menuOpenHandler(event:Event):void {
        dispatchEventWith(OPEN_MAIN_MENU);
    }

    private function menuCloseHandler(event:Event):void {
        dispatchEventWith(CLOSE_MAIN_MENU);
    }

    public function showBlocker() : void {
        if (this.blockerView) blockerView.visible = true;
    }

    public function hideBlocker() : void {
        if (this.blockerView) blockerView.visible = false;
    }

    public function get languages() : Array{
        return _languages;
    }
    public function set languages(value : Array):void {
        _languages = value;
        invalidate("languages");
    }

    public function featuredCarListChangeHandler(event:Event=null):void
    {
        if (!featuredCars || featuredCarsList.selectedIndex < 0){
            featuredCarsList.selectedIndex = -1;
            return;
        }

        trace("featuredCarListChangeHandler")

        var selectedFeaturedCar : Car = this.featuredCars[featuredCarsList.selectedIndex];

        //selectedFeaturedCar = BrandsParser.allCarsList[selectedFeaturedCar.id]

        if (selectedFeaturedCar) {
            SoundManager.playSound(SoundManager.SELECT_PART);
            dispatchEventWith(CAR_SELECTED, false, selectedFeaturedCar);
        }

        featuredCarsList.selectedIndex = -1;
    }

    private function feauturedListChange(event:Event=null) : void
    {
        if(featuredCarsList.isScrolling) return;

        if (!featuredCarsList || featuredCarsList.dataProvider==null ||  featuredCarsList.dataProvider.length < 1) {
            return;
        }

        var dir : int = 'leftArrow' == Button(event.target).name ? -1 : 1;

        if(featuredCarsList.horizontalPageIndex==0 && dir==-1){
            _carChooser.open();
            return;
        }

        if(featuredCarsList.horizontalPageIndex==featuredCarsList.dataProvider.length-1 && dir==1){
            _carChooser.open();
            return;
        }

        feauturedItemIndex = featuredCarsList.horizontalPageIndex + dir;

        featuredCarsList.dataProvider.updateItemAt(featuredCarsList.horizontalPageIndex + dir);
        featuredCarsList.scrollToDisplayIndex(feauturedItemIndex, 0.5);

    }

    internal static function getCarLabel(car:Car):String{
        if(!car){
            return '';
        }
        var limit:int = 30;
        var year:String = (car.year?car.year.toString().substring(2):'');
        var result:String = (car.name?car.name:"").toUpperCase() + ' ' + (car.model?car.model:"") + ' “' + year;
        return (result.length > limit?result.substr(0, limit) + "...":result);
    }

    private function searchMenuToggleEvent(event:Event) : void {
        if(_carChooser){
            _carChooser.open();
        }
    }

    private function updateStandText(index:int = 0):void {
        if(AppMode.self.mode == AppMode.MODE_TUNING) {
            if(brandListButton && index > -1 && featuredCarsList.dataProvider && featuredCarsList.dataProvider.length){
                var car:Car = featuredCarsList.dataProvider.getItemAt(index) as Car;
                brandListButton.label = getCarLabel(car);
            }
        }
        var visiblity : Boolean = false;
        var careInFocuse : Car = featuredCars[index];
        var tapStr:String = '<br/><font color="#ff0000" size="7" style="font-style:italic">&#34;<i>tap on car to start</i>&#34;</font>';

        if (Car.weakDevice) {
            careInFocuse = featuredCars[index];
            visiblity = (careInFocuse.updateText && careInFocuse.updateText.indexOf('<br>') != -1 || careInFocuse.updateText.length > 1 && careInFocuse.updateText.indexOf('test text') == -1);
            if (visiblity){
                updateTextLabel.text = careInFocuse.updateText + tapStr;
                updateTextLabel.visible = displayImage.visible = visiblity;
            }
            updateTextPosition();
            return;
        }

        if (careInFocuse && careInFocuse.updateText) {
            visiblity = (careInFocuse.updateText.indexOf('<br>') != -1);
            if (visiblity){
                updateTextLabel.text = careInFocuse.updateText + tapStr;
                updateTextLabel.visible = displayImage.visible = visiblity;
            }
        } else {
            updateTextLabel.visible = displayImage.visible = visiblity;
        }
        updateTextPosition();
    }

    private function updateTextPosition():void{
        updateTextLabel.width = displayImage.width - 20;
        updateTextLabel.validate();
        updateTextLabel.x = displayImage.x + 15;
        updateTextLabel.y = displayImage.y + (displayImage.height - updateTextLabel.height) / 2;
    }

    private var touches:Vector.<Touch> = new Vector.<Touch>;
    private function handleTouch(event:TouchEvent):void
    {
        var touch : Touch = event.touches[0] as Touch;

        if (touch.phase == TouchPhase.BEGAN){
            touchEventTriggered = true;
            if(carListIsScrolling && featuredCarsList.isScrolling){
                SoundManager.playSound(SoundManager.SELECT_PART);
            }
        }

        if (touch.phase == TouchPhase.MOVED){
        }

        if (touch.phase == TouchPhase.ENDED){
            
        }
    }

    private function featuredListScrollHandler(event:Event) : void {
        if (featuredCarsList.isScrolling && featuredCarsList.horizontalScrollPosition != featuredCarsList.minHorizontalScrollPosition && featuredCarsList.horizontalScrollPosition != featuredCarsList.maxHorizontalScrollPosition) {
            if(!carListIsScrolling){
                carListIsScrolling = true;
                SoundManager.playSound(SoundManager.SELECT_PART);
            }
            return;
        }

        if(featuredCarsList.dataProvider==null || featuredCarsList.dataProvider.length == 0){
            return;
        }

        updateNavViews();

        carListIsScrolling = false;
        updateStandText(featuredCarsList.horizontalPageIndex);
    }

    public function addResource(resourceType:String, resourceValue:int, color:uint, startX:Number, startY:Number):void{
        if(!stage){
            return;
        }
        resourceValue = MathUtil.clamp(resourceValue, 0, resourceValue);

        var resourceLabel:ImageLabel = new ImageLabel();
        stage.addChild(resourceLabel);
        resourceLabel.scale = 0.75 * ButtonFactory.assetManager.scaleFactor / 2;
        resourceLabel.color = color;
        resourceLabel.text = resourceValue.toString();
        resourceLabel.x = startX - resourceLabel.width / 2;
        resourceLabel.y = startY + 30;
        var tween:Tween = new Tween(resourceLabel, 0.35, Transitions.LINEAR);
        tween.onComplete = function():void{
            resourceLabel.removeFromParent(true);
        }
        if(resourceType == RewardType.DIAMONDS){
            tween.moveTo(rewardsButton.x + (rewardsButton.width - resourceLabel.width) / 2, rewardsButton.y + (rewardsButton.height - resourceLabel.height) / 2);
        }
        Starling.juggler.add(tween);
    }

    private function loadFeaturedCarImage(index:int):Boolean{
        Console.log("loadFeaturedCarImage", index);
        var data:Object = featuredCarsList.dataProvider.getItemAt(index);
        var renderer:FeaturedCarItemRenderer = featuredCarsList.itemToItemRenderer(data) as FeaturedCarItemRenderer;
        if(renderer && !renderer.isLoaded) {
            renderer.loading();
            return true;
        }
        return false;
    }

    private function updateNavViews():void{
        if(lftSlidButton && rgtSlidButton && featuredCarsList && featuredCarsList.dataProvider){
            rgtSlidButton.alpha = (featuredCarsList.horizontalPageIndex == featuredCarsList.dataProvider.length -1)? 0.5: 1;
            lftSlidButton.alpha = (featuredCarsList.horizontalPageIndex == 0)? 0.5: 1;
        }
    }

    public function updateView():void{

    }

    private function diamondTriggeredHandler(event:Event):void {
        showCollectPopup = true;
        var statsDialog:ChallengeAlertView = ChallengeAlertView.show(ChallengeAlertView.DIAMONDS, null, this);
        statsDialog.open();
        statsDialog.addEventListener(ChallengeAlertEvent.CHALLENGES_TRIGGERED, challengesSelectHandler);
        statsDialog.addEventListener(ChallengeAlertEvent.REWARDS_TRIGGERED, rewardsButtonTriggeredHandler);
        statsDialog.addEventListener(ChallengeAlertEvent.WATCH_TRIGGERED, watchButtonTriggerHandler);
    }

    private function rewardsButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.PART_MENU);
        dispatchEventWith(StackedScreen.DISPLAY_REWARD_INFO_POPUP);
    }

    private function watchButtonTriggerHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(StackedScreen.DISPLAY_REWARD_INFO_POPUP, false, {watchAds: true});
    }

    private function challengesSelectHandler(event:Event):void {
        dispatchEvent(new Event(StackedBannerScreen.CHALLENGES_HOME_SELECTED));
    }

    private function allCarsButtonTriggeredHandler(event : Event) : void {
        if (!_packages || _packages.length < 1){
            return;
        }
        SoundManager.playSound(SoundManager.PART_MENU);
        AdsManager.$.showBannerAfterComplete = false;
        AdsManager.$.bannerHide();
        packagesView.show(true);
    }

    public function set mainMenuView(value : MainMenuView): void {
        this._mainMenuView = value;
        this._mainMenuView.owner = this;
    }

    public function get mainMenuView():MainMenuView {
        return this._mainMenuView;
    }

    public function brandsScreenButtonTriggeredHandler(event:Event = null):void {
    }

    public function homeButtonTriggeredHandler(event: Event = null) : void
    {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(StackedScreen.HOME_SELECTED);
    }

    public function set selectedLanguage(value:Language):void {
        this._selectedLanguage = value;
    }

    public function get selectedLanguage():Language {
        return this._selectedLanguage;
    }

    public function enterRowsState() : void {
        Tracer.print("Brands screen doesn't have row state");
    }

    public function get topButtonPadding():Number {
        return _topButtonPadding;
    }

    public function set topButtonPadding(value:Number):void {
        if(_topButtonPadding != value) {
            _topButtonPadding = value;
            invalidate(FeathersControl.INVALIDATION_FLAG_SIZE);
            draw();
        }
    }

    public function refresh():void {
        var idList:Object = {};
        var j:int;
        var haveVipPack: Boolean = false;
        for(j = 0; j < _purchasedList.length; j++){
            idList[_purchasedList[j].id] = _purchasedList[j];
            if (_purchasedList[j].type == Packet.TYPE_ALLPACKET) {
                haveVipPack = true;
                break;
            }
        }
        if(featuredCarsList && featuredCarsList.dataProvider) {
            for (var i:int = 0; i < featuredCarsList.dataProvider.length; i++) {
                var car:Car = featuredCarsList.dataProvider.getItemAt(i) as Car;
                if (car.packets && car.packets.length) {
                    for (j = 0; j < car.packets.length; j++) {
                        if (idList.hasOwnProperty(Packet(car.packets[j]).id)) {
                            Packet(car.packets[j]).lock = false;
                        }
                    }
                }
                if (car.packet && (idList.hasOwnProperty(car.packet.id) || haveVipPack)) {
                    car.packet.lock = false;
                }
            }
        }
        refreshCurrentFeatured();
    }

    public function refreshCurrentFeatured():void{
        if(featuredCarsList && featuredCarsList.dataProvider && featuredCarsList.dataProvider.length) {
            featuredCarsList.dataProvider.updateItemAt(featuredCarsList.horizontalPageIndex);
        }
    }

    public function updateTempOpenPacket(packet:Packet):void {
        if(brands && !_carChooser.brands){
            _carChooser.brands = brands;
        }
        packagesView.updateTempOpenPacket(packet);
        _carChooser.updateTempOpenPacket(packet);
    }

    public function get onComplete():Function {
        return _onComplete;
    }

    public function set onComplete(value:Function):void {
        _onComplete = value;
    }

    public function get carChooserBackgrounds():Array {
        return _carChooserBackgrounds;
    }

    public function set carChooserBackgrounds(value:Array):void {
        _carChooserBackgrounds = value;
    }
}
}