package com.despark.tuning3d.view.components.brands
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.packages.Packet;
	import com.despark.tuning3d.model.parts.PartSlot;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.MultilingualButton;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.components.downloads.DownloadsDefCarSlotView;
	import com.despark.tuning3d.view.components.downloads.DownloadsPartSlotView;
	import com.utils.FontSelector;

import feathers.controls.ScrollBarDisplayMode;

import feathers.layout.VerticalAlign;

import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.controls.Button;
	import feathers.controls.Label;
	import feathers.controls.List;
	import feathers.controls.ScrollContainer;
	import feathers.controls.renderers.IListItemRenderer;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.FeathersControl;
	import feathers.data.ListCollection;
	import feathers.layout.VerticalLayout;
	
	import starling.core.Starling;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.filters.ColorMatrixFilter;

	public class BuyPacketPopUp extends PopUp implements Multilingual
	{
		//cleanCacheButton
		public static const BUY_NOW_PACKET : String = "buyNowPacket";
		//public static const DOWNLOAD_SELECTED : String = "DownloadSelected";
		//public static const DELETE_SELECTED : String = "DeleteSelected";
		public static const MIN_WIDTH : int = 480;
		
		
		
		private var currentLanguage : Language;
		private var container : ScrollContainer;
		
		private var laterButton : MultilingualButton;
		private var buyNowButton : MultilingualButton;
		
		private var textLabel:TextFieldTextRenderer;
		
		private var headerLabel:TextFieldTextRenderer;
			
		private var _text:String="";
		
		private var _packet:Packet;
		
		private var _carList:List;
		
		private var _dataProvider:Array;
		
		private var _purchasedMode:Boolean=false;
		
		
		
		
		
		public function BuyPacketPopUp()
		{
			super()
						
			setSizeInternal(350, Starling.current.stage.height - 60, false);
			
			/*if(Starling.current.stage.width  <= MIN_WIDTH)
			{
				setSizeInternal(Starling.current.stage.width - 50, Starling.current.stage.height - 50, false);
			}*/
		}
		
		public function set packet(value:Packet):void{
			_packet=value;
            _purchasedMode = !_packet.lock;
			dataProvider=_packet.cars;
		}
		
		public function get packet():Packet{
			return _packet;
		}
		
		public function set dataProvider(value:Array):void{
			_dataProvider=value;
			this.invalidate("data_provider");
		}
		
		public function get dataProvider():Array{
			return _dataProvider;
		}
		
		public function updateWithLanguage(language : Language) : void
		{
			currentLanguage = language;
			
			//title = //language.translate("mob_morecars", "more cars?").toUpperCase();
			titleLabel.updateWithLanguage(language);
			
			
			//headerLabel.u
			//intializingLabel.updateWithLanguage(language);
			
			//totalLabel.text = language.translate("mob_downloads", "total");
			//totalLabel.updateWithLanguage(language);
			
			//cleanCacheButton.updateWithLanguage(language);
			//cleanCacheButton.label = "   CLEAN CACHE"//language.translate("mob_downloads", "cleanCache").toUpperCase();
			
			
			laterButton.updateWithLanguage(language);
			laterButton.label = language.translate("mob_info", "later").toUpperCase();
			
			
			buyNowButton.updateWithLanguage(language);
			buyNowButton.label = language.translate("mob_info", "Buy Now").toUpperCase();
			
			if(packet)
				buyNowButton.label = language.translate("mob_info", "Buy Now").toUpperCase() + " ("+packet.countAmountLabel+" cars for "+packet.feeString+")";
			
			
		}
		override public function set  title(value:String):void{
			
			super.title=value;
			this.invalidate("title");
		}
		
		public function set text(value:String):void{
			
			_text=value;
			
			this.invalidate("text");
		}
		
		public function get text():String{
			
			return _text;
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			container = new ScrollContainer();
			//container.visible = false;
			container.paddingTop = container.paddingBottom = 0;
			container.paddingLeft = container.paddingRight = 10;
			addChild( container );
			
			
			
			/*intializingLabel = new MultilingualLabel();
			intializingLabel.height = 20;
			intializingLabel.textFormat = new TextFormat("OpenSansSemiBold", 12, 0xFFFFFF);
			intializingLabel.textFormat.horizontalAlign = TextFormatAlign.CENTER;
			addChild(intializingLabel);*/
			
			
		
			
			laterButton = ButtonFactory.defaultButton(null, 0x30383b);
			//leaveACommentButton.visible = false;
			
			laterButton.textFormat.size=11;
			laterButton.addEventListener(Event.TRIGGERED, okButtonnTriggeredHandler);
			laterButton.visible=false;
			addChild(laterButton);
			
			
			buyNowButton = ButtonFactory.defaultButton(null, 0x49cc46);
			
			//buyNowButton.width=120;
			//leaveACommentButton.visible = false;
			
			buyNowButton.textFormat.size=11;
			buyNowButton.addEventListener(Event.TRIGGERED, buyNowButtonnTriggeredHandler);
			addChild(buyNowButton);
		
			
		
			
			textLabel=new TextFieldTextRenderer();
			textLabel.height=60;
			textLabel.textFormat = new TextFormat(FontSelector.getFont(), 9, 0x434343);
			textLabel.textFormat.align = TextFormatAlign.LEFT;
			textLabel.wordWrap=true;
			textLabel.isHTML=true;
			
			textLabel.embedFonts=FontSelector.embedFonts();
			
			
			
			
		/*	textLabel.x=13;
			textLabel.y=16;*/
			
		
			/*textLabel.paddingRight=13;
			textLabel.paddingLeft=13;
			textLabel.paddingTop=16;*/
			
			
			      
			  
		
			addChild(textLabel);
			
			
			headerLabel=new TextFieldTextRenderer();
			
			headerLabel.textFormat = new TextFormat(FontSelector.getFont(true), 12, 0x434343); 
			headerLabel.textFormat.align=TextFormatAlign.CENTER;
			headerLabel.textFormat.bold=true;
			
			headerLabel.embedFonts=FontSelector.embedFonts();
			//headerLabel.textFormat.
			addChild(headerLabel);
			
			
			
			var carListLayout :VerticalLayout = new VerticalLayout();
			//carListLayout.manageVisibility = true;
			carListLayout.paddingTop = 0;
			carListLayout.useVirtualLayout = false;
			
			carListLayout.scrollPositionVerticalAlign=VerticalAlign.TOP;
			carListLayout.gap=6;
			
			_carList=new List();
			
			_carList.clipContent = true;
			_carList.layout = carListLayout;
			
			_carList.scrollBarDisplayMode=ScrollBarDisplayMode.FIXED;
			_carList.itemRendererFactory = function() : IListItemRenderer
			{
				var renderer:BuyPacketItemRenderer = new BuyPacketItemRenderer();   
				renderer.setSize(260, 80);
				
				return renderer;   
			};
			addChild(_carList);
		}
	
		
		override protected function draw() : void
		{
			super.draw();
			
			
			if(isInvalid("data_provider")){
				
				
				_carList.dataProvider=new ListCollection(_dataProvider);
				
				if(this._purchasedMode){
					laterButton.label = currentLanguage.translate("mob_info", "close").toUpperCase();
					buyNowButton.label = currentLanguage.translate("mob_info", "purchased").toUpperCase();
					buyNowButton.isEnabled=false;
					buyNowButton.alpha=0.5;
					
					
				}else{
					
					laterButton.label = currentLanguage.translate("mob_info", "later").toUpperCase();
					buyNowButton.label = currentLanguage.translate("mob_info", "Buy Now").toUpperCase() + " ("+packet.cars.length+" cars for "+packet.feeString+")";
					buyNowButton.isEnabled=true;
					buyNowButton.alpha=1;
				}
			}
			
			if(isInvalid("text")){
				
				
				if(textLabel){
					
					textLabel.text=text;
					textLabel.validate();
				}
			}
			
			if(isInvalid("title")){
				
				
				if(titleLabel){
					
					titleLabel.text="PACKAGES";
					
					
				}
				
				if(headerLabel){
					
					headerLabel.text=title.toLocaleUpperCase();
					headerLabel.validate();
				}
			}
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				contentBackgroundImage.width-=10;
				contentBackgroundImage.height-=15;
				
				contentBackgroundImage.x+=5;
				contentBackgroundImage.y+=5;
				
				
				container.x = contentBackgroundImage.x;
				container.y = contentBackgroundImage.y;
				container.width = contentBackgroundImage.width;
				container.height = contentBackgroundImage.height;
				
				
			
			
				laterButton.width=100;
				laterButton.height=28;
				laterButton.x =  ((actualWidth)/2)+10;  
				laterButton.y = contentBackgroundImage.y + contentBackgroundImage.height + 15;; 
				
				buyNowButton.width=180;
				buyNowButton.height=28;
				buyNowButton.x = ((actualWidth)/2)-(buyNowButton.width/2)-10;  
				buyNowButton.y =laterButton.y
				
				
				headerLabel.width=contentBackgroundImage.width-26;
				headerLabel.x= contentBackgroundImage.x+13;
				headerLabel.y=contentBackgroundImage.y+7;
			
				textLabel.width=contentBackgroundImage.width-26;
				textLabel.height=35;
							
				textLabel.x = contentBackgroundImage.x+13;
				textLabel.y =headerLabel.y+headerLabel.height+6;
				
				
			
				_carList.width=contentBackgroundImage.width-26;
				_carList.height=contentBackgroundImage.height-(textLabel.height+headerLabel.height+7+6+5);
				
				
				_carList.x=contentBackgroundImage.x+13;
				_carList.y=textLabel.y+textLabel.height+5;
				
				/*intializingLabel.width = actualWidth;
				intializingLabel.y = int((actualHeight - intializingLabel.height) / 2);*/
			}
			
			
		}
		
	
	
		private function buyNowButtonnTriggeredHandler(event : Event) : void
		{
		
		
			dispatchEventWith(BUY_NOW_PACKET, false, {packet:packet});     
		}
			
				
		
		private function okButtonnTriggeredHandler(event : Event) : void
		{
					
			
			
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}
		
		
	}
}