package com.despark.tuning3d.view.components.brands
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.disks.Disk;
	import com.despark.tuning3d.model.disks.DiskBrand;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.packages.Packet;
	import com.despark.tuning3d.model.parts.PartSlot;
	import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
	import com.despark.tuning3d.view.components.core.MultilingualButton;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.core.PopUp;
	import com.despark.tuning3d.view.components.downloads.DownloadsDefCarSlotView;
	import com.despark.tuning3d.view.components.downloads.DownloadsPartSlotView;
	import com.despark.tuning3d.view.components.parts.PartItemRenderer;
	import com.utils.FontSelector;
	
	import flash.display.DisplayObject;
	import flash.display.Stage;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.utils.setTimeout;
	
	import feathers.controls.Button;
	import feathers.controls.Label;
	import feathers.controls.ScrollContainer;
	import feathers.controls.WebView;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.FeathersControl;
	
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.filters.ColorMatrixFilter;
	import starling.textures.Texture;

	public class PartInfoPopUp extends PopUp implements Multilingual
	{
		//cleanCacheButton
		//public static const CLEAN_CACHE_SELECTED : String = "cleanCacheSelected";
		//public static const DOWNLOAD_SELECTED : String = "DownloadSelected";
		//public static const DELETE_SELECTED : String = "DeleteSelected";
		public static const MIN_WIDTH : int = 480;
		
		public static const IMAGE_WIDTH:int = 100;
		
		
		
		private var currentLanguage : Language;
		private var container : ScrollContainer;

		private var linkArrowImage:Image;
		
		
		private var linkLabel:MultilingualButton;
		
		private var partNameLabel:MultilingualLabel;
		
		private var recommendedLabel:MultilingualLabel;
		
		//private var okButton : MultilingualButton;
		//private var textLabel:TextFieldTextRenderer;
			
		private var _text:String="";
		
		private var _partItem:PartItemRenderer=null;
		
		private var _webView:WebView=null;
		
		public static var WEBVIEW:WebView=null;
		
		public static var WEBVIEW_HIDE:Boolean=false;
		
		public static var WEBVIEW_CLOSE_ALERT:AlertView=null;
		
		
		
		
		
		//private var _packet:Packet;
		
		
		
		public function PartInfoPopUp()
		{
			super();
						
			setSizeInternal(428, Starling.current.stage.height - 40, false);
			
			//_webView.st
			
			/*if(Starling.current.stage.width  <= MIN_WIDTH)
			{
				setSizeInternal(Starling.current.stage.width - 50, Starling.current.stage.height - 50, false);
			}*/
		}
		
	
		public function set partItem(value:PartItemRenderer):void{
			
			_partItem=value;
			
			invalidate("part_item");
		}
		
		public function get partItem():PartItemRenderer{
			
			return _partItem;
		}
		
		public function updateWithLanguage(language : Language) : void
		{
			currentLanguage = language;
			
			//title = //language.translate("mob_morecars", "more cars?").toUpperCase();
			titleLabel.updateWithLanguage(language);
			
			//intializingLabel.updateWithLanguage(language);
			
			//totalLabel.text = language.translate("mob_downloads", "total");
			//totalLabel.updateWithLanguage(language);
			
			//cleanCacheButton.updateWithLanguage(language);
			//cleanCacheButton.label = "   CLEAN CACHE"//language.translate("mob_downloads", "cleanCache").toUpperCase();
			
			
			/*okButton.updateWithLanguage(language);
			okButton.label = language.translate("mob_info", "ok").toUpperCase();*/
			
			
		}
		override public function set  title(value:String):void{
			
			super.title=value;
			this.invalidate("title");
		}
		
		public function set text(value:String):void{
			
			_text=value;
			
			this.invalidate("text");
		}
		
		public function get text():String{
			
			return _text;
		}
		
		override protected function initialize() : void
		{
			super.initialize();
						
			container = new ScrollContainer();
			//container.visible = false;
			container.paddingTop = container.paddingBottom = 0;
			container.paddingLeft = container.paddingRight = 10;
			addChild( container );
			
			linkLabel=new  MultilingualButton();
			linkLabel.textFormat = new TextFormat(FontSelector.getFont(false), 8.5, 0x454545 );
			linkLabel.textFormat.align = TextFormatAlign.LEFT;
			linkLabel.textFormat.underline = true;
			linkLabel.wordWrap=false;
			linkLabel.height = linkArrowImage.height+2;			
			linkLabel.updateWithLanguage(AlertView.language);			
			linkLabel.addEventListener(Event.TRIGGERED, onLinkTouch);
			addChild(linkLabel);
						
			partNameLabel=new MultilingualLabel();			
			partNameLabel.textFormat = new TextFormat(FontSelector.getFont(true), 11, 0x454545);
			partNameLabel.textFormat.align = TextFormatAlign.CENTER;
			partNameLabel.textFormat.bold=true;   			
			partNameLabel.updateWithLanguage(AlertView.language);
			//label.textFormat.italic=true;   
			addChild(partNameLabel);
		
			
			recommendedLabel=new MultilingualLabel();			
			recommendedLabel.textFormat = new TextFormat(FontSelector.getFont(true), 9, 0x454545);
			recommendedLabel.textFormat.align = TextFormatAlign.LEFT;
			recommendedLabel.textFormat.bold=true;   
			recommendedLabel.textFormat.italic=true;
			recommendedLabel.updateWithLanguage(AlertView.language);
			recommendedLabel.text=AlertView.language.translate("mob_alertsAndOverlays", "recommended_places_for_purchase")
			
			addChild(recommendedLabel);
			
			_webView=new WebView();
			
			_webView.addEventListener(Event.COMPLETE, onCompleteLoad);
			
		
			//_webView.
			
			addChild(_webView);
			
			WEBVIEW=_webView;
			
			
			//textLabel.text
			//contentBackgroundImage.visible = false;
		}
	
		protected function onCompleteLoad(event:Event):void{
			
			
			_webView.removeEventListener(Event.COMPLETE, onCompleteLoad);
			
			_webView.addEventListener("locationChange", onLocationChange);
			
			_webView.addEventListener("locationChanging", onLocationChanging);
			
			
		}
		
		protected function onLocationChanging(event:Event):void{
			

			_webView.removeEventListener("locationChange", onLocationChange);
			
			_webView.removeEventListener("locationChanging", onLocationChanging);
			
			_webView.stop();
			var url:String=_webView.location;
			_webView.addEventListener(Event.COMPLETE, onCompleteLoad);
			if(!Device.isIos()){
				_webView.loadString('<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0" name="viewport" /><style>body{width:100%;  padding:0px;margin:0px; overflow:hidden}</style></head><body>'+_text+'</body></html>');
				
			}else{
				_webView.loadString('<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width"><style>body{width:100%;  padding:0px;margin:0px; overflow:hidden}</style></head><body>'+_text+'</body></html>');
			}
			navigateToURL(new URLRequest(url));
			
			setTimeout(function():void{
				
				_webView.addEventListener("locationChanging", onLocationChanging);
			}, 1000);
		}
		protected function onLocationChange(event:Event):void{
			
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid("text")){
				
				
				if(_webView){
					
					/*textLabel.isHTML=true;
					textLabel.text=text;*/
					
					
					
					if(!Device.isIos())
					{
						_webView.loadString('<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0" name="viewport" /><style>body{width:100%;  padding:0px;margin:0px; overflow:hidden}</style></head><body>'+_text+'</body></html>');
					}else{
						
						_webView.loadString('<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width"><style>body{width:100%;  padding:0px;margin:0px; overflow:hidden}</style></head><body>'+_text+'</body></html>');
						
					}
				}
			}
			
			if(isInvalid("title")){
				
				
				if(titleLabel){
					
					titleLabel.text=title;
				}
			}
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				
				contentBackgroundImage.x = 25;
				contentBackgroundImage.width = actualWidth - 50;
				contentBackgroundImage.y = 25;
				contentBackgroundImage.height = actualHeight - 50;
				
				container.x = contentBackgroundImage.x;
				container.y = contentBackgroundImage.y;
				container.width = contentBackgroundImage.width;
				container.height = contentBackgroundImage.height;
				
				recommendedLabel.x=2;
				recommendedLabel.y=contentBackgroundImage.y+14;     
				
				recommendedLabel.width=(contentBackgroundImage.width-_webView.x)+15;
				recommendedLabel.height=13;
				
				
				_webView.x=2;//contentBackgroundImage.x+13+IMAGE_WIDTH+10;
				_webView.y=contentBackgroundImage.y+16+recommendedLabel.height+5;        
				
				_webView.width=(contentBackgroundImage.width-_webView.x)+15;
				
				_webView.height=contentBackgroundImage.height-32-recommendedLabel.height-10;
				
				 
				
				/*intializingLabel.width = actualWidth;
				intializingLabel.y = int((actualHeight - intializingLabel.height) / 2);*/
			}
			
			
			if(isInvalid("part_item")){
				
			
				
				var brandLogo:DiskBrand=Disk.getDiskBrandById(partItem.part.manufacturer);
				var nextYpos:int=contentBackgroundImage.y+12;
				if(brandLogo){
					
					var brandLogoImageLoader:ImageLoaderWithStates=new ImageLoaderWithStates();
					
					brandLogoImageLoader.completeHandler=function(image:ImageLoaderWithStates=null):void{
						
						brandLogoImageLoader.completeHandler=null;
						setTimeout(function():void{
							brandLogoImageLoader.image.x=0;
						},500);
						
					}
					//brandLogoImageLoader.
					
					brandLogoImageLoader.overrideDispose = true;
					
					brandLogoImageLoader.persistentImageProvider=brandLogo;
					
					brandLogoImageLoader.x=contentBackgroundImage.x+14;
					
					brandLogoImageLoader.y=nextYpos; 
					
					brandLogoImageLoader.width=0;
					brandLogoImageLoader.height=26;//IMAGE_WIDTH/2;
					
					nextYpos+=brandLogoImageLoader.height+10;
					
					addChild(brandLogoImageLoader);
					
					linkArrowImage.x=contentBackgroundImage.x+14;      
					
					linkArrowImage.y=nextYpos;
					
					linkLabel.x=contentBackgroundImage.x+14+linkArrowImage.width+5;
					
					linkLabel.y=nextYpos-1;
					
					linkLabel.width=50;
					//linkLabel.height=12;
					var link:String=brandLogo.link;
					
					if(link){
						linkUrl=link;
						link=link.replace("http://", "");
					}
					linkLabel.label=link;
					
					//linkLabel.addEventListener(Event.TRIGGERED, onLinkTouch);
					
					nextYpos+=linkArrowImage.height+5;
				}
				
				var partImageLoader:ImageLoaderWithStates=new ImageLoaderWithStates();
				
				partImageLoader.overrideDispose = true;
				
				partImageLoader.persistentImageProvider=partItem.part;
				
				partImageLoader.x=contentBackgroundImage.x+14;
				
				partImageLoader.y=nextYpos;
				
				partImageLoader.width=10;//((contentBackgroundImage.width*0.43)+25);
				partImageLoader.height=108;//IMAGE_WIDTH/2;
				
					
				addChild(partImageLoader);
				
				nextYpos+=partImageLoader.height+15;
				
				
				partNameLabel.x=contentBackgroundImage.x+14;
				
				partNameLabel.y=nextYpos;   
				
				partNameLabel.width=partImageLoader.width;
				
				if(partItem.part.name.indexOf("{custom}") >= 0) 
				{
					var text1:String = partItem.part.name;
					text1 = text1.replace("{custom}",AlertView.language.translate("componentNames", "custom").toUpperCase());
					
					partNameLabel.text=text1
					
				}
				else if(partItem.part.name.indexOf("{factory}") >= 0)
				{
					var text2:String = partItem.part.name;
					text2 = text2.replace("{factory}",AlertView.language.translate("componentNames", "factory").toUpperCase());
					
					partNameLabel.text = text2;//AlertView.language.translate("componentNames", "factory").toUpperCase();
				}
					
				
			}
			
			
			
			
		}
		
		private var linkUrl:String="";
				
		protected function onLinkTouch(event:Event):void{
			
			//trace("onLinkTouch", linkUrl)
			
			navigateToURL(new URLRequest(linkUrl));
		}
		
		private function okButtonnTriggeredHandler(event : Event) : void
		{
					
			
			WEBVIEW=null;
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}
		
		
	}
}