package com.despark.tuning3d.view.components.brands {
    import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
    import com.despark.tuning3d.model.packages.Packet;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
    import com.despark.tuning3d.view.components.core.PopUp;

    import starling.core.Starling;
    import starling.events.Event;

    public class RewardConfirmPopUp   extends PopUp{
    public static const REWARD_BUY_PACKET: String = "REWARD_BUY_PACKET";
    public var packet: Packet;
    public var details: Object;
    public var singleModel:Boolean = false;
    public var moreOptionsHandler:Function;
    public function RewardConfirmPopUp() {
        super();
        setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);
    }

    override protected function initialize() : void {
        super.initialize();
        contentBackgroundImage.visible = false;
        this.closeButton.visible = false;
        background.visible = false;
        return confirmButtonTriggeredHandler(null);

        var oneTimeUnlocked:Boolean = details["oneTimeUnlocked"];
        var alertView:ChallengeAlertView;
        if(singleModel){
            alertView = ChallengeAlertView.show(ChallengeAlertView.UNLOCK_MODEL_ONE_TIME, packet, this);
            alertView.addEventListener(ChallengeAlertEvent.OPTIONS_TRIGGERED, moreOptionsButtonTriggeredHandler);
            alertView.addEventListener(ChallengeAlertEvent.CLOSE_TRIGGERED, cancelButtonTriggeredHandler);
        }else{
            alertView = ChallengeAlertView.show(oneTimeUnlocked?ChallengeAlertView.UNLOCK_PACKAGE_ONE_TIME:ChallengeAlertView.UNLOCK_PACKAGE, packet, this);
            alertView.addEventListener(ChallengeAlertEvent.CLOSE_TRIGGERED, cancelButtonTriggeredHandler);
        }

        alertView.addEventListener(ChallengeAlertEvent.CONFIRM_TRIGGERED, confirmButtonTriggeredHandler);
        alertView.open();
    }

    override protected function draw() : void {
        super.draw();
    }

    private function cancelButtonTriggeredHandler(event: Event): void {
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
    }

    private function moreOptionsButtonTriggeredHandler(event: Event): void {
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        if(moreOptionsHandler != null){
            moreOptionsHandler();
        }
    }

    private function confirmButtonTriggeredHandler(event: Event): void {
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        var eventData:Object;
        if(details){
            eventData = details;
        }else {
            eventData = {packet: packet};
        }
        dispatchEventWith(REWARD_BUY_PACKET, false, eventData);
    }

    override public function dispose(): void {
        super.dispose();
    }

}
}
