package com.despark.tuning3d.view.components.brands {
    import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.core.StackedBannerScreen;
    import com.distriqt.AdsManager;

    import feathers.layout.AnchorLayoutData;

    import starling.core.Starling;
    import starling.events.Event;

    public class RewardNoCoinPopUp   extends PopUp {
    public static const OPEN_WATCH_REWARD_POP_UP : String = 'openWatchRewardPopup';
    public var moreOptionsAvailable:Boolean = false;
    public var moreOptionsHandler:Function;
    private var alertView:ChallengeAlertView;
    public function RewardNoCoinPopUp() {
        super();
        setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);
    }
    override protected function initialize() : void {
        super.initialize();
        contentBackgroundImage.visible = false;
        this.closeButton.visible = false;
        background.visible = false;

        var mainLayout : AnchorLayoutData = new AnchorLayoutData();
        mainLayout.verticalCenter = 0;
        mainLayout.horizontalCenter = 0;
        if(moreOptionsAvailable){
            alertView = ChallengeAlertView.show(ChallengeAlertView.DIAMONDS_NOT_ENOUGH_OPTIONS, {moreOptionsAvailable: moreOptionsAvailable}, this);
            alertView.addEventListener(ChallengeAlertEvent.OPTIONS_TRIGGERED, optionsButtonTriggeredHandler);
        }else{
            alertView = ChallengeAlertView.show(ChallengeAlertView.DIAMONDS_NOT_ENOUGH, {moreOptionsAvailable: moreOptionsAvailable}, this);
            alertView.addEventListener(ChallengeAlertEvent.WATCH_TRIGGERED, watchButtonTriggeredHandler);
        }
        alertView.addEventListener(ChallengeAlertEvent.REWARDS_TRIGGERED, rewardsButtonTriggeredHandler);
        alertView.addEventListener(ChallengeAlertEvent.CHALLENGES_TRIGGERED, challengesTriggeredHandler);
        alertView.addEventListener(ChallengeAlertEvent.CLOSE_TRIGGERED, cancelButtonTriggeredHandler);
        alertView.open();
        if(!AdsManager.$.haveRewardAds){
            enableWatching(false);
        }
    }
    override protected function draw() : void {
        super.draw();
    }

    override public function dispose(): void {
        super.dispose();
    }

    private function cancelButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
    }

    private function optionsButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        if(moreOptionsHandler != null){
            moreOptionsHandler();
        }
    }

    private function rewardsButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        dispatchEventWith(OPEN_WATCH_REWARD_POP_UP);
    }

    private function watchButtonTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        dispatchEventWith(OPEN_WATCH_REWARD_POP_UP, false, {watchAds:true});
    }

    private function challengesTriggeredHandler(event: Event): void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        dispatchEventWith(CLOSE_BUTTON_SELECTED);
        dispatchEventWith(StackedBannerScreen.CHALLENGES_HOME_SELECTED);
    }

    public function enableWatching(value:Boolean = false):void{
        if(alertView){
            alertView.data = {enabled: value};
        }
    }
}
}
