package com.despark.tuning3d.view.components.challenges.controls {
    import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.utils.FontSelector;

    import feathers.controls.Button;
    import feathers.controls.Label;
    import feathers.core.FeathersControl;

    import flash.text.TextFormatAlign;

    import starling.animation.Transitions;
    import starling.animation.Tween;
    import starling.core.Starling;
    import starling.display.DisplayObjectContainer;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;

    public class ChallengeAlertView extends FeathersControl{
        //
        public static const DIAMONDS:String = "diamonds";
        public static const KEYS:String = "keys";
        public static const KEYS_NOT_ENOUGH:String = "keysNotEnough";
        public static const DIAMONDS_NOT_ENOUGH:String = "diamondsNotEnough";
        public static const DIAMONDS_NOT_ENOUGH_OPTIONS:String = "diamondsNotEnoughOptions";
        public static const STARS:String = "stars";
        public static const CHALLENGE_SUBMITTED:String = "challengeSubmitted";
        public static const CHALLENGE_TIME_TRAIL_SUBMITTED:String = "challengeTimeTrialSubmitted";
        public static const SUBMIT_CHALLENGE:String = "submitChallenge";
        public static const HOW_TO_VOTE:String = "howToVote";
        public static const KEYS_RECEIVED:String = "keysReceived";
        public static const DAILY_REWARDS_LIMIT_REACHED:String = "dailyRewardsLimitReached";
        public static const DAILY_REWARDS:String = "dailyRewards";
        public static const COLLECT_REWARDS:String = "collectRewards";
        public static const DAILY_REWARDS_LIST:String = "dailyRewardsList";
        public static const DAILY_GUEST_WELCOME:String = "dailyGuestRewards";
        public static const REWARDED_ADS_POPUP:String = "rewardedAdsPopup";
        public static const REWARDED_ADS_NOT_AVAILABLE_POPUP:String = "rewardedAdsNotAvailablePopup";
        public static const WELCOME_GUEST_POPUP:String = "welcomeGuestPopup";
        public static const WELCOME_USER_POPUP:String = "welcomeUserPopup";
        public static const UNLOCK_PACKAGE:String = "unlockPackagePopup";
        public static const UNLOCK_PACKAGE_ONE_TIME:String = "unlockOneTimePackagePopup";
        public static const UNLOCK_MODEL_ONE_TIME:String = "unlockOneTimeModelPopup";
        public static const CHALLENGE_REQUIREMENTS:String = "challengeRequirementsPopup";
        public static const CHALLENGE_NOT_AVAILABLE:String = "challengeNotAvailable";
        public static const RATE_BOX_POPUP:String = "moreCarsPopup";
        public static const CHALLENGE_TIME_LEFT:String = "challengeTimeLeft";
        public static const CHALLENGE_EXPIRED:String = "challengeExpired";
        public static const CHALLENGE_LEVEL_UP:String = "challengeLevelUp";
        //
        protected var _contentWidth:Number;
        protected var _contentHeight:Number;
        protected var _closeButton:Button;
        protected var _background:Quad;
        protected var _data:*;

        protected var _titleLabel:Label;
        protected var _headerBorder:Quad;
        protected var _contentBackground:Image;
        protected var _contentBackgroundId:String;
        protected var _closeHandler:Function;
        protected var _openCompleteHandler:Function;
        private static var isOpenView:ChallengeAlertView;
        private static const _openInstances:Vector.<ChallengeAlertView> = new <ChallengeAlertView>[];
        private var _closeOnForegroundTouch:Boolean = true;
        public function ChallengeAlertView(contentWidth:Number = 320, contentHeight:Number = 207) {
            _contentWidth = contentWidth;
            _contentHeight = contentHeight;
            alpha = 0;
            _openInstances.push(this);
    }

    override public function setSize(contentWidth:Number, contentHeight:Number):void{
        _contentWidth = contentWidth;
        _contentHeight = contentHeight;
    }

    public static function show(dialogType:String, data:* = null, target:DisplayObjectContainer = null, closeOthers:Boolean = true):ChallengeAlertView{
        if(closeOthers && isOpenView && isOpenView.stage){
            isOpenView.close();
        }
        var dialogue:ChallengeAlertView;
        if(dialogType == DIAMONDS){
            dialogue = new DiamondStatsDialog();
        }else if(dialogType == DIAMONDS_NOT_ENOUGH){
            dialogue = new DiamondNotEnoughStatsDialog();
        }else  if(dialogType == DIAMONDS_NOT_ENOUGH_OPTIONS){
            dialogue = new DiamondNotEnoughOptionsDialog();
        }else if(dialogType == KEYS){
            dialogue = new KeysStatsDialog();
        }else if(dialogType == KEYS_NOT_ENOUGH){
            dialogue = new KeysNotEnoughStatsDialog();
        }else if(dialogType == STARS){
            dialogue = new StarsStatsDialog();
        }else if(dialogType == SUBMIT_CHALLENGE){
            dialogue = new SubmitChallengePopup();
        }else if(dialogType == CHALLENGE_SUBMITTED){
            dialogue = new ChallengeSubmittedDialog();
        }else  if(dialogType == CHALLENGE_TIME_TRAIL_SUBMITTED){
            dialogue = new ChallengeSubmittedTimeTrialDialog();
        }else if(dialogType == HOW_TO_VOTE){
            dialogue = new VoteHelpDialog();
        }else if(dialogType == KEYS_RECEIVED){
            dialogue = new KeysReceivedDialog();
        }else if(dialogType == DAILY_REWARDS_LIMIT_REACHED){
            dialogue = new RewardedDailyLimit();
        }else if(dialogType == DAILY_REWARDS){
            dialogue = new DailyRewards();
        }else if(dialogType == COLLECT_REWARDS){
            dialogue = new CollectRewards();
        }else  if(dialogType == DAILY_REWARDS_LIST){
            dialogue = new RewardsList();
        }else if(dialogType == DAILY_GUEST_WELCOME){
            dialogue = new DailyGuestPopup();
        }else if(dialogType == REWARDED_ADS_POPUP){
            dialogue = new RewardedAdsPopup();
        }else  if(dialogType == UNLOCK_PACKAGE){
            dialogue = new UnlockPackagesPopup();
        }else  if(dialogType == UNLOCK_PACKAGE_ONE_TIME){
            dialogue = new UnlockOneTimePackagesPopup();
        }else if(dialogType == UNLOCK_MODEL_ONE_TIME){
            dialogue = new UnlockOneTimeModelPopup();
        }else if(dialogType == REWARDED_ADS_NOT_AVAILABLE_POPUP){
            dialogue = new RewardedAdsNotAvailablePopup();
        }else if(dialogType == WELCOME_GUEST_POPUP){
            dialogue = new WelcomeGuestPopup();
        }else if(dialogType == WELCOME_USER_POPUP){
            dialogue = new WelcomeUserPopup();
        }else if(dialogType == RATE_BOX_POPUP){
            dialogue = new RateBoxPopup();
        }else if(dialogType == CHALLENGE_REQUIREMENTS){
            dialogue = new ChallengeRequirementsNotMet();
        }else if(dialogType == CHALLENGE_NOT_AVAILABLE){
            dialogue = new ChallengeNotAvailable();
        }else if(dialogType == CHALLENGE_TIME_LEFT){
            dialogue = new ChallengeTimeLeft();
        }else if(dialogType == CHALLENGE_EXPIRED){
            dialogue = new ChallengeExpired();
        }else if(dialogType == CHALLENGE_LEVEL_UP){
            dialogue = new ChallengeLevelUp();
        }
        if(dialogue){
            dialogue.data = data;
        }
        if(target){
            target.addChild(dialogue);
        }
        isOpenView = dialogue;
        return dialogue;
    }

    public static function closeAll():void{
        for each(var view:ChallengeAlertView in _openInstances){
            if(view){
                view.close();
            }
        }
    }

    public function open():void{
        self.dispatchEventWith(ChallengeAlertEvent.VIEW_OPEN);
        alpha = 0;
        Starling.current.stage.addChild(this);
        var openTween:Tween = new Tween(this, 0.1, Transitions.LINEAR);
        openTween.fadeTo(1);
        openTween.onComplete = _openCompleteHandler;
        Starling.juggler.add(openTween);
        SoundManager.playSound(SoundManager.SELECT_PART);
    }

        protected function get self():ChallengeAlertView{
            return this;
        }

    public function close():void{
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        Starling.juggler.tween(this, 0.25,
                {
                    alpha: 0,
                    transition: Transitions.LINEAR,
                    onComplete:function ():void {
                        if(isOpenView == this){
                            isOpenView = null;
                        }
                        if(_closeHandler != null){
                            _closeHandler.call();
                        }
                        self.dispatchEventWith(ChallengeAlertEvent.VIEW_CLOSED);
                        removeFromParent(true);
                        var index:int = _openInstances.indexOf(self);
                        if(index != -1){
                            _openInstances.removeAt(index);
                        }
                    }
                });
    }

    protected override function initialize():void{
        super.initialize();
        _background = new Quad(1,1,0x000000);
        _background.alpha = 0.65;
        addChild(_background);

        addEventListener(TouchEvent.TOUCH, foregroundTouchHandler);

        _titleLabel = LabelFactory.createSimpleLabel(FontSelector.AlumniSansHtml, 21, 0x4a4a4a, TextFormatAlign.LEFT, false, true);
        addChild(_titleLabel);

        _headerBorder = new Quad(1,1,0x4a4a4a);
        _headerBorder.width = _contentWidth - 50;
        _headerBorder.height = 0.5;
        addChild(_headerBorder);

        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
    }

        private function foregroundTouchHandler(event:TouchEvent):void {
            if(!_closeOnForegroundTouch){
                return;
            }
            var touch:Touch = event.getTouch(_background, TouchPhase.ENDED);
            var noTouch:Touch = event.getTouch(_contentBackground, TouchPhase.ENDED);
            if(touch && !noTouch){
                close();
            }
        }

        protected function closeButtonTriggeredHandler(event:Event):void {
            close();
        }

    override protected function draw():void {
        super.draw();
        if(stage){
            _background.width = stage.stageWidth;
            _background.height = stage.stageHeight;

            if(_contentBackground) {
                _contentBackground.x = (stage.stageWidth - _contentBackground.width) / 2;
                _contentBackground.y = (stage.stageHeight - _contentBackground.height) / 2;

                _headerBorder.x = _contentBackground.x + (_contentBackground.width - _headerBorder.width) / 2;
                _headerBorder.y = _contentBackground.y + 40;
            }

            if(_closeButton){
                _closeButton.x = _contentBackground.x + _contentBackground.width - _closeButton.width - 2;
                _closeButton.y = _contentBackground.y + 2;
            }

            if(_contentBackground){
                _titleLabel.y = _contentBackground.y + 8;
            }
        }
    }

    override public function dispose():void {
        super.dispose();

        if(_closeButton){
            _closeButton.removeFromParent(true);
            _closeButton = null;
        }

        if(_background){
            _background.removeFromParent(true);
            _background = null;
        }

        if(_contentBackground){
            _contentBackground.removeFromParent(true);
            _contentBackground = null;
        }

        if(_titleLabel){
            _titleLabel.removeFromParent(true);
            _titleLabel = null;
        }

        if(_headerBorder){
            _headerBorder.removeFromParent(true);
            _headerBorder = null;
        }
    }

        public function get data():* {
            return _data;
        }

        public function set data(value:*):void {
            _data = value;
        }

        public function get closeOnForegroundTouch():Boolean {
            return _closeOnForegroundTouch;
        }

        public function set closeOnForegroundTouch(value:Boolean):void {
            _closeOnForegroundTouch = value;
        }
    }
}

import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.model.assets.AssetsProxy;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.parts.PartMaterial;
import com.despark.tuning3d.view.components.rewards.RewardType;
import com.despark.tuning3d.view.components.rewards.ShineImage;
import com.distriqt.AdsManager;

import starling.core.Starling;


class AnimatedAlertView extends ChallengeAlertView{
    protected var iconImage:Image;
    protected var iconBottomBorder:Image;
    protected var iconRightBorder:Quad;

    protected var _contentBorder:Image;
    protected var _borderMask:Sprite;
    protected var _contentMask:Quad;
    protected var _headerMask:Quad;
    protected var _maskParts:Object;
    protected var _maskTween:Tween;
    protected var _iconImageTexture:String;
    protected var _iconImageColor:uint;
    protected static const headerSize:Number = 42;
    public function AnimatedAlertView(contentWidth:Number, contentHeight:Number){
        super (contentWidth, contentHeight);
        _contentBackgroundId = "anim_content_background";
        _iconImageTexture = "collect_gift_icon";
        _iconImageColor = 0xFF0000;
    }

    override protected function initialize():void{
        super .initialize();

        _contentBackground = new Image(ButtonFactory.assetManager.getTexture(_contentBackgroundId));
        _contentBackground.texture = TextureUtil.scaleTexture(_contentBackground.texture, 0.5);
        _contentBackground.scale9Grid = new Rectangle(_contentBackground.texture.frameWidth / 2 - 0.5,_contentBackground.texture.frameHeight / 2 - 0.5, 1, 1);
        _contentBackground.width = _contentWidth;
        _contentBackground.height = _contentHeight;
        addChildAt(_contentBackground, getChildIndex(_background) + 1);
        _contentBackground.alpha = 0;

        _contentBorder = new Image(ButtonFactory.assetManager.getTexture("anim_content_border"));
        _contentBorder.texture = TextureUtil.scaleTexture(_contentBorder.texture, 0.5);
        _contentBorder.scale9Grid = new Rectangle(_contentBorder.texture.frameWidth / 2 - 0.5,_contentBorder.texture.frameHeight / 2 - 0.5, 1, 1);
        _contentBorder.width = _contentWidth;
        _contentBorder.height = _contentHeight;
        _contentBorder.color = 0xFEFFFF;
        addChild(_contentBorder);

        if(_titleLabel){
            _titleLabel.removeFromParent(true);
        }
        _titleLabel = LabelFactory.createSimpleLabel(FontSelector.AlumniSansHtml, 21, 0xFFFFFF, TextFormatAlign.LEFT, false, true);
        addChild(_titleLabel);

        iconImage = new Image(ButtonFactory.assetManager.getTexture(_iconImageTexture));
        iconImage.color = _iconImageColor;
        addChild(iconImage);

        iconBottomBorder = new Image(ButtonFactory.assetManager.getTexture("anim_popup_icon_border"));
        iconBottomBorder.color = 0xFF0000;
        addChild(iconBottomBorder);

        iconRightBorder = new Quad(1, 1, 0xFFFFFF);
        iconRightBorder.width = 1;
        addChild(iconRightBorder);

        _headerBorder.color = 0xFFFFFF;
        _headerBorder.scaleX = 1;
        _headerBorder.pivotX = _headerBorder.width / 2;
        _headerBorder.height = 1;
        _openCompleteHandler = startOpeningAnimation;
        setChildIndex(_headerBorder, getChildIndex(iconRightBorder) + 1);

        _borderMask = new Sprite();
        _maskParts = {};
        var maskPart:Quad;

        maskPart = createMaskPart();
        maskPart.height = 10;
        _maskParts["top"] = maskPart;
        _borderMask.addChild(maskPart);
        maskPart.x = _contentWidth / 2;
        maskPart.y = 0;

        maskPart = createMaskPart();
        maskPart.height = 10;
        _maskParts["bottom"] = maskPart;
        _borderMask.addChild(maskPart);
        maskPart.x = _contentWidth / 2;
        maskPart.y = _contentHeight;

        maskPart = createMaskPart();
        maskPart.width = 10;
        _maskParts["left"] = maskPart;
        _borderMask.addChild(maskPart);
        maskPart.x = 0;
        maskPart.y = _contentHeight / 2;

        maskPart = createMaskPart();
        maskPart.width = 10;
        _maskParts["right"] = maskPart;
        _borderMask.addChild(maskPart);
        maskPart.x = _contentWidth;
        maskPart.y = _contentHeight / 2;
        addChild(_borderMask);
        _contentBorder.mask = _borderMask;


        _contentMask = new Quad(1,1);
        _contentMask.pivotX = _contentMask.width / 2;
        _contentMask.pivotY = _contentMask.height / 2;
        addChild(_contentMask);

        _headerMask = new Quad(1,1);
        _headerMask.pivotX = _contentMask.width / 2;
        _headerMask.width = _contentWidth;
        addChild(_headerMask);

        _titleLabel.mask = _headerMask;
        iconImage.mask = _headerMask;
        iconBottomBorder.mask = _headerMask;

        iconRightBorder.mask = _contentMask;
    }

    protected static function createMaskPart():Quad{
        var maskPart:Quad = new Quad(1,1);
        maskPart.pivotX = maskPart.width / 2;
        maskPart.pivotY = maskPart.height / 2;
        return maskPart;
    }

    protected function startOpeningAnimation():void{
        var bgTween:Tween = new Tween(_contentBackground, 0.25, Transitions.LINEAR);
        bgTween.fadeTo(0.75);
        Starling.juggler.add(bgTween);

        if(!_headerBorder){
            return;
        }
        _headerBorder.width = 1;
        var brTween:Tween = new Tween(_headerBorder, 0.2, Transitions.LINEAR);
        brTween.animate("width", _contentWidth);
        Starling.juggler.add(brTween);

        _maskTween = new Tween(_borderMask, 0.2);
        _maskTween.delay = 0.1;
        _maskTween.onUpdate = function():void{
            var num:Number = _maskTween.currentTime/_maskTween.totalTime;
            _maskParts["top"].width = _maskParts["bottom"].width = _contentWidth * num;
            _maskParts["left"].height = _maskParts["right"].height = _contentHeight * num;
        }
        _maskTween.onComplete = function():void{
            _contentBorder.mask = null;
            _borderMask.removeFromParent(true);
            _borderMask = null;
            startContentAnimation();
        }
        Starling.juggler.add(_maskTween);
    }

    protected function startContentAnimation():void{
        if(!stage){
            dispose();
            return;
        }
        var tween:Tween = new Tween(_contentMask, 0.25);
        tween.animate("width", _contentBackground.width);
        tween.animate("height", _contentBackground.height);
        tween.delay = 0.1;
        tween.onComplete = animationCompleteHandler;
        Starling.juggler.add(tween);

        var headerTween:Tween = new Tween(_headerMask, 0.15);
        headerTween.animate("height", 50);
        Starling.juggler.add(headerTween);
    }

    protected function animationCompleteHandler():void{
        if(_titleLabel){
            _titleLabel.mask = null;
        }

        if(iconImage){
            iconImage.mask = null;
        }

        if(iconBottomBorder){
            iconBottomBorder.mask = null;
        }

        if(iconRightBorder){
            iconRightBorder.mask = null;
        }

        if(_contentMask){
            _contentMask.removeFromParent(true);
            _contentMask = null;
        }

        if(_headerMask){
            _headerMask.removeFromParent(true);
            _headerMask = null;
        }
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _headerBorder.x = _contentBackground.x + _contentBackground.width / 2;
            _headerBorder.y = _contentBackground.y + headerSize;

            _contentBorder.x = _contentBackground.x;
            _contentBorder.y = _contentBackground.y;

            iconRightBorder.height = headerSize;
            iconRightBorder.x = _contentBackground.x + headerSize;
            iconRightBorder.y = _contentBackground.y;

            if(_borderMask){
                _borderMask.x = _contentBorder.x;
                _borderMask.y = _contentBorder.y;
            }

            iconBottomBorder.width = headerSize;
            iconBottomBorder.scale = iconBottomBorder.scaleX;
            iconBottomBorder.x = _contentBackground.x + (headerSize - iconBottomBorder.width) / 2;
            iconBottomBorder.y = _contentBackground.y + headerSize - iconBottomBorder.height;

            iconImage.width = headerSize - 20;
            iconImage.scale = iconImage.scaleX;
            iconImage.x = _contentBackground.x + (headerSize - iconImage.width) / 2;
            iconImage.y = _contentBackground.y + (headerSize - iconImage.height - iconBottomBorder.height) / 2;

            _titleLabel.x = _contentBackground.x + headerSize + 20;
            _titleLabel.y = _contentBackground.y + (headerSize - _titleLabel.height) / 2;

            if(_contentMask){
                _contentMask.x = _contentBackground.x + _contentWidth / 2;
                _contentMask.y = _contentBackground.y + _contentHeight / 2;
            }

            if(_headerMask){
                _headerMask.x = _contentBackground.x + _contentWidth / 2;
                _headerMask.y = _contentBackground.y;
            }
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class CollectRewards extends AnimatedAlertView{
    protected var _collectBtn:Button;
    private var _rewardsLabels:Vector.<RewardsLabel>;
    private var _rewardsLabelBorders:Vector.<Quad>;
    //
    public function CollectRewards(){
        super (211, 198);
    }

    override protected function initialize():void{
        if(data.keys > 0 && data.diamonds > 0){
            setSize(236, _contentHeight);
        }
        super .initialize();
        _collectBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("anim_button_texture"), null, null, false, 2.5));
        closeImg.scale9Grid = new Rectangle(closeImg.texture.frameHeight / 2 - 0.5,0, 1, closeImg.texture.frameHeight);
        _collectBtn.defaultSkin = closeImg;

        _collectBtn.label = "COLLECT";
        _collectBtn.width = 92;
        _collectBtn.height = 23;
        _collectBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_collectBtn);
        _collectBtn.validate();
        _collectBtn.addEventListener(Event.TRIGGERED, collectSelectedHandler);

        _collectBtn.mask = _contentMask;
        if(data.hasOwnProperty("title")){
            _titleLabel.text = (data.title as String).toUpperCase();
        }else{
            _titleLabel.text = "CONGRATULATIONS!";
        }
        _titleLabel.validate();

        if(!rewardData.length && this is KeysReceivedDialog){
            _rewardsLabels = new Vector.<RewardsLabel>(1);
            _rewardsLabels[0] = RewardsLabel.createInstance(RewardType.KEYS, 0);
            _rewardsLabels[0].mask = _contentMask;
            addChildAt(_rewardsLabels[0], getChildIndex(_contentBackground) + 1);
            if(_rewardsLabels.length > 1){
                _rewardsLabels[0].scale = 0.8;
            }
            return;
        }

        _rewardsLabels = new Vector.<RewardsLabel>(rewardData.length);
        if(rewardData.length > 1){
            _rewardsLabelBorders = new Vector.<Quad>(rewardData.length - 1);
        }
        var i:int = 0;
        for(var key:String in rewardData){
            if(data[key] == 0){
                i++;
                continue;
            }
            if(data[key] is Number){
                var valueLabel:Number = (data[key] < 0? 0: data[key]);
                _rewardsLabels[i] = RewardsLabel.createInstance(key, valueLabel);
            }else{
                _rewardsLabels[i] = RewardsLabel.createInstance(key, data[key]);
            }

            _rewardsLabels[i].mask = _contentMask;
            addChildAt(_rewardsLabels[i], getChildIndex(_contentBackground) + 1);
            if(_rewardsLabels.length > 1){
                _rewardsLabels[i].scale = 0.8;
            }

            if(_rewardsLabelBorders && i < _rewardsLabelBorders.length){
                _rewardsLabelBorders[i] = new Quad(1,1,0xFFFFFF);
                _rewardsLabelBorders[i].width = 1.5;
                _rewardsLabelBorders[i].height = 75;
                _rewardsLabelBorders[i].mask = _contentMask;

                addChildAt(_rewardsLabelBorders[i], getChildIndex(_contentBackground) + 1);
            }
            i++;
        }
    }

    public function get rewardData():DailyRewardsData{
        return data as DailyRewardsData;
    }

    override public function open():void{
        super .open();
    }

    override protected function animationCompleteHandler():void{
        super .animationCompleteHandler();
        _collectBtn.mask = null;
        if(_rewardsLabels){
            for(var i:int = 0; i < _rewardsLabels.length; i++){
                if(_rewardsLabels[i]){
                    _rewardsLabels[i].mask = null;
                    _rewardsLabels[i].startLabelAnimation();
                    if(_rewardsLabelBorders && i < _rewardsLabelBorders.length){
                        _rewardsLabelBorders[i].mask = null;
                    }
                }
            }
        }
    }

    private function collectSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            var eventData:Array = [];
            for(var i:int = 0; i < _rewardsLabels.length; i++){
                eventData.push({rewardType:_rewardsLabels[i].rewardType, x:_rewardsLabels[i].x, y:_rewardsLabels[i].y});
                if(_rewardsLabels[i] is RewardsResourceLabel){
                    eventData[i]["color"] = RewardsResourceLabel(_rewardsLabels[i]).color;
                    eventData[i]["value"] = RewardsResourceLabel(_rewardsLabels[i]).rewardValue;
                }
            }
            self.dispatchEventWith(ChallengeAlertEvent.COLLECT_TRIGGERED, false, eventData);
            _closeHandler = null;
        };
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            for(var i:int = 0; i < _rewardsLabels.length; i++){
                if(_rewardsLabels[i]){
                    _rewardsLabels[i].x = _contentBackground.x + _contentBackground.width / 2 + ((_rewardsLabels.length - 1) / 2 - i) * 100;
                    _rewardsLabels[i].y = _contentBackground.y + _contentBackground.height / 2 - (_rewardsLabels.length == 1?10: 0);
                    if(_rewardsLabelBorders && i < _rewardsLabelBorders.length){
                        _rewardsLabelBorders[i].x = _rewardsLabels[i].x - 50;
                        _rewardsLabelBorders[i].y = _rewardsLabels[i].y - 35;
                    }
                }
            }

            _collectBtn.x = _contentBackground.x + (_contentBackground.width - _collectBtn.width) / 2;
            _collectBtn.y = _contentBackground.y + _contentBackground.height - (_collectBtn.height + 15);
        }
    }

    override public function dispose():void{
        super .dispose();
        if(_rewardsLabels){
            while (_rewardsLabels.length){
                var label:RewardsLabel = _rewardsLabels.pop();
                label.removeFromParent(true);
            }
            _rewardsLabels = null;
        }
    }
}


import com.despark.tuning3d.model.challenges.ChallengeAlertEvent;
import com.despark.tuning3d.model.challenges.ChallengeData;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.UIStrings;
import com.despark.tuning3d.model.levels.LevelData;
import com.despark.tuning3d.model.packages.Packet;
import com.despark.tuning3d.model.rewards.DailyRewardsData;
import com.despark.tuning3d.model.parts.PartMaterial;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.view.components.challenges.controls.ChallengeAlertView;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ExtendedLabel;
import com.despark.tuning3d.view.components.core.LabelFactory;
import com.despark.tuning3d.view.components.core.LayoutImage;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.core.MultilingualButton;
import com.despark.tuning3d.view.components.parts.IPartItemRenderer;
import com.despark.tuning3d.view.components.rewards.RewardsLabel;
import com.despark.tuning3d.view.components.rewards.RewardsListItem;
import com.despark.tuning3d.view.components.rewards.RewardsResourceLabel;
import com.despark.tuning3d.view.components.levels.LevelDataItemRenderer;
import com.utils.DateParser;
import com.utils.FontSelector;
import com.utils.TextureUtil;

import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.List;
import feathers.controls.ScrollPolicy;
import feathers.controls.renderers.IListItemRenderer;
import feathers.data.ListCollection;
import feathers.layout.VerticalLayout;

import flash.events.TimerEvent;
import flash.geom.Rectangle;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.utils.Timer;
import flash.utils.getTimer;

import starling.animation.Transitions;

import starling.animation.Tween;

import starling.core.Starling;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.display.Image;
import starling.display.Quad;
import starling.display.Sprite;
import starling.display.Quad;
import starling.events.Event;
import starling.textures.Texture;
import starling.utils.StringUtil;

class InfoDialog extends ChallengeAlertView{
    protected var _messageLabel:Label;
    public function InfoDialog(popupWidth:Number = 320, popupHeight:Number = 170){
        super (popupWidth, popupHeight);
        _contentBackgroundId = "popUpContentBackground";
    }

    override protected function initialize():void{
        super .initialize();

        _contentBackground = new Image(ButtonFactory.assetManager.getTexture(_contentBackgroundId));
        _contentBackground.scale9Grid = new Rectangle( 13, 13, 10, 6);
        _contentBackground.width = _contentWidth;
        _contentBackground.height = _contentHeight;
        addChildAt(_contentBackground, getChildIndex(_background) + 1);

        _closeButton = new Button();
        var closeIcon:Image = new Image(ButtonFactory.assetManager.getTexture("details_close"));
        closeIcon.scale = 0.75 * ButtonFactory.assetManager.scaleFactor/2;
        closeIcon.color = 0x3d3d3d;
        var closeSkin:Quad = new Quad(1,1,0xFFFFFF);
        closeSkin.width = closeSkin.height = 30;
        closeSkin.alpha = 0;
        _closeButton.width = closeIcon.width;
        _closeButton.height = closeIcon.height;
        _closeButton.defaultIcon = closeIcon;
        _closeButton.defaultSkin = closeSkin;
        addChild(_closeButton);
        _closeButton.validate();
        _closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);

        var textFormat:TextFormat = new TextFormat();
        textFormat.letterSpacing = -0.1;
        textFormat.leading = -1.5;
        _messageLabel = LabelFactory.createSimpleLabel(FontSelector.MontserratHtml, 11, 0x535353, TextFormatAlign.CENTER, true, true, textFormat);
        addChild(_messageLabel);
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _messageLabel.width = _headerBorder.width;
            _messageLabel.x = _headerBorder.x;
            _messageLabel.y = _headerBorder.y + 15;
        }
    }

    override public function dispose():void{
        super .dispose();
        if(_messageLabel){
            _messageLabel.removeFromParent(true);
            _messageLabel = null;
        }
    }
}

class DiamondStatsDialog extends InfoDialog{
    private var iconImage:Image;

    private var _challengeBtn:MultilingualButton;
    private var _watchBtn:Button;
    private var _infoBtn:Button;
    public function DiamondStatsDialog(){
        super (320, 175);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "DIAMONDS";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_icon"));
        iconImage.scale = 0.8 * ButtonFactory.assetManager.scaleFactor / 2;

        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "Use Diamonds to unlock <b>“FEATURED”</b> Packages." + "\n\nEarn Diamonds by getting high scores in Tuning\n" +
                "Challenges or by watching Rewarded Ads.*";
        addChild(_messageLabel);
        _messageLabel.validate();

        _challengeBtn = ButtonFactory.defaultButton("GO TO CHALLENGES", 0x187499);
        _challengeBtn.width = 125;
        _challengeBtn.height = 23;
        _challengeBtn.paddingLeft = _challengeBtn.paddingRight = 10;
        _challengeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_challengeBtn);
        _challengeBtn.validate();
        _challengeBtn.addEventListener(Event.TRIGGERED, challengesSelectedHandler);

        _watchBtn = ButtonFactory.defaultButton("WATCH ADS", 0xff0000, "button_gradient");
        _watchBtn.width = 100;
        _watchBtn.height = 23;
        _watchBtn.paddingLeft = _watchBtn.paddingRight = 5;
        _watchBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _watchBtn.addEventListener(Event.TRIGGERED, watchSelectedHandler);
        addChild(_watchBtn);
        _watchBtn.validate();

        var rewardsIcon:Image = new Image(ButtonFactory.assetManager.getTexture("rewards_watch_btn_icon"));
        rewardsIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
        rewardsIcon.color = 0xFFFFFE;

        _watchBtn.defaultIcon = rewardsIcon;
        _watchBtn.iconOffsetX = -5;
        _watchBtn.labelOffsetX = -1.5;


        _infoBtn = new Button();
        _infoBtn.defaultSkin = new Image(ButtonFactory.assetManager.getTexture('a_fast_mode_help'));
        Image(_infoBtn.defaultSkin).color = 0x2996c8;
        _infoBtn.width = _infoBtn.height = 12;
        _infoBtn.scaleWhenDown = 0.9;
        addChild(_infoBtn);
        _infoBtn.addEventListener(Event.TRIGGERED, rewardsSelectedHandler);
    }

    private function rewardsSelectedHandler(event:Event):void {
        self.dispatchEventWith(ChallengeAlertEvent.REWARDS_TRIGGERED);
    }

    private function watchSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.WATCH_TRIGGERED);
            _closeHandler = null;
        };
        closeAll();
    }

    private function challengesSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;

            iconImage.x = _titleLabel.x + _titleLabel.width + 5;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2 + 1;

            _challengeBtn.x = _contentBackground.x + _contentBackground.width /2 - (_challengeBtn.width + 10);
            _challengeBtn.y = _contentBackground.y + _contentBackground.height - (_challengeBtn.height / 2 + 30);

            _watchBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _watchBtn.y = _contentBackground.y + _contentBackground.height - (_watchBtn.height / 2 + 30);

            _infoBtn.x = _watchBtn.x + _watchBtn.width + 10;
            _infoBtn.y = _contentBackground.y + _contentBackground.height - (_infoBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
        if(iconImage){
            iconImage.removeFromParent(true);
            iconImage = null;
        }
    }
}

class DiamondNotEnoughOptionsDialog extends InfoDialog{
    private var iconImage:Image;

    private var _challengeBtn:MultilingualButton;
    private var _rewardsBtn:MultilingualButton;
    private var _optionsBtn:Button;
    public function DiamondNotEnoughOptionsDialog(){
        super (380, 192);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "NOT ENOUGH DIAMONDS";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_icon"));
        iconImage.scale = 0.8 * ButtonFactory.assetManager.scaleFactor / 2;

        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "You don't have enough "+UIStrings.getDiamondChar()+" <b>Diamonds</b> to open\n" +
                "this package.\n<br>" +
                "Earn Diamonds by getting high scores in Tuning\n"+
                "Challenges or by watching Rewarded Ads.";
        addChild(_messageLabel);
        _messageLabel.validate();

        _challengeBtn = ButtonFactory.defaultButton("GO TO CHALLENGES", 0x187499);
        _challengeBtn.width = 112;
        _challengeBtn.height = 23;
        _challengeBtn.paddingLeft = _challengeBtn.paddingRight = 10;
        _challengeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_challengeBtn);
        _challengeBtn.validate();
        _challengeBtn.addEventListener(Event.TRIGGERED, challengesSelectedHandler);

        _rewardsBtn = ButtonFactory.defaultButton("REWARDED ADS", 0xff0000, "button_gradient");
        _rewardsBtn.width = 112;
        _rewardsBtn.height = 23;
        _rewardsBtn.paddingLeft = _rewardsBtn.paddingRight = 5;
        _rewardsBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _rewardsBtn.addEventListener(Event.TRIGGERED, rewardsSelectedHandler);
        addChild(_rewardsBtn);
        _rewardsBtn.validate();

        _optionsBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _optionsBtn.defaultSkin = closeImg;
        _optionsBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        _optionsBtn.label = "MORE OPTIONS";
        _optionsBtn.width = 97;
        _optionsBtn.height = 23;
        addChild(_optionsBtn);
        _optionsBtn.validate();
        _optionsBtn.addEventListener(Event.TRIGGERED, moreOptionsSelectedHandler);


        var rewardsIcon:Image = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_btn_icon"));
        rewardsIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
        rewardsIcon.color = 0xFFFFFE;

        _rewardsBtn.defaultIcon = rewardsIcon;
        _rewardsBtn.iconOffsetX = -5;
        _rewardsBtn.labelOffsetX = -1.5;

        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
        }
    }

    private function rewardsSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.REWARDS_TRIGGERED);
        }
        close();
    }

    private function challengesSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }
        close();
    }

    private function moreOptionsSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.OPTIONS_TRIGGERED);
        }
        close();
    }

    override public function set data(value:*):void {
        super .data = value;
        if(value && value.hasOwnProperty("enabled") && _rewardsBtn){
            _rewardsBtn.isEnabled = value["enabled"];
            _rewardsBtn.alpha = (_rewardsBtn.isEnabled? 1: 0.75);
        }
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;

            iconImage.x = _titleLabel.x + _titleLabel.width + 5;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2 + 1;

            var startX:Number = _contentBackground.x + (_contentBackground.width - (_challengeBtn.width + _rewardsBtn.width + _optionsBtn.width + 20)) / 2;

            _challengeBtn.x = startX;
            _challengeBtn.y = _contentBackground.y + _contentBackground.height - (_challengeBtn.height / 2 + 30);

            _rewardsBtn.x = _challengeBtn.width + _challengeBtn.x + 10;
            _rewardsBtn.y = _contentBackground.y + _contentBackground.height - (_rewardsBtn.height / 2 + 30);

            _optionsBtn.x = _rewardsBtn.width + _rewardsBtn.x + 10;
            _optionsBtn.y = _contentBackground.y + _contentBackground.height - (_rewardsBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
        if(iconImage){
            iconImage.removeFromParent(true);
            iconImage = null;
        }
        if(_challengeBtn){
            _challengeBtn.removeFromParent(true);
            _challengeBtn = null;
        }
    }
}


class DiamondNotEnoughStatsDialog extends InfoDialog{
    private var iconImage:Image;

    private var _challengeBtn:MultilingualButton;
    private var _watchBtn:Button;
    private var _infoBtn:Button;
    public function DiamondNotEnoughStatsDialog(){
        super (320, 192);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "NOT ENOUGH DIAMONDS";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_icon"));
        iconImage.scale = 0.8 * ButtonFactory.assetManager.scaleFactor / 2;

        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "You don't have enough "+UIStrings.getDiamondChar()+" <b>Diamonds</b> to open\n" +
                "this package.\n<br>" +
                "Earn Diamonds by getting high scores in Tuning\n"+
                "Challenges or by watching Rewarded Ads.";
        addChild(_messageLabel);
        _messageLabel.validate();

        _challengeBtn = ButtonFactory.defaultButton("GO TO CHALLENGES", 0x187499);
        _challengeBtn.width = 125;
        _challengeBtn.height = 23;
        _challengeBtn.paddingLeft = _challengeBtn.paddingRight = 10;
        _challengeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_challengeBtn);
        _challengeBtn.validate();
        _challengeBtn.addEventListener(Event.TRIGGERED, challengesSelectedHandler);

        _watchBtn = ButtonFactory.defaultButton("WATCH ADS", 0xff0000, "button_gradient");
        _watchBtn.width = 100;
        _watchBtn.height = 23;
        _watchBtn.paddingLeft = _watchBtn.paddingRight = 5;
        _watchBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _watchBtn.addEventListener(Event.TRIGGERED, watchSelectedHandler);
        addChild(_watchBtn);
        _watchBtn.validate();

        var rewardsIcon:Image = new Image(ButtonFactory.assetManager.getTexture("rewards_watch_btn_icon"));
        rewardsIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
        rewardsIcon.color = 0xFFFFFE;

        _watchBtn.defaultIcon = rewardsIcon;
        _watchBtn.iconOffsetX = -5;
        _watchBtn.labelOffsetX = -1.5;


        _infoBtn = new Button();
        _infoBtn.defaultSkin = new Image(ButtonFactory.assetManager.getTexture('a_fast_mode_help'));
        Image(_infoBtn.defaultSkin).color = 0x2996c8;
        _infoBtn.width = _infoBtn.height = 12;
        _infoBtn.scaleWhenDown = 0.9;
        addChild(_infoBtn);
        _infoBtn.addEventListener(Event.TRIGGERED, rewardsSelectedHandler);
    }

    private function rewardsSelectedHandler(event:Event):void {
        self.dispatchEventWith(ChallengeAlertEvent.REWARDS_TRIGGERED);
    }

    private function watchSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.WATCH_TRIGGERED);
            _closeHandler = null;
        };
        closeAll();
    }

    private function challengesSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;

            iconImage.x = _titleLabel.x + _titleLabel.width + 5;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2 + 1;

            _challengeBtn.x = _contentBackground.x + _contentBackground.width /2 - (_challengeBtn.width + 10);
            _challengeBtn.y = _contentBackground.y + _contentBackground.height - (_challengeBtn.height / 2 + 30);

            _watchBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _watchBtn.y = _contentBackground.y + _contentBackground.height - (_watchBtn.height / 2 + 30);

            _infoBtn.x = _watchBtn.x + _watchBtn.width + 10;
            _infoBtn.y = _contentBackground.y + _contentBackground.height - (_infoBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
        if(iconImage){
            iconImage.removeFromParent(true);
            iconImage = null;
        }
    }
}

class KeysStatsDialog extends InfoDialog{
    private var iconImage:Image;

    private var _votingBtn:MultilingualButton;
    private var _closeBtn:Button;
    public function KeysStatsDialog(){
        super (320, 176);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "KEYS";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_keys_icon"));
        iconImage.scale = 0.95 * ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "Keys are used to enter Tuning Challenges." +
                "\n\nTo earn more Keys, vote on other Tuning\n " + "Challenges entries in the <b>Voting Section.</b>";
        addChild(_messageLabel);
        _messageLabel.validate();

        _votingBtn = ButtonFactory.defaultButton("VOTING", 0x267596);
        _votingBtn.width = 96;
        _votingBtn.height = 23;
        _votingBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_votingBtn);
        _votingBtn.validate();
        _votingBtn.addEventListener(Event.TRIGGERED, votingSelectedHandler);


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function votingSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.VOTING_TRIGGERED);
        }
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;

            iconImage.x = _titleLabel.x + _titleLabel.width + 5;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;

            _votingBtn.x = _contentBackground.x + _contentBackground.width /2 - (_votingBtn.width + 10);
            _votingBtn.y = _contentBackground.y + _contentBackground.height - (_votingBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class KeysNotEnoughStatsDialog extends InfoDialog{
    private var iconImage:Image;

    private var _votingBtn:MultilingualButton;
    private var _closeBtn:Button;
    public function KeysNotEnoughStatsDialog(){
        super (320, 176);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "NOT ENOUGH KEYS";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_keys_icon"));
        iconImage.scale = 0.95 * ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "You don't have enough Keys to apply to this\n" + "challenge." + "\n\nTo earn more Keys, vote on other Tuning\n " + "Challenges entries in the <b>Voting Section.</b>";
        addChild(_messageLabel);
        _messageLabel.validate();

        _votingBtn = ButtonFactory.defaultButton("VOTING", 0x267596);
        _votingBtn.width = 96;
        _votingBtn.height = 23;
        _votingBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_votingBtn);
        _votingBtn.validate();
        _votingBtn.addEventListener(Event.TRIGGERED, votingSelectedHandler);


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function votingSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.VOTING_TRIGGERED);
        }
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;

            iconImage.x = _titleLabel.x + _titleLabel.width + 5;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;

            _votingBtn.x = _contentBackground.x + _contentBackground.width /2 - (_votingBtn.width + 10);
            _votingBtn.y = _contentBackground.y + _contentBackground.height - (_votingBtn.height / 2 + 35);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 35);
        }
    }

    override public function dispose():void{
        super .dispose();
        if(_votingBtn){
            _votingBtn.removeFromParent(true);
            _votingBtn = null;
        }
        if(iconImage){
            iconImage.removeFromParent(true);
            iconImage = null;
        }
        if(_closeBtn){
            _closeBtn.removeFromParent(true);
            _closeBtn = null;
        }
    }
}

class StarsStatsDialog extends InfoDialog{
    private var iconImage:Image;

    private var _challengesBtn:MultilingualButton;
    private var _closeBtn:Button;
    public function StarsStatsDialog(){
        super (320, 191);
    }

    override protected function initialize():void{
        super .initialize();
        _titleLabel.text = "STARS";
        _titleLabel.validate();


        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_stars_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "Your Star Score is the average score of all Tuning<br>"
                + "Challenges that you have participated.<br><br>"
                + "Please note that your standings in the Leaderboard will  appear after you have submitted 5 challenges.";
        addChild(_messageLabel);
        _messageLabel.validate();


        _challengesBtn = ButtonFactory.defaultButton("CHALLENGES", 0x267596);
        _challengesBtn.width = 96;
        _challengesBtn.height = 23;
        _challengesBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_challengesBtn);
        _challengesBtn.validate();
        _challengesBtn.addEventListener(Event.TRIGGERED, challengesTriggeredHandler);


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 90;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);

    }

    private function challengesTriggeredHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;

            _messageLabel.y = _headerBorder.y + 10;

            iconImage.x = _titleLabel.x + _titleLabel.width + 5;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;

            _challengesBtn.x = _contentBackground.x + _contentBackground.width /2 - (_challengesBtn.width + 10);
            _challengesBtn.y = _contentBackground.y + _contentBackground.height - (_challengesBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();

    }
}

class ChallengeSubmittedDialog extends InfoDialog{
    private var _continueBtn:Button;
    private var iconImage:Image;
    public function ChallengeSubmittedDialog(){
        super (241, 154);
    }

    override protected function initialize():void{
        super .initialize();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_submitted_popup_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _titleLabel.text = "BUILD SUBMITTED";
        _titleLabel.validate();

        var votingFinishDate:Date = DateParser.parseDate(data.votingFinishDate);
        var timeLeft:String = DateParser.getInChallengeLabel(votingFinishDate.time - new Date().time, {sec:["second", "seconds"], min:["minute","minutes"], hr:["hour","hours"], day:["day", "days"]});

        var textFormat:TextFormat = new TextFormat();
        textFormat.letterSpacing = 0;
        textFormat.leading = -1.5;
        _messageLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.MontserratHtml, 11, 0x535353, TextFormatAlign.CENTER, true, true, textFormat);
        _messageLabel.text = "Results will be ready in " + timeLeft + ".\nThank you for submitting your\nbuild for voting.";
        addChild(_messageLabel);
        _messageLabel.validate();

        _continueBtn = ButtonFactory.defaultButton("CONTINUE", 0x187499);
        _continueBtn.width = 91;
        _continueBtn.height = 23;
        _continueBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _continueBtn.addEventListener(Event.TRIGGERED, continueTriggeredHandler);
        addChild(_continueBtn);
        _continueBtn.validate();
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }
    }

    private function continueTriggeredHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            iconImage.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;
            _titleLabel.x = iconImage.x + iconImage.width + 5;

            _messageLabel.y = _headerBorder.y + 15;

            _continueBtn.x = _contentBackground.x + (_contentBackground.width - _continueBtn.width) / 2;
            _continueBtn.y = _contentBackground.y + _contentBackground.height - (_continueBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }

}

class ChallengeSubmittedTimeTrialDialog extends InfoDialog{
    private var _claimBtn:Button;
    private var iconImage:Image;
    private var _contentBorder:Image;
    private var _resultList:List;
    private var _scoreLabel:Label;
    private var _rewardLabel:ExtendedLabel;
    public function ChallengeSubmittedTimeTrialDialog(){
        super (241, 242);
        _contentBackgroundId = "anim_content_background";
    }

    override protected function initialize():void{
        super .initialize();

        if(_closeButton){
            _closeButton.removeFromParent(true);
            _closeButton = null;
        }

        _contentBackground.alpha = 0.5;

        _contentBorder = new Image(ButtonFactory.assetManager.getTexture("anim_content_border"));
        _contentBorder.texture = TextureUtil.scaleTexture(_contentBorder.texture, 0.5);
        _contentBorder.scale9Grid = new Rectangle(_contentBorder.texture.frameWidth / 2 - 0.5,_contentBorder.texture.frameHeight / 2 - 0.5, 1, 1);
        _contentBorder.width = _contentWidth;
        _contentBorder.height = _contentHeight;
        _contentBorder.color = 0xFEFFFF;
        addChild(_contentBorder);

        _headerBorder.color = 0xFFFFFF;

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_time_trails"));
        iconImage.width = 30;
        iconImage.scale = iconImage.scaleX;
        iconImage.color = 0xFEFFFF;
        addChild(iconImage);

        if(_titleLabel){
            _titleLabel.removeFromParent(true);
        }
        _titleLabel = LabelFactory.createSimpleLabel(FontSelector.getGoldBold(), 18, 0xFFFFFF, TextFormatAlign.LEFT, false, true);
        _titleLabel.text = "RESULTS";
        addChild(_titleLabel);
        _titleLabel.validate();

        _resultList = new List();
        _resultList.width = 188;
        _resultList.height = 155;
        _resultList.verticalScrollPolicy = ScrollPolicy.ON;
        _resultList.horizontalScrollPolicy = ScrollPolicy.OFF;
        var listLayout:VerticalLayout = new VerticalLayout();
        listLayout.useVirtualLayout = false;
        _resultList.layout = listLayout;
        _resultList.itemRendererFactory = function slideItemRendererFactory() : IListItemRenderer {
            var renderer:ChallengeResultItemRenderer = new ChallengeResultItemRenderer();
            renderer.setSize(_resultList.width, 31);
            return renderer;
        }
        _resultList.dataProvider = new ListCollection();
        addChild(_resultList);


        _rewardLabel = new ExtendedLabel();
        _rewardLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.getGoldBold(), 18, 0xFFFFFF, TextFormatAlign.LEFT, false, true);

        addChild(_rewardLabel);
        _rewardLabel.text = data.reward.toString() + "x";
        _rewardLabel.defaultIcon = new LayoutImage(ButtonFactory.assetManager.getTextureAtlas("resource_icons").getTexture("collect_diamond_big.png"));

        _rewardLabel.defaultIcon.height = 24;
        _rewardLabel.defaultIcon.scale = _rewardLabel.defaultIcon.scaleY;
        _rewardLabel.validate();
        _rewardLabel.alpha = 0;
        _rewardLabel.pivotX = _rewardLabel.width / 2;
        _rewardLabel.pivotY = _rewardLabel.height / 2;
        _rewardLabel.scale = 2;


        _claimBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("anim_button_texture"), null, null, false, 2.5));
        closeImg.scale9Grid = new Rectangle(closeImg.texture.frameHeight / 2 - 0.5,0, 1, closeImg.texture.frameHeight);
        _claimBtn.defaultSkin = closeImg;

        if(data.reward){
            _claimBtn.label = "CLAIM";
        }else{
            _claimBtn.label = "CLOSE";
        }
        _claimBtn.width = 71;
        _claimBtn.height = 23;
        _claimBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_claimBtn);
        _claimBtn.addEventListener(Event.TRIGGERED, claimTriggeredHandler);
        _claimBtn.validate();
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }

        _scoreLabel = LabelFactory.createSimpleLabel(FontSelector.getGoldBold(), 18, 0xFFFFFF, TextFormatAlign.LEFT, false, true);
        _scoreLabel.text = data.rating + "%";
        addChild(_scoreLabel);
        _scoreLabel.validate();
        _scoreLabel.alpha = 0;
        _scoreLabel.pivotX = _scoreLabel.width / 2;
        _scoreLabel.pivotY = _scoreLabel.height / 2;
        _scoreLabel.scale = 2;

        _openCompleteHandler = function():void{
            var resultDataList:Array = [];
            for(var compType:String in data){
                if(data[compType].hasOwnProperty("sortKey")){
                    var sortKey:Number = data[compType].sortKey;
                    delete data[compType].sortKey;
                    for(var reqType:String in data[compType]){
                        var resultData:Object = {"label": AlertView.language.translate("componentTypes", compType), complete: data[compType][reqType], iconId: compType, sortKey: sortKey};
                        resultDataList.push(resultData);
                    }
                }
            }
            resultDataList.sortOn("sortKey", Array.NUMERIC);
            addItem(resultDataList);
        }
    }

    private function addItem(resultDataList:Array):void{
        if(resultDataList && resultDataList.length){
            if(_resultList && _resultList.dataProvider){
                _resultList.dataProvider.addItem(resultDataList.shift());
                Starling.juggler.delayCall(addItem, 0.75, resultDataList);
            }
        }else{
            var rewardTween:Tween = new Tween(_rewardLabel, 0.25, Transitions.EASE_OUT);
            rewardTween.fadeTo(1);
            rewardTween.scaleTo(1);

            var scoreTween:Tween = new Tween(_scoreLabel, 0.25, Transitions.EASE_OUT);
            scoreTween.fadeTo(1);
            scoreTween.scaleTo(1);

            Starling.juggler.add(rewardTween);
            Starling.juggler.add(scoreTween);
        }
    }

    private function claimTriggeredHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.COLLECT_TRIGGERED);
        }
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _contentBorder.x = _contentBackground.x;
            _contentBorder.y = _contentBackground.y;

            iconImage.x = _contentBackground.x + (_contentBackground.width - iconImage.width) / 2;
            iconImage.y = _contentBackground.y - iconImage.height / 2 - 5;

            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _titleLabel.y = _contentBackground.y + (_headerBorder.y - _contentBackground.y - _titleLabel.height) / 2 + 3;

            _resultList.x = _contentBackground.x + (_contentBackground.width - _resultList.width) / 2;
            _resultList.y = _headerBorder.y + 5;

            _claimBtn.x = _contentBackground.x + (_contentBackground.width - _claimBtn.width) / 2;
            _claimBtn.y = _contentBackground.y + _contentBackground.height - (_claimBtn.height + 10);

            _rewardLabel.x =  _contentBackground.x + (_claimBtn.x - _contentBackground.x - _rewardLabel.width) / 2 + _rewardLabel.width / 2;
            _rewardLabel.y = _claimBtn.y + (_claimBtn.height - _rewardLabel.height) / 2 + _rewardLabel.height / 2;

            _scoreLabel.x =  (_claimBtn.x + _claimBtn.width + _contentBackground.x + _contentBackground.width - _scoreLabel.width) / 2 + _scoreLabel.width / 2;
            _scoreLabel.y = _claimBtn.y + (_claimBtn.height - _scoreLabel.height) / 2 + _scoreLabel.height / 2;
        }
    }

    override public function dispose():void{
        super .dispose();
    }

}

class ChallengeResultItemRenderer extends ListItemRenderer{
    private var _nameLabel:Label;
    private var _icon:Image;
    private var _typeIcon:Image;
    private var _border:LayoutImage;
    private var _shiningImage:ShineImage;
    public function ChallengeResultItemRenderer(){
    }

    override protected function initialize():void{
        super.initialize();
        _border = new LayoutImage(Texture.fromColor(1,1,0xFFFFFF));
        _border.height = 0.5;
        _border.width = actualWidth;
        _border.alpha = 0.6;
        addChild(_border);

        _nameLabel = LabelFactory.createSimpleLabel(FontSelector.getAlumniSansMedium(), 21, 0xFFFFFF, TextFormatAlign.LEFT, false, false);
        addChild(_nameLabel);
    }

    override protected function commitData():void{
        super.commitData();
        if(data && data.label){
            _nameLabel.x = actualWidth;
            _nameLabel.alpha = 0;
            _nameLabel.text = (data.label as String).toUpperCase();
            _nameLabel.validate();
            _nameLabel.y = (actualHeight - _nameLabel.height) / 2;
            if(data.complete){
                _icon = new Image(ButtonFactory.assetManager.getTexture("profile_yes"));
                _icon.color = 0xFF0000;
            }else{
                _icon = new Image(ButtonFactory.assetManager.getTexture("close_btn_texture"));
                _icon.color = 0xF00000;
            }

            _icon.visible = false;
            addChild(_icon);

            var assetsProxy:AssetsProxy = ApplicationFacade.getInstance().retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
            if(ButtonFactory.assetManager.getTexture(data.iconId)){
                loadAndSetIcon();
            }else{
                assetsProxy.loadComponentIcon(data.iconId, function():void{
                    loadAndSetIcon();
                }, function ():void{

                });
            }
        }
    }

    private function loadAndSetIcon():void{
        _typeIcon = new Image(ButtonFactory.assetManager.getTexture(data.iconId));
        if(_typeIcon.width * 22 / _typeIcon.height > _typeIcon.height * 30 / _typeIcon.width){
            _typeIcon.width = 30;
            _typeIcon.scale = _typeIcon.scaleX;
        }else{
            _typeIcon.height = 22;
            _typeIcon.scale = _typeIcon.scaleY;
        }

        addChild(_typeIcon);
        _typeIcon.x = (30 - _typeIcon.width) / 2;
        _typeIcon.y = (actualHeight - _typeIcon.height) / 2;
    }

    override protected function draw():void{
        super .draw();
        if(isInvalid(INVALIDATION_FLAG_DATA)){
            animateComponents();
        }
        if(_border){
            _border.y = actualHeight - _border.height;
        }
    }

    private function animateComponents():void{
        var tween:Tween = new Tween(_nameLabel, 0.35, Transitions.EASE_IN);
        tween.moveTo(35, _nameLabel.y);
        tween.fadeTo(1);
        tween.onStart = function():void{
            if(owner.verticalScrollPosition < owner.maxVerticalScrollPosition){
                owner.scrollToDisplayIndex(owner.dataProvider.length - 1, 0.2);
            }
        }

        _icon.width = 16;
        _icon.scale = _icon.scaleX;
        _icon.x = actualWidth - (_icon.width + 2);
        _icon.y = (actualHeight - _icon.height) / 2;

        //
        _shiningImage = new ShineImage(ButtonFactory.assetManager.getTexture("lights_effect"));
        _shiningImage.setColor(0x1189fb);
        _shiningImage.dir = 0.5;
        _shiningImage.isRotating = true;
        _shiningImage.alpha = 0;
        _shiningImage.scale = 1.5 * ButtonFactory.assetManager.scaleFactor / 2;
        _shiningImage.colorChangingInterval = 5;
        _shiningImage.rotationSpeed = Math.PI / 18;
        _shiningImage.x = owner.x + actualWidth - _icon.width / 2;
        _shiningImage.y = owner.y + Math.min(actualHeight * index + actualHeight / 2, owner.height - actualHeight / 2);
        owner.parent.addChild(_shiningImage);
        //
        var shineTween:Tween = new Tween(_shiningImage, 1, Transitions.EASE_OUT);
        shineTween.fadeTo(1);
        shineTween.scaleTo(0);
        shineTween.delay = 0.35;
        shineTween.onComplete = function():void{
            if(_shiningImage){
                _shiningImage.removeFromParent(true);
                _shiningImage = null;
            }
        }
        Starling.juggler.add(shineTween);
        tween.onComplete = function():void{
            _icon.alpha = 0;
            _icon.visible = true;
            tween = new Tween(_icon, 0.1, Transitions.EASE_IN);
            tween.fadeTo(1);
            tween.delay = 0.5;
            Starling.juggler.add(tween);
        }
        Starling.juggler.add(tween);
    }

    override public function dispose():void{
        super.dispose();
        if(_typeIcon){
            _typeIcon.removeFromParent(true);
            _typeIcon = null;
        }
    }
}

class VoteHelpDialog extends InfoDialog{
    public function VoteHelpDialog(){
        super(320, 191);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "HOW VOTING WORKS";
        _titleLabel.validate();

        _messageLabel.text = "Your votes determine the Star scores & ratings in\n"+
                "Tuning Challenges - the more votes an entry\n"+
                "receives, the higher its Star score & rating gets!\n<br>"+
                "Voting earns you "+UIStrings.getKeyChar()+" <b>Keys</b> so you can enter more\n"+
                "Tuning Challenges - each set of five votes earns\n"+
                "you "+UIStrings.getKeyChar()+" <b>" + Constants.VOTING_KEY_AMOUNT.toString() +" Keys!</b>\n<br>"+
                "<b>DON'T FORGET TO VOTE!</b>";
        addChild(_messageLabel);
        _messageLabel.validate();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _messageLabel.y = _headerBorder.y + 8;
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class KeysReceivedDialog extends CollectRewards{
    protected var _totalKeysLabel:Label;

    public function KeysReceivedDialog(){

    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "KEYS RECEIVED";
        _titleLabel.validate();

        _totalKeysLabel = LabelFactory.createSimpleLabel(FontSelector.getMontserratRegular(), 10, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _totalKeysLabel.text = rewardData.source.totalKeys + "/" + rewardData.source.maxKeys;
        addChild(_totalKeysLabel);
        _totalKeysLabel.validate();

        _collectBtn.label = "CONTINUE VOTING";
        _collectBtn.width = 121;
        _collectBtn.height = 23;
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = _titleLabel.width;
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;

            _totalKeysLabel.x = _contentBackground.x + (_contentBackground.width - _totalKeysLabel.width) / 2;
            _totalKeysLabel.y = _headerBorder.y + 5;
        }
    }

    override public function dispose():void{
        super .dispose();
        if(_titleLabel){
            _titleLabel.removeFromParent(true);
            _titleLabel = null;
        }

        if(_totalKeysLabel){
            _totalKeysLabel.removeFromParent(true);
            _totalKeysLabel = null;
        }

        if(_headerBorder){
            _headerBorder.removeFromParent(true);
            _headerBorder = null;
        }
    }
}

class RewardedDailyLimit extends InfoDialog{
    private var iconImage:Image;

    private var _challengesBtn:MultilingualButton;
    private var _closeBtn:Button;
    public function RewardedDailyLimit(){
        super (320, 195);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "DAILY LIMIT OF REWARDS ADS";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_popup_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "You have reached the limit of "+AdsManager.MAX_REWARDS_COUNT.toString()+" daily Rewarded\n" +
                "Ads. Tomorrow the limit will be reset.\n\n"+
        "<font size='10'>Please note that you can also earn "+UIStrings.getDiamondChar()+" </font><b>Diamonds</b>\nby participating in Tuning Challenges.</font>";
        addChild(_messageLabel);
        _messageLabel.validate();

        _challengesBtn = ButtonFactory.defaultButton("CHALLENGES", 0x187499);
        _challengesBtn.width = 96;
        _challengesBtn.height = 23;
        _challengesBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_challengesBtn);
        _challengesBtn.validate();
        _challengesBtn.addEventListener(Event.TRIGGERED, challengesSelectedHandler);


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function challengesSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        }
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            iconImage.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;
            _titleLabel.x = iconImage.x + iconImage.width + 5;

            _messageLabel.y = _headerBorder.y + 20;

            _challengesBtn.x = _contentBackground.x + _contentBackground.width /2 - (_challengesBtn.width + 10);
            _challengesBtn.y = _contentBackground.y + _contentBackground.height - (_challengesBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class ChallengeRequirementsNotMet extends InfoDialog{
    private var iconImage:Image;
    private var reqImage:Image;

    private var messageData:Object = function():Object{
        var result:Object = {};
        result[ChallengeData.TYPE_WIDE] = {
            message:"Wide body kits or front & rear fender flares \n" +
                    "must be applied.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Parts Menu  2. Choose & apply required body parts</font>",
            imageId: "req_wide_body"
        };
        result[ChallengeData.TYPE_STANCE] = {
            message:"Wheel camber and/or wheel off-set must be \n" +
                    "applied to the front and rear wheels.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Stance Menu  2. Apply Desired Stance Settings</font>",
            imageId: "req_stance"
        };
        result[ChallengeData.TYPE_BACKGROUND] = {
            message:"Please choose any background from\n the list or upload a new one.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Car settings  2. Select a background from background list</font>",
            imageId: "req_background"
        };


        result[ChallengeData.TYPE_CAMBER] = {
            message:"Wheel camber must be applied to the \n" +
                    "front and/or rear wheels.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Stance Menu  2. Apply Desired Stance Settings</font>",
            imageId: "req_camber"
        };
        result[ChallengeData.TYPE_OFFSET] = {
            message:"Wheel off-set must be applied to the  \n" +
                    "front and/or rear wheels.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Stance Menu  2. Apply Desired Stance Settings</font>",
            imageId: "req_offset"
        };
        result[ChallengeData.TYPE_STRIPES] = {
            message:"Racing Stripe Kits must be applied \n" +
                    "from Vinyls category.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Parts Menu  2. Choose & apply required body parts</font>",
            imageId: "req_racing_strip"
        };
        result[ChallengeData.TYPE_VINYLS] = {
            message:"All Decals must be applied \n" +
                    "from Vinyls category.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Parts Menu  2. Choose & apply required body parts</font>",
            imageId: "req_decals"
        };
        result[ChallengeData.TYPE_TWO_TONE] = {
            message:"Two Tone Vinyl Kits \n" +
                    "must be applied.\n<br>" +
                    "<font size='8'>" + UIStrings.getLightBulbChar() + " <b>Help tips:</b>\n" +
                    "1. Open Parts Menu  2. Choose & apply required body parts</font>",
            imageId: "req_two_tone_vinyl"
        };
        return result;
    }();

    public function ChallengeRequirementsNotMet(){
        super (321, 191);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "CHALLENGE REQUIREMENTS NOT MET!";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_requirement_popup_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        if(data){
            var dataArr:Array = StringUtil.trim(data).split(',');
            var msgData:Object;
            if(dataArr.indexOf(ChallengeData.TYPE_WIDE) != -1){
                msgData = messageData[ChallengeData.TYPE_WIDE];

            }else if(dataArr.indexOf(ChallengeData.TYPE_STANCE) != -1){
                msgData = messageData[ChallengeData.TYPE_STANCE];

            }else if(dataArr.indexOf(ChallengeData.TYPE_BACKGROUND) != -1){
                msgData = messageData[ChallengeData.TYPE_BACKGROUND];

            }else if(dataArr.indexOf(ChallengeData.TYPE_CAMBER) != -1){
                msgData = messageData[ChallengeData.TYPE_CAMBER];

            }else if(dataArr.indexOf(ChallengeData.TYPE_OFFSET) != -1){
                msgData = messageData[ChallengeData.TYPE_OFFSET];

            }else if(dataArr.indexOf(ChallengeData.TYPE_STRIPES) != -1){
                msgData = messageData[ChallengeData.TYPE_STRIPES];

            }else if(dataArr.indexOf(ChallengeData.TYPE_VINYLS) != -1){
                msgData = messageData[ChallengeData.TYPE_VINYLS];

            }else if(dataArr.indexOf(ChallengeData.TYPE_TWO_TONE) != -1){
                msgData = messageData[ChallengeData.TYPE_TWO_TONE];
            }

            if(msgData){
                _messageLabel.text = msgData.message;
                reqImage = new Image(ButtonFactory.assetManager.getTexture(msgData.imageId));
            }
        }

        addChild(_messageLabel);
        _messageLabel.validate();
        if(reqImage){
            reqImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
            reqImage.color = 0xFF0000;
            addChild(reqImage);
        }

    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            iconImage.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;
            _titleLabel.x = iconImage.x + iconImage.width + 5;

            _messageLabel.y = _headerBorder.y + 10;
            if(reqImage){
                reqImage.width = _headerBorder.width;
                reqImage.scale = reqImage.scaleX;
                reqImage.x = _contentBackground.x + (_contentBackground.width - reqImage.width) / 2;
                reqImage.y = _messageLabel.y + _messageLabel.height + 2;
            }
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class DailyRewards extends InfoDialog{
    private var iconImage:Image;

    private var _closeBtn:Button;
    public function DailyRewards(){
        super (332, 195);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "DAILY REWARD!";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_popup_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        var andText:String;
        var keysText:String;
        var keyNum:int = parseInt(data.keys);
        if(keyNum){
            if(keyNum == 1){
                keysText = UIStrings.getKeyChar() + " <b>1 Key</b>";
            }else{
                keysText = UIStrings.getKeyChar() + " <b>" + data.keys + " Keys</b>";
            }
        }else{
            keysText = "";
        }
        var diamondText:String;
        var diamondNum:int = parseInt(data.diamonds);
        if(diamondNum){
            if(diamondNum == 1){
                diamondText = UIStrings.getDiamondChar() + " <b>1 Diamond</b>";
            }else{
                diamondText = UIStrings.getDiamondChar() + " <b>" + data.diamonds + " Diamonds</b>";
            }
        }else{
            diamondText = "";
        }
        andText = (diamondNum && keyNum)?" and ":"";

        _messageLabel.text = "Welcome back to 3DTuning!\n" +
                "We have added " + keysText + andText + diamondText + "\nto your account!\n\n"+
        "Please don't forget to come back tomorrow\nfor more "+UIStrings.getKeyChar()+" <b>Keys</b> and "+UIStrings.getDiamondChar()+" <b>Diamonds!</b>";
        addChild(_messageLabel);
        _messageLabel.validate();

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            iconImage.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;
            _titleLabel.x = iconImage.x + iconImage.width + 5;

            _messageLabel.y = _headerBorder.y + 15;

            _closeBtn.x = _contentBackground.x + (_contentBackground.width - _closeBtn.width) / 2;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class RewardsList extends AnimatedAlertView{
    private var _timeLeftLabel:Label;
    private var _nextPriceLabel:Label;
    private var _clockIcon:Image;
    private var _labels:Object = {sec:["S"], min:["M"], hr:["H"], day:["D"]};
    private var _claimHandler:Function;
    //
    private var _clockTimer:Timer;
    private var _timeLeft:Number;
    private var _prevTime:Number;


    private var _items:Vector.<RewardsListItem>;
    private var _openAnimationTimer:Timer;

    public function RewardsList(){
        super (380, 254);
        closeOnForegroundTouch = false;
    }

    override protected function initialize():void{
        super .initialize();
        _clockTimer = new Timer(DateParser.SECOND);
        _clockTimer.addEventListener(TimerEvent.TIMER, timerHandler);

        _titleLabel.text = "DAILY BONUS";
        _titleLabel.validate();

        _timeLeftLabel = LabelFactory.createSimpleLabel(FontSelector.getAlumniSansBold(), 21, 0x0da7d9, TextFormatAlign.RIGHT, false, false);
        addChild(_timeLeftLabel);
        _timeLeftLabel.visible = false;
        _timeLeftLabel.text = "0S";

        _nextPriceLabel = LabelFactory.createSimpleLabel(FontSelector.getAlumniSansMedium(), 13, 0xFFFFFF, TextFormatAlign.RIGHT, false, false);
        addChild(_nextPriceLabel);
        _nextPriceLabel.visible = false;
        _nextPriceLabel.text = "NEXT PRICE IN";

        _clockIcon = new Image(ButtonFactory.assetManager.getTexture("clock-menu"));
        addChild(_clockIcon);
        _clockIcon.visible = false;
        _clockIcon.color = 0x0da7d9;
        _clockIcon.width = _clockIcon.height = 18;


        _closeButton = new Button();
        var closeIcon:Image = new Image(ButtonFactory.assetManager.getTexture("details_close"));
        closeIcon.scale = 0.75 * ButtonFactory.assetManager.scaleFactor/2;
        closeIcon.color = 0xFEFFFF;

        var closeSkin:Quad = new Quad(1,1,0xFFFFFF);
        closeSkin.width = closeSkin.height = 30;
        closeSkin.alpha = 0;
        _closeButton.width = closeIcon.width;
        _closeButton.height = closeIcon.height;
        _closeButton.defaultIcon = closeIcon;
        _closeButton.defaultSkin = closeSkin;
        addChild(_closeButton);
        _closeButton.validate();
        _closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);

        _nextPriceLabel.mask = _contentMask;
        _timeLeftLabel.mask = _contentMask;
        _clockIcon.mask = _contentMask;

    }

    private function updateClockLayout():void{
        if(_timeLeftLabel){
            _timeLeftLabel.text = DateParser.getInChallengeLabel(_timeLeft, _labels, 2, false);
            _timeLeftLabel.validate();
            _timeLeftLabel.x = _contentBackground.x + _contentWidth - 85;
            _timeLeftLabel.y = _contentBackground.y + 3;

            _clockIcon.x = _timeLeftLabel.x - _clockIcon.width - 5;
            _clockIcon.y = _timeLeftLabel.y + (_timeLeftLabel.height - _clockIcon.width) / 2;
        }
    }

    private function timerHandler(event:TimerEvent):void {
        _timeLeft -= getTimer() - _prevTime;
        _prevTime = getTimer();
        if(_timeLeft <= 0){
            activateNextItem();
            return;
        }
        updateClockLayout();
    }

    override public function open():void{
        super .open();

    }

    override protected function animationCompleteHandler():void{
        super .animationCompleteHandler();
        if(!stage){
            return;
        }

        _nextPriceLabel.mask = null;
        _timeLeftLabel.mask = null;
        _clockIcon.mask = null;


        var lastVisitDate:Date = DateParser.parseDate(data.userData.date as String);
        var lastVisitTime:Number = DateParser.getDateTime(lastVisitDate);
        var currentTime:Number = DateParser.getDateTime(new Date());
        var isActive:Boolean = false;
        _timeLeft = 0;
        if(lastVisitTime == currentTime){
            _timeLeft = currentTime + DateParser.DAY - new Date().getTime();
        }
        if(_timeLeft <= 0){
            isActive = true;
        }else{
            _timeLeftLabel.visible = true;
            _timeLeftLabel.text = DateParser.getInChallengeLabel(_timeLeft, _labels, 2, false);
            _nextPriceLabel.visible = true;
            _clockIcon.visible = true;
            _prevTime = getTimer();
            _clockTimer.start();
            Starling.juggler.delayCall(activateNextItem, _timeLeft / DateParser.SECOND);
        }

        var iw:Number = RewardsListItem.ITEM_WIDTH;
        var ih:Number = RewardsListItem.ITEM_HEIGHT;
        _items = new <RewardsListItem>[];

        var startIndex:int = Math.floor(data.userData.dayIndex / 28) * 28;
        var endIndex:int = startIndex + 28;
        for(var i:int = startIndex; i < endIndex; i++){
            var rewardsListItem:RewardsListItem = new RewardsListItem();
            rewardsListItem.addEventListener(RewardsListItem.CLAIM_REWARDS, claimRewardsHandler);
            rewardsListItem.data = DailyRewardsData.dailyRewardsList[i];
            if(data.userData && data.userData.hasOwnProperty("dayIndex")){
                var userDayIndex:int = data.userData.dayIndex + 1;
                if(userDayIndex > rewardsListItem.data.day){
                    rewardsListItem.status = RewardsListItem.STATUS_COMPLETE;
                }else if(userDayIndex == rewardsListItem.data.day && isActive){
                    rewardsListItem.status = RewardsListItem.STATUS_CURRENT;
                }else{
                    rewardsListItem.status = RewardsListItem.STATUS_INACTIVE;
                }
            }

            if(rewardsListItem.data.carId && data.cars){
                rewardsListItem.car = data.cars[rewardsListItem.data.carId];
            }
            rewardsListItem.pivotX = iw / 2;
            rewardsListItem.scaleX = 0;
            addChild(rewardsListItem);
            rewardsListItem.validate();
            var index:int = i % 28;
            var itemGap:Number = 5;
            var leftMargin:Number = (_contentWidth - (7 * (iw + itemGap) - itemGap)) / 2 + iw / 2;
            rewardsListItem.x = _contentBackground.x + leftMargin + (index % 7) * (iw + itemGap);
            rewardsListItem.y = _contentBackground.y + 56 + Math.floor(index / 7) * (ih + itemGap);
            _items.push(rewardsListItem);
        }
        _openAnimationTimer = new Timer(60);
        _openAnimationTimer.addEventListener(TimerEvent.TIMER, listOpenAnimTimer);
        _openAnimationTimer.start();
    }

    private function listOpenAnimTimer(event:TimerEvent):void {
        var index:int = _openAnimationTimer.currentCount - 1;
        var selectedItems:Vector.<RewardsListItem> = new <RewardsListItem>[];
        var rowCount:int = Math.ceil(_items.length/7);
        var col:int = index;
        for(var row:int = 0; row < rowCount; row++){
            var currIndex:int = row * 7 + col;
            if(currIndex > -1 && currIndex < _items.length){
                selectedItems.push(_items[currIndex]);
            }else{
                break;
            }
            col--;
            if(col < 0){
                break;
            }
        }
        if(!selectedItems.length){
            _openAnimationTimer.stop();
            _openAnimationTimer.removeEventListener(TimerEvent.TIMER, listOpenAnimTimer);
            _openAnimationTimer = null;
            return;
        }
        for(var i:int =0; i < selectedItems.length; i++){
            var tween:Tween = new Tween(selectedItems[i], 0.25, Transitions.EASE_OUT);
            tween.animate("scaleX", 1);
            Starling.juggler.add(tween);
        }
    }

    override public function set data(value:*):void{
        super.data = value;
        if(data.hasOwnProperty("claimHandler")){
            _claimHandler = data.claimHandler;
        }
    }

    private function claimRewardsHandler(event:Event):void{
        var alertView:ChallengeAlertView = show(COLLECT_REWARDS, event.data, stage, false);
        alertView.addEventListener(ChallengeAlertEvent.COLLECT_TRIGGERED, collectEventHandler);
        alertView.open();
    }

    private function collectEventHandler(event:Event):void{
        var index:int = data.userData.dayIndex % 28;
        var item:RewardsListItem = _items[index];
        item.status = RewardsListItem.STATUS_COMPLETE;
        item.updateStatus();
        item.validate();

        if(_claimHandler !== null){
            _claimHandler(data.userData);
        }

        var currentTime:Number = DateParser.getDateTime(new Date());
        _timeLeft = currentTime + DateParser.DAY - new Date().getTime();
        _prevTime = getTimer();
        updateClockLayout();

        if(_clockTimer){
            _clockTimer.reset();
            _clockTimer.start();
        }

        _timeLeftLabel.visible = true;
        _nextPriceLabel.visible = true;
        _clockIcon.visible = true;
    }

    private function activateNextItem():void {
        Starling.juggler.removeDelayedCalls(activateNextItem);
        if(!stage){
            dispose();
            return;
        }
        if(_clockTimer){
            _clockTimer.stop();
        }

        _timeLeftLabel.visible = false;
        _nextPriceLabel.visible = false;
        _clockIcon.visible = false;

        var index:int = data.userData.dayIndex;
        var item:RewardsListItem = _items[index];
        item.status = RewardsListItem.STATUS_CURRENT;
        item.updateStatus();
        item.validate();
        if(index == 0){
            for(var i:int = 1; i < _items.length; i++){
                _items[i].status = RewardsListItem.STATUS_INACTIVE;
                _items[i].updateStatus();
            }
        }
    }

    override protected function draw():void{
        super .draw();
        if(_nextPriceLabel){
            _nextPriceLabel.validate();
            _nextPriceLabel.x = _contentBackground.x + _contentWidth - 85;
            _nextPriceLabel.y = _contentBackground.y + (38 - _nextPriceLabel.height);
        }

        updateClockLayout();
    }

    override public function dispose():void{
        super .dispose();
        if(_clockTimer){
            _clockTimer.stop();
            _clockTimer.removeEventListener(TimerEvent.TIMER, timerHandler);
            _clockTimer = null;
        }

        if(_timeLeftLabel){
            _timeLeftLabel.removeFromParent(true);
            _timeLeftLabel = null;
        }

        if(_nextPriceLabel){
            _nextPriceLabel.removeFromParent(true);
            _nextPriceLabel = null;
        }

        if(_clockIcon){
            _clockIcon.removeFromParent(true);
            _clockIcon = null;
        }
        _labels = null;
        _claimHandler = null;
    }
}

class ChallengeNotAvailable extends InfoDialog{
    private var _closeBtn:Button;
    public function ChallengeNotAvailable(){
        super (240, 160);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "VOTING HAS FINISHED";
        _titleLabel.validate();
        _messageLabel.text = "This challenge is not available\n" +
                "for voting anymore!\n\n"+
        "Please vote for the next challenge.</b>";
        addChild(_messageLabel);
        _messageLabel.validate();

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
        _closeHandler = function():void{
            dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
        };
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _messageLabel.y = _headerBorder.y + 10;
            _closeBtn.x = _contentBackground.x + (_contentBackground.width - _closeBtn.width) / 2;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class ChallengeTimeLeft extends InfoDialog{
    private var _closeBtn:Button;
    public function ChallengeTimeLeft(){
        super (240, 156);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = UIStrings.getTimeLimitChar(18) + " TIME IS ALMOST UP!";
        _titleLabel.validate();
        _messageLabel.text = "There is "+ data +" left for\n" +
                "submitting your build to this\n"+
        "challenge. Please hurry up!";
        addChild(_messageLabel);
        _messageLabel.validate();

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
        _closeHandler = function():void{
            dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
        };
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _messageLabel.y = _headerBorder.y + 15;
            _closeBtn.x = _contentBackground.x + (_contentBackground.width - _closeBtn.width) / 2;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class ChallengeExpired extends InfoDialog{
    private var _closeBtn:Button;
    public function ChallengeExpired(){
        super (380, 216);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = UIStrings.getFinishedChar(16) + "  SUBMISSIONS TO THIS CHALLENGE ARE OVER!";
        _titleLabel.validate();
        _messageLabel.text = "<font size='11'>Unfortunately, the time has run out for submitting\n"
                +"builds to this challenge.\n\n" +
                "Your spent " + UIStrings.getKeyChar()+ " keys for this challenge has been added\n"+
                "back to you account.</font>\n\n"+
        "Please choose another active challenge.";
        addChild(_messageLabel);
        _messageLabel.validate();

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
        _closeHandler = function():void{
            dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
        };
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _messageLabel.y = _headerBorder.y + 20;
            _closeBtn.x = _contentBackground.x + (_contentBackground.width - _closeBtn.width) / 2;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class ChallengeLevelUp extends AnimatedAlertView{
    private var _collectBtn:Button;
    private var _levelLabel:Label;
    private var _rewardsLabel:Label;
    private var _user:User;
    private var _animationList:Vector.<ShineImage>;
    private var _animationIcons:Vector.<Image>;
    private var _animationBorder:Vector.<Image>;
    private var _animationCheck:Vector.<Image>;
    private var _animationPlus:Vector.<Image>;
    private var _animationLabels:Vector.<Label>;
    private var _animationTween:Vector.<Tween>;
    public function ChallengeLevelUp(){
        super (248, 223);
        _iconImageTexture = "level_up_icon";
        _iconImageColor = 0xf8a007;
    }

    override protected function initialize():void{
        if(data && data is User){
            _user = data as User;
        }
        var count:int = 0;
        if(_user && _user.levelData){
            if(_user.levelData.unlockedData.limit){
                count++;
            }
            if(_user.levelData.unlockedData.components && _user.levelData.unlockedData.components.length){
                count += _user.levelData.unlockedData.components.length;
            }
            if(_user.levelData.unlockedData.materials && _user.levelData.unlockedData.materials.length){
                count += _user.levelData.unlockedData.materials.length;
            }
            if(count == 3){
                setSize(308, _contentHeight);
            }
        }
        super .initialize();
        _headerBorder.color = 0xFFFFFF;

        _levelLabel = LabelFactory.createSimpleLabel(FontSelector.AlumniSansHtml, 18, 0xFFFFFF, TextFormatAlign.CENTER, false, true);
        _levelLabel.paddingLeft = _levelLabel.paddingRight = 4;
        _levelLabel.paddingBottom = 2;
        _levelLabel.paddingTop = -2;
        _levelLabel.backgroundSkin = new Quad(1,1,0xf8a007);
        if(_user && _user.levelData){
            _levelLabel.text = UIStrings.getStarChar(8) + " <b>LEVEL " + _user.levelData.level.toString() + "</b> " + UIStrings.getStarChar(8);
        }
        _levelLabel.height = 18;

        addChild(_levelLabel);
        _levelLabel.validate();

        _rewardsLabel = LabelFactory.createSimpleLabel(FontSelector.getAlumniSansRegular(), 11, 0xFFFFFF, TextFormatAlign.LEFT, false, false);
        _rewardsLabel.text = "REWARDS";
        addChild(_rewardsLabel);
        _rewardsLabel.validate();

        _titleLabel.text = "YOU HAVE LEVELED UP!";
        _titleLabel.validate();

        _collectBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("anim_button_texture"), null, null, false, 2.5));
        closeImg.scale9Grid = new Rectangle(closeImg.texture.frameHeight / 2 - 0.5,0, 1, closeImg.texture.frameHeight);
        _collectBtn.defaultSkin = closeImg;

        _collectBtn.label = "COLLECT";
        _collectBtn.width = 92;
        _collectBtn.height = 23;
        _collectBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        addChild(_collectBtn);
        _collectBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
        _closeHandler = function():void{
            dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
        };

        _levelLabel.mask = _contentMask;
        _rewardsLabel.mask = _contentMask;
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _levelLabel.x = _headerBorder.x + (_headerBorder.width - _levelLabel.width) / 2;
            _levelLabel.y = _headerBorder.y + _headerBorder.height;

            _rewardsLabel.x = _levelLabel.x + (_levelLabel.width - _rewardsLabel.width) / 2;
            _rewardsLabel.y = _levelLabel.y + _levelLabel.height;

            _collectBtn.x = _contentBackground.x + (_contentBackground.width - _collectBtn.width) / 2;
            _collectBtn.y = _contentBackground.y + _contentBackground.height - (_collectBtn.height / 2 + 25);

            iconImage.width = headerSize - 25;
            iconImage.scale = iconImage.scaleX;
            iconImage.x = _contentBackground.x + (headerSize - iconImage.width) / 2;
            iconImage.y = _contentBackground.y + (headerSize - iconImage.height - iconBottomBorder.height) / 2;
        }
    }

    override protected function animationCompleteHandler():void{
        super .animationCompleteHandler();
        if(_levelLabel){
            _levelLabel.mask = null;
        }
        if(_rewardsLabel){
            _rewardsLabel.mask = null;
        }
        var count:int = 0;
        var levelData:Array = [];
        var i:int;
        if(_user.levelData.unlockedData.materials && _user.levelData.unlockedData.materials.length){
            count += _user.levelData.unlockedData.materials.length;
            for(i = 0; i < _user.levelData.unlockedData.materials.length; i++){
                levelData.push({name:"material", "value":_user.levelData.unlockedData.materials[i]});
            }
        }
        if(_user.levelData.unlockedData.components && _user.levelData.unlockedData.components.length){
            count += _user.levelData.unlockedData.components.length;
            for(i = 0; i < _user.levelData.unlockedData.components.length; i++){
                levelData.push(_user.levelData.unlockedData.components[i]);
            }
        }
        if(_user.levelData.unlockedData.limit){
            count++;
            levelData.push({name:"limit", "value": _user.levelData.unlockedData.limit});
        }
        //
        _animationList = new Vector.<ShineImage>(levelData.length);
        _animationBorder = new Vector.<Image>(levelData.length);
        _animationCheck = new Vector.<Image>(levelData.length);
        _animationIcons = new Vector.<Image>(levelData.length);
        _animationPlus = new Vector.<Image>(levelData.length);
        _animationLabels = new Vector.<Label>(levelData.length);
        _animationTween = new Vector.<Tween>(levelData.length);
        for(i = 0; i < levelData.length; i++){
            _animationList[i] = new ShineImage(ButtonFactory.assetManager.getTexture("lights_effect"));
            if(levelData[i].name == "material"){
                _animationList[i].setColor(0xeeea10);
            }else if(levelData[i].name == "limit"){
                _animationList[i].setColor(0x3cfd58);
            }else if(levelData[i].name == "aerography_packs"){
                _animationList[i].setColor(0x158efd);
            }else if(levelData[i].name == "vinyl_decals"){
                _animationList[i].setColor(0x00eaff);
            }
            _animationList[i].dir = 1;
            _animationList[i].isRotating = true;
            _animationList[i].alpha = 0;
            _animationList[i].scale = 2 * ButtonFactory.assetManager.scaleFactor / 2;
            _animationList[i].colorChangingInterval = 10;
            _animationList[i].rotationSpeed = Math.PI / 9;
            addChild(_animationList[i]);

            _animationList[i].x = _contentBackground.x + _contentBackground.width / 2 - 100 * (levelData.length - 1) / 2 + i * 100;
            _animationList[i].y = _contentBackground.y + 120;

            _animationTween[i] = new Tween(_animationList[i], 0.5, Transitions.EASE_OUT);
            _animationTween[i].animate("rotationSpeed", Math.PI / 720);
            _animationTween[i].scaleTo(0.5 * ButtonFactory.assetManager.scaleFactor / 2);
            _animationTween[i].fadeTo(1);
            if(i == 0){
                Starling.juggler.add(_animationTween[i]);
            }else{
                _animationTween[i - 1].nextTween = _animationTween[i];
            }
            //
            if(levelData[i].name == "material"){
                _animationIcons[i] = new Image(getIconTexture(levelData[i].value));
            }else if(levelData[i].name == "limit"){
                _animationIcons[i] = new Image(getIconTexture("level_key_limit"));
            }else if(levelData[i].name == "aerography_packs"){
                _animationIcons[i] = new Image(getIconTexture("racing_stripe"));
            }else if(levelData[i].name == "vinyl_decals"){
                _animationIcons[i] = new Image(getIconTexture("vinyl_big"));
            }

            _animationBorder[i] = new Image(ButtonFactory.assetManager.getTexture("reward_list_item_border"));
            _animationBorder[i].texture = TextureUtil.scaleTexture(_animationBorder[i].texture, 0.5);
            _animationBorder[i].scale = ButtonFactory.assetManager.scaleFactor / 2;
            _animationBorder[i].scale9Grid = new Rectangle(_animationBorder[i].texture.frameWidth / 2 - 0.5,_animationBorder[i].texture.frameHeight / 2 - 0.5, 1, 1);
            _animationBorder[i].width = 50;
            _animationBorder[i].height = 60;
            _animationBorder[i].alpha = 0;
            _animationBorder[i].color = 0xFEFFFF;
            _animationBorder[i].x = _animationList[i].x - _animationBorder[i].width / 2;
            _animationBorder[i].y = _animationList[i].y - _animationBorder[i].height / 2;
            addChild(_animationBorder[i]);

            _animationCheck[i] = new Image(ButtonFactory.assetManager.getTexture("car_unlock_big_icon"));
            _animationCheck[i].width = 10;
            _animationCheck[i].scale = _animationCheck[i].scaleX;
            _animationCheck[i].alpha = 0;
            _animationCheck[i].color = 0xFEFFFF;
            _animationCheck[i].x = _animationBorder[i].x + _animationBorder[i].width - _animationCheck[i].width;
            _animationCheck[i].y = _animationBorder[i].y;
            addChild(_animationCheck[i]);

            _animationLabels[i] = LabelFactory.createSimpleLabel(FontSelector.getAlumniSansMedium(), 14, 0xFFFFFF, TextFormatAlign.CENTER, false, false);
            var iconSize:Number;
            if(levelData[i].name == "material"){
                _animationLabels[i].text = PartMaterial.getLabel(levelData[i].value) + " Finish";
                iconSize = 60;
            }else if(levelData[i].name == "limit"){
                _animationLabels[i].text = "Key Limit " + _user.levelData.maxKeys.toString();
                iconSize = 50;
            }else if(levelData[i].name == "aerography_packs"){
                _animationLabels[i].text = "Racing Stripe #" + _user.levelData.components["aerography_packs"].toString();
                iconSize = 70;
            }else if(levelData[i].name == "vinyl_decals"){
                _animationLabels[i].text = "Vinyl #" + _user.levelData.components["vinyl_decals"].toString();
                iconSize = 70;
            }
            addChild(_animationLabels[i]);
            _animationLabels[i].validate();
            _animationLabels[i].visible = false;
            _animationLabels[i].x = _animationBorder[i].x + (_animationBorder[i].width - _animationLabels[i].width) / 2;
            _animationLabels[i].y = _animationBorder[i].y + _animationBorder[i].height + 2;

            _animationIcons[i].pivotX = _animationIcons[i].width / 2;
            _animationIcons[i].pivotY = _animationIcons[i].height / 2;
            _animationIcons[i].width = 1;
            _animationIcons[i].scale = _animationIcons[i].scaleX;
            _animationIcons[i].x = _animationList[i].x;
            _animationIcons[i].y = _animationList[i].y;
            _animationIcons[i].color = 0xFF0000;
            _animationIcons[i].alpha = 0;
            addChild(_animationIcons[i]);

            if(i < levelData.length - 1){
                _animationPlus[i] = new Image(getIconTexture("level_plus"));
                _animationPlus[i].pivotX = _animationPlus[i].width / 2;
                _animationPlus[i].pivotY = _animationPlus[i].height / 2;
                _animationPlus[i].width = 12;
                _animationPlus[i].scale = _animationPlus[i].scaleX;
                _animationPlus[i].x = _animationList[i].x + 50;
                _animationPlus[i].y = _animationList[i].y;
                _animationPlus[i].color = 0x19d300;
                _animationPlus[i].visible = false;
                addChild(_animationPlus[i]);
            }

            _animationTween[i].onStart = onStartHandler(_animationIcons[i]);
            _animationTween[i].onUpdate = onUpdateHandler(_animationIcons[i], _animationBorder[i], _animationTween[i], _animationPlus[i], iconSize);
            _animationTween[i].onComplete = onCompleteHandler(_animationIcons[i], _animationBorder[i], iconSize);
        }
    }

    private static function onStartHandler(image:Image):Function{
        return function():void{
            image.visible = true;
        };
    }

    private function onUpdateHandler(image:Image, border:Image, tween:Tween, plus:Image, iconSize:Number):Function{
        return function():void{
            image.width = iconSize * tween.progress;
            image.scale = image.scaleX;
            image.alpha = border.alpha = tween.progress;
            var index:int = _animationBorder.indexOf(border);
            if(index != -1){
                _animationCheck[index].alpha = tween.progress;
            }
            if(plus && !plus.visible && tween.progress > 0.95){
                plus.visible = true;
            }
        };
    }

    private function onCompleteHandler(image:Image, border:Image, iconSize:Number):Function{
        return function():void{
            image.width = iconSize;
            image.scale = image.scaleX;
            image.alpha = 1;
            border.alpha = 1;
            var index:int = _animationBorder.indexOf(border);
            if(index != -1){
                _animationCheck[index].alpha = 1;
                _animationLabels[index].visible = true;
            }
        };
    }

    override public function dispose():void{
        super .dispose();
        if(_animationList){
            while(_animationList.length){
                var anim:ShineImage = _animationList.pop() as ShineImage;
                if(anim){
                    anim.removeFromParent(true);
                    anim = null;
                }
            }
            _animationList = null;
        }


        var img:Image
        if(_animationBorder){
            while(_animationBorder.length){
                img = _animationBorder.pop() as Image;
                if(img){
                    img.removeFromParent(true);
                    img = null;
                }
            }
            _animationBorder = null;
        }


        if(_animationCheck){
            while(_animationCheck.length){
                img = _animationCheck.pop() as Image;
                if(img){
                    img.removeFromParent(true);
                    img = null;
                }
            }
            _animationCheck = null;
        }


        if(_animationIcons){
            while(_animationIcons.length){
                img = _animationIcons.pop() as Image;
                if(img){
                    img.removeFromParent(true);
                    img = null;
                }
            }
            _animationIcons = null;
        }


        if(_animationPlus){
            while(_animationPlus.length){
                img = _animationPlus.pop() as Image;
                if(img){
                    img.removeFromParent(true);
                    img = null;
                }
            }
            _animationPlus = null;
        }


        if(_animationTween){
            while(_animationTween.length){
                var tween:Tween = _animationTween.pop() as Tween;
                if(tween){
                    Starling.juggler.remove(tween);
                }
            }
            _animationTween = null;
        }
    }

    private static function getIconTexture(name:String):Texture{
        return ButtonFactory.assetManager.getTextureAtlas("level_icons").getTexture(name + ".png");
    }
}

class RewardedAdsPopup extends InfoDialog{
    private var iconImage:Image;

    private var _closeBtn:Button;
    private var _watchBtn:Button;
    public function RewardedAdsPopup(){
        super (380, 215);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "REWARDED ADS IN 3DTUNING";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_popup_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _messageLabel.text = "<p align='left'>By watching Rewarded Ads you collect "+UIStrings.getDiamondChar()+" <b>Diamonds,</b> that\n" +
                "can be used to open <b>“FEATURED”</b> packages.\n<font size='6'><br></font>"+
        "Every watched Rewarded Ad earns you <b>2 (two) "+UIStrings.getDiamondChar()+" Diamond.</b>\n<font size='6'><br></font>"+
        "Subject to availability of Rewarded Ads, there is a limit of 6 Ads available for each user per day.</p>";
        addChild(_messageLabel);
        _messageLabel.validate();

        _watchBtn = ButtonFactory.defaultButton("WATCH NOW", 0xff0000, "button_gradient");
        _watchBtn.width = 100;
        _watchBtn.height = 23;
        _watchBtn.paddingLeft = _watchBtn.paddingRight = 5;
        _watchBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _watchBtn.addEventListener(Event.TRIGGERED, watchSelectedHandler);
        addChild(_watchBtn);
        _watchBtn.validate();

        var rewardsIcon:Image = new Image(ButtonFactory.assetManager.getTexture("rewards_watch_btn_icon"));
        rewardsIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
        rewardsIcon.color = 0xFFFFFE;

        _watchBtn.defaultIcon = rewardsIcon;
        _watchBtn.iconOffsetX = -5;
        _watchBtn.labelOffsetX = -1.5;

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "NOT NOW";
        _closeBtn.width = 96;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);

        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
    }

    private function watchSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.WATCH_TRIGGERED);
            _closeHandler = null;
        };
        closeAll();
    }

    private function closeSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            iconImage.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;
            _titleLabel.x = iconImage.x + iconImage.width + 5;

            _messageLabel.y = _headerBorder.y + 7;

            _watchBtn.x = _contentBackground.x + _contentBackground.width /2 - (_watchBtn.width + 10);
            _watchBtn.y = _contentBackground.y + _contentBackground.height - (_watchBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}


class UnlockPackagesPopup extends InfoDialog{

    private var _closeBtn:Button;
    private var _confirmBtn:Button;
    public function UnlockPackagesPopup(){
        super (321, 176);
    }

    override protected function initialize():void{
        super .initialize();

        var pack:Packet = data as Packet;
        _titleLabel.text = "UNLOCK “" + pack.title.toUpperCase() + "” PACKAGE";
        _titleLabel.validate();

        _messageLabel.text = "Using <b>" + pack.coin3dFee.toString() + "</b> " + UIStrings.getDiamondChar()+" <b>Diamonds</b> will grant you unlimited\n" +
        "access to all of the content available in\n" +
        "<b>“" + pack.title.toUpperCase() + "”</b> Package for 7 days!";
        addChild(_messageLabel);
        _messageLabel.validate();

        _confirmBtn = ButtonFactory.defaultButton("CONFIRM", 0xff0000, "button_gradient");
        _confirmBtn.width = 92;
        _confirmBtn.height = 23;
        _confirmBtn.paddingLeft = _confirmBtn.paddingRight = 5;
        _confirmBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _confirmBtn.addEventListener(Event.TRIGGERED, confirmSelectedHandler);
        addChild(_confirmBtn);
        _confirmBtn.validate();

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 91;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);

        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
    }

    private function confirmSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CONFIRM_TRIGGERED);
            _closeHandler = null;
        };
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _messageLabel.y = _headerBorder.y + 25;

            _confirmBtn.x = _contentBackground.x + _contentBackground.width /2 - (_confirmBtn.width + 10);
            _confirmBtn.y = _contentBackground.y + _contentBackground.height - (_confirmBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class UnlockOneTimePackagesPopup extends InfoDialog{

    private var _closeBtn:Button;
    private var _confirmBtn:Button;
    public function UnlockOneTimePackagesPopup(){
        super (321, 176);
    }

    override protected function initialize():void{
        super .initialize();

        var pack:Packet = data as Packet;
        _titleLabel.text = "UNLOCK ONE “" + pack.title.toUpperCase() + "” MODEL";
        _titleLabel.validate();

        _messageLabel.text = "Using <b>" + Packet.ONE_TIME_PACKET_FEE.toString() + "</b> " + UIStrings.getDiamondChar()+" <b>Diamonds</b> will grant you ONE-TIME\n" +
        "access to any one of the models available in\n" +
        "<b>“" + pack.title.toUpperCase() + "”</b> package.";
        addChild(_messageLabel);
        _messageLabel.validate();

        _confirmBtn = ButtonFactory.defaultButton("CONFIRM", 0xff0000, "button_gradient");
        _confirmBtn.width = 92;
        _confirmBtn.height = 23;
        _confirmBtn.paddingLeft = _confirmBtn.paddingRight = 5;
        _confirmBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _confirmBtn.addEventListener(Event.TRIGGERED, confirmSelectedHandler);
        addChild(_confirmBtn);
        _confirmBtn.validate();

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 91;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);

        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
    }

    private function confirmSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CONFIRM_TRIGGERED);
            _closeHandler = null;
        };
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _messageLabel.y = _headerBorder.y + 25;

            _confirmBtn.x = _contentBackground.x + _contentBackground.width /2 - (_confirmBtn.width + 10);
            _confirmBtn.y = _contentBackground.y + _contentBackground.height - (_confirmBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class UnlockOneTimeModelPopup extends InfoDialog{

    private var _optionsBtn:Button;
    private var _confirmBtn:Button;
    public function UnlockOneTimeModelPopup(){
        super (321, 160);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "UNLOCK THIS MODEL";
        _titleLabel.validate();

        _messageLabel.text = "Using <b>" + Packet.ONE_TIME_PACKET_FEE.toString() + "</b> " + UIStrings.getDiamondChar()+" <b>Diamonds</b> will grant you ONE-TIME\n" +
        "access to this model.";
        addChild(_messageLabel);
        _messageLabel.validate();

        _confirmBtn = ButtonFactory.defaultButton("CONFIRM", 0xff0000, "button_gradient");
        _confirmBtn.width = 112;
        _confirmBtn.height = 23;
        _confirmBtn.paddingLeft = _confirmBtn.paddingRight = 5;
        _confirmBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _confirmBtn.addEventListener(Event.TRIGGERED, confirmSelectedHandler);
        addChild(_confirmBtn);
        _confirmBtn.validate();

        _optionsBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _optionsBtn.defaultSkin = closeImg;
        _optionsBtn.label = "MORE OPTIONS";
        _optionsBtn.width = 112;
        _optionsBtn.height = 23;
        _optionsBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_optionsBtn);
        _optionsBtn.validate();
        _optionsBtn.addEventListener(Event.TRIGGERED, moreOptionsSelectedHandler);

        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
            _closeHandler = null;
        };
    }

    private function confirmSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CONFIRM_TRIGGERED);
            _closeHandler = null;
        };
        close();
    }

    private function moreOptionsSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.OPTIONS_TRIGGERED);
            _closeHandler = null;
        };
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;
            _messageLabel.y = _headerBorder.y + 15;

            _confirmBtn.x = _contentBackground.x + _contentBackground.width /2 - (_confirmBtn.width + 10);
            _confirmBtn.y = _contentBackground.y + _contentBackground.height - (_confirmBtn.height / 2 + 30);

            _optionsBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _optionsBtn.y = _contentBackground.y + _contentBackground.height - (_optionsBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class RewardedAdsNotAvailablePopup extends InfoDialog{
    private var iconImage:Image;

    private var _closeBtn:Button;
    private var _challengesBtn:Button;
    public function RewardedAdsNotAvailablePopup(){
        super (380, 215);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "REWARDED ADS IN 3DTUNING";
        _titleLabel.validate();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_popup_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        var textFormat:TextFormat = new TextFormat();
        textFormat.letterSpacing = -0.58;
        textFormat.leading = -1.5;
        _messageLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.MontserratHtml, 11, 0x535353, TextFormatAlign.CENTER, true, true, textFormat);
        _messageLabel.text = "Unfortunately, there are no Reward Ads available at this moment.\n" +
                "Please come back a little bit later for more Reward Ads.\n\n"+
        "Please note that you can also earn "+UIStrings.getDiamondChar()+" <b>Diamonds</b> by\n"+
        "participating in <b>Tuning Challenges</b>\n<font size='8'><br></font>"+
        "<font size='9'>We will also notify you once there are available Reward Ads with a\nnotification sign on the Diamonds icon on the home screen</font>";
        addChild(_messageLabel);
        _messageLabel.validate();

        _challengesBtn = ButtonFactory.defaultButton("CHALLENGES", 0x187499);
        _challengesBtn.width = 96;
        _challengesBtn.height = 23;
        _challengesBtn.paddingLeft = _challengesBtn.paddingRight = 5;
        _challengesBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _challengesBtn.addEventListener(Event.TRIGGERED, challengesSelectedHandler);
        addChild(_challengesBtn);
        _challengesBtn.validate();


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CLOSE";
        _closeBtn.width = 90;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function challengesSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CHALLENGES_TRIGGERED);
        };
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.CLOSE_TRIGGERED);
        };
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            iconImage.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;
            _titleLabel.x = iconImage.x + iconImage.width + 5;

            _messageLabel.y = _headerBorder.y + 18;

            _closeBtn.x = _contentBackground.x + (_contentBackground.width - _closeBtn.width) / 2;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);

            _challengesBtn.x = _contentBackground.x + _contentBackground.width /2 - (_challengesBtn.width + 10);
            _challengesBtn.y = _contentBackground.y + _contentBackground.height - (_challengesBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class WelcomeGuestPopup extends InfoDialog{
    private var _closeBtn:Button;
    private var _loginBtn:Button;
    public function WelcomeGuestPopup(){
        super (380, 215);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "WELCOME TO THE UPDATED 3DTUNING!";
        _titleLabel.validate();

        var textFormat:TextFormat = new TextFormat();
        textFormat.letterSpacing = -0.2;
        textFormat.leading = -1.5;
        _messageLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.MontserratHtml, 11, 0x535353, TextFormatAlign.CENTER, true, true, textFormat);
        _messageLabel.text = "Brand new \"Tuning Challenges\" and major updates to the\n"+
                "\"Tuning Configurator\" are available in this update!\n\n" +
                "Please log in to your account to claim "+UIStrings.getKeyChar()+" <b>Keys</b> & "+UIStrings.getDiamondChar()+" <b>Diamonds</b>\n"+
        "so you can start your  tuning journey straight away!\n\n"+
        "Hope you will enjoy this update!";
        addChild(_messageLabel);
        _messageLabel.validate();

        _loginBtn = ButtonFactory.defaultButton("LOG IN", 0x187499);
        _loginBtn.width = 96;
        _loginBtn.height = 23;
        _loginBtn.paddingLeft = _loginBtn.paddingRight = 5;
        _loginBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _loginBtn.addEventListener(Event.TRIGGERED, loginSelectedHandler);
        addChild(_loginBtn);
        _loginBtn.validate();


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "NOT NOW";
        _closeBtn.width = 90;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function loginSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.LOGIN_TRIGGERED);
        };
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;

            _messageLabel.y = _headerBorder.y + 15;

            _loginBtn.x = _contentBackground.x + _contentBackground.width /2 - (_loginBtn.width + 10);
            _loginBtn.y = _contentBackground.y + _contentBackground.height - (_loginBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class RateBoxPopup extends InfoDialog{
    private var _closeBtn:Button;
    private var _commentBtn:Button;
    public function RateBoxPopup(){
        super (321, 176);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "WELCOME TO 3DTUNING!";
        _titleLabel.validate();

        var textFormat:TextFormat = new TextFormat();
        textFormat.letterSpacing = 0;
        textFormat.leading = -1.5;
        _messageLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.MontserratHtml, 11, 0x535353, TextFormatAlign.CENTER, true, true, textFormat);
        _messageLabel.text = "We are constantly adding new cars, parts and\n" +
                "tuning option. Your feedback is very important\n" +
                "for us to stay on the right track!\n<font size='9'><br></font>" +
                "Please give us your feedback!";
        addChild(_messageLabel);
        _messageLabel.validate();

        _commentBtn = ButtonFactory.defaultButton("LEAVE A COMMENT", 0x187499);
        _commentBtn.width = 121;
        _commentBtn.height = 23;
        _commentBtn.paddingLeft = _commentBtn.paddingRight = 5;
        _commentBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _commentBtn.addEventListener(Event.TRIGGERED, loginSelectedHandler);
        addChild(_commentBtn);
        _commentBtn.validate();

        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "REMIND ME LATER";
        _closeBtn.width = 121;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);

        _closeHandler = function():void{
            self.dispatchEvent(new ChallengeAlertEvent(ChallengeAlertEvent.CLOSE_TRIGGERED));
        };
    }

    private function loginSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            if(data && data.car){
                self.dispatchEvent(new ChallengeAlertEvent(ChallengeAlertEvent.COMMENT_TRIGGERED, {car: data.car}));
            }else{
                self.dispatchEvent(new ChallengeAlertEvent(ChallengeAlertEvent.COMMENT_TRIGGERED));
            }
        };
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEvent(new ChallengeAlertEvent(ChallengeAlertEvent.REMIND_TRIGGERED));
        };
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;

            _messageLabel.y = _headerBorder.y + 12;

            _commentBtn.x = _contentBackground.x + _contentBackground.width /2 - (_commentBtn.width + 10);
            _commentBtn.y = _contentBackground.y + _contentBackground.height - (_commentBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class DailyGuestPopup extends InfoDialog{
    private var _closeBtn:Button;
    private var _loginBtn:Button;
    private var iconImage:Image;
    public function DailyGuestPopup(){
        super (241, 154);
    }

    override protected function initialize():void{
        super .initialize();

        iconImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rewards_popup_icon"));
        iconImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        iconImage.color = 0xFF0000;
        addChild(iconImage);

        _titleLabel.text = "DAILY REWARD!";
        _titleLabel.validate();

        var textFormat:TextFormat = new TextFormat();
        textFormat.letterSpacing = -0.2;
        textFormat.leading = -1.5;
        _messageLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.MontserratHtml, 11, 0x535353, TextFormatAlign.CENTER, true, true, textFormat);
        _messageLabel.text = "Welcome back to <b>3DT</b>uning\nPlease log in to claim your daily\nrewards!";
        addChild(_messageLabel);
        _messageLabel.validate();

        _loginBtn = ButtonFactory.defaultButton("LOG IN", 0x187499);
        _loginBtn.width = 71;
        _loginBtn.height = 23;
        _loginBtn.paddingLeft = _loginBtn.paddingRight = 5;
        _loginBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _loginBtn.addEventListener(Event.TRIGGERED, loginSelectedHandler);
        addChild(_loginBtn);
        _loginBtn.validate();


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "LATER";
        _closeBtn.width = 71;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function loginSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEventWith(ChallengeAlertEvent.LOGIN_TRIGGERED);
        }
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            var titleWidth:Number = iconImage.width + _titleLabel.width + 5;
            iconImage.x = _contentBackground.x + (_contentBackground.width - titleWidth) / 2;
            iconImage.y = _titleLabel.y + (_titleLabel.height - iconImage.height) / 2;
            _titleLabel.x = iconImage.x + iconImage.width + 5;

            _messageLabel.y = _headerBorder.y + 15;

            _closeBtn.x = _contentBackground.x + (_contentBackground.width - _closeBtn.width) / 2;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);

            _loginBtn.x = _contentBackground.x + _contentBackground.width /2 - (_loginBtn.width + 10);
            _loginBtn.y = _contentBackground.y + _contentBackground.height - (_loginBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 10;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class SubmitChallengePopup extends InfoDialog{
    private var _closeBtn:Button;
    private var _submitBtn:Button;
    public function SubmitChallengePopup(){
        super (241, 139);
    }

    override protected function initialize():void{
        super .initialize();

        _titleLabel.text = "SUBMIT YOUR BUILD";
        _titleLabel.validate();

        var textFormat:TextFormat = new TextFormat();
        textFormat.letterSpacing = -0.2;
        textFormat.leading = -1.5;
        _messageLabel.textRendererFactory = LabelFactory.createTextRendererFactory(FontSelector.MontserratHtml, 11, 0x535353, TextFormatAlign.CENTER, true, true, textFormat);
        if(data && data.indexOf("timetrial") != -1){
            _messageLabel.text = "Do you want to submit your\nbuild for review?";
        }else{
            _messageLabel.text = "Do you want to submit your\nbuild for voting?";
        }
        addChild(_messageLabel);
        _messageLabel.validate();

        var submitLabel:String = "SUBMIT";
        var btnWidth:Number = 71;
        if(data && data.indexOf("filter") != -1){
            submitLabel = "EDIT & SUBMIT";
            btnWidth = 100;
        }

        _submitBtn = ButtonFactory.defaultButton(submitLabel, 0x187499);
        _submitBtn.width = btnWidth;
        _submitBtn.height = 23;
        _submitBtn.paddingLeft = _submitBtn.paddingRight = 5;
        _submitBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0xFFFFFF, TextFormatAlign.CENTER, false);
        _submitBtn.addEventListener(Event.TRIGGERED, submitSelectedHandler);
        addChild(_submitBtn);
        _submitBtn.validate();


        _closeBtn = new Button();
        var closeImg:Image = new Image(Texture.fromTexture(ButtonFactory.assetManager.getTexture("button_border"), null, null, false, 2.5));
        closeImg.color = 0x4a4a4a;
        closeImg.scale9Grid = new Rectangle(12.5,0,closeImg.texture.frameWidth - 25, closeImg.texture.frameHeight);
        _closeBtn.defaultSkin = closeImg;
        _closeBtn.label = "CANCEL";
        _closeBtn.width = btnWidth;
        _closeBtn.height = 23;
        _closeBtn.labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 18, 0x424242, TextFormatAlign.CENTER, false);
        addChild(_closeBtn);
        _closeBtn.validate();
        _closeBtn.addEventListener(Event.TRIGGERED, closeSelectedHandler);
    }

    private function submitSelectedHandler(event:Event):void {
        _closeHandler = function():void{
            self.dispatchEvent(new ChallengeAlertEvent(ChallengeAlertEvent.SUBMIT_TRIGGERED));
        }
        close();
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }

    override protected function draw():void{
        super .draw();
        if(stage){
            _titleLabel.x = _contentBackground.x + (_contentBackground.width - _titleLabel.width) / 2;

            _messageLabel.y = _headerBorder.y + 10;

            _submitBtn.x = _contentBackground.x + _contentBackground.width /2 - (_submitBtn.width + 6.5);
            _submitBtn.y = _contentBackground.y + _contentBackground.height - (_submitBtn.height / 2 + 30);

            _closeBtn.x = _contentBackground.x + _contentBackground.width /2 + 6.5;
            _closeBtn.y = _contentBackground.y + _contentBackground.height - (_closeBtn.height / 2 + 30);
        }
    }

    override public function dispose():void{
        super .dispose();
    }
}

class WelcomeUserPopup extends CollectRewards{
    public function WelcomeUserPopup(){

    }

    override protected function initialize():void{
        super .initialize();
        _titleLabel.text = "WELCOME TO 3DTUNING!";
        _collectBtn.label = "CLOSE";
    }

    private function closeSelectedHandler(event:Event):void {
        close();
    }
}
