package com.despark.tuning3d.view.components.challenges.controls {
import com.despark.tuning3d.view.components.core.ButtonFactory;

import feathers.core.FeathersControl;

import starling.display.Image;
import starling.display.Quad;

import starling.display.Sprite;
import starling.events.EnterFrameEvent;
import starling.events.Event;
import starling.textures.Texture;

public class ChallengesLoadBar extends FeathersControl{
    private var spinner:Sprite;
    private var _background:Quad;
    public function ChallengesLoadBar() {

    }

    protected override function initialize():void{
        super.initialize();
        spinner=new Sprite();
        var spinnerTexture:Texture=ButtonFactory.assetManager.getTexture("spinner");
        var spinnerImage:Image=new Image(spinnerTexture);
        spinnerImage.width=40;
        spinnerImage.height=40;
        spinnerImage.x=-20;
        spinnerImage.y=-20;
        spinner.addChild(spinnerImage);
        _background = new Quad(1,1,0x000000);
        _background.alpha = 0.2;
        addChild(_background);
        addChild(spinner);
    }

    override protected function draw():void {
        super.draw();
        _background.width = actualWidth;
        _background.height = actualHeight;
        spinner.x = actualWidth/2;
        spinner.y = actualHeight/2;
    }

    override protected function feathersControl_addedToStageHandler(event:Event):void {
        super.feathersControl_addedToStageHandler(event);
        addEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
    }

    override protected function feathersControl_removedFromStageHandler(event:Event):void {
        super.feathersControl_removedFromStageHandler(event);
        removeEventListener(EnterFrameEvent.ENTER_FRAME, enterFrameHandler);
    }

    private function enterFrameHandler(event : EnterFrameEvent) : void{
        if(spinner && spinner.visible){
            spinner.rotation+=Math.PI / 18;
        }
    }

    override public function dispose():void {
        super.dispose();
        if(spinner){
            spinner.removeFromParent(true);
            spinner = null;
        }
        if(_background){
            _background.removeFromParent(true);
            _background = null;
        }
    }
}
}
