package com.despark.tuning3d.view.components.challenges.controls {
    import com.despark.tuning3d.view.components.core.ButtonFactory;

    import feathers.controls.LayoutGroup;
    import feathers.layout.HorizontalLayout;
    import feathers.layout.VerticalAlign;

    import starling.display.Image;
    import starling.textures.Texture;
    import starling.textures.TextureAtlas;
    import starling.utils.AssetManager;

    public class ImageLabel extends LayoutGroup {
        private var _charList:Vector.<Image>;
        private var _color:uint;
        private var _text:String;
        public function ImageLabel() {
            super();
            layout = new HorizontalLayout();
            HorizontalLayout(layout).verticalAlign = VerticalAlign.BOTTOM;
        }

        public function set color(value:uint):void{
            _color = value;
            if(_charList){
                for each(var img:Image in _charList){
                    img.color = _color;
                }
            }
        }

        public function set text(value:String):void{
            _text = value;
            if(_charList){
                while(_charList.length){
                    var img:Image = _charList.shift() as Image;
                    img.removeFromParent(true);
                }
            }
            _charList = new Vector.<Image>(_text.length);
            var assetManager:AssetManager = ButtonFactory.assetManager;
            var atlas:TextureAtlas = assetManager.getTextureAtlas("gold_nums");
            for(var i:int = 0; i < _charList.length; i++){
                if(_text.charAt(i) == "@"){
                    _charList[i] = new Image(atlas.getTexture("time_icon.png"));
                }else if(_text.charAt(i) == " "){
                    _charList[i] = new Image(Texture.fromColor(1,1,0,0));
                    if(i > 0){
                        _charList[i].width = _charList[i - 1].height / 3;
                        _charList[i].height = _charList[i - 1].height;
                    }
                }else{
                    _charList[i] = new Image(atlas.getTexture(_text.charAt(i) + ".png"));
                }
                addChild(_charList[i]);
            }
            color = _color;
            validate();
        }

        public function get text():String {
            return _text;
        }
    }
}
