package com.despark.tuning3d.view.components.core
{
	import com.despark.tuning3d.model.core.Constants;
	
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.globalization.DateTimeFormatter;
	import flash.globalization.LocaleID;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;

	public class DASLog
	{
		
		public static var df:DateTimeFormatter = new DateTimeFormatter(LocaleID.DEFAULT);
		df.setDateTimePattern("yyyyMMdd");//format for filename
		public static var fileStream:FileStream = null;
		
		public static var bodyOfMail:String = "";
		
		public static var sending:Boolean = false;
		
		public static const saveToFile:Boolean = false;
		public static const saveToVar:Boolean = true;
		
		public function DASLog()
		{
		}
		
		
		public static function cancelLog() : void
		{
			if(!Constants.LogToFile)return;
			stopLog();
			
			if(saveToFile){
				var file: File = fileOfLog();
				if(file.exists)
					file.deleteFile();
			}
			
			if(saveToVar){
				bodyOfMail = "";
			}
			
		}
		
		
		public static function fileOfLog() : File
		{
			var file: File = File.cacheDirectory.resolvePath("log.txt");
			return file;
		}
		
		public static function startNewLog() : void
		{
			if(!Constants.LogToFile)return;
			cancelLog();
			
			if(saveToFile){
				var file: File = fileOfLog();
				file.preventBackup = true;
				
				fileStream  = new FileStream();
				
				fileStream.open(file, FileMode.WRITE);
			}
			sending = true;
			
			
			
			
		}
		
		public static function log(__message : String) : void
		{
			if(!Constants.LogToFile)return;
			if(!__message)return;
			if(!(__message is String))return;
			if(!sending)return;
			if(saveToFile){
				fileStream.writeUTF(__message);
			}
			
			if(saveToVar){
				bodyOfMail += __message;
			}
			
		}
		
		public static function stopLog() : void
		{
			if(!Constants.LogToFile)return;
			if(!sending)return;
			
			if(saveToFile){
				fileStream.close();
				fileStream = null;
				sending = false;
			}
			
			
			
		}
		
		public static function stopAndSendLog() : void
		{
			if(!Constants.LogToFile)return;
			stopLog();
			
			navigateToURL(new URLRequest("mailto:ashenemy@gmail.com"+"?subject=LogOfTuning3d"+"&body="+ bodyOfMail));
			
			
		}
		
		
			
	}
}