package com.despark.tuning3d.view.components.core {
import feathers.controls.ToggleButton;

import flash.geom.Point;
import flash.geom.Rectangle;

import starling.display.DisplayObject;

public class ExtendedToggleButton extends ToggleButton{

    private var _hitAreaPadding:Number = 0;

    private var _hitAreaPaddingTop:Number = 0;
    private var _hitAreaPaddingBottom:Number = 0;
    private var _hitAreaPaddingLeft:Number = 0;
    private var _hitAreaPaddingRight:Number = 0;

    private var _customHitArea:Point;

    public function ExtendedToggleButton(hitAreaPadding : int = 0) {
        this.hitAreaPadding = hitAreaPadding
    }

    public override function hitTest(localPoint : Point) : DisplayObject {
        if (!visible || !touchable) {
            return null;
        }

        var theBounds : Rectangle = getBounds(this);
        if(_hitAreaPaddingTop || _hitAreaPaddingBottom || _hitAreaPaddingLeft || _hitAreaPaddingRight){
            theBounds.width += _hitAreaPaddingLeft + _hitAreaPaddingRight;
            theBounds.height += _hitAreaPaddingTop + _hitAreaPaddingBottom;
            theBounds.offset(-_hitAreaPaddingLeft, -_hitAreaPaddingTop);
            if (theBounds.containsPoint(localPoint)) {
                return this;
            }
        }


        if(_customHitArea){
            theBounds.inflate(_customHitArea.x, _customHitArea.y);
            if (theBounds.containsPoint(localPoint)) {
                return this;
            }
        }

        theBounds.inflate(_hitAreaPadding, _hitAreaPadding);
        if (theBounds.containsPoint(localPoint)) {
            return this;
        }

        return null;
    }

    public function get hitAreaPadding():int {
        return _hitAreaPadding;
    }

    public function set hitAreaPadding(value : int):void {
        if(value > 0) {
            _hitAreaPadding = value;
            _hitAreaPaddingTop = value;
            _hitAreaPaddingBottom = value;
            _hitAreaPaddingLeft = value;
            _hitAreaPaddingRight = value;
        }
    }

    public function set customHitArea(value:Point):void {
        _customHitArea = value;
    }

    public function get hitAreaPaddingTop():Number {
        return _hitAreaPaddingTop;
    }

    public function set hitAreaPaddingTop(value:Number):void {
        _hitAreaPaddingTop = value;
    }

    public function get hitAreaPaddingBottom():Number {
        return _hitAreaPaddingBottom;
    }

    public function set hitAreaPaddingBottom(value:Number):void {
        _hitAreaPaddingBottom = value;
    }

    public function get hitAreaPaddingLeft():Number {
        return _hitAreaPaddingLeft;
    }

    public function set hitAreaPaddingLeft(value:Number):void {
        _hitAreaPaddingLeft = value;
    }

    public function get hitAreaPaddingRight():Number {
        return _hitAreaPaddingRight;
    }

    public function set hitAreaPaddingRight(value:Number):void {
        _hitAreaPaddingRight = value;
    }
}
}
