package com.despark.tuning3d.view.components.core
{
	
	import com.utils.FontSelector;
	
	import flash.text.TextFormat;
	
	import feathers.controls.Label;
	import feathers.controls.ScrollContainer;
	import feathers.controls.text.TextFieldTextRenderer;
	
	import starling.display.Quad;
	
	public class FormScreen extends StackedScreen
	{
		public var title : String;
		
		protected var backgroundQuad : Quad;
		protected var titleLabel : MultilingualLabel;
		protected var underlineQuad : Quad;
		protected var scrollContainer : ScrollContainer;
		
		public function FormScreen()
		{
			super("FormScreen");
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			backgroundQuad = new Quad(1, 1, 0x262D2F);
			addChild(backgroundQuad);
			
			scrollContainer = new ScrollContainer();
			addChild(scrollContainer);
			
			if(title)
			{
				titleLabel = new MultilingualLabel();
				titleLabel.height = 15;
				titleLabel.text = title;
				titleLabel.textFormat = new TextFormat(FontSelector.getFont(), 10, 0x6C7578);
				scrollContainer.addChild(titleLabel);
				
				underlineQuad = new Quad(1, 1, 0x6C7578);
				scrollContainer.addChild(underlineQuad);
			}
			
			super.initializeBackButton();
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				backgroundQuad.width = actualWidth;
				backgroundQuad.height = actualHeight;
			}
			
			if(title)
			{
				titleLabel.y = 10;
				titleLabel.width = 200;
				titleLabel.x = -3 + int((actualWidth - titleLabel.width) / 2);
			
				underlineQuad.x = int((actualWidth - titleLabel.width) / 2);
				underlineQuad.width = titleLabel.width;
				underlineQuad.y = titleLabel.y + titleLabel.height + 10;
			}
		}
	}
}

