package com.despark.tuning3d.view.components.core {
import feathers.controls.PageIndicator;
import feathers.layout.IVirtualLayout;
import feathers.layout.LayoutBoundsResult;
import feathers.layout.TiledRowsLayout;
import feathers.layout.ViewPortBounds;

public class GridPageIndicator extends PageIndicator {
    private static const SUGGESTED_BOUNDS:ViewPortBounds = new ViewPortBounds();
    private static const LAYOUT_RESULT:LayoutBoundsResult = new LayoutBoundsResult();
    public function GridPageIndicator() {
        super();
    }


    override protected function layoutSymbols(layoutInvalid:Boolean):void
    {
        if(layoutInvalid) {
            var tiledLayout:TiledRowsLayout = new TiledRowsLayout();
            tiledLayout.typicalItemWidth = tiledLayout.typicalItemHeight = 20;

            tiledLayout.paddingTop = this._paddingTop;
            tiledLayout.paddingRight = this._paddingRight;
            tiledLayout.paddingBottom = this._paddingBottom;
            tiledLayout.paddingLeft = this._paddingLeft;
            tiledLayout.gap = this._gap;
            tiledLayout.horizontalAlign = this._horizontalAlign;
            tiledLayout.verticalAlign = this._verticalAlign;
            _layout = tiledLayout;
            IVirtualLayout(_layout).useVirtualLayout = false;
        }
        SUGGESTED_BOUNDS.x = SUGGESTED_BOUNDS.y = 0;
        SUGGESTED_BOUNDS.scrollX = SUGGESTED_BOUNDS.scrollY = 0;
        SUGGESTED_BOUNDS.explicitWidth = this._explicitWidth;
        SUGGESTED_BOUNDS.explicitHeight = this._explicitHeight;
        SUGGESTED_BOUNDS.maxWidth = this._explicitMaxWidth;
        SUGGESTED_BOUNDS.maxHeight = this._explicitMaxHeight;
        SUGGESTED_BOUNDS.minWidth = this._explicitMinWidth;
        SUGGESTED_BOUNDS.minHeight = this._explicitMinHeight;
        this._layout.layout(this.symbols, SUGGESTED_BOUNDS, LAYOUT_RESULT);
        this.saveMeasurements(LAYOUT_RESULT.contentWidth, LAYOUT_RESULT.contentHeight,
                LAYOUT_RESULT.contentWidth, LAYOUT_RESULT.contentHeight);
    }
}
}
