package com.despark.tuning3d.view.components.core {
    import com.utils.FontSelector;

    import feathers.controls.Button;
    import feathers.controls.ButtonState;
    import feathers.layout.HorizontalAlign;
    import feathers.layout.RelativePosition;

    import flash.geom.Rectangle;
    import flash.text.TextFormatAlign;

    import starling.display.Image;
    import starling.display.Quad;
    import starling.text.TextFormat;
    import starling.textures.Texture;

    public class HomeSubMenuItem extends Button {
    public function HomeSubMenuItem(textureName:String, iconColor:int = -1, iconScale:Number = 1, userScaleFactor:Boolean = false, itemWidth:Number = 77) {
        super();
        width = itemWidth;
        height = 53.5;
        labelFactory = LabelFactory.createTextRendererFactory(FontSelector.getAlumniSansMedium(), 14, 0xFFFFFF, TextFormatAlign.CENTER, false);
        var selectedTextFormat:TextFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 14, 0x707070);
        setFontStylesForState( ButtonState.DOWN, selectedTextFormat);

        var buttonTexture:Texture = ButtonFactory.assetManager.getTexture(textureName);
        var btnDefaultImg:Image = new Image(buttonTexture);
        var btnDownImg:Image = new Image(buttonTexture);
        btnDownImg.alpha = 0.6;

        btnDefaultImg.scale = btnDownImg.scale = iconScale * (userScaleFactor?ButtonFactory.assetManager.scaleFactor / 2: 0.75);
        if(iconColor != -1){
            btnDefaultImg.color = iconColor;
        }
        defaultIcon = btnDefaultImg;
        downIcon = btnDownImg;
        horizontalAlign = HorizontalAlign.CENTER;
        iconPosition = RelativePosition.TOP;
        //
        var background:Quad = new Quad(1,1, 0x000000);
        background.alpha = 0;
        defaultSkin = background;

        /*var borderTexture:Texture = Texture.fromTexture(ButtonFactory.assetManager.getTexture("timeline_feed_border"), null, null, null, 2 / ButtonFactory.assetManager.scaleFactor);
        var border:Image = new LayoutImage(borderTexture);
        border.scale9Grid = new Rectangle(border.texture.frameWidth / 3,border.texture.frameHeight / 3,border.texture.frameWidth / 3,border.texture.frameHeight / 3);
        border.width = width;
        border.height = height;
        border.touchable = false;
        addChild(border);*/
    }

    override protected function initialize():void{
        super .initialize();

    }
}
}
