package com.despark.tuning3d.view.components.core {
import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.UIColors;
    import com.despark.tuning3d.view.components.timeline.components.TimelineLabelFactory;
import com.utils.FontSelector;

import feathers.controls.Label;

import feathers.controls.text.StageTextTextEditor;
    import feathers.controls.text.TextBlockTextRenderer;
    import feathers.controls.text.TextFieldTextEditor;
    import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.FeathersControl;
    import feathers.core.IMultilineTextEditor;
    import feathers.core.IMultilineTextEditor;
    import feathers.core.ITextEditor;
    import feathers.core.ITextRenderer;

import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.text.engine.FontPosture;
import flash.text.engine.FontWeight;

// ITextBaselineControl, IFeathersControl
public class LabelFactory {
    private static const TEXT_COLOR_BLACK:uint = 0x242424;
    private static const TEXT_COLOR_GRAY:uint = 0x646464;
    private static const TEXT_COLOR_FRIEND_LIST:uint = 0x58595b;
    private static const MAIL_LABEL_DATE_COLOR:uint = 0x999999;
    private static const TEXT_COLOR_WHITE:uint = 0xFFFFFF;
    //
    private static const FONT_SIZE_FRIEND_LIST:uint = 10;
    private static const FONT_SIZE_MAIL_BODY:uint = 12;
    //
    private static const MAIL_LABEL_NAME_SIZE:uint = 12;
    private static const MAIL_LABEL_MESSAGE_SIZE:uint = 11;
    private static const MAIL_LABEL_DATE_SIZE:uint = 10;
    private static const MAIL_BODY_LINK_TITLE_SIZE:uint = 14;
    private static const MAIL_BODY_LINK_DESC_SIZE:uint = 12;
    private static const MAIL_BODY_LINK_URL_SIZE:uint = 12;
    //
    public static const TURN5_PRICE_SIZE:uint = 9;

    public static const HOME_NEWS_SMALL:uint = 7;
    public static const NEWS_SIZE:uint = 12;
    public function LabelFactory() {
    }

    public static function  garageSettingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 14, UIColors.WHITE);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function profileButtonLabel():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 14, UIColors.WHITE);
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        return textRenderer;
    }

    public static function profileButtonLabel2():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 11, UIColors.WHITE);
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        return textRenderer;
    }

    public static function profileButtonLabelBlack():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 11, UIColors.BLACK);
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        return textRenderer;
    }

    public static function profileSoundLabel():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 10, UIColors.WHITE);
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        return textRenderer;
    }

    public static function createTextRenderer(textFormat:TextFormat):Function {
        return function ():ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = textFormat;
            textRenderer.textFormat.align = TextFormatAlign.CENTER;
            textRenderer.textFormat.bold = true;
            textRenderer.embedFonts = true;
            textRenderer.isHTML = true;
            return textRenderer;
        }
    }

    public static function profileRestoreLabel():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 10, UIColors.WHITE);
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;

        textRenderer.selectedTextFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 10, UIColors.UI_COMPONENT_GRAY);
        return textRenderer;
    }

    public static function saveVideoMessageLabel(): ITextRenderer {
        var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();
        var bold:Boolean = false;
        var italic:Boolean = false;
        var color:uint = 0xFFFFFF;
        var size:int = 12;
        var align:String = TextFormatAlign.CENTER;
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratLight(), size, color);
        textRenderer.textFormat.align = align;
        textRenderer.textFormat.bold = bold;
        textRenderer.textFormat.italic = italic;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.isHTML = true;
        return textRenderer;
    }

    public static function saveVideoHeaderLabel(): ITextRenderer {
        var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 12, 0xFFFFFF);
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        textRenderer.textFormat.bold = true;
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.isHTML = false;
        return textRenderer;
    }

    public static function  mailDateLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), MAIL_LABEL_DATE_SIZE, MAIL_LABEL_DATE_COLOR);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function turn5PriceLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratBold(), TURN5_PRICE_SIZE, TEXT_COLOR_WHITE);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function turn5Label ():ITextRenderer {
        var textRenderer:TextBlockTextRenderer = new TextBlockTextRenderer();
        /*textRenderer.textFormat = new TextFormat(FontSelector.getMonserratBold(), TURN5_PRICE_SIZE, TEXT_COLOR_WHITE);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;*/
        textRenderer.truncationText = "...";
        textRenderer.truncateToFit = true;
       // textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  mailBodyLinkTitleLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), MAIL_BODY_LINK_TITLE_SIZE, TEXT_COLOR_BLACK);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  friendSocialLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), MAIL_LABEL_NAME_SIZE, TEXT_COLOR_BLACK);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  mailBodyLinkDescLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), MAIL_BODY_LINK_DESC_SIZE, TEXT_COLOR_GRAY);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  mailBodyLinkURLLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), MAIL_BODY_LINK_URL_SIZE, TEXT_COLOR_GRAY);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.underline = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  tuningSettingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 8, UIColors.WHITE);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  searchBoxTypeLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 11, 0x7e7e7e);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  challengeListTitleLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 21, 0x424242);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeHelpButton ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 14, 0x707070);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeLeaderboardTitleLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 14, 0xFFFFFF);
        textRenderer.textFormat.leading = 0;
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeLeaderboardTitleRightLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 13, 0xFFFFFF);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function  challengeLeaderboardTitle2Label ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 9, 0x535353);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeRatingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getGoldBold(), 14, 0xFFFFFF);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeListDescLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratRegular(), 9, 0x535353);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeGarageUserLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 8, 0xFFFFFF);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  challengeGarageUserTitleLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratBold(), 12, 0xFFFFFF);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeLeaderboardUserLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 6.5, 0x535353);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  challengeListLocLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 11, 0x242424);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeListTimeLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 11, 0xFFFFFF);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  challengeVoteBtnLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansSemiBold(), 18, 0xFFFFFF);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeNotificationsRewardsLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 12, 0x58595b);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = false;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeTuningsListRatingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansMedium(), 13, 0x494949);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function  challengeTuningPopupRatingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansSemiBold(), 18, 0x494949);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function  challengeUserRatingLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansBold(), 10, 0xFFFFFF, true);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  newsDateLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratBold(), NEWS_SIZE, 0xb00000);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  newsCarNameLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratBold(), NEWS_SIZE, 0x58595b);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  newsTextLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), NEWS_SIZE, 0x58595b);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  valueStepperLabel():ITextEditor {
        var textRenderer:TextFieldTextEditor = new TextFieldTextEditor();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 10, UIColors.WHITE);
        textRenderer.textFormat.bold = false;
        textRenderer.isEditable = false;
        textRenderer.isSelectable = false;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function  valueStepperTitle():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratLight(), 8, 0xFFFFFF);
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        textRenderer.embedFonts = true;
        return textRenderer;
    }

    public static function  leaderBoardWinLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 11, UIColors.WHITE, true);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengeTuningViewLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getAlumniSansSemiBold(), 11, 0x4a4a4a);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function  challengesAlertTitleLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), 9, 0xb81919);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  challengesAlertBodyLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 9, 0x58595b);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.isHTML = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        textRenderer.textFormat.leading = -1.5;
        return textRenderer;
    }

    public static function  startChallengeRulesLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 11, 0x313131);
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.underline = true;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.RIGHT;
        return textRenderer;
    }

    public static function  notificationsMessageField ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), 12, UIColors.UI_COMPONENT_GRAY);
        textRenderer.textFormat.italic = false;
        textRenderer.embedFonts = true;
        textRenderer.wordWrap = true;
        textRenderer.textFormat.align = TextFormatAlign.CENTER;
        return textRenderer;
    }

    public static function createLabelPopup():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.usernameLabelPopupIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelRendererPopupAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createHomeScreenUserLabel():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = getIOSRenderer(TimelineLabelFactory.SIZE_SMALL, TEXT_COLOR_WHITE, false, false, TextFormatAlign.LEFT) as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = function ():ITextRenderer {
                return getAndroidRenderer(TimelineLabelFactory.SIZE_SMALL, TEXT_COLOR_WHITE, false, false, TextFormatAlign.LEFT, false);
            }
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createSimpleLabel(font:String, size:Number, color:uint, align:String, wordWrap:Boolean, isHTML:Boolean = false, textFormat:TextFormat = null, embedFonts:Boolean = true, autoShorten:Boolean = false):Label{
        var result:Label;
        result = new Label();
        result.textRendererFactory = createTextRendererFactory(font, size, color, align, wordWrap, isHTML, textFormat, embedFonts, autoShorten);
        result.wordWrap = wordWrap;
        return result;
    }

    public static function createTextRendererFactory(font:String, size:Number, color:uint, align:String, wordWrap:Boolean, isHTML:Boolean = false, textFormat:TextFormat = null, embedFonts:Boolean = true, autoShorten:Boolean = false):Function{
        return function():ITextRenderer{
            var textRenderer:LabelTextFieldTextRenderer = new LabelTextFieldTextRenderer();
            if(textFormat){
                textFormat.font = font;
                textFormat.size = size;
                textFormat.color = color;
            }else{
                textFormat = new TextFormat(font, size, color);
            }
            textRenderer.textFormat = textFormat;
            textRenderer.embedFonts = embedFonts;
            textRenderer.wordWrap = wordWrap;
            textRenderer.textFormat.align = align;
            textRenderer.isHTML = isHTML;
            textRenderer.autoTruncate = autoShorten;
            return textRenderer;
        };
    }

    public static function createLabelLarge():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.usernameLabelLargeIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelRendererLargeAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelTimelineCarName():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.carNameTimelineLabelLargeIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.carNameLabelRendererLargeAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelComment():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.usernameLabelCommentIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelRendererCommentAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createAvatarLabel(textSize:Number):FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = getIOSRenderer(textSize, TimelineLabelFactory.COLOR_TEXT_WHITE, true, false, TextFormatAlign.LEFT, false) as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = function():ITextRenderer{
                return getAndroidRenderer(textSize, TimelineLabelFactory.COLOR_TEXT_WHITE, true, false, TextFormatAlign.LEFT, true, false);
            }
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createUserDetailsLabel():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.userDetailsLabelIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.userDetailsLabelAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelMailPopupUsername():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.createMailPopupUsernameLabelIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.createMailPopupUsernameLabelAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelMailBody():FeathersControl{
        var result:FeathersControl;
        /*if(Constants.isIOS) {
            result = labelMailBodyIos() as FeathersControl;
            StageTextTextEditor(result).multiline = true;
        }else{*/
            result = new Label();
            Label(result).textRendererFactory = labelMailBodyAndroid;
            Label(result).wordWrap = true;
        //}
        return result;
    }

    private static function  labelMailBodyIosTemp ():IMultilineTextEditor {
        var textEditor:StageTextTextEditor = new StageTextTextEditor();
        textEditor.multiline = true;
        textEditor.fontFamily = "Arial";
        textEditor.isEditable = false;
        textEditor.fontSize = TimelineLabelFactory.SIZE_BIG;
        textEditor.color = TEXT_COLOR_BLACK;
        return textEditor;
    }

    public static function createLabelMailMessage():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.labelMailMessageIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.labelMailMessageAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelFriendList():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.nameLabelFriendListIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.nameLabelFriendListAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelMailUserName():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.labelMailUserNameIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.labelMailUserNameAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function createLabelTimelineDesc():FeathersControl{
        var result:FeathersControl;
        if(Constants.isIOS) {
            result = LabelFactory.labelTimelineDescIos() as FeathersControl;
        }else{
            result = new Label();
            Label(result).textRendererFactory = LabelFactory.labelTimelineDescAndroid;
            Label(result).wordWrap = false;
        }
        return result;
    }

    public static function setLabelText(label:FeathersControl, text:String):void{
        if(label.hasOwnProperty("text")){
            label["text"] = text;
        }else if(label.hasOwnProperty("label")){
            label["label"] = text;
        }
        label.validate();
    }

    // ************** Android ******************
    public static function  nameLabelRendererCommentAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  userDetailsLabelAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  createMailPopupUsernameLabelAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_WHITE, false, false, TextFormatAlign.LEFT);
    }

    public static function  labelMailMessageAndroid ():ITextRenderer{
        return getAndroidRenderer(MAIL_LABEL_MESSAGE_SIZE, MAIL_LABEL_DATE_COLOR, false, false, TextFormatAlign.LEFT, true);
    }

    public static function  labelMailBodyAndroid ():ITextRenderer{
        return getAndroidRenderer(FONT_SIZE_MAIL_BODY, TEXT_COLOR_BLACK, false, false, TextFormatAlign.LEFT, true, true);
    }

    public static function  nameLabelRendererLargeAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  carNameLabelRendererLargeAndroid ():ITextRenderer{
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_RED, true, false, TextFormatAlign.LEFT, false);
    }

    private static function nameLabelRendererPopupAndroid() :ITextRenderer {
        return getAndroidRenderer(TimelineLabelFactory.SIZE_SMALL, TEXT_COLOR_BLACK, false, false, TextFormatAlign.LEFT);
    }

    private static function nameLabelFriendListAndroid() :ITextRenderer {
        return getAndroidRenderer(FONT_SIZE_FRIEND_LIST, TEXT_COLOR_FRIEND_LIST, true, false, TextFormatAlign.LEFT);
    }

    private static function labelMailUserNameAndroid() :ITextRenderer {
        return getAndroidRenderer(MAIL_LABEL_NAME_SIZE, TEXT_COLOR_FRIEND_LIST, false, false, TextFormatAlign.LEFT);
    }

    private static function labelTimelineDescAndroid() :ITextRenderer {
        return getAndroidRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, false, false, TextFormatAlign.LEFT);
    }

    private static function getAndroidRenderer(fontSize:int, textColor:uint, bold:Boolean = false, italic:Boolean = false, align:String = null, hasFilter:Boolean = true, multiline:Boolean = false):ITextRenderer{
        align ||= TextFormatAlign.LEFT;
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getUnicode(), fontSize, textColor);
        textRenderer.textFormat.italic = italic;
        textRenderer.textFormat.bold = bold;
        textRenderer.textFormat.align = align;
        textRenderer.wordWrap = multiline;
        textRenderer.filter = hasFilter?TimelineLabelFactory.getFilter():null;
        return textRenderer;
    }

    // ************** IOS **********************
    public static function  usernameLabelCommentIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  userDetailsLabelIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  createMailPopupUsernameLabelIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_SMALL, TimelineLabelFactory.COLOR_TEXT_WHITE, false, false, TextFormatAlign.LEFT);
    }

    public static function  labelMailBodyIos ():IMultilineTextEditor {
        return getIOSRenderer(FONT_SIZE_MAIL_BODY, TEXT_COLOR_BLACK, false, false, TextFormatAlign.LEFT, false);
    }

    public static function  labelMailMessageIos ():IMultilineTextEditor {
        return getIOSRenderer(MAIL_LABEL_MESSAGE_SIZE, MAIL_LABEL_DATE_COLOR, false, false, TextFormatAlign.LEFT);
    }

    public static function  usernameLabelLargeIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_GREY, true, false, TextFormatAlign.LEFT);
    }

    public static function  carNameTimelineLabelLargeIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG_NAME, TimelineLabelFactory.COLOR_TEXT_RED, true, false, TextFormatAlign.LEFT);
    }

    public static function  usernameLabelPopupIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_SMALL, TEXT_COLOR_BLACK, false, false, TextFormatAlign.LEFT);
    }

    public static function  nameLabelFriendListIos ():IMultilineTextEditor {
        return getIOSRenderer(FONT_SIZE_FRIEND_LIST, TEXT_COLOR_FRIEND_LIST, true, false, TextFormatAlign.LEFT);
    }

    public static function  labelMailUserNameIos ():IMultilineTextEditor {
        return getIOSRenderer(MAIL_LABEL_NAME_SIZE, TEXT_COLOR_FRIEND_LIST, false, false, TextFormatAlign.LEFT);
    }

    public static function  labelTimelineDescIos ():IMultilineTextEditor {
        return getIOSRenderer(TimelineLabelFactory.SIZE_BIG, TimelineLabelFactory.COLOR_TEXT_GREY, false, false, TextFormatAlign.LEFT);
    }

    private static function getIOSRenderer(fontSize:int, textColor:uint, bold:Boolean = false, italic:Boolean = false, align:String = null, multiline:Boolean = false):IMultilineTextEditor{
        align ||= TextFormatAlign.LEFT;
        var textEditor:StageTextTextEditor = new StageTextTextEditor();
        textEditor.fontSize = fontSize;
        textEditor.color = textColor;
        textEditor.multiline = multiline;
        textEditor.isEditable = false;
        if(bold){
            textEditor.fontWeight = FontWeight.BOLD;
        }
        if(italic){
            textEditor.fontPosture = FontPosture.ITALIC;
        }
        textEditor.textAlign = align;
        textEditor.fontFamily = "Arial";
        return textEditor;
    }
}
}
