package com.despark.tuning3d.view.components.core {
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.NotificationView.NotificationPanelLabelFactory;
    import com.despark.tuning3d.view.components.timeline.FeedData;

    import feathers.controls.Label;
    import feathers.controls.LayoutGroup;
    import feathers.layout.AnchorLayout;
    import feathers.layout.AnchorLayoutData;

    import flash.geom.Rectangle;

    import starling.display.Image;
    import starling.textures.Texture;

    public class MainMenuButton extends ExtentedButton{
    private var _texture:Texture;
    private var _notContainer:LayoutGroup;
    public function MainMenuButton(texture:Texture, scaleFactor:int, color:uint = 0x0055aa) {
        super();

        this._texture = texture;
        this.hitAreaPadding = 5;


        var defaultImage : Image = new Image(_texture);
        defaultImage.color = color;
        this.defaultSkin = defaultImage;

        var down: Image = new Image(_texture);
        defaultImage.color = color;
        this.downSkin = down;
        this.downSkin.alpha = .6;

        var w:Number = Device.isIos() || scaleFactor < 3.375 ? 34 : 32;
        var h:Number = Device.isIos() || scaleFactor < 3.375 ? 34 : 32;
        this.width = w;
        this.height = h;
    }


    override protected function draw():void {
        super.draw();
        updateNotification();
    }

    public function updateNotification() : void{
        if(UsersProxy.loggedInUser()){

        } else if(_notContainer){
            Constants.clearNotificationCount();
            _notContainer.visible = false;
        }
    }


    override protected function initialize():void {
        super.initialize();
        updateNotification();
    }

    public static function generateNotificationIcon() : LayoutGroup{
        var _notContainer : LayoutGroup = new LayoutGroup();
        var notBg:Image = new Image(ButtonFactory.assetManager.getTexture("notification"));
        notBg.scale9Grid = new Rectangle(notBg.texture.frameWidth / 2 - 0.1, 0,0.2, notBg.texture.frameHeight);
        _notContainer.backgroundSkin = notBg;
        _notContainer.layout = new AnchorLayout();
        _notContainer.width = 12;
        _notContainer.height = 12;

        var layData : AnchorLayoutData = new AnchorLayoutData();
        layData.verticalCenter = 0;
        layData.horizontalCenter = 0;

        var _notLabel : Label = new Label();
        _notLabel.textRendererFactory = NotificationPanelLabelFactory.notificationNotifierTextRenderer;
        _notLabel.layoutData = layData;
        _notContainer.addChild(_notLabel);
        return _notContainer;
    }
}
}
