
package com.despark.tuning3d.view.components.core {
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.utils.FontSelector;
	
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import feathers.controls.Label;
	import feathers.controls.text.TextFieldTextRenderer;
	import feathers.core.ITextRenderer;
	
	public class MultilingualLabel extends Label implements Multilingual {
		public var textFormat : TextFormat;
		public var isHTML : Boolean=false;
		public function updateWithLanguage(language : Language) : void {
			textRendererFactory = function() : ITextRenderer {
				var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();
				var font:String = FontSelector.getFont();
				var bold:Boolean = false;
				var italic:Boolean = false;
				var color:uint = 0x000000;
				var size:int = 12;
				var align:String = TextFormatAlign.LEFT;
				if(textFormat){
					font = textFormat.font;
					bold = textFormat.bold;
					italic = textFormat.italic;
					color = textFormat.color as uint;
					size = textFormat.size as int;
					align= textFormat.align;
				}
				textRenderer.textFormat = new TextFormat(font, size, color);
				textRenderer.textFormat.align = align;
				textRenderer.textFormat.bold = bold;
				textRenderer.textFormat.italic = italic;
				textRenderer.embedFonts = FontSelector.embedFonts();
				textRenderer.wordWrap = wordWrap;
				textRenderer.isHTML = isHTML;
				return textRenderer;
			}
		}
	}
}