package com.despark.tuning3d.view.components.core
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.packages.Packet;
	import com.despark.tuning3d.model.packages.Purchase;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.brands.BrandsScreen;
	import com.despark.tuning3d.view.components.brands.PacketItemRenderer;
	import com.distriqt.GameService;
	import com.utils.Console;
	import com.utils.FontSelector;
	import com.utils.ObjectUtils;

	import feathers.controls.Button;
	import feathers.controls.List;
	import feathers.controls.ScrollBar;
	import feathers.controls.ScrollBarDisplayMode;
	import feathers.controls.ScrollPolicy;
	import feathers.controls.renderers.IListItemRenderer;
	import feathers.core.FeathersControl;
	import feathers.data.ListCollection;
	import feathers.layout.Direction;
	import feathers.layout.VerticalAlign;
	import feathers.layout.VerticalLayout;

	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	import starling.animation.Transitions;
	import starling.animation.Tween;
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.utils.AssetManager;

	public class PackagesView extends FeathersControl implements Multilingual
	{
		
		public static const BUY_NOW_PACKET:String="BUY_NOW_PACKET";
		public static const PACKAGES_VIEW_CALC_WIDTH_END:String="PACKAGES_VIEW_CALC_WIDTH_END";
        public static const SHOW_NO_COIN_POP_UP: String = 'SHOW_NO_COIN_POP_UP';
        public static const SHOW_CONFIRM_POP_UP: String = 'SHOW_CONFIRM_POP_UP';
		public static const UPDATE_CAR_PACKAGES: String = "UPDATE_CAR_PACKAGES";
		public static const WATCH_REWARDS_ADS: String = "watchRewardsAds";
		public static const OPEN_CHALLENGES: String = "openChallenges";


		public static const VIEW_CAR_360 : String = "VIEW_CAR_360";
		
		
		public static var assetManager : AssetManager;
		public static var language : Language;
		
		private var overlay:Button;  
		private var backgroundHeadImage:Quad;
		private var backgroundImage:Quad;
		private var closeButton:Button;
		private var backButton:MultilingualButton;
		private var label : MultilingualLabel;
		private var _text : String;
		private var selectedPacketView:PacketView;
		private var packetView:PacketView;
		private var mainList : List;
		private var _dataProvider:Array;
		private var _featuredArrow:Image;
		public static var ITEM_COUNT:int=0;
		public static var calacItemCount:Boolean=true;
		private var _parentActualWith:Number;
		private var _parentActualHeight:Number;
		public static var PACKAGE_ITEM_WIDTH:Number = 263;

		public static function getPackageItemWidth():Number{
			if(Constants.isNarrowScreen){
				return 180;
			}
			return (Device.isIos() ? 262 : Constants.SCALE_FACTOR==3.375 ? 252 : 262) + (Device.isIphoneXVariant()?25:0);
		}


		public function PackagesView() {
			super();
			PACKAGE_ITEM_WIDTH = getPackageItemWidth();
			PackagesView.ITEM_COUNT = 0;
		}

		public function set parentActualWith(value:Number):void{
			_parentActualWith = value;
			var packetViewWidth:Number = parentActualWith-PACKAGE_ITEM_WIDTH + 20;
			if(selectedPacketView){
				selectedPacketView.hideX =- (packetViewWidth - (PACKAGE_ITEM_WIDTH - 20));
				selectedPacketView.showX = (PACKAGE_ITEM_WIDTH - 20);
			}
			
			if(packetView){
				packetView.hideX =- (packetViewWidth - (PACKAGE_ITEM_WIDTH - 20));
				packetView.showX = (PACKAGE_ITEM_WIDTH - 20);
			}
		}
		
		
		public function get parentActualWith():Number{
			return _parentActualWith;
		}
		
		public function set parentActualHeight(value:Number):void{
			_parentActualHeight=value;
		}
		
		public function get parentActualHeight():Number{
			return _parentActualHeight;
		}
		
		public function packetPurchaseSuccess(packet:Packet):void{
			var i:int;
			var pc:Packet;
			if(this.mainList){
				if (packet.type == Packet.TYPE_ALLPACKET) {
					for (i = 0; i < mainList.dataProvider.length; i++) {
						pc = mainList.dataProvider.getItemAt(i) as Packet;
						pc.lock = false;
					}
				} else {
					for (i = 0; i < mainList.dataProvider.length; i++) {
						pc = mainList.dataProvider.getItemAt(i) as Packet;
						if (pc.id == packet.id) {
							mainList.dataProvider.removeItemAt(i);
							mainList.dataProvider.addItemAt(packet, i);
							break;
						}
					}
				}
				this.mainList.dataProvider.updateAll();
				this.mainList.invalidate();
			}
		}

		public function packetPurchaseUpdate(purchase:Purchase):void{
			if(this.mainList && mainList.dataProvider){
				for(var i:int = 0; i < mainList.dataProvider.length; i++){
					var pc:Packet = mainList.dataProvider.getItemAt(i) as Packet;
					if(pc.id == purchase.id || pc.productId === purchase.productId){
						pc.lock = false;
						mainList.dataProvider.addItemAt(mainList.dataProvider.removeItemAt(i), i);
						break;
					}
				}
				this.mainList.dataProvider.updateAll();
				this.mainList.invalidate();
			}
		}

		public function clearPurchases():void{
			if(this.mainList && mainList.dataProvider){
				for(var i:int = 0; i < mainList.dataProvider.length; i++){
					var pc:Packet = mainList.dataProvider.getItemAt(i) as Packet;
					pc.lock = true;
				}
				this.mainList.dataProvider.updateAll();
				this.mainList.invalidate();
			}
		}
		
		public function set dataProvider(value:Array):void{
			this.subpacksMode=false;
			var sameValue:Boolean = true;
			var i:int;
			if(value && _dataProvider && value.length == _dataProvider.length){
				var idList:Object = {};
				for(i = 0; i < _dataProvider.length; i++){
					idList[_dataProvider[i].id] = _dataProvider[i];
				}
				for(i = 0; i < value.length; i++){
					var pack:Packet = value[i];
					if(!idList.hasOwnProperty(pack.id) || idList[pack.id].tempOpened != pack.tempOpened || idList[pack.id].lock != pack.lock){
						sameValue = false;
						break;
					}
				}
			}else{
				sameValue = false;
			}
			if(sameValue){
				return;
			}
			text = "FEATURED PACKAGES";
			Console.log(text);
			if(value && value.length) {
				for (i = value.length - 1; i >= 0; i--) {
					var index:int = value.indexOf(value[i]);
					if (index != i) {
						value.removeAt(i);
					}else{
						trace(value[i].id);
					}
				}
			}
			_dataProvider = value;
			Console.log("PackagesView #dataProvider end same remove");
			resetPackages();
			function resetPackages():void{
				if(mainList && _dataProvider && _dataProvider.length){
					var mainListLayout :VerticalLayout = new VerticalLayout();
					mainListLayout.paddingTop = 0;
					mainListLayout.useVirtualLayout = false;
					mainListLayout.scrollPositionVerticalAlign=VerticalAlign.TOP;
					mainList.layout = mainListLayout;
					mainList.dataProvider = new ListCollection(_dataProvider);
					_featuredArrow.visible = ((mainList.dataProvider && mainList.dataProvider.length*40) > actualHeight-85);
				}
			}

		}
		
		public function get dataProvider():Array{
			return _dataProvider;
		}
		
		private var _language:Language=null;
		
		public function updateWithLanguage(language:Language):void {
			_language=language;
			if(backButton)
				backButton.updateWithLanguage(language);

			if(label)
				label.updateWithLanguage(language);

			if(selectedPacketView)
				selectedPacketView.updateWithLanguage(language);

			if(packetView)
				packetView.updateWithLanguage(language);

			if(mainList && mainList.dataProvider){
				mainList.dataProvider.updateAll();
			}
			text=this._language.translate("mob_home", "featured");
		}
		
		protected override function initialize() : void {
			super.initialize();
			//Constants.
			//var t:Constants
			var packetViewWidth:Number;
			overlay=new Button();
			overlay.defaultSkin=new Quad((Constants.STAGE_WIDTH-PACKAGE_ITEM_WIDTH)+12, 1, 0x000000);  
			overlay.defaultSkin.alpha=0.0;   
			overlay.addEventListener(Event.TRIGGERED, onTouchOverlay);
			addChild(overlay);
			

			packetView=new PacketView(); //-actualWidth), actualWidth-20 );


			packetView.addEventListener(PacketView.BUY_NOW_PACKET, onBuyNowPacket);


			packetView.addEventListener(PacketView.VIEW_CAR_360, viewCar360);

            packetView.addEventListener(PacketView.SHOW_NO_COIN_POP_UP, showNoCoinPopUp);
            packetView.addEventListener(PacketView.SHOW_CONFIRM_POP_UP, showConfirmPopUp);
            packetView.addEventListener(PacketView.WATCH_REWARDS_ADS, watchRewardsHandler);
            packetView.addEventListener(PacketView.OPEN_CHALLENGES, openChallengesHandler);

			packetViewWidth = parentActualWith-PACKAGE_ITEM_WIDTH+20;
			packetView.setSize((packetViewWidth), actualHeight);

			packetView.hideX=-(packetViewWidth-(PACKAGE_ITEM_WIDTH-20));


			packetView.showX=(PACKAGE_ITEM_WIDTH-20);

			packetView.hide();
			addChild(packetView);
			
			
			
			selectedPacketView=new PacketView(); //-actualWidth), actualWidth-20 );
			
			
			selectedPacketView.addEventListener(PacketView.BUY_NOW_PACKET, onBuyNowPacket);
			
			
			selectedPacketView.addEventListener(PacketView.VIEW_CAR_360, viewCar360);
            selectedPacketView.addEventListener(PacketView.SHOW_NO_COIN_POP_UP, showNoCoinPopUp);
            selectedPacketView.addEventListener(PacketView.SHOW_CONFIRM_POP_UP, showConfirmPopUp);
            selectedPacketView.addEventListener(PacketView.WATCH_REWARDS_ADS, watchRewardsHandler);
            selectedPacketView.addEventListener(PacketView.OPEN_CHALLENGES, openChallengesHandler);

			packetViewWidth = parentActualWith-PACKAGE_ITEM_WIDTH+20;
			selectedPacketView.setSize((packetViewWidth), actualHeight);
			selectedPacketView.hideX=-(packetViewWidth-(PACKAGE_ITEM_WIDTH-20));
			selectedPacketView.showX=(PACKAGE_ITEM_WIDTH-20);
			selectedPacketView.hide();
			
			
			
			addChild(selectedPacketView);
			backgroundImage = new Quad(1, 1, 0x111111);
			addChild(backgroundImage);

			backgroundHeadImage = new Quad(1,1,0x111111);
			addChild(backgroundHeadImage);
			
			label = new MultilingualLabel();
			label.textFormat = new TextFormat(FontSelector.getMontserratBold(),  12, 0xffffff );
			label.textFormat.align = TextFormatAlign.LEFT;
			label.textFormat.bold = true;
			label.wordWrap = true;
			addChild(label); 
			
			
			closeButton = ButtonFactory.menuBigButton("a_back_button", 0x000000);
			closeButton.width = closeButton.height = 35;
			closeButton.addEventListener(Event.TRIGGERED, backButtonTriggeredHandler);
			addChild(closeButton);
			
			var mainListLayout :VerticalLayout = new VerticalLayout();
			mainListLayout.paddingTop = 0;
			mainListLayout.useVirtualLayout = false;
			mainListLayout.scrollPositionVerticalAlign=VerticalAlign.TOP;

			mainList = new List();
			mainList.name = "PackagesView:List";
			mainList.clipContent = true;
			mainList.layout = mainListLayout;
			mainList.scrollBarDisplayMode=ScrollBarDisplayMode.FIXED;
			mainList.horizontalScrollPolicy = ScrollPolicy.OFF;
			mainList.addEventListener(PacketItemRenderer.ITEM_RECIEVE_WIDTH , onItemRecieveWidth );
			mainList.addEventListener("itemSelectedAgain", mainListItemSelectedAgain);
			mainList.addEventListener(Event.CHANGE, changePacketItem);
			mainList.itemRendererFactory = function() : IListItemRenderer {
				var renderer:PacketItemRenderer = new PacketItemRenderer();
				renderer.setSize(PackagesView.PACKAGE_ITEM_WIDTH, 50);     
				return renderer;
			};
				
			mainList.verticalScrollBarFactory = function ():ScrollBar {
				var scrollbar:ScrollBar = new ScrollBar();
				scrollbar.direction = Direction.VERTICAL;
				scrollbar.thumbFactory = function ():Button {
					var button:Button = new Button();
					var sprite:Sprite=new Sprite();
					var back:Quad = new Quad(15, 25, 0xffffff);   
					back.alpha=0;
					var quad:Quad = new Quad(3, 25, 0xc1c3c3);  
					sprite.addChild(back);
					sprite.addChild(quad);
					button.defaultSkin = sprite;
					return button;
				};
				return scrollbar;
			};
			if(_dataProvider && _dataProvider.length){
				mainList.dataProvider = new ListCollection(_dataProvider);
			}
			addChild(mainList);
			
			var featuredArrowTexture:Texture = assetManager.getTexture("slide_arr_lt");
			_featuredArrow=new Image(featuredArrowTexture);
			_featuredArrow.pivotX = _featuredArrow.width/2;
			_featuredArrow.pivotY = _featuredArrow.height/2;
			_featuredArrow.rotation = - Math.PI/2;
			_featuredArrow.scaleX  = 0.7;
			_featuredArrow.scaleY  = 0.7;

			addChild(_featuredArrow);    
		}

		private function showNoCoinPopUp(event: Event): void {

            if(subpacksMode) {
                dataProvider=_dataProvider;
            }
            this.dispatchEventWith(SHOW_NO_COIN_POP_UP);
		}

        private function showConfirmPopUp(event: Event): void {
            if(subpacksMode) {
                dataProvider=_dataProvider;
            }else{
                selectedPacketView.hide(true);
            }
			var eventData:Object = {packet: selectedPacketView.packet};
			if(event.data){
				eventData = ObjectUtils.merge(eventData, event.data);
			}
            this.dispatchEventWith(SHOW_CONFIRM_POP_UP, false, eventData);
        }

		private function watchRewardsHandler(event: Event): void {
            if(subpacksMode) {
                dataProvider=_dataProvider;
            }else{
                selectedPacketView.hide(true);
            }
			var eventData:Object = {packet: selectedPacketView.packet};
			if(event.data){
				eventData = ObjectUtils.merge(eventData, event.data);
			}
            dispatchEventWith(WATCH_REWARDS_ADS, false, eventData);
        }

		private function openChallengesHandler(event: Event): void {
            dispatchEventWith(OPEN_CHALLENGES);
        }

		private function viewCar360(event:Event):void{
			
			var car:Car=event.data.car;
			//this.
			this.dispatchEventWith(VIEW_CAR_360, false, {car:car, packet:selectedPacketView.packet});
			
			selectedPacketView.hide(true, function():void{
				hide(false);
			});
			
		}
		
		private function onBuyNowPacket(event:Event):void{
			
			var packet:Packet=event.data.packet;
			dispatchEventWith(BUY_NOW_PACKET, false, {packet: packet});    
			
			
		}
		
		public function updateLists():void{
			if(mainList && mainList.dataProvider){
				mainList.dataProvider.updateAll();
				mainList.invalidate();
			}
			
			if(selectedPacketView){
				selectedPacketView.updateLists();	
			}
			
			if(packetView){
				packetView.updateLists();
			}
			
		}
		
		private function onItemRecieveWidth(event:Event):void{
			
			//PACKAGE_ITEM_WIDTH
			
			//ITEM_COUNT
			

			if(this.mainList.dataProvider)

			if(this.mainList.dataProvider && mainList.dataProvider.length<=ITEM_COUNT){
				
				if(OLD_PACKET_ITEM_WIDTH!=PACKAGE_ITEM_WIDTH){
					
					dispatchEventWith(PACKAGES_VIEW_CALC_WIDTH_END, false, {width:PACKAGE_ITEM_WIDTH});
					OLD_PACKET_ITEM_WIDTH=PACKAGE_ITEM_WIDTH;
					
				}
			}
		}
		
		public static var OLD_PACKET_ITEM_WIDTH:Number=262;    
		
		private function mainListItemSelectedAgain(event:Event):void{
			if(selectedPacketView.visible){
				this.mainList.selectedIndex=-1;
				selectedPacketView.hide(true);
			}else {
				selectedPacketView.show(true, function():void{
					completeShowFlag=true;
					BrandsScreen.adsBlocker=true;
				});
			}
		}
		
		private var completeShowFlag:Boolean=true;
		private var subpacksMode:Boolean=false;
		protected function changePacketItem(event:Event=null):void{
			if(!completeShowFlag){
				Starling.juggler.delayCall(changePacketItem, 0.64);      
				return;
			}

			if(mainList.selectedIndex<0)  
				return;
            SoundManager.playSound(SoundManager.SELECT_PART);
			var packet:Packet = mainList.selectedItem as Packet;
			if(packet == selectedPacketView.packet && selectedPacketView.visible)
				return;
			if(packet.subpacks == null){
				if(mainList.selectedIndex >= 0){
					var tmpPacketView:PacketView = selectedPacketView;
					this.swapChildren(selectedPacketView, packetView);
					selectedPacketView = packetView;
					packetView = tmpPacketView;
					selectedPacketView.packet = packet;
					selectedPacketView.x = selectedPacketView.hideX;
					completeShowFlag = false;
					if(GameService.$.userProxy.currentUser){
						selectedPacketView.availableDiamonds = GameService.$.userProxy.currentUser.diamonds;
					}else{
						selectedPacketView.availableDiamonds = -1;
					}
					selectedPacketView.clearButtons();
					selectedPacketView.createButtons();
					selectedPacketView.validate();
					selectedPacketView.show(true, function():void{
						completeShowFlag=true;
						BrandsScreen.adsBlocker=true;
					});
					packetView.hideRight(true);
				}else{
					selectedPacketView.packet=packet;
					completeShowFlag=false;
					if(GameService.$.userProxy.currentUser){
						selectedPacketView.availableDiamonds = GameService.$.userProxy.currentUser.diamonds;
					}else{
						selectedPacketView.availableDiamonds = -1;
					}
					selectedPacketView.clearButtons();
					selectedPacketView.createButtons();
					selectedPacketView.validate();
					selectedPacketView.show(true, function():void{
						completeShowFlag=true;
					});   
				}
			}else{
				mainList.dataProvider = new ListCollection(packet.subpacks);
				subpacksMode = true;
			    text = packet.title.toLocaleUpperCase();
			}
		}

		
		public function get text():String {
			return _text;
		}
		
		public function set text(value:String):void {
			_text = value;
			// invalidate("text");
		}
		
		private function onTouchOverlay(event:Event):void{
			
			
			hide(true);  
		}
		
		private function backButtonTriggeredHandler(event : Event) : void 
		{
			
			if(subpacksMode)
			{
				
				dataProvider=_dataProvider;   
				
			}else{
				
				if(this.selectedPacketView && selectedPacketView.visible){
					
					selectedPacketView.hide(true, function():void{
						hide(true);
					});
				}else{
					
					hide(true);
				}
			
			}
			//dispatchEventWith(BrandsScreen.GARAGE_SELECTED);	
		}
		
		
		public function hide(animation:Boolean=false):void{
			if(visible && stage){
				SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			}
			BrandsScreen.adsBlocker=false;
			if(animation){
				
				var tween : Tween = new Tween(this, 0.35, Transitions.EASE_IN_OUT);
				tween.moveTo(-this.actualWidth, 0);//fadeTo(1.0);
				
				tween.onComplete=completeHide;
				//tween.addEventListener( Transitions.
				Starling.juggler.add(tween);
			
			}else{
				
				if(mainList)
				mainList.selectedIndex=-1;  
				
				if(packetView)
				packetView.hide();  
				
				
				completeHide();
				
			}
			
		
			
		}
		
		private var completeShowCallback:Function=null;
		
		public function show(animation:Boolean=false, complete:Function=null):void{
			
			
			
			completeShowCallback=complete;
			
			if(_language){
			
				text=this._language.translate("mob_home", "featured");  
			
			}else{
				
				text = "FEATURED PACKAGES";
			}
			
			

			
			if(animation){
			
				this.x=-this.actualWidth;
			}else{
				
				this.x=0;
			}
			
			this.visible=true;   
		
			if(animation){
				var tween : Tween = new Tween(this, 0.5, Transitions.EASE_IN_OUT);
				tween.moveTo(0, 0);
				
				tween.onComplete=completeShow;
				Starling.juggler.add(tween);
			}else{
				
				completeShow();
			}
		}
		
		
		private function completeHide():void{
			visible=false;
			dispatchEventWith(Event.CLOSE);
			
			if(this.mainList)  
			this.mainList.selectedIndex=-1;
			
		}
		
		private function completeShow():void{
			
			this.dispatchEventWith(Event.OPEN);
			
			if(completeShowCallback){
				
				completeShowCallback();
				completeShowCallback=null;
			}
			
		}
		
		public function updateItemAt(index:int):void{
			
			if(mainList && mainList.dataProvider){
				
				if(mainList.selectedIndex==index){
					
					mainList.selectedIndex=-1;
					
					if(selectedPacketView && selectedPacketView.visible)
						selectedPacketView.hide(true); 
				}
				mainList.dataProvider.updateItemAt(index);
			}
		}
		
		public function showPacket(packet:Packet):void{
			show(true, function():void{
				if(_dataProvider){
					for(var i:int=0; i<_dataProvider.length; i++){
						if(_dataProvider[i].id==packet.id){
							if(mainList.selectedIndex>=0){
								mainList.selectedIndex=-1;
							}

							mainList.selectedIndex=i;
							mainList.scrollToDisplayIndex(i);  
						}
					}
				}
			});
		}
		
		override protected function draw() : void {
			super.draw();
			if(isInvalid("text")) {
				if(PackagesView.language) {
					label.updateWithLanguage(PackagesView.language);
				} else {
					var l:Language = Language.createInstance("en-US");
					label.updateWithLanguage(l);
				}
				label.text = text;
			}
			
			if(isInvalid(INVALIDATION_FLAG_SIZE) && parent) {
				overlay.x=(PACKAGE_ITEM_WIDTH-20);
				overlay.width=(parent.width-actualWidth)+20;
				overlay.height=actualHeight;
				
				
				selectedPacketView.setSize((parent.width-actualWidth)+20, actualHeight);
				
				packetView.setSize((parent.width-actualWidth)+20, actualHeight);


				backgroundHeadImage.x=0;
				backgroundHeadImage.y=0;

				backgroundHeadImage.width = actualWidth;
				backgroundHeadImage.height = 50;

				closeButton.x = 10;
				closeButton.y = (backgroundHeadImage.height - closeButton.height) /2;
			

				var labelGap:Number = 10;
				label.x = closeButton.width + closeButton.x + labelGap;
				label.width = actualWidth - (closeButton.width + closeButton.x + 2 * labelGap);
				label.y = closeButton.y + (closeButton.height - label.height) / 2;
				   
				
				backgroundImage.x=-20;
				backgroundImage.width = actualWidth + 20;
				backgroundImage.height = actualHeight;
				
				
				//backButton.x=0;
				//backButton.y=actualHeight-backButton.height;
				
				mainList.x = 0;
				mainList.y = backgroundHeadImage.height;
				mainList.width = actualWidth;
				mainList.height = actualHeight - 60;
				
				
				_featuredArrow.x = (actualWidth - _featuredArrow.width)/2;
				_featuredArrow.y = actualHeight - _featuredArrow.height / 2;
			}
		}

		public function updateTempOpenPacket(packet:Packet):void {
			if(mainList && mainList.dataProvider){
				for(var i:int = 0; i < mainList.dataProvider.length; i++){
					var pkt:Packet = mainList.dataProvider.getItemAt(i) as Packet;
					if(pkt && pkt.id == packet.id){
						pkt.lock = packet.lock;
						pkt.tempOpened = packet.tempOpened;
						pkt.oneTimeUnlocked = packet.oneTimeUnlocked;
						mainList.dataProvider.updateItemAt(i);
						break;
					}
				}
			}
			updateLists();
		}
	}
}