package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.utils.FontSelector;

import feathers.core.FeathersControl;

import flash.geom.Rectangle;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.display.Image;
import starling.display.Quad;
import starling.events.Event;
import starling.textures.Texture;
import starling.utils.AssetManager;
import starling.utils.StringUtil;

public class PopUp extends FeathersControl {
		public static const CLOSE_BUTTON_SELECTED : String = "CloseButtonSelected";
		
		private static var currentID : int = 0;

		private var id : int;
		protected var titleLabel : MultilingualLabel;
		private var _title : String;
		
		protected var closeButton : SimpleExtendedButton;
		protected var contentBackgroundImage:Image;
		
		public var assetManager : AssetManager;
		
		protected var background:Quad;
		
		private var _hAlign:String;
		private var _horizontalTransition:Boolean;
		private var _paddingTop:Number = 0;
		public function PopUp()
		{
			super();
			
			id = currentID;
			currentID++;
		}
		
		public function get popUpName() : String
		{
			
			return StringUtil.format("PopUp_{0}", id);
		}
		
		public function set title(value : String) : void
		{
			_title = value;
			invalidate("title");
		}
		
		public function get title() : String
		{
			return _title;
		}
		
		override protected function initialize() : void
		{
			super.initialize();
			background=new Quad(1,1,0x000000);
			background.alpha=0.8;
			
			addChild(background);
			
			titleLabel = new MultilingualLabel();
			titleLabel.textFormat = new TextFormat(FontSelector.getFont(true), 14, 0xffffff); 
			titleLabel.textFormat.align = TextFormatAlign.CENTER;
			titleLabel.textFormat.bold=true;
			titleLabel.height = 16;
			titleLabel.text = title;
			addChild(titleLabel);
				
			var closeButtonTexture : Texture = ButtonFactory.assetManager.getTexture("a_close_effect_menu");
			closeButton = new SimpleExtendedButton();
			closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
			closeButton.defaultIcon = new Image(closeButtonTexture);
			closeButton.width = 12;
			closeButton.height = 12;
			
			closeButton.defaultIcon.width=12;
			closeButton.defaultIcon.height=12;
			
			(closeButton).hitAreaPadding=10;

			addChild(closeButton);
			
			var texture:Texture = ButtonFactory.assetManager.getTexture("popUpContentBackground");
			
			contentBackgroundImage = new Image(texture);
			contentBackgroundImage.scale9Grid = new Rectangle( 13, 13, 10, 6);
			addChild(contentBackgroundImage);
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{

				background.width=actualWidth;
				background.height=actualHeight;

				titleLabel.width = actualWidth;
				titleLabel.x =0;
				titleLabel.y = 89;
				
				if(closeButton){
					closeButton.x = actualWidth - (closeButton.width + 10);
					closeButton.y = 10;
				}

				if(contentBackgroundImage){
					contentBackgroundImage.x = 25;
					contentBackgroundImage.width = actualWidth - 50;
					contentBackgroundImage.y = 25;
					contentBackgroundImage.height = actualHeight - 80;
				}
			}
			
			if(isInvalid("title") && title)
			{
				titleLabel.text = title;
			}
		}

	public function transitionComplete() : void {

	}

	protected function closeButtonTriggeredHandler(event : Event) : void {
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}

        public function get hAlign():String {
            return _hAlign;
        }

        public function set hAlign(value:String):void {
            _hAlign = value;
        }

        public function get horizontalTransition():Boolean {
            return _horizontalTransition;
        }

        public function set horizontalTransition(value:Boolean):void {
            _horizontalTransition = value;
        }

		public function isDisposed():Boolean{
			return _isDisposed;
		}

		public function get paddingTop():Number {
			return _paddingTop;
		}

		public function set paddingTop(value:Number):void {
			_paddingTop = value;
		}
}
}