/**
 * Created by armen on 10.08.2017.
 */
package com.despark.tuning3d.view.components.core
{
import feathers.controls.LayoutGroup;
import feathers.core.FeathersControl;

import starling.animation.Transitions;
import starling.animation.Tween;
import starling.core.Starling;
import starling.events.Event;

public class SlidingButton extends LayoutGroup
    {
        private var _open:Boolean;
        protected var _tween:Tween;

        private var overlayButton  : MultilingualButton;

        public function get swipeButton() : MultilingualButton{
            return overlayButton;
        }

        public function SlidingButton(texture:String=null, label:String=null, color:uint=0x939393, padding:int=8)
        {
            super();

            _open = false;

            var txt : String = texture ? texture : "friend";
            var lbl : String = label ? label : "friend";

            overlayButton  = ButtonFactory.newButton(txt,lbl,color,padding);
            overlayButton.addEventListener(Event.TRIGGERED, slideEventHandler);
        }


        override protected function initialize():void {
            super.initialize();

            addChild(overlayButton);
            overlayButton.validate();
        }

        private function slideEventHandler(event:Event) : void {
            isOpen ? hide() : show();
        }

        override public function dispose() : void {
            super.dispose();

            try {
                overlayButton.removeEventListener(Event.TRIGGERED, slideEventHandler);
                removeChild(overlayButton);
            }catch(e:Error){
                e.getStackTrace();
            }

        }

        public function show():void
        {
            var dir : Number = swipeButton.width / 3 + 5;
            _tween = new Tween(swipeButton, 0.3, Transitions.EASE_IN_OUT);
            _tween.moveTo(-dir,0);
            _tween.onComplete = completeShow;

            Starling.juggler.add(_tween);
        }


        override public function validate():void {
            overlayButton.validate();
            super.validate();
        }

        public function hide():void
        {
            _tween = new Tween(swipeButton, 0.3, Transitions.EASE_IN_OUT);
            _tween.moveTo(0,0);
            _tween.onComplete = completeHide;

            Starling.juggler.add(_tween);
        }

        private function completeHide() : void {
            _open = false;
        }
        private function completeShow() : void {
            _open = true;
        }

        public function get isOpen():Boolean {
            return _open;
        }
    }
}