/**
 * Created by Render-2 on 8/15/2017.
 */
package com.despark.tuning3d.view.components.gallery {
import com.despark.tuning3d.model.core.Constants;
import com.utils.FontSelector;

import feathers.controls.TextInput;

import feathers.controls.text.StageTextTextEditor;
import feathers.controls.text.TextBlockTextRenderer;
import feathers.controls.text.TextFieldTextEditor;
import feathers.controls.text.TextFieldTextRenderer;
    import feathers.core.IMultilineTextEditor;
    import feathers.core.ITextEditor;
import feathers.core.ITextRenderer;
    import feathers.layout.HorizontalAlign;
    import feathers.text.StageTextField;

    import flash.text.StyleSheet;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.text.engine.CFFHinting;
import flash.text.engine.ElementFormat;
import flash.text.engine.FontDescription;
import flash.text.engine.FontLookup;
import flash.text.engine.FontPosture;
import flash.text.engine.FontWeight;
import flash.text.engine.RenderingMode;

import starling.filters.ColorMatrixFilter;

public class GalleryLabelFactory {

    public static const COLOR_TEXT_WHITE : uint = 0xFEFFFF;
    public static const COLOR_TEXT_LITE_GREY : uint = 0xDEDEDE;
    public static const COLOR_TEXT_GREY : uint = 0x767676;
    public static const COLOR_TEXT_BLUE : uint = 0x026EDC;
    public static const SIZE_BIG : uint = 16;
    public static const SCREEN_TITLE_SIZE:uint = 14;
    public static const SIZE_SMALL  :uint = 12;

    public static function  screenTitle ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), SIZE_SMALL, COLOR_TEXT_WHITE);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  messageLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_GREY);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  searchFieldLabel ():IMultilineTextEditor {
        var textEditor:StageTextTextEditor = new StageTextTextEditor();
        textEditor.multiline = false;
        textEditor.fontFamily = "Arial";
        textEditor.isEditable = true;
        textEditor.fontSize = SIZE_SMALL;
        textEditor.color = COLOR_TEXT_GREY;
        return textEditor;
    }

    public static function  sortByTitleLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_GREY);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  tuningCountLabel():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratSemiBold(), SIZE_SMALL, COLOR_TEXT_WHITE);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = true;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  availableCountLabel():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_WHITE);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

    public static function  garagePeriodLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_GREY);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        textRenderer.selectedTextFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_WHITE);
        return textRenderer;
    }

    public static function  showByRadioDefaultLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_GREY);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;

        textRenderer.selectedTextFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_BLUE);
        return textRenderer;
    }

    public static function  showByRadioGarageLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_WHITE);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;

        textRenderer.selectedTextFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_BLUE);
        return textRenderer;
    }

    public static function  searchPlaceholderDefaultLabel ():ITextRenderer {
        var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
        textRenderer.textFormat = new TextFormat(FontSelector.getMontserratMedium(), SIZE_SMALL, COLOR_TEXT_GREY);
        textRenderer.embedFonts = FontSelector.embedFonts();
        textRenderer.textFormat.italic = false;
        textRenderer.textFormat.bold = false;
        textRenderer.embedFonts = true;
        textRenderer.textFormat.align = TextFormatAlign.LEFT;
        return textRenderer;
    }

}
}
