package com.despark.tuning3d.view.components.instructions
{
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.images.PersistentImageProvider;
	import com.despark.tuning3d.model.parts.Material3dtProvider;
	
	import flash.filesystem.File;
	
	public class SimpleImageProvider implements PersistentImageProvider
	{
		
		public var urlForDownloading : String;
		
		public var sourceUrl: String;//например //data.3dtuning.com/bkg/ или с http
		//sourceUrl нужно заменить в urlForDownloading на destinationPath 
		//но если задан nameOfFile то будет использоватся nameOfFile  
		
		public var nameOfFile: String;//например qwerty.png
		
		public var destinationPath: String;//например Cars/Backgrounds/
		
		private var _isDefault : Boolean;
		
		public function SimpleImageProvider() {
            sourceUrl = 'http://data.3dtuning.com/tun/';
            destinationPath = "cars/thumb/";
		}

        public function get localFile():String
        {
            var path : String = null;
            if(nameOfFile){
                path = destinationPath + nameOfFile;
            }else{
                path = urlForDownloading.replace(sourceUrl, destinationPath);
            }
            path = quickReplace(path,"-","_");

            var file1: File = File.cacheDirectory.resolvePath(path);
            file1.preventBackup = true;
            return file1.url;
        }
		
		public static function quickReplace(source:String, oldString:String, newString:String):String
		{
			return source.split(oldString).join(newString);
		}
		
		public function get remoteUrl():String
		{
			return urlForDownloading;
		}
		
		public function get isEncrypted():Boolean
		{
			return false;
		}
		
		public function get ignoresTransparentPixelsOnTouch():Boolean
		{
			return false;
		}
		
		public function get touchable():Boolean
		{
			return true;//не факт что так правильнее!!!
		}
		
		public function get important():Boolean
		{
			return true;//не факт что так правильнее!!!
		}
		
		public function get brightness():Number
		{
			return 1.0;
		}
		
		public function set brightness(value:Number):void
		{
		}
		
		public function get isDefault() : Boolean 
		{
			return _isDefault;
		}
		
		public function set isDefault(value : Boolean) : void
		{
			_isDefault = value;
		}
		
		public function get material3dtProvider():Material3dtProvider
		{
			return null;
		}
		
		public function get frameIndeX():int
		{
			return -1;
		}
	}
}