package com.despark.tuning3d.view.components.mailbox.mails
{
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.utils.DateParser;

    import feathers.controls.Label;
    import feathers.controls.LayoutGroup;
    import feathers.layout.AnchorLayout;
    import feathers.layout.AnchorLayoutData;

    import flash.utils.setTimeout;

    import starling.display.Quad;

    public class MailDateItemRenderer extends MailItemRenderer{
        private var _dateLabel: Label;
        private var _mainContainer:LayoutGroup;
        private var _leftLine:Quad;
        private var _rightLine:Quad;
        public function MailDateItemRenderer(){

        }

		protected override function initialize() : void {
			super.initialize();
            _mainContainer = new LayoutGroup();
            _mainContainer.layout = new AnchorLayout();
            _mainContainer.width = ownerWidth;
            addChild(_mainContainer);

            var layData : AnchorLayoutData;
            layData = new AnchorLayoutData();
            layData.horizontalCenter = 0;
            layData.verticalCenter = 0;
            _dateLabel ||= new Label();
            _dateLabel.textRendererFactory = LabelFactory.mailDateLabel;
            _dateLabel.layoutData = layData;

            _leftLine = new Quad(1, 1, 0xCCCCCC);
            _rightLine = new Quad(1, 1, 0xCCCCCC);

            _mainContainer.addChild(_leftLine);
            _mainContainer.addChild(_dateLabel);
            _mainContainer.addChild(_rightLine);
		}

        override protected function draw():void{
            super .draw();
            _mainContainer.width = ownerWidth;
            _mainContainer.height = actualHeight;
            //
            function layoutItems():void {
                if(_dateLabel && _dateLabel.x){
                    _rightLine.width = _leftLine.width = (ownerWidth - _dateLabel.width - 20) / 2;
                    _rightLine.height = _leftLine.height = 1;
                    _rightLine.x = _dateLabel.x + _dateLabel.width + 5;
                    _leftLine.x = 5;
                    _rightLine.y = _leftLine.y = (actualHeight - _rightLine.height) / 2;
                }else{
                    setTimeout(layoutItems, 50);
                }
            }
            layoutItems();
        }

		public override function dispose() : void {
            super.dispose();
            if (_dateLabel){
                _dateLabel.removeFromParent(true);
                _dateLabel = null;
            }
        }

		protected override function commitData() : void {
            super.commitData();
            if(!data){
                return;
            }
            _dateLabel.text = DateParser.getHeaderDateAppropriateText(data.date);
            _dateLabel.validate();
		}
    }
}