package com.despark.tuning3d.view.components.parts
{
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.disks.DiskBrand;
	import com.despark.tuning3d.model.parts.PartDisk;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.ListItemRenderer;

import starling.display.Image;
import starling.display.Quad;
import starling.textures.Texture;

public class BrandPartItemRenderer extends ListItemRenderer
	{
		
		private var quad:Quad;
		private var allBrandsImage:Image=null;
		private var seporator:Image;
		
		private var stance:Image;
		
		
		public function BrandPartItemRenderer()
		{
			super();
			
			fontSize = 10;
			_textColor = 0xffffff;
			_bold=true;
			
		}
		
		public function get part() : DiskBrand
		{
			return data as DiskBrand;
		}
		
		protected override function initialize():void 
		{
			
			quad=new Quad(1,1,0xeaeaea);
			
			quad.alpha=0;
			
			addChild(quad);
			
			
			super.initialize();
			
			
			var seporatorTexture:Texture=ButtonFactory.assetManager.getTexture("a_seporator_1");
			
			seporator=new Image(seporatorTexture);
			
			seporator.width=1.5;
			
			addChild(seporator);
			
			var stanceTexture:Texture=ButtonFactory.assetManager.getTexture("stance");
			
			stance=new Image(stanceTexture);
			stance.visible=false;
			stance.width=30;
			stance.height=28
			addChild(stance);
			
			
			allBrandsImage=new Image(ButtonFactory.assetManager.getTexture("a_show_all_disks"));
			allBrandsImage.width=27;//actualWidth;
			allBrandsImage.height=26.5;//actualHeight- label.height - 5;
			
			allBrandsImage.visible=false;
			
			addChild(allBrandsImage);
			//label.alpha = 0.5;
		}
		
		protected override function commitData() : void 
		{
			super.commitData();
			
			/*if (part.id == null)
			{
			return;
			}*/
			
			if(!part) return;
			
			
			
			label.text = part.name.toUpperCase();
			
			label.height=NaN;
			
			label.validate();
			
			label.y=actualHeight - label.height;
			//var t:Constants
			stance.visible = (part is PartDisk && part.existCamber && Constants.CRAMB_ENABLED);
			if(!part.isAllBrands){
				imageLoader.recieveImageSize2=recieveImageSize;
				imageLoader.persistentImageProvider = part;		
				allBrandsImage.visible=false;
				imageLoader.visible=true;
				
				//trace("NOT part.isAllBrands:", part.name, part.remoteUrl);
			}else{
				
				//trace("part.isAllBrands:",  true, label.text);
				
				
				
				
				allBrandsImage.visible=true;
				imageLoader.visible=false;
				
			}
		}
		
		protected function recieveImageSize(width:Number, height:Number, image:ImageLoaderWithStates):void{
			
			/*	if(image.width>90){
			
			image.width=80;
			image.x=(110-80)/2
			}*/
		}
		
		
		
		protected override function autoSizeIfNeeded() : Boolean
		{
			
			return true;
		}
		
		protected override function commitSelection() :void
		{
			
			super.commitSelection();
			
		}
		
		protected override function layout():void
		{
			
			//label.validate();
			
			
			imageLoader.x=5;
			imageLoader.y=5;//actualHeight-;
			imageLoader.width = actualWidth-10;
			imageLoader.height = 25;//actualHeight - label.height;
			
			label.y = imageLoader.height+9;
			
			label.width = actualWidth;
			label.height = 20;
			
			/*if(imageLoader.height>35){
			
			imageLoader.height=35;
			}*/
			
			if(allBrandsImage){
				
				allBrandsImage.width=27;// actualWidth;
				allBrandsImage.height=26.5;// actualHeight - label.height - 5;
				
				allBrandsImage.x=(actualWidth-allBrandsImage.width)/2;
				allBrandsImage.y=4.5;//(actualHeight-allBrandsImage.height)/2;
			}
			
			
			stance.x=3
			stance.y=2;
			
		}
		
		
		
		protected override function draw():void{
			
			super.draw();
			
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			
			if(sizeInvalid) 
			{
				if(quad){
					
					quad.width=actualWidth;
					quad.height=actualHeight;
				}
				
				//if(allBrandsImage)
				{
					
					//allBrandsImage.width=32;// actualWidth;
					//allBrandsImage.height=32;// actualHeight - label.height - 5;
					
					allBrandsImage.x=(actualWidth-allBrandsImage.width)/2;
					//allBrandsImage.y=imageLoader.y+5;//(actualHeight-allBrandsImage.height)/2;
					
				}
				
				seporator.x=actualWidth-seporator.width;
				seporator.y=0;
				seporator.height=actualHeight;
			}
			
			
		}
		
	}
}

