package com.despark.tuning3d.view.components.parts
{
    import com.despark.tuning3d.model.core.images.PersistentImageProvider;
    import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.LayoutImage;
    import com.despark.tuning3d.view.components.core.ListItemRenderer;
    import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
    import com.distriqt.AdsManager;
    import com.utils.FontSelector;

    import feathers.controls.Button;
    import feathers.controls.Label;

    import flash.geom.Rectangle;
    import flash.text.TextFormatAlign;

    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.textures.Texture;

    public class PartItemRenderer extends ListItemRenderer implements IPartItemRenderer
{

    public static const EVENT_OPEN_INFO_POP_UP:String="EVENT_OPEN_INFO_POP_UP";
    public static const CLEAR_VIEW_WIDTH:Number = 90;


    protected var quad_back:Quad;
    protected var carLock:Image;
    protected var btnInfo : Button;

    private var _isTranslate:Boolean=false;
    private var _clearView:Boolean=false;
    private var _translateDescription:String="";

    private var _enabled:Boolean=true;



    private var _separator:Image;
	
	private var button:Button;
    protected var profileNewBadgeIcon:Image;
    protected var badgeTextures:Object;

    private var _activeIcon:Image;
    private var _selectedBorder:LayoutImage;
    //
    private var _levelLabel:Label;
    public function PartItemRenderer() {
        super();
        fontSize = 9;
        textColor = 0xFFFFFF;
        _bold = false;
    }
	
	private function onTouch(event:Event):void{
		
		trace("onTouch", part.isFastModeLoaded);
		
		if(part.isFastModeLoaded){
			//var selIndex:int = owner.selectedIndex;
			//owner.selectedIndex = -1;
			//owner.selectedIndex = selIndex;
			itemSelectedAgainBlocker = true;
			
			owner.dispatchEventWith("ExitFromFastMode", false, {part:part});
			
			trace("onTouch2", part.isFastModeLoaded);
			
			this.invalidate();
		}
	}

    public function get translateDescription():String{

        return _translateDescription;
    }

    public function get part() : Part
    {
        return data as Part;
    }

    public function get isChopper():Boolean{
        return part ? part.parentSlot.parentCar.isChopper: false;
    }

    override public function dispose():void{
        if(quad_back){
            quad_back.dispose();
            quad_back = null;
        }
        if(carLock){
            carLock.dispose();
            carLock = null;
        }
        if(_separator){
            _separator.dispose();
            _separator = null;
        }
        if(button){
            button.dispose();
            button = null;
        }
        if(btnInfo){
            btnInfo.dispose();
            btnInfo = null;
        }
        if(profileNewBadgeIcon){
            profileNewBadgeIcon.dispose();
            profileNewBadgeIcon = null;
        }
        super.dispose();
    }

    protected override function initialize():void {

        if(clearView){
            fontSize = 25;
        }

        super.initialize();
        quad_back = new Quad(1, 1, 0xeaeaea);
        quad_back.alpha=0;
        this.addChildAt(quad_back, 0);


        var carLockTexture : Texture = AlertView.assetManager.getTexture("challenge_rewards_icon");
        carLock=new Image(carLockTexture);
        carLock.width = 18;
        carLock.scale = carLock.scaleX;
        addChild(carLock);

        var seporatorTexture:Texture=ButtonFactory.assetManager.getTexture("a_seporator_1");

        _separator=new Image(seporatorTexture);

        _separator.width=1.5;

        addChild(_separator);

        label.paddingLeft=5;
        label.paddingRight=5;
		
		button = ButtonFactory.transparentButton();
		button.addEventListener(Event.TRIGGERED, onTouch);
		addChild(button);

        btnInfo = ButtonFactory.circleButton("a_part_info_icon", 0.6, null, 7);
        Image(btnInfo.defaultSkin).color = Image(btnInfo.downSkin).color = 0xFF0000;
        btnInfo.width = 16;
        btnInfo.height = 16.5;
        btnInfo.addEventListener(Event.TRIGGERED, btnInfoHandler);
        if(!_clearView){
            addChild(btnInfo);
        }

        badgeTextures = {
            "new_icon": ButtonFactory.assetManager.getTexture("new_icon"),
            "profile_icon": ButtonFactory.assetManager.getTexture("profile_icon"),
            "new_and_profile_icon": ButtonFactory.assetManager.getTexture("new_and_profile_icon")
        };

        profileNewBadgeIcon = new Image(badgeTextures["new_icon"]);
        profileNewBadgeIcon.width = 38;
        profileNewBadgeIcon.height = 38;
        profileNewBadgeIcon.color = 0xFF0000;
        if(!_clearView){
            addChild(profileNewBadgeIcon);
        }

        var frameTxt:Texture = ButtonFactory.assetManager.getTexture("border_line");
        _selectedBorder = new LayoutImage(frameTxt);
        _selectedBorder.scale9Grid = new Rectangle(frameTxt.width/2 - 0.5, frameTxt.height / 2 - 0.5, 1, 1);
        _selectedBorder.touchable = _selectedBorder.includeInLayout = false;
        addChild(_selectedBorder);
        _selectedBorder.color = 0xFFFFFE;
        _selectedBorder.width = actualWidth;
        _selectedBorder.height = actualHeight;
        _selectedBorder.visible = false;

        imageLoader.visible = !clearView;

    }

    override protected function touchHandler(event:TouchEvent):void{
        var touch:Touch = event.getTouch(btnInfo);
        if(touch){
            return;
        }
        super .touchHandler(event)
    }

    private function btnInfoHandler(event:Event):void {
        if(isSelected){
            SoundManager.playSound(SoundManager.SELECT_PART);
        }
        owner.dispatchEventWith(EVENT_OPEN_INFO_POP_UP, false, {part:this});
        event.stopImmediatePropagation();
    }

    protected override function commitData() : void
    {
        super.commitData();
        var typicalWidth:Number = 100;
        if (part && part.name == 'banner') {
            imageLoader.persistentImageProvider = null;
            profileNewBadgeIcon.visible = btnInfo.visible = label.visible = carLock.visible = _separator.visible = imageLoader.visible = false;
            var bannerWidth: Number = AdsManager.$.bannerWidth + TuningScreen.PART_SELECTOR_WIDTH / 2;
            if(!AdsManager.$.bannerEnabled || owner.width - typicalWidth < bannerWidth){
                AdsManager.$.preventToggle = true;
                setSize(0, 50);
            }else{
                AdsManager.$.preventToggle = false;
                setSize(bannerWidth, 50);
            }
            touchable = false;

        } else {
            if (this.part) {
                this.touchable = part.name != '.';
            } else {
                this.touchable = false;
            }
            profileNewBadgeIcon.visible = btnInfo.visible = label.visible = carLock.visible = _separator.visible = true;
            imageLoader.visible = !clearView;
            if(clearView){
                setSize(CLEAR_VIEW_WIDTH, 50);
            }else{
                this.setSize(typicalWidth, 50);
            }
            if (part && AlertView.language.translate(part.id, "htmlCode") != null && AlertView.language.translate(part.id, "htmlCode") != "htmlCode") {
                _isTranslate = true;

                _translateDescription = AlertView.language.translate(part.id, "htmlCode");

            } else if (part && AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode") != null && AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode") != "htmlCode") {

                _isTranslate = true;

                _translateDescription = AlertView.language.translate(part.parentSlot.name + "." + part.name, "htmlCode");
            } else {

                _isTranslate = false;
                _translateDescription = "";
            }

            profileNewBadgeIcon.visible = (badgeIconName != null);
            if(profileNewBadgeIcon.visible && profileNewBadgeIcon.texture != badgeTextures[badgeIconName]){
                profileNewBadgeIcon.texture = badgeTextures[badgeIconName];
            }


            if(clearView){
                label.text = (index + 1).toString();
            }else if (part && part.name.indexOf("{custom}") >= 0) {
                var text:String = part.name;
                text = text.replace("{custom}", AlertView.language.translate("componentNames", "custom"));
                label.text = text;
            } else if (part && part.name.indexOf("{factory}") >= 0) {
                var text2:String = part.name;
                text2 = text2.replace("{factory}", AlertView.language.translate("componentNames", "factory"));
                label.text = text2;//AlertView.language.translate("componentNames", "factory").toUpperCase();
            } else if (part) {
                label.text = part.name;
            }

            if (part) {
                if(part.isEnabled && _activeIcon){
                    _activeIcon.removeFromParent(true);
                    _activeIcon = null;
                }else if(!part.isEnabled && !_activeIcon){
                    _activeIcon = new Image(ButtonFactory.assetManager.getTexture("close_btn_texture"));
                    _activeIcon.width = _activeIcon.height = 18;
                    addChild(_activeIcon);
                    _activeIcon.x = (actualWidth - _activeIcon.width) / 2;
                    _activeIcon.y = (actualHeight - _activeIcon.height) / 2;
                }

                _enabled = part.enabled && !part.parentSlot.isExcluded;

                var newPersistentImageProvider:PersistentImageProvider = part;


                if (imageLoader.persistentImageProvider && imageLoader.persistentImageProvider.remoteUrl != newPersistentImageProvider.remoteUrl) {
                    //imageLoader.persistentImageProvider.remoteUrl
                    imageLoader.persistentImageProvider = part;
                    imageLoader.completeHandler = completeIconLoad;
                } else if (!imageLoader.persistentImageProvider) {

                    imageLoader.completeHandler = completeIconLoad;
                    imageLoader.persistentImageProvider = part;
                } else {
                    updatePartIcon();
                }

                if(part.unlockLevel != -1){
                    if(!_levelLabel){
                        _levelLabel = LabelFactory.createSimpleLabel(FontSelector.getAlumniSansMedium(), 11, 0xFFFFFF, TextFormatAlign.CENTER, true, true);
                        var _levelBg:Image = new Image(ButtonFactory.assetManager.getTexture("component_level_bg"));
                        _levelBg.height = actualHeight - 6;
                        _levelBg.scale = _levelBg.scaleY;
                        _levelLabel.width = _levelBg.width;
                        _levelLabel.height = _levelBg.height;
                        _levelLabel.backgroundSkin = _levelBg;
                        _levelLabel.paddingTop = 10;
                    }
                    _levelLabel.text = '<textformat leading="-6" align="center"><font size="16">' + part.unlockLevel.toString() + '</font>' + '\n' + "LEVEL</textformat>";
                    addChild(_levelLabel);
                }else if(_levelLabel){
                    _levelLabel.removeFromParent(true);
                    _levelLabel = null;
                    isEnabled = touchable = true;
                }
            }
        }
        isEnabled = _enabled;
    }

    override public function get index():int {
        if(owner && owner.dataProvider && data && owner.dataProvider.contains(data)){
            return owner.dataProvider.getItemIndex(data);
        }
        return _index;
    }

    protected function get badgeIconName():String{
        var isNew:Boolean = false;
        var hasProfile:Boolean = false;
        if(part){
            isNew = (part.properties.hasOwnProperty("is_new") && part.properties["is_new"]);
            hasProfile = (part.properties.hasOwnProperty("profilesAvailable") && part.properties["profilesAvailable"]);
            if(isNew && !hasProfile){
                return "new_icon";
            }
            if(!isNew && hasProfile){
                return "profile_icon";
            }
            if(isNew && hasProfile){
                return "new_and_profile_icon";
            }
            return null;
        }
        return null;
    }

    override public function set bold(value : Boolean) : void {
        _bold = value;
        if(label) {
            label.textFormat.color = 0xffffff;
            label.textFormat.font=FontSelector.getFont(_bold);
            label.textFormat.bold=_bold;
            label.invalidate();
        }
    }

    protected override function commitSelection() :void
    {
        super.commitSelection();

        if (part && part.parentSlot) {
            if (!part.parentSlot.isExcluded) {
                bold = isSelected;
            }
        }
        layoutSelection();
    }

    protected function completeIconLoad(image:ImageLoaderWithStates) : void
    {
        updatePartIcon();
    }

    protected function updatePartIcon() : void{

        imageLoader.width = 80;
        imageLoader.height = actualHeight - label.height - 5;
        imageLoader.x=(actualWidth-imageLoader.width )/2;
        imageLoader.y=4;
        imageLoader.color = 0xFF0000;
        if(imageLoader.image){
            imageLoader.image.color = 0xFF0000;
        }

        Starling.juggler.delayCall(function () : void {
            if(profileNewBadgeIcon) {
                profileNewBadgeIcon.visible = (badgeIconName != null);
                if(profileNewBadgeIcon.visible && profileNewBadgeIcon.texture != badgeTextures[badgeIconName]){
                    profileNewBadgeIcon.texture = badgeTextures[badgeIconName];
                    updateBadgeIcon();
                }
            }
        }, 0.3);
    }

    protected function updateBadgeIcon() :void {
        if(imageLoader && imageLoader.image) {
            profileNewBadgeIcon.width = profileNewBadgeIcon.height = imageLoader.image.height * 0.8;
            profileNewBadgeIcon.x = imageLoader.x + imageLoader.image.x;
            profileNewBadgeIcon.y = imageLoader.y + imageLoader.image.y;
            trace(imageLoader.image.height, imageLoader.height, imageLoader.x, imageLoader.image.x);
        } else {
            profileNewBadgeIcon.visible = false;
        }
    }

    private function updateLevelIcon():void{
        if(_levelLabel){
            if(part && part.unlockLevel == -1){
                _levelLabel.removeFromParent(true);
                _levelLabel = null;
                return;
            }
            setChildIndex(_levelLabel, numChildren - 1);
            _levelLabel.x = (actualWidth - _levelLabel.width) / 2;
            _levelLabel.y = (actualHeight - _levelLabel.height) / 2;
        }
    }

    protected override function layout():void {
        if(_isDisposed){
            return;
        }
        var featuresWidth:Number=0;

        if(isSelected && _isTranslate){

            featuresWidth=(btnInfo.width)+4;
        }


        label.updateWithLanguage(AlertView.language);

        if(!clearView){
            label.maxWidth=actualWidth-featuresWidth;
        }
        label.validate();

        if(clearView){
            label.x = (actualWidth - label.width) / 2;
        }else if (isChopper){
            label.x = actualWidth-label.width;
        } else {
            label.x = ((actualWidth-label.width)/2)-featuresWidth/2;
        }

        if(clearView){
            label.y = (actualHeight - label.height) / 2;
        }else{
            label.height = 15;
            label.y = 34;
        }

        quad_back.width = actualWidth;
        quad_back.height = actualHeight;

        btnInfo.x = actualWidth - (btnInfo.width + 6);
        btnInfo.y = actualHeight - (btnInfo.height + 5);

        carLock.x = actualWidth - (carLock.width + 6);
        carLock.y = 4;

        if(part && part.name == 'banner') {
            carLock.visible=false;
        }else {
            carLock.visible = (part && part.lock);
        }

        btnInfo.visible = (part && part.activeForInformation);

        if(!_enabled && (part && part.unlockLevel == -1)){
            this.alpha=0.3;
        }else{
            this.alpha= 1;
        }

        updateLevelIcon();
    }


    private function chopperLayout():void{
        var featuresWidth:Number=0;

        if(isSelected && _isTranslate){

            featuresWidth=(btnInfo.width)+4;
        }

        label.updateWithLanguage(AlertView.language);

        label.maxWidth=actualWidth-featuresWidth;
        label.validate();

        label.x = actualWidth-label.width;
        label.height = 15;
        label.y = 34;//actualHeight - label.height;
        label.validate();

        quad_back.width=this.actualWidth;
        quad_back.height=this.actualHeight;

        btnInfo.x = actualWidth - (btnInfo.width + 6);
        btnInfo.y = actualHeight - (btnInfo.height + 5);

        carLock.x = actualWidth - (carLock.width + 6);
        carLock.y = 4;

        carLock.visible=(part && part.lock);

        btnInfo.visible = (part && part.activeForInformation);

        if(!_enabled && (part && part.unlockLevel == -1)){
            this.alpha=0.3;
        }else{
            this.alpha=1;
        }

        btnInfo.x = actualWidth - (btnInfo.width + 6);
        btnInfo.y = actualHeight - (btnInfo.height + 5);

        _separator.height = actualHeight - 10;
        _separator.x = actualWidth-_separator.width;
        _separator.y = 5;
    }


    protected override function  draw():void{
        super.draw();
        if(part && part.parentSlot.parentCar.isChopper && !clearView){
            chopperLayout();
        }else{
            layout();
        }

		button.width = actualWidth;
		button.height = actualHeight;

        _separator.height = actualHeight - 10;
        _separator.y = 5;
        _separator.x = actualWidth-_separator.width;

        layoutSelection();
    }

    protected function layoutSelection():void{
        if(_selectedBorder){
            _selectedBorder.width = actualWidth;
            _selectedBorder.height = actualHeight;
            _selectedBorder.visible = isSelected;
            //
            if(owner && owner.dataProvider){
                var itemIndex:int = owner.dataProvider.getItemIndex(_data);
                if(itemIndex < owner.dataProvider.length - 1){
                    var rightRenderer:PartItemRenderer = owner.itemToItemRenderer(owner.dataProvider.getItemAt(itemIndex + 1)) as PartItemRenderer;
                    if(rightRenderer){
                        _separator.visible = (!isSelected && !rightRenderer.isSelected);
                    }else{
                        _separator.visible = !isSelected;
                    }
                }else{
                    _separator.visible = !isSelected;
                }
            }
            //
        }
    }

    public function set clearView(value:Boolean):void {
        _clearView = value;
    }

    public function get clearView():Boolean {
        return _clearView;
    }
}
}

