package com.despark.tuning3d.view.components.rewards {
    import com.despark.tuning3d.view.components.challenges.controls.ImageLabel;
    import com.despark.tuning3d.view.components.core.ButtonFactory;

    import starling.animation.Transitions;

    import starling.animation.Tween;
    import starling.core.Starling;

    import starling.display.Image;

    public class RewardsCarTypeLabel extends RewardsLabel {
        private var _shineImg:ShineImage;
        private var _durLabel:ImageLabel;
        private var _rewardIcon:Image;
        private var _carType:String;
        public function RewardsCarTypeLabel(value:*) {
            super();
            _rewardType = RewardType.CAR_TYPE;
            _carType = value as String;
        }
        
        override protected function initialize():void{
            super .initialize();
            _shineImg = new ShineImage(ButtonFactory.assetManager.getTexture("lights_effect"));
            _shineImg.setColor(0x1189fb);
            _shineImg.dir = 0.5;
            _shineImg.scale = 3 * ButtonFactory.assetManager.scaleFactor / 2;
            _shineImg.colorChangingInterval = 5;
            _shineImg.rotation = 0;
            _shineImg.rotationSpeed = Math.PI / 360;
            addChild(_shineImg);
            _shineImg.y = 10;
            var tween:Tween = new Tween(_shineImg, 1, Transitions.LINEAR);
            tween.scaleTo(0.6 * ButtonFactory.assetManager.scaleFactor / 2);
            tween.animate("rotation", Math.PI);
            Starling.juggler.add(tween);

            _durLabel = new ImageLabel();
            _durLabel.color = 0x1399f4;
            _durLabel.text = "@ 24h";
            _durLabel.scale = 0.45 * ButtonFactory.assetManager.scaleFactor / 2;
            addChild(_durLabel);
            _durLabel.x = -_durLabel.width / 2;
            _durLabel.y = 50;

            if(_carType == "ALL"){
                _rewardIcon = new Image(ButtonFactory.assetManager.getTextureAtlas("resource_icons").getTexture("all_cars.png"));
            }else{
                _rewardIcon = new Image(ButtonFactory.assetManager.getTextureAtlas("resource_icons").getTexture("all_" + _carType.toLowerCase() + ".png"));
            }
            _rewardIcon.pivotX = _rewardIcon.width / 2;
            _rewardIcon.pivotY = _rewardIcon.height / 2;
            _rewardIcon.height = 52;
            _rewardIcon.scale = _rewardIcon.scaleY;
            addChild(_rewardIcon);
            _rewardIcon.y = _shineImg.y;

            var toScale:Number = _rewardIcon.scale;
            _rewardIcon.scale = toScale * 3;
            _rewardIcon.alpha = 0;
            var tween2:Tween = new Tween(_rewardIcon, 0.5, Transitions.EASE_OUT);
            tween2.delay = 0.75;
            tween2.scaleTo(toScale);
            tween2.fadeTo(1);
            Starling.juggler.add(tween2);
        }

        override public function dispose():void{
            super .dispose();
            if(_shineImg){
                _shineImg.removeFromParent(true);
                _shineImg = null;
            }
            if(_durLabel){
                _durLabel.removeFromParent(true);
                _durLabel = null;
            }
            if(_rewardIcon){
                _rewardIcon.removeFromParent(true);
                _rewardIcon = null;
            }
        }
    }
}
