package com.despark.tuning3d.view.components.rewards {
    import feathers.core.FeathersControl;

    public class RewardsLabel extends FeathersControl {
        protected var _rewardType:String;
        public function RewardsLabel() {
            super();
        }

        public static function createInstance(resourceType:String, value:*):RewardsLabel{
            switch (resourceType) {
                case RewardType.KEYS:
                    return new RewardsKeyLabel(value);
                case RewardType.DIAMONDS:
                    return new RewardsDiamondLabel(value);
                case RewardType.CAR_ID:
                    return new RewardsCarIdLabel(value);
                case RewardType.CAR_TYPE:
                    return new RewardsCarTypeLabel(value);
                case RewardType.MULTIPLIER:
                    return new RewardsMultiplierLabel();
            }
            return null;
        }

        public function startLabelAnimation():void{

        }

        public function get rewardType():String {
            return _rewardType;
        }
    }


}
