package com.despark.tuning3d.view.components.rewards {
    import com.despark.tuning3d.view.components.challenges.controls.ImageLabel;
    import com.despark.tuning3d.view.components.core.ButtonFactory;

    import starling.display.Image;

    public class RewardsMultiplierLabel extends RewardsLabel {
        private var _shineImg:ShineImage;
        private var _durLabel:ImageLabel;
        private var _rewardIcon:Image;
        private var _doubleIcon:Image;
        public function RewardsMultiplierLabel() {
            super();
            _rewardType = RewardType.MULTIPLIER;
        }
        
        override protected function initialize():void{
            super .initialize();
            _shineImg = new ShineImage(ButtonFactory.assetManager.getTexture("lights_effect"));
            _shineImg.setColor(0x1189fb);
            _shineImg.dir = 0.5;
            _shineImg.scale = 0.575 * ButtonFactory.assetManager.scaleFactor / 2;
            _shineImg.colorChangingInterval = 5;
            _shineImg.rotation = 20 * Math.PI / 180;
            addChild(_shineImg);
            _shineImg.y = 4;

            _durLabel = new ImageLabel();
            _durLabel.color = 0x1399f4;
            _durLabel.text = "@ 24h";
            _durLabel.scale = 0.45 * ButtonFactory.assetManager.scaleFactor / 2;
            addChild(_durLabel);
            _durLabel.x = -_durLabel.width / 2;
            _durLabel.y = 50;

            _rewardIcon = new Image(ButtonFactory.assetManager.getTextureAtlas("resource_icons").getTexture("x2.png"));
            _rewardIcon.pivotX = _rewardIcon.width / 2;
            _rewardIcon.pivotY = _rewardIcon.height / 2;
            _rewardIcon.height = 44;
            _rewardIcon.scale = _rewardIcon.scaleY;
            addChild(_rewardIcon);
            _rewardIcon.y = 0;

            _doubleIcon = new Image(ButtonFactory.assetManager.getTextureAtlas("resource_icons").getTexture("double_points.png"));
            _doubleIcon.pivotX = _doubleIcon.width / 2;
            _doubleIcon.pivotY = _doubleIcon.height / 2;
            _doubleIcon.height = 42;
            _doubleIcon.scale = _doubleIcon.scaleY;
            addChild(_doubleIcon);
            _doubleIcon.y = 33;
        }
    }
}
