package com.despark.tuning3d.view.components.timeline.TimelineGarage {
import com.despark.tuning3d.view.components.timeline.FeedData;
import com.despark.tuning3d.view.components.timeline.ItemRenderers.Comments.CommentData;

public class CommentsPocket{


    private var _comments : Array;
    private var _holder : FeedData;
    private var _totalLength : int = 0;
    private var _isLoading : Boolean = false;

    public function CommentsPocket(holder : FeedData) {
        super();
        this._holder = holder;
        this._comments = [];
    }

    public function get totalLength() : int {
        return _totalLength;
    }

    public function get comments() : Array{
        return _comments;
    }

    public function get currentLength() : int {
        return _comments.length;
    }

    public function get isNotFull() : Boolean{
        return currentLength < totalLength;
    }

    public function initialLoad() : void{
        if(_isLoading) return;

        _isLoading = true;
        var skip : int = 0;
        var limit : int = 1;

        FeedData.Proxy.getComments(_holder.isTuningUse, _holder.useId, skip, limit, function (data : Object) : void{
            if(data) {
                parseComments(data.items);
                _totalLength = data.count;
            }
            invalidateHoldersData();
            _isLoading = false;
        });
    }

    private function invalidateHoldersData():void {
        if(_holder.holder){
            _holder.holder.invalidateLikeCommentsViews();
            _holder.holder.invalidate();
        }
    }

    private function parseComments( commentsArray : Array) : void
    {
        if(!commentsArray || commentsArray.length == 0)
        {
            return;
        }
        for(var i : int = 0 ; i < commentsArray.length; i++)
        {
            var commentData : CommentData = new CommentData(commentsArray[i]);
            _comments.push(commentData);
        }
    }

    public function addMoreComment(commentData : CommentData) : void{
        _comments.push(commentData);
    }

    public function updateComment(comment : CommentData) : void{
        for(var i : int =0;  i < currentLength; i++)
        {
            if(_comments[i].id.length == 0)
            {
                _comments[i].id = comment.id;
                _comments[i].owner = comment.owner;
                _comments[i].comment = comment.comment;
                _comments[i].created = comment.created;
                _comments[i].tuningId = comment.tuningId;
                _comments[i].updatedDate = comment.updatedDate;
                _comments[i].invalidateItemRenderer();
                return;
            }
        }
    }

    public function deleteComment(comment : CommentData) : Boolean{
        for(var i : int = 0; i < currentLength; i++){
            if(_comments[i].id == comment.id){
                _comments.removeAt(i);
                _totalLength --;
                invalidateHoldersData();
                return true;
            }
        }
        return false;
    }

    public function generateComment(text : String) : void
    {
        var comment : CommentData = new CommentData();
        comment.owner = _holder.currentUser;
        comment.created = new Date();
        comment.updatedDate = new Date();
        comment.comment = text;
        if(_holder.tuning)
        {
            comment.tuningId = _holder.tuning._id;

        }
        comment.id = "";
        _totalLength ++;
        _comments.unshift(comment);

        invalidateHoldersData();
    }

}
}
