package com.despark.tuning3d.view.components.timeline.TimelineGarage
{
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.model.cars.CarBackground;
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
import com.despark.tuning3d.view.components.tunings.TuningsListScreen;
import com.utils.DisplayObjectUtil;

import feathers.layout.HorizontalAlign;
import feathers.layout.VerticalAlign;

import flash.desktop.Clipboard;
import flash.desktop.ClipboardFormats;

import flash.filesystem.File;
import flash.utils.getTimer;

import starling.core.Starling;

import starling.display.Image;

import starling.display.Quad;
import starling.events.Event;
import starling.events.EventDispatcher;
import starling.events.Touch;
import starling.events.TouchEvent;
import starling.events.TouchPhase;
import starling.textures.TextureSmoothing;

public class TimelineTuningItem extends ListItemRenderer {
		private var backgroundImage:ImageLoaderWithStates=null;
		public var count:int = 0;
		public var horizontalAlign:String;
		public var verticalAlign:String;
    	private var _eventDispatcher:EventDispatcher;
		private var imgX:Number;
		private var imgY:Number;
		private var imgW:Number;
		private var imgH:Number;

        private var _loadingTime:Number;
		public function TimelineTuningItem(){

		}

		public function get tuning() : Tuning {
			return data as Tuning;
		}
		
		protected override function initialize() : void {
			super.initialize();
			this.label.visible=false;
		}

        override public function dispose():void {
            if(backgroundImage) {
                if(backgroundImage.currentTexture){
                    backgroundImage.currentTexture.dispose();
				}
                backgroundImage.removeFromParent(true);
                backgroundImage = null;
            }
            super.dispose();
        }

        protected override function draw() : void {
			super.draw();
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			if(imageLoader){
				imageLoader.overrideDispose = true;
			}
			
			if(sizeInvalid){
                if(backgroundImage) {
                    backgroundImage.x = (actualWidth - backgroundImage.width) / 2;
                    backgroundImage.y = (actualHeight - backgroundImage.height) / 2;
                }
			}

			if(imageLoader.image){
                imgX = imageLoader.image.x;
                imgY = imageLoader.image.y;
                imgW = imageLoader.image.width;
                imgH = imageLoader.image.height;
			}
		}
		
		protected function completeLoadImage(imageWidth:Number, imageHeight:Number):void{
			var imgRatio:Number = imageWidth / imageHeight;
			var itemRatio:Number = actualWidth / actualHeight;
			var size:Number;
			if(imgRatio < itemRatio) {
				size = (count == 1?actualWidth:0.9*actualWidth);
                imageLoader.width = size;
                imageLoader.height = size / imgRatio;
            }else{
                size = (count == 1?actualHeight:0.9*actualHeight);
                imageLoader.height = size;
                imageLoader.width = size * imgRatio;
			}
			imageLoader.x = (actualWidth - imageLoader.width) / 2;
			imageLoader.y = (actualHeight - imageLoader.height) / 2;
            //
            loadBackground();
		}

		protected function backgroundCompleteLoadImage(imageWidth:Number, imageHeight:Number):void{
			var imgRatio:Number = imageWidth / imageHeight;
			var itemRatio:Number = actualWidth / actualHeight;
            if(imgRatio < itemRatio) {
                backgroundImage.width = actualWidth;
                backgroundImage.height = actualWidth / imgRatio;
            }else{
                backgroundImage.height = actualHeight;
                backgroundImage.width = actualHeight * imgRatio;
            }
            backgroundImage.x = (actualWidth - backgroundImage.width) / 2;
            backgroundImage.y = (actualHeight - backgroundImage.height) / 2;

            //
            _loadingTime = getTimer() - _loadingTime;
            var currentText:String = '';
            if(Clipboard.generalClipboard.getData(ClipboardFormats.TEXT_FORMAT)){
                currentText = Clipboard.generalClipboard.getData(ClipboardFormats.TEXT_FORMAT) as String;
            }
            var text:String =  currentText + tuning.name + ": " + (_loadingTime / 1000).toFixed(2) + 'sec.\n';
            Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, text);
		}

    private function getBgUrl() : String {
        if(!tuning) return "";

        if(
                tuning.customSnapshotsBackgrounds && tuning.customSnapshotsBackgrounds[0] && tuning.customSnapshotsBackgrounds[0] != CarBackground.DEFAULT_ID
                &&   tuning.backgroundsMap && tuning.backgroundsMap[tuning.customSnapshotsBackgrounds[0]]){

            var carBackground:CarBackground=  tuning.backgroundsMap[tuning.customSnapshotsBackgrounds[index]];//tuning.backgroundsMap[tuning.backgroundId];
            carBackground.showThumbnailUrl=false;
            var cameraIndex:int =0;
            if(tuning.customSnapshotsCamera && tuning.customSnapshotsCamera.length>0 && carBackground.imagePathSecondCam && carBackground.imagePathSecondCam.length>0){
                cameraIndex = tuning.customSnapshotsCamera[0];
            }

            carBackground.selectedCamera =cameraIndex;
            return carBackground.remoteUrl;

        }else{

            var randomSplashUrl:String = "";
            if(tuning.customSnapshotsBackgrounds){
                for(var i:int = tuning.customSnapshotsBackgrounds.length-1; i >= 0; i--){
                    if(!tuning.customSnapshotsBackgrounds[i]){
                        tuning.customSnapshotsBackgrounds.removeAt(i);
                    }
                }
            }

            if(tuning.customSnapshotsBackgrounds && tuning.customSnapshotsBackgrounds.length){
                randomSplashUrl = tuning.customSnapshotsBackgrounds[0];
                randomSplashUrl = 'http:' + randomSplashUrl.replace(/https?:/i, '');
                return randomSplashUrl;
            }
            if(tuning.carChooserBgName) {
                randomSplashUrl = File.applicationDirectory.resolvePath("assets/textures/bgs/"+tuning.carChooserBgName.replace('.jpg', '') + ".jpg").url;
                if(tuning.customSnapshotsCamera && tuning.customSnapshotsCamera.length>0){
                    var cameraIndex:int = tuning.customSnapshotsCamera[0];
                    if(tuning.carObj.defaultBkgMobile[cameraIndex]){
                        randomSplashUrl = tuning.carObj.defaultBkgMobile[cameraIndex];
                    }
                }
                randomSplashUrl = 'http:' + randomSplashUrl.replace(/https?:/i, '');
                return randomSplashUrl;
            }else if(tuning.customSnapshotsBackgrounds && tuning.customSnapshotsBackgrounds.length && tuning.customSnapshotsBackgrounds[0].indexOf("data.3dtuning.com") > -1){
                index = 0;
                return 'http:' + tuning.customSnapshotsBackgrounds[index].replace(/https?:/i, '');
            } else {
                randomSplashUrl = File.applicationDirectory.resolvePath("assets/textures/bgs/car_chooser.jpg").url;
                return randomSplashUrl;
            }
        }
    }
		
		protected override function commitData() : void{
			super.commitData();
            if(backgroundImage){
                backgroundImage.removeFromParent(true);
                backgroundImage = null;
            }
			if(tuning){
				var car:Car = new Car();
				car.imageURL = tuning.imageURL/*.replace('http://data.3dtuning.com/', 'http://tuning.blob.core.windows.net/')*/;
				imageLoader.recieveImageSize = completeLoadImage;
                 // imageLoader.bitmapScale = 0.5;
                imageLoader.persistentImageProvider = car;
                _loadingTime = getTimer();
            }
		}

		public function set eventDispatcher(eventDispatcher:EventDispatcher):void {
			_eventDispatcher = eventDispatcher;
		}

        private function loadBackground():void{
            backgroundImage ||= new ImageLoaderWithStates();
            backgroundImage.overrideDispose = true;
            backgroundImage.visible=false;
            if(backgroundImage.currentTexture){
                backgroundImage.currentTexture.dispose();
            }
            addChildAt(backgroundImage, 0);

            var carBackground:CarBackground;
            var cameraIndex:int = 0;
            if(tuning && tuning.backgroundId && tuning.backgroundId != CarBackground.DEFAULT_ID && tuning.backgroundsMap && tuning.backgroundsMap[tuning.backgroundId]){
                carBackground= tuning.backgroundsMap[tuning.backgroundId];
                cameraIndex = 0;
                if(tuning.customSnapshotsCamera && tuning.customSnapshotsCamera.length>0 && carBackground.imagePathSecondCam && carBackground.imagePathSecondCam.length>0){
                    cameraIndex = tuning.customSnapshotsCamera[0];
                }
                carBackground.showThumbnailUrl=false;
                carBackground.selectedCamera = cameraIndex;
                backgroundImage.smoothing = TextureSmoothing.BILINEAR;
                backgroundImage.persistentImageProvider = carBackground;
                backgroundImage.visible = true;
            }else if(tuning){
                var randomSplashUrl:String;
                if(tuning && tuning.carChooserBgName) {
                    randomSplashUrl = getBgUrl();
                    if (!randomSplashUrl && tuning.customSnapshotsCamera && tuning.customSnapshotsCamera.length > 0) {
                        cameraIndex = tuning.customSnapshotsCamera[0];
                        if (tuning.carObj.defaultBkgMobile[cameraIndex]) {
                            randomSplashUrl = tuning.carObj.defaultBkgMobile[cameraIndex];
                        }
                    }
                    carBackground = new CarBackground();
                    carBackground.mainUrl = randomSplashUrl/*.replace('http://data.3dtuning.com/', 'http://tuning.blob.core.windows.net/')*/;
                    carBackground.isLocalFile = true;
                    carBackground.showThumbnailUrl = false;
                    backgroundImage.persistentImageProvider = carBackground;
                }else if(tuning && tuning.backgroundId && tuning.backgroundId.indexOf('data.3dtuning.com') != -1){
                    if(tuning.backgroundId.indexOf('http:') == -1){
                        tuning.backgroundId = 'http:' + tuning.backgroundId;
                    }
                    carBackground = new CarBackground();
                    carBackground.mainUrl = tuning.backgroundId/*.replace('http://data.3dtuning.com/', 'http://tuning.blob.core.windows.net/')*/;
                    carBackground.isLocalFile = true;
                    carBackground.showThumbnailUrl = false;
                    backgroundImage.persistentImageProvider = carBackground;
                }else{
                    randomSplashUrl = File.applicationDirectory.resolvePath("assets/textures/bgs/car_chooser.jpg").url;
                    carBackground = new CarBackground();
                    carBackground.mainUrl = randomSplashUrl/*.replace('http://data.3dtuning.com/', 'http://tuning.blob.core.windows.net/')*/;
                    carBackground.isLocalFile = true;
                    carBackground.showThumbnailUrl = false;
                    backgroundImage.persistentImageProvider = carBackground;
                }
                backgroundImage.visible=true;
                // backgroundImage.bitmapScale = 0.5;
                backgroundImage.recieveImageSize = backgroundCompleteLoadImage;
            }
        }
}
}
