/**
 * Created by Render-2 on 8/10/2017.
 */
package com.despark.tuning3d.view.components.timeline.TimelineGarage {
import com.despark.tuning3d.model.cars.Car;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.timeline.FeedData;
import com.utils.TextureUtil;

import flash.geom.Rectangle;

import starling.display.Image;

import starling.display.Quad;
import starling.filters.BlurFilter;
import starling.textures.Texture;

public class TimelineTuningViewItemRenderer extends ListItemRenderer{
	
	private var _maskQuad:Quad;
    private var _sourceDimensions:Object;
    private var bg1:Image;
    private var bg2:Image;
    private var def:Number;
    private static const DIV:uint = 10;
    private static const DIV_2:uint = 2*DIV;
    public function TimelineTuningViewItemRenderer(sourceDimensions:Object){
        _sourceDimensions = sourceDimensions;
        super ();
    }

    public function get slide() : String
    {
        var dataString : String = data as String;
        if(dataString && dataString.indexOf("http") < 0)
        {
            return "http:" + dataString
        }
        return data as String;
    }

    protected override function initialize() : void {
        super.initialize();
        this.label.visible=false;
		_maskQuad = new Quad(1,1);
        if(_sourceDimensions && _sourceDimensions.width / _sourceDimensions.height<FeedData.FHDRatio){
            return;
        }
        imageLoader.cropOnLoadCoefficient = 0.05;
    }

    protected override function draw() : void
    {
        super.draw();
        //this.clipRect=new Rectangle(0, 0, actualWidth, actualHeight); //tt
		_maskQuad.width = actualWidth;
		_maskQuad.height = actualHeight;
//		this.mask = _maskQuad;

    }

    protected override function commitData() : void {
        super.commitData();

        var car:Car = new Car();
        car.imageURL = slide;

        imageLoader.recieveImageSize = completeLoadImage;
        imageLoader.persistentImageProvider = car;
        imageLoader.source = car.remoteUrl;
        imageLoader.completeHandler = function ():void {
            updateBackgroundTexture();
        };
        imageLoader.textureCommitedHandler = function():void{
            updateBackgroundTexture();
        };
    }

    private function updateBackgroundTexture():void{
        if(bg1 && bg2){
            var size:Number;
            if(def<=1){
                size = (1/def-0.9)*imageLoader.currentTexture.height/DIV;
                var sy:Number = imageLoader.currentTexture.height - size;
                bg1.texture = Texture.fromTexture(imageLoader.currentTexture, new Rectangle(0, 0, imageLoader.currentTexture.width, size));
                bg2.texture = Texture.fromTexture(imageLoader.currentTexture, new Rectangle(0, sy, imageLoader.currentTexture.width, size));
            }else if(imageLoader.currentTexture){
                size = (def-1)*imageLoader.currentTexture.width/DIV;
                var sx:Number = imageLoader.currentTexture.width - size;
                bg1.texture = Texture.fromTexture(imageLoader.currentTexture, new Rectangle(0, 0, size, imageLoader.currentTexture.height));
                bg2.texture = Texture.fromTexture(imageLoader.currentTexture, new Rectangle(sx, 0, size, imageLoader.currentTexture.height));
            }
        }
    }

    override public function dispose():void {
        super.dispose();
        if(bg1){
            if(bg1.texture){
                bg1.texture.dispose();
            }
            bg1.removeFromParent(true);
            bg1 = null;
        }
        if(bg2){
            if(bg2.texture){
                bg2.texture.dispose();
            }
            bg2.removeFromParent(true);
            bg2 = null;
        }
        if(_maskQuad){
            _maskQuad.removeFromParent(true);
            _maskQuad = null;
        }
    }

    protected function completeLoadImage(imageWidth:Number, imageHeight:Number):void{
        /*
        const fhdWidth:int = 1920;
        const fhdHeight:int = 1080;
        const hdWidth:int = 1440;
        const hdHeight:int = 900;
        const dh:int = hdHeight - imageHeight*hdWidth/imageWidth;
        */
        //
        var s1:Number;
        var s2:Number;
        if(imageWidth/imageHeight < FeedData.FHDRatio){
            s1 = imageWidth/imageHeight;
            s2 = actualWidth/actualHeight;
            def = s2/s1;
            var size:Number;
            if(def<=1) {
                imageLoader.width = actualWidth;
                size = (1/def-0.9)*imageLoader.currentTexture.height/DIV_2;
                var sy:Number = imageLoader.currentTexture.height - size;

                if(bg1){
                    if(bg1.texture){
                        bg1.texture.dispose();
                    }
                    bg1.removeFromParent(true);
                }
                bg1 = new Image(Texture.fromTexture(imageLoader.currentTexture, new Rectangle(0, 0, imageLoader.currentTexture.width, size)));
                bg1.width = imageLoader.width;
                bg1.scaleY = bg1.scaleX*DIV;

                if(bg2){
                    if(bg2.texture){
                        bg2.texture.dispose();
                    }
                    bg2.removeFromParent(true);
                }
                bg2 = new Image(Texture.fromTexture(imageLoader.currentTexture, new Rectangle(0, sy, imageLoader.currentTexture.width, size)));
                bg2.width = imageLoader.width;
                bg2.scaleY = bg2.scaleX*DIV;

                bg2.y = imageLoader.height - bg2.height;
            }else{
                imageLoader.height = actualHeight;
                size = (def-1)*imageLoader.currentTexture.width/DIV_2;
                var sx:Number = imageLoader.currentTexture.width - size;

                if(bg1){
                    if(bg1.texture){
                        bg1.texture.dispose();
                    }
                    bg1.removeFromParent(true);
                }
                bg1 = new Image(Texture.fromTexture(imageLoader.currentTexture, new Rectangle(0, 0, size, imageLoader.currentTexture.height)));
                bg1.height = imageLoader.height;
                bg1.scaleX = bg1.scaleY*DIV;

                if(bg2){
                    if(bg2.texture){
                        bg2.texture.dispose();
                    }
                    bg2.removeFromParent(true);
                }
                bg2 = new Image(Texture.fromTexture(imageLoader.currentTexture, new Rectangle(sx, 0, size, imageLoader.currentTexture.height)));
                bg2.height = imageLoader.height;
                bg2.scaleX = bg2.scaleY*DIV;
                bg2.x = imageLoader.width - bg2.width;
            }
            imageLoader.addChild(bg1);
            imageLoader.addChild(bg2);
            imageLoader.x=(actualWidth-imageLoader.width)/2;
            imageLoader.y=(actualHeight-imageLoader.height)/2;
        }else {
            //var diff2:Number = actualHeight - actualWidth * imageHeight / imageWidth;
            var diff:int = 70; //Math.abs(diff2); // 70
            s1 = imageWidth/imageHeight;
            s2 = actualWidth/(actualHeight+diff);
            if(s1 > s2){
                imageLoader.height= (actualHeight+diff);
                imageLoader.width = s1 * (actualHeight+diff);
            } else {
                imageLoader.width = actualWidth;
                imageLoader.height = actualWidth/s1;
            }
            imageLoader.x=(actualWidth-imageLoader.width)/2;
            imageLoader.y=(actualHeight-imageLoader.height-diff)/2;
        }
    }
}
}
