package com.despark.tuning3d.view.components.tunings
{

	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.ExtentedButton;
	import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;

	import feathers.controls.Button;
import feathers.core.FeathersControl;

import starling.events.Event;

public class ShareView extends FeathersControl
	{
		
		public static const SHARE_SELECTED:String="SHARE_SELECTED";
		
		private var fbButton:Button;
		private var vkButton:Button;
		private var instagramButton:Button;
		
		private var _color:uint=0x000000;
		//	private var twButton:Button;
		
		
		private var _selectedSocialId:String="";
		private var buttons:Vector.<Button>;
		public function ShareView()
		{
			super();
		}
		
		
		override protected function initialize() : void
		{
			super.initialize();
			
			fbButton = ButtonFactory.circleButton("a_fb_icon2");
			fbButton.name="fb";
			fbButton.width=35;
			fbButton.height=35;
			(fbButton as ExtentedButton).color=_color;
			fbButton.addEventListener(Event.TRIGGERED, onShareSelectedHandler);
			addChild(fbButton);


			instagramButton = ButtonFactory.circleButton("a_instagram_icon2");
			instagramButton.name="instagram";
			instagramButton.width=35;
			instagramButton.height=35;
			(instagramButton as ExtentedButton).color=_color;
			instagramButton.addEventListener(Event.TRIGGERED, onShareSelectedHandler);
			addChild(instagramButton);

//			vkButton = ButtonFactory.circleButton("a_vk_icon2");
//			vkButton.name="vk";
//			vkButton.width=35;
//			vkButton.height=35;
//			(vkButton as ExtentedButton).color=_color;
//			vkButton.addEventListener(Event.TRIGGERED, onShareSelectedHandler);
//			addChild(vkButton);
			
			
			//container.snapToPages = true;
            buttons = new <Button>[instagramButton, fbButton];
			width = 35;
            height = 35*buttons.length + (buttons.length-1)*7.5;
		}
		
		
		
		public function get selectedSocialId():String{
			
			return _selectedSocialId;
		}
		
		
		
		private function onShareSelectedHandler(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART);
			_selectedSocialId=(event.currentTarget as Button).name;
			
			this.dispatchEventWith(SHARE_SELECTED);
			
		}
		
		public function set color(value:uint):void{
			
			_color=value;
			
			this.invalidate("updateButtonColor");
		}
		
		public function get color():uint{
			
			return _color;
		}
		
		
		override protected function draw() : void {
			super.draw();
			if(isInvalid(INVALIDATION_FLAG_SIZE)) {
				for(var i:int = 0;  i < buttons.length; i++){
					buttons[i].x = (i==0?0:(buttons[i-1].x - buttons[i-1].height - TuningScreen.BUTTON_MENU_GAP));
					buttons[i].y = 0;
				}
			}
			
			if(isInvalid("updateButtonColor") && fbButton && instagramButton && vkButton){
				for each(var btn:Button in buttons){
					(btn as ExtentedButton).color = _color;
				}
			}
		}
	}
}


