package com.despark.tuning3d.view.components.tunings
{
	import com.despark.tuning3d.model.cars.Car;
	import com.despark.tuning3d.view.components.core.ListItemRenderer;
	import com.utils.DisplayObjectUtil;

	import flash.filesystem.File;

	import flash.geom.Rectangle;

	import starling.display.Image;

	import starling.display.Quad;
	import starling.utils.MathUtil;

	public class TuningSlideFHDItemRenderer extends ListItemRenderer {
		private var clipRectQuad:Quad;
		private var _slide:Object;
		public var clipBackground:Boolean = false;

        private var _overrideDispose:Boolean = false;
		private var _fitContent:Boolean = false;
		private var _topOffset:Number = -25;
		private var _leftOffset:Number = 0;
		private var _contentScale:Number = 1;
		public function get slide() : Object {
			return data as Object;
		}
		
		protected override function initialize() : void {
            overrideDispose = _overrideDispose;
			super.initialize();
			clipRectQuad = new Quad(1,1);
			this.label.visible=false;
		}

		protected override function draw() : void {
			super.draw();
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			if(sizeInvalid){
				if(!this.mask){
					clipRectQuad.x = 0;
					clipRectQuad.width = actualWidth;
					if(clipBackground){
                        clipRectQuad.height = actualHeight + 50;
                        clipRectQuad.y = -25;
						addChild(clipRectQuad);
                    }else{
                        clipRectQuad.height = actualHeight;
                        clipRectQuad.y=0;
					}
					 this.mask = clipRectQuad;
				}else if(clipBackground){
                    if(mask.height != actualHeight + 50){
                        mask.height = actualHeight + 50;
                    }
                    if(mask.y != -25){
                        mask.y = -25;
                    }
                    if(!mask.parent){
                        addChild(mask);
                    }
				}
			}
		}
		
		protected function completeLoadImage(imageWidth:Number, imageHeight:Number):void{
			trace("imageWidth:", imageWidth, "imageHeight:", imageHeight);
			imageLoader.scale = 1;
			if(_fitContent && imageLoader.image){
				if(owner.width / owner.height < imageLoader.originalSourceWidth / imageLoader.originalSourceHeight){
					imageLoader.height = _contentScale * owner.height;
					imageLoader.width = _contentScale * owner.height * imageLoader.originalSourceWidth / imageLoader.originalSourceHeight;
				}else{
					imageLoader.width = _contentScale * owner.width;
					imageLoader.height = _contentScale * owner.width * imageLoader.originalSourceHeight / imageLoader.originalSourceWidth;
				}
			}else{
				imageLoader.width =  _contentScale * imageWidth / 2;
				imageLoader.height = _contentScale * imageLoader.originalSourceHeight * imageLoader.scaleX;
			}

			setSize(owner.width, owner.height);
			imageLoader.x = Math.min((actualWidth - imageLoader.width) / 2 + _leftOffset, 0);
			imageLoader.y = Math.min((actualHeight - imageLoader.height)/ 2 + _topOffset, 0);
			updatePositions();
		}

		override public function setSize(w:Number, h:Number):void{
			super .setSize(w, h);
		}

		public function updatePositions():void{
			if(_fitContent){
				if(imageLoader.image){
					imageLoader.validate();
					imageLoader.x = Math.min((actualWidth - imageLoader.width) / 2 + _leftOffset, 0);
					imageLoader.y = Math.min((actualHeight - imageLoader.height)/ 2 + _topOffset, 0);
				}
			}
		}

		public function getImageClone():Image{
			if(imageLoader && imageLoader.image){
				var result:Image = new Image(imageLoader.image.texture);
				var bounds:Rectangle = imageLoader.image.getBounds(stage);
				result.width = bounds.width;
				result.height = bounds.height;
				result.x = bounds.x;
				result.y = bounds.y;
				return result;
			}
			return null;
		}

        override public function dispose():void {
            super.dispose();
			if(clipRectQuad){
                clipRectQuad.removeFromParent(true);
                clipRectQuad = null;
			}
			DisplayObjectUtil.dispose(this);
        }

        protected override function commitData() : void {
			super.commitData();
			if(!slide || slide == _slide) {
				return;
            }
			_slide = slide;
			var car:Car = new Car();
			car.imageURL = slide.tuning.fullHdSnapshots[MathUtil.clamp(slide.index, 0, slide.tuning.fullHdSnapshots.length - 1)];
			car.imageURL = car.imageURL.replace(/^\/\//gmi, "http://");
			imageLoader.recieveImageSize = completeLoadImage;
			imageLoader.overrideDispose = _overrideDispose;
			imageLoader.scale = 1;
			imageLoader.errorHandler = imageLoaderErrorHandler;
			imageLoader.persistentImageProvider = car;
		}

		private function imageLoaderErrorHandler():void{
			var url:String = "http://data.3dtuning.com/ui-elements/intro_page/image-archived.jpg";
			var imageProvider:Car = imageLoader.persistentImageProvider as Car;
			imageProvider.imageURL = url;
			imageLoader.persistentImageProvider = imageProvider;
		}

        public function set overrideDispose(overrideDispose:Boolean):void {
            _overrideDispose = overrideDispose;
			if(imageLoader){
				imageLoader.overrideDispose = _overrideDispose;
			}
        }

		public function set fitContent(value:Boolean):void {
			_fitContent = value;
		}

		public function set topOffset(value:Number):void {
			_topOffset = value;
		}

		public function set leftOffset(value:Number):void {
			_leftOffset = value;
		}

		public function set contentScale(value:Number):void {
			_contentScale = value;
		}
	}
}
