package com.despark.tuning3d.view.components.tunings.editing
{
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
import com.utils.FontSelector;

import feathers.controls.text.TextFieldTextRenderer;

import feathers.core.FeathersControl;
import feathers.core.ITextRenderer;

	import flash.media.SoundChannel;

	import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.utils.AssetManager;

public class TuningFlatProgressBar extends FeathersControl {
		public var assetManager : AssetManager;
		private var _progress : Number = -1;
		private var percentDisplay:MultilingualLabel;
		private var soundChannel:SoundChannel;
		public function TuningFlatProgressBar() {
			super();
		}
		
		public function get progress() : Number {
			return _progress;
		}

		public function set progress(value : Number):void {
			if(_progress == -1 && value != -1){
				SoundManager.pauseChannel(SoundManager.THEME);
				soundChannel = SoundManager.playSound(SoundManager.LOADING, 100);
			}else if((value == 1 || value == -1) && soundChannel){
				soundChannel.stop();
				soundChannel = null;
			}
			_progress = value;
			invalidate("progress");
		}

		override protected function initialize() : void {
			super.initialize();
			percentDisplay=new MultilingualLabel();
			//percentDisplay.updateWithLanguage(AlertView.language);
            percentDisplay.textRendererFactory = textRendererFactory;

			percentDisplay.textFormat = new TextFormat(FontSelector.getFont(), 10, 0xffffff);
			percentDisplay.textFormat.align = TextFormatAlign.LEFT;
			percentDisplay.textFormat.bold = true;
			percentDisplay.textFormat.italic = true;
			percentDisplay.text="LOADING 0%";
			addChild(percentDisplay);
			//setSizeInternal(130, 19.5, true);
		}

		private static function textRendererFactory() : ITextRenderer {
			var textRenderer : TextFieldTextRenderer = new TextFieldTextRenderer();

			var bold:Boolean=true;
			var italic:Boolean=true;
			var size:int=10;
			var align:String=TextFormatAlign.LEFT;

			textRenderer.textFormat = new TextFormat(FontSelector.getFont(), size, 0xFFFFFF);
			textRenderer.textFormat.align = align;
			textRenderer.textFormat.bold=bold;
			textRenderer.textFormat.italic=italic;
			textRenderer.embedFonts = true;
			return textRenderer;
		}

		override protected function draw() : void {
			super.draw();
			if(isInvalid(INVALIDATION_FLAG_SIZE)) {
				percentDisplay.validate();
				percentDisplay.x=(width-percentDisplay.width)/2;
				//percentDisplay.y=((this.actualHeight-percentDisplay.height)/2)-1.0;
			}
			
			if(isInvalid("progress") && progress >= 0){
				percentDisplay.text="LOADING "+Math.round(progress*100)+"%"
			}
		}
	}
}