package com.despark.tuning3d.view.components.tunings.editing {
	import com.utils.FontSelector;

	import feathers.controls.Label;
	import feathers.core.FeathersControl;

	import flash.events.TimerEvent;

	import flash.geom.Rectangle;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.utils.Timer;

	import starling.animation.Transitions;
	import starling.animation.Tween;
	import starling.core.Starling;
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.filters.DropShadowFilter;
	import starling.textures.Texture;
	import starling.utils.AssetManager;

	public class TuningLoaderBar extends Sprite {
		public var assetManager : AssetManager;
		
		private var _progress : Number = -1;
		private var progressImage:Image;
		private var _timer:Timer;
		public function TuningLoaderBar() {
			super();
			visible = false;
			addEventListener(Event.ADDED_TO_STAGE, feathersControl_addedToStageHandler);
			addEventListener(Event.REMOVED_FROM_STAGE, feathersControl_removedFromStageHandler);
		}
		
		public function get progress() : Number {
			return _progress;
		}

		public function set progress(value : Number):void {
			_progress = value;
			alpha = 1.0;
			if(_timer && !_timer.running){
				_timer.start();
			}
			if(progress == 1) {
				var tween : Tween = new Tween(this, 0.3, Transitions.EASE_OUT);
				tween.delay = 0.5;
				tween.fadeTo(0);
				tween.onComplete = function() : void {
					visible = false;
				}
				Starling.juggler.add(tween);
			}
		}

		private function feathersControl_addedToStageHandler(event:Event):void{
			initialize();
			_timer ||= new Timer(30);
			if(!_timer.hasEventListener(TimerEvent.TIMER)){
				_timer.addEventListener(TimerEvent.TIMER, timerEventHandler);
			}
			_timer.start();
		}

		private function feathersControl_removedFromStageHandler(event:Event):void{
			if(_timer){
				_timer.stop();
			}
		}

		private function timerEventHandler(event:TimerEvent):void {
			if(progressImage.alpha == 0 || !visible){
				_timer.stop();
				return;
			}
			progressImage.rotation += Math.PI / 18;
		}

		override public function set width(value:Number):void{
			super .width = value;
		}

		override public function set height(value:Number):void{
			super .height = value;
		}

		private function initialize() : void {
			progressImage ||= new Image(assetManager.getTexture("spinner"));
			progressImage.pivotX = progressImage.width / 2;
			progressImage.pivotY = progressImage.height / 2;
			progressImage.x = progressImage.y = 0;
			addChild(progressImage);
			width = 26;
			height = 26;
		}
	}
}