package com.despark.tuning3d.view.components.tunings.editing
{
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ButtonFactory;
import com.despark.tuning3d.view.components.core.MultilingualButton;
import com.despark.tuning3d.view.components.core.PopUp;
import com.despark.tuning3d.view.components.core.TextInputNewView;
import com.utils.FontSelector;

import flash.geom.Rectangle;
import flash.text.TextFormat;

import starling.core.Starling;
import starling.display.Image;
import starling.events.Event;
import starling.textures.Texture;

public class TuningSharingPopUp extends PopUp implements Multilingual
	{
		public static var SHARE_BUTTON_SELECTED : String = "ShareButtonSelected";
		
		private var textInputView : TextInputNewView;
		//private var textAreaView:TextAreaView;
		private var shareButton : MultilingualButton;
		private var cancelButton:MultilingualButton;
		
		
		private var bgImage:Image;
		

		
		private var _hashTags:String="";
		
		private var _siteLink:String="";
		
		public function TuningSharingPopUp(__title : String, challenge:Boolean=false, hashTags:String="", siteLink:String = "" )
		{
			super();
			
			
			trace("__title:", __title)
			
			_siteLink = siteLink;
			
			if(__title=="SHARE ON FACEBOOK"){
				_siteLink = "";	
			}
			
			if(challenge){
				title = "SUBMIT TO CHALLENGE";
			}else{
				
				title = __title;
			}
			

			
			_hashTags=hashTags;
			
			
			

				setSizeInternal(Starling.current.stage.width, Starling.current.stage.height, false);

			
		}
		
//		public function TuningSharingPopUp()
//		{
//			super();
//			if(!title)
//				title = "SHARE ON FACEBOOK";
//			setSizeInternal(200, 120, false);
//		}
		
		public function updateWithLanguage(language : Language) : void
		{
			

				if(title=="VK"){
					
					title = language.translate("mob_social", "shareOnVk");
					
				}else if(title=="instagram"){
					
					title = language.translate("mob_social", "shareOnInstagram");
				}else if(title=="TW"){
					
					title = language.translate("mob_social", "shareOnTwiter");
				}
			titleLabel.updateWithLanguage(language);
			
			
			textInputView.updateWithLanguage(language);
			

				textInputView.title = "";//language.translate("mob_social", "message").toUpperCase();

			
			shareButton.updateWithLanguage(language);
			

				shareButton.label = language.translate("mob_social", "Share");

		}
		
		override protected function initialize() : void
		{
			super.initialize();
			
			contentBackgroundImage.visible = false;
		

			
			textInputView = new TextInputNewView(true);

			
			
			textInputView.fun_enterPress = function() : void
			{
				textInputView.textInput.visible = false;
				textInputView.textInput.visible = true;
				shareButtonTriggeredHandler(null);
			}

			
			
			addChild(textInputView);
			//textInputView.text = _siteLink;
			
			
			

				
				this.closeButton.visible=false;
				
				/*shareButton = ButtonFactory.defaultButton("SHARE", 0xED3F25);
				shareButton.addEventListener(Event.TRIGGERED, shareButtonTriggeredHandler);
				addChild(shareButton);
				*/
				var scale:Number=ButtonFactory.assetManager.scaleFactor/2;
				
				shareButton = new MultilingualButton();//ButtonFactory.circleButton("a_blue_bg_button");
				shareButton.textFormat = new TextFormat(FontSelector.getFont(false), 10, 0xffffff);
				
				var buttonTexture:Texture = ButtonFactory.assetManager.getTexture("a_blue_bg_button");
				
				//var textureBlueButton:Scale3Textures=new Scale3Textures(ButtonFactory.assetManager.getTexture("a_blue_bg_button"), 25.5/scale,25.5/scale, Scale3Textures.DIRECTION_HORIZONTAL);
				var blueButtonSkin:Image = new Image(buttonTexture);
			
				
				blueButtonSkin.scale9Grid = new Rectangle( 25.5/scale, 0, 25.5/scale, buttonTexture.frameHeight)
					
				blueButtonSkin.width = 67.5;
				blueButtonSkin.height = 25.5;
				
				shareButton.defaultSkin=blueButtonSkin;
				shareButton.addEventListener(Event.TRIGGERED, shareButtonTriggeredHandler);
				shareButton.label="Save";
				shareButton.updateWithLanguage(AlertView.language);
				addChild(shareButton);
				
				
				cancelButton = new MultilingualButton();
				cancelButton.textFormat = new TextFormat(FontSelector.getFont(false), 10, 0xffffff);
				
				buttonTexture = ButtonFactory.assetManager.getTexture("a_transparent_bg_button");
				
				//var textureTransparentButton:Scale3Textures=new Scale3Textures(ButtonFactory.assetManager.getTexture("a_transparent_bg_button"), 25.5/scale,25.5/scale, Scale3Textures.DIRECTION_HORIZONTAL);
				var blueTransparentSkin:Image = new Image(buttonTexture);
				
				
				blueTransparentSkin.scale9Grid = new Rectangle( 25.5/scale, 0, 25.5/scale, buttonTexture.frameHeight)
					
				blueTransparentSkin.width = 67.5;
				blueTransparentSkin.height = 25.5;
				
				cancelButton.addEventListener(Event.TRIGGERED, cancelButtonTriggeredHandler);
				cancelButton.defaultSkin=blueTransparentSkin;
				
				cancelButton.label="Cancel";
				cancelButton.updateWithLanguage(AlertView.language);
				addChild(cancelButton);

		}
		
		protected function cancelButtonTriggeredHandler(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			dispatchEventWith(CLOSE_BUTTON_SELECTED);
		}
		
		
		public function get message() : String
		{
			
				return _siteLink;
			
		}
		
		override protected function draw() : void
		{
			super.draw();
			
			if(isInvalid(INVALIDATION_FLAG_SIZE))
			{
				

				
					this.titleLabel.y=140/2;
				
					textInputView.y = 172/2;
					textInputView.width = 469/2;
					textInputView.height = 190/2;
					
					textInputView.x = (this.actualWidth-textInputView.width)/2;
					//textInputView.height=80;
					
					
				
					
					cancelButton.x= (this.actualWidth-((87.5*2)+19))/2;
					cancelButton.width=87.5;
					cancelButton.y=422/2;
					
					
					shareButton.x =  cancelButton.x+cancelButton.width+19;
					shareButton.width = 87.5;
					shareButton.y = 422/2; 

			}
		}
		
		private function shareButtonTriggeredHandler(event : Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			dispatchEventWith(SHARE_BUTTON_SELECTED);
		}
	}
}

