package com.despark.tuning3d.view.components.votes
{
import com.despark.tuning3d.model.cars.CarBackground;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.core.Tracer;
import com.despark.tuning3d.model.tunings.Tuning;
import com.despark.tuning3d.model.votes.Vote;
import com.despark.tuning3d.view.components.core.AlertView;
import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
import com.despark.tuning3d.view.components.core.ListItemRenderer;
import com.despark.tuning3d.view.components.core.MultilingualLabel;
import com.greensock.TweenLite;
import com.utils.FontSelector;

import flash.geom.Rectangle;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;

import starling.display.Image;
import starling.display.Quad;
import starling.utils.ScaleMode;

	public class VoteItemRenderer extends ListItemRenderer
	{
		protected var nameBg:Quad;
		
		protected var overlayBg:Quad;
		
		protected var likeCountLabelBgWhite:Image;
		protected var likeCountLabelBgBlue:Image
		
		protected var circleBg:Image;
		
		protected var likeButton:Image;
		
		protected var youHaveLikedLabel:MultilingualLabel;
		
		
		protected var indexLabel:MultilingualLabel;
		protected var nameLabel:MultilingualLabel;
		protected var likeCountLabel:MultilingualLabel;
		
		
		
		
		
		
		
		public function get vote() : Vote
		{
			return data as Vote;
		}
		
		protected override function initialize() : void
		{
			
			//quad.alpha = 0.2;
			//addChild(quad);
			
			super.initialize();
			
			label.visible=false;
			
			
			nameBg = new Quad(1, 1, 0x000000); // under the name bg
			nameBg.alpha=0.4;
			addChild(nameBg);
			
		
			circleBg = new Image( AlertView.assetManager.getTexture("likeButtonBg")); // under the like button bg
			addChild(circleBg);
		
			
			
			
			indexLabel= new MultilingualLabel();
			indexLabel.textFormat = new TextFormat(FontSelector.getFont(true), 10, 0xffffff);
			indexLabel.textFormat.align = TextFormatAlign.LEFT;
			indexLabel.textFormat.bold=true;   
			
			addChild(indexLabel);
			indexLabel.updateWithLanguage(AlertView.language);  
			
			
			nameLabel= new MultilingualLabel();
			nameLabel.textFormat = new TextFormat(FontSelector.getFont(false), 10, 0xffffff);
			nameLabel.textFormat.align = TextFormatAlign.LEFT;
			nameLabel.textFormat.bold=false;   
			addChild(nameLabel);
			nameLabel.updateWithLanguage(AlertView.language);  
			
			
			
			
			overlayBg = new Quad(1, 1, 0x000000);
			overlayBg.visible=false;
			overlayBg.alpha=0.5;
			addChild(overlayBg);
			
			
			
			likeCountLabelBgWhite = new Image(AlertView.assetManager.getTexture("likeBg"));
			addChild(likeCountLabelBgWhite);
			
			
			likeCountLabelBgBlue=new Image(AlertView.assetManager.getTexture("youLikeBg"));
			addChild(likeCountLabelBgBlue);
			
			
			
			likeCountLabel= new MultilingualLabel();
			likeCountLabel.textFormat = new TextFormat(FontSelector.getFont(true), 10, 0x4f4f4f);
			likeCountLabel.textFormat.align = TextFormatAlign.LEFT;
			likeCountLabel.textFormat.bold=true;
		
			addChild(likeCountLabel);
			likeCountLabel.updateWithLanguage(AlertView.language);
			
			
			likeButton = new Image(AlertView.assetManager.getTexture("like"));
			addChild(likeButton);

			
			
			
			youHaveLikedLabel= new MultilingualLabel();
			youHaveLikedLabel.visible=false;
			youHaveLikedLabel.textFormat = new TextFormat(FontSelector.getFont(false), 10, 0xffffff);
			youHaveLikedLabel.textFormat.align = TextFormatAlign.LEFT;
			youHaveLikedLabel.textFormat.bold=false;   
			addChild(youHaveLikedLabel);
			youHaveLikedLabel.updateWithLanguage(AlertView.language);  
			
		
			imageLoader.maintainAspectRatio = false;
			imageLoader.overrideDispose = true;

			
			
		
			
			/*imageLoader.forceReload = true;
			imageLoader.scaleMode = ScaleMode.NO_BORDER;*/ /* comment by maxb */
		}
		
		protected override function draw() : void
		{
			super.draw();
			/*if (!imageLoader.clipRect){
				imageLoader.clipRect = new Rectangle(0, 0, actualWidth, actualHeight);
			}*/
			

			var selectionInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SELECTED);
			var sizeInvalid : Boolean = isInvalid(INVALIDATION_FLAG_SIZE);
			
			if (sizeInvalid)
			{
				nameBg.width=actualWidth;
				nameBg.height=20;
				nameBg.x=0;
				nameBg.y=actualHeight-nameBg.height;
				
				circleBg.width=39;
				circleBg.height=39;
				
				circleBg.x=(actualWidth-circleBg.width)/2;
				circleBg.y=(actualHeight-circleBg.height)/2;
				
				likeButton.width=18.5;
				likeButton.height=20;
				likeButton.x=(actualWidth-likeButton.width)/2;
				likeButton.y=(actualHeight-likeButton.height)/2;
					
				likeCountLabelBgWhite.width= likeCountLabelBgBlue.width = 43;
				likeCountLabelBgWhite.height= likeCountLabelBgBlue.height = 16.5;
				likeCountLabelBgWhite.x=likeCountLabelBgBlue.x = 0;
				likeCountLabelBgWhite.y=likeCountLabelBgBlue.y=8.5;
				
				likeCountLabel.x=5;
				likeCountLabel.y=10;
				
				overlayBg.width=actualWidth;
				overlayBg.height=actualHeight;
				overlayBg.x=0;
				overlayBg.y=0;
				
				youHaveLikedLabel.text=AlertView.language.translate("voting", "havealike");//"You have Liked this car";
				
				youHaveLikedLabel.width=actualWidth-5-10-4-5;
				youHaveLikedLabel.height=NaN;
				youHaveLikedLabel.validate();
				
				youHaveLikedLabel.x=5+10+4;
				youHaveLikedLabel.y=(actualHeight-24-youHaveLikedLabel.height);
			}
            updateItemsViibility();

			//quad.width = actualWidth;
			//quad.height = actualHeight;
		}

		private function updateItemsViibility() : void
		{
            var dataInvalid : Boolean = isInvalid(INVALIDATION_FLAG_DATA);
			
			if(!vote) return;
			
			
			imageLoader.completeHandler=completeLoadImage
			imageLoader.recieveImageSize2=recieveImageSize2;
			var carBackground:CarBackground = new CarBackground();
			carBackground.mainUrl =  vote.image;
			carBackground.isLocalFile = true;
			carBackground.showThumbnailUrl = false;

			if(imageLoader.persistentImageProvider && imageLoader.persistentImageProvider.remoteUrl!=vote.image){
				imageLoader.alpha=0;
				imageLoader.persistentImageProvider = carBackground;
			}else if(!imageLoader.persistentImageProvider){
				imageLoader.alpha=0;
				imageLoader.persistentImageProvider = carBackground;
			}
			
           

            if (dataInvalid)
			{
                indexLabel.text = "#" + vote.order;
                indexLabel.validate();
                indexLabel.x = 5;
                indexLabel.y = (actualHeight - nameBg.height) + ((20 - indexLabel.height) / 2);

                nameLabel.text = vote.make + " " + vote.model;
                nameLabel.height = NaN;
                nameLabel.width = actualWidth - indexLabel.x - indexLabel.width - 4 - 5;
                nameLabel.validate();
                nameLabel.x = indexLabel.x + indexLabel.width + 4;
                nameLabel.y = (actualHeight - nameBg.height) + ((20 - nameLabel.height) / 2);
				nameLabel.visible = true;
				
				if(Device.isIphoneXVariant()){
					indexLabel.x = (actualWidth - (indexLabel.width+4+nameLabel.width))/2;
					nameLabel.x = indexLabel.x + indexLabel.width + 4;
				}

                likeCountLabel.text = "+" + vote.voting;
				likeCountLabel.visible = true;
                likeCountLabel.validate();

                if (!vote.showVotingCount) {
                    likeCountLabel.textFormat.color = 0x4f4f4f;
                    likeCountLabel.updateWithLanguage(AlertView.language);

                    likeButton.width = 18.5;
                    likeButton.height = 20;
                    likeButton.x = (actualWidth - likeButton.width) / 2;
                    likeButton.y = (actualHeight - likeButton.height) / 2;

                    youHaveLikedLabel.visible = false;
                    likeCountLabelBgWhite.visible = false;
                    circleBg.visible = false;
                    overlayBg.visible = false;
                    likeCountLabelBgBlue.visible = false;
                    likeButton.visible = false;
                    likeCountLabel.visible = false;
                    circleBg.visible = false;
                    this.touchable = false;

                } else if (vote.youHaveLiked) {

                    likeCountLabel.textFormat.color = 0xffffff;
                    likeCountLabel.updateWithLanguage(AlertView.language);

                    likeButton.width = 10;
                    likeButton.height = likeButton.width * 1.08;
					likeButton.visible = false;
                    likeButton.x = 5;
                    likeButton.y = (actualHeight - 25 - likeButton.height);

                    youHaveLikedLabel.visible = true;
                    circleBg.visible = false;
                    overlayBg.visible = true;
                    likeCountLabelBgWhite.visible = false;
                    likeCountLabelBgBlue.visible = true;
                    this.touchable = true;

                } else {
                    likeCountLabel.textFormat.color = 0x4f4f4f;
                    likeCountLabel.updateWithLanguage(AlertView.language);

                    likeButton.width = 18.5;
                    likeButton.height = 20;
                    likeButton.x = (actualWidth - likeButton.width) / 2;
                    likeButton.y = (actualHeight - likeButton.height) / 2;

                    youHaveLikedLabel.visible = false;
                    likeCountLabelBgWhite.visible = true;
                    circleBg.visible = true;
                    overlayBg.visible = false;
                    likeCountLabelBgBlue.visible = false;
					likeButton.visible = true;
					this.touchable = true;
                }
            }
		}
		
		protected override function commitData() : void
		{
			super.commitData();
            this.updateItemsViibility();

			if(data && data is Vote) {
				var voteData:Vote = data as Vote;
				if (voteData.image.indexOf("http://") == -1) {
					voteData.image = "http:" + voteData.image;
				}
			}
			//vote.make+" "+vote.model;
		}
		
		protected function recieveImageSize2(w:Number, h:Number, image:ImageLoaderWithStates):void{

			image.invalidate(INVALIDATION_FLAG_SIZE);
			/*var thumb_width:Number=actualWidth;
			var thumb_height:Number=actualHeight;
			
			var wI:Number=image.image.width;
			var hI:Number=image.image.height;
				
		
			
			var original_aspect:Number=wI/hI;
			var thumb_aspect:Number=thumb_width/thumb_height;
			
			var new_height:Number;
			var new_width:Number;
			
			if ( original_aspect >= thumb_aspect )
			{
				// If image is wider than thumbnail (in aspect ratio sense)
				new_height = thumb_height;
				new_width = wI / (hI / thumb_height);
			}
			else
			{
				// If the thumbnail is wider than the image
				new_width = thumb_width;
				new_height = wI / (hI / thumb_width);
			}
			
			image.image.x=0-(new_width-thumb_width)/2;

			image.image.y=0-(new_height-thumb_height)/2;

			image.image.width=new_width;

			image.image.height=new_height;
			image.validate();

			Tracer.print(new_width +" : " +  new_height);
			//$thumb = imagecreatetruecolor( $thumb_width, $thumb_height );*/
		}
		
		protected function completeLoadImage(img:ImageLoaderWithStates):void{
			imageLoader.color = 0xFF0000;
			TweenLite.to(imageLoader, 0.5, {alpha:1});
		}

		override public function dispose():void{
			super.dispose();
			if(imageLoader){
				imageLoader.sepcialDispose();
				imageLoader.removeFromParent(true);
				imageLoader = null;
			}

			if(nameBg){
				nameBg.removeFromParent(true);
				nameBg = null;
			}

			if(overlayBg){
				overlayBg.removeFromParent(true);
				overlayBg = null;
			}

			if(likeCountLabelBgWhite){
				likeCountLabelBgWhite.removeFromParent(true);
				likeCountLabelBgWhite = null;
			}

			if(likeCountLabelBgBlue){
				likeCountLabelBgBlue.removeFromParent(true);
				likeCountLabelBgBlue = null;
			}

			if(circleBg){
				circleBg.removeFromParent(true);
				circleBg = null;
			}

			if(likeButton){
				likeButton.removeFromParent(true);
				likeButton = null;
			}

			if(youHaveLikedLabel){
				youHaveLikedLabel.removeFromParent(true);
				youHaveLikedLabel = null;
			}

			if(indexLabel){
				indexLabel.removeFromParent(true);
				indexLabel = null;
			}

			if(nameLabel){
				nameLabel.removeFromParent(true);
				nameLabel = null;
			}

			if(likeCountLabel){
				likeCountLabel.removeFromParent(true);
				likeCountLabel = null;
			}
		}
	}
}