package com.despark.tuning3d.view.components.votes
{
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.Device;
	import com.despark.tuning3d.model.core.Tracer;
	import com.despark.tuning3d.model.core.UIColors;
	import com.despark.tuning3d.model.core.UIStrings;
	import com.despark.tuning3d.model.languages.Language;
	import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.model.votes.Vote;
	import com.despark.tuning3d.view.components.core.AlertView;
	import com.despark.tuning3d.view.components.core.BannerStackedScreen;
	import com.despark.tuning3d.view.components.core.BannerStackedScreen;
	import com.despark.tuning3d.view.components.core.ButtonFactory;
	import com.despark.tuning3d.view.components.core.IMainMenuHolder;
	import com.despark.tuning3d.view.components.core.MainMenuView;
	import com.despark.tuning3d.view.components.core.MultilingualLabel;
	import com.despark.tuning3d.view.components.core.StackedScreen;
	import com.despark.tuning3d.view.components.gallery.GalleryLabelFactory;
	import com.despark.tuning3d.view.components.gallery.GalleryScreen;
	import com.despark.tuning3d.view.components.gallery.GalleryScreen;
	import com.despark.tuning3d.view.components.gallery.GalleryScreen;
	import com.despark.tuning3d.view.components.gallery.GalleryScreen;
	import com.despark.tuning3d.view.components.gallery.SearchInput;
	import com.despark.tuning3d.view.components.gallery.data.RequestSort;
	import com.utils.FontSelector;
	import com.utils.Tracker;

	import feathers.controls.Button;
	import feathers.controls.Label;
	import feathers.controls.LayoutGroup;
	import feathers.controls.List;
	import feathers.controls.PageIndicator;
	import feathers.controls.Radio;
	import feathers.controls.ScrollBarDisplayMode;
	import feathers.controls.ScrollPolicy;
	import feathers.controls.ToggleButton;
	import feathers.controls.ToggleButton;
	import feathers.controls.renderers.IListItemRenderer;
	import feathers.core.FeathersControl;
	import feathers.core.ToggleGroup;
	import feathers.data.ListCollection;
	import feathers.layout.Direction;
	import feathers.layout.HorizontalAlign;
	import feathers.layout.HorizontalLayout;
	import feathers.layout.TiledRowsLayout;
	import feathers.layout.VerticalAlign;

	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;

	import starling.core.Starling;
	import starling.display.DisplayObject;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.utils.Color;

	public class VotesListScreen extends StackedScreen implements Multilingual, IMainMenuHolder
	{
		
		
		
		private static var k:int = 0;

		public static const CHANGE_SEARCH_TEXT:String ="CHANGE_SEARCH_TEXT";
		public static const VOTE_TYPE_CHANGE:String ="VOTE_TYPE_CHANGE";
		public static const VOTE_ITEM_LIKED:String ="voteItemLiked";
		public var _mainMenuView : MainMenuView;
		
		private var menuButton:Button;
		private var backgroundQuad : Quad;
		private var bannerBackground : Image;
		private var topBarHeight : int;
		private var tuningCountLabel : Label;
		private var availableLabel : Label;
		private var countGroup:LayoutGroup;

		private var votesList : List;
		private var votesListCollection : ListCollection;
		private var pages:PageIndicator;
		private var pagesLabel:MultilingualLabel;
		private var screenTitleLabel:Label;
		
		private var searchView:SearchInput;
		private var _noResultLabel:Label;

		public var userSignedIn:Boolean;
		private var _selectedLanguage:Language
		private var _languages:Array;
		private static const TOOLBAR_SIZE:int = 31;
		// Sorting buttons
		private var typeSortGroup:ToggleGroup;
		private var typeSortLayout:LayoutGroup;
		private var _votingType:String;
		private var _queryText:String;

		// Sort bay components
		private var sortByToggleGroup:ToggleGroup;
		private var sortByLayout:LayoutGroup;
		private var sortByBorderList:Array;
		private var _sortBy:String;
		private var _sortByOrder:String;
		public static const ASC:String = "asc";
		public static const DESC:String = "desc";
		//
		private var _onComplete:Function;
		public function VotesListScreen() {
			super("VotesListScreen");
			k++;
		}

		override protected function screen_removedFromStageHandler(event:Event):void{
			super.screen_removedFromStageHandler(event);
			BannerStackedScreen.hideAdBanner(true);
		}
		
		public function set languages(value:Array):void{
			
			_languages=value;
		}
		
		
		public function get languages():Array{
			return _languages;
		}
		


		override public function dispose():void{
			if(menuButton){
				menuButton.removeFromParent(true);
				menuButton = null;
			}
			if(backgroundQuad){
				backgroundQuad.removeFromParent(true);
				backgroundQuad = null;
			}
			if(bannerBackground){
				bannerBackground.removeFromParent(true);
				bannerBackground = null;
			}
			if(tuningCountLabel){
				tuningCountLabel.removeFromParent(true);
				tuningCountLabel = null;
			}
			if(availableLabel){
				availableLabel.removeFromParent(true);
				availableLabel = null;
			}
			if(countGroup){
				countGroup.removeFromParent(true);
				countGroup = null;
			}
			if(votesList){
				votesList.removeFromParent(true);
				votesList = null;
			}
			if(pages){
				pages.removeFromParent(true);
				pages = null;
			}
			if(pagesLabel){
				pagesLabel.removeFromParent(true);
				pagesLabel = null;
			}
			if(screenTitleLabel){
				screenTitleLabel.removeFromParent(true);
				screenTitleLabel = null;
			}
			if(searchView){
				searchView.removeFromParent(true);
				searchView = null;
			}
			if(_noResultLabel){
				_noResultLabel.removeFromParent(true);
				_noResultLabel = null;
			}
			if(typeSortGroup){
				typeSortGroup.removeAllItems();
				typeSortGroup.removeEventListeners();
				typeSortGroup = null;
			}
			if(typeSortLayout){
				typeSortLayout.removeFromParent(true);
				typeSortLayout = null;
			}
			if(sortByToggleGroup){
				sortByToggleGroup.removeAllItems();
				sortByToggleGroup.removeEventListeners();
				sortByToggleGroup = null;
			}
			if(sortByLayout){
				sortByLayout.removeFromParent(true);
				sortByLayout = null;
			}
			votesListCollection = null;
			super.dispose();
		}
		
		private var _topButtonPadding:Number=0;

        public function get topButtonPadding():Number {
            return _topButtonPadding;
        }

		
		public function updateWithLanguage(language : Language) : void {
			if(availableLabel){
				availableLabel.text = "Models";//language.translate( "voting", "modelavailable");
			}
			if(votesList && votesList.dataProvider){
				if(tuningCountLabel){
					tuningCountLabel.text = votesList.dataProvider.length.toString();
				}
			}else{
				tuningCountLabel.text ="0";
			}
			if (mainMenuView){
				mainMenuView.updateWithLanguage(language); 
			}
		}

		override protected function initialize() : void {
			super.initialize();
			_sortBy = RequestSort.LIKE;
			_sortByOrder = DESC;

			topBarHeight = BannerStackedScreen.BANNER_SIZE + TOOLBAR_SIZE;
			backgroundQuad = new Quad(1, 1, Color.rgb(255, 255, 255));
			addChild(backgroundQuad);

			bannerBackground = new Image(Texture.fromColor(1,1, UIColors.BANNER_BACKGROUND_COLOR));
			bannerBackground.x = bannerBackground.y = 0;
			addChild(bannerBackground);

			screenTitleLabel = new Label();
			screenTitleLabel.textRendererFactory = GalleryLabelFactory.screenTitle;
			screenTitleLabel.text = "SCHEDULE";
			screenTitleLabel.validate();
			screenTitleLabel.paddingBottom = 3;
			addChild(screenTitleLabel);

			countGroup = new LayoutGroup();
			var countLayout:HorizontalLayout = new HorizontalLayout();
			countLayout.verticalAlign = VerticalAlign.MIDDLE;
			countLayout.gap = 3;
			countGroup.layout = countLayout;

			tuningCountLabel = new Label();
			tuningCountLabel.height = 14;
			tuningCountLabel.textRendererFactory = GalleryLabelFactory.tuningCountLabel;
			countGroup.addChild(tuningCountLabel);

			availableLabel = new Label();
			availableLabel.height = 14;
			availableLabel.textRendererFactory = GalleryLabelFactory.availableCountLabel;
			countGroup.addChild(availableLabel);

			addChild(countGroup);
			
			
			pagesLabel = new MultilingualLabel();
			pagesLabel.textFormat = new TextFormat( FontSelector.getMontserratMedium(), 11, UIColors.UI_COMPONENT_GRAY );
			pagesLabel.textFormat.align = TextFormatAlign.CENTER;
			pagesLabel.height = 12;
			addChild(pagesLabel);

			createSortBySection();
			
			
			searchView = new SearchInput();
			searchView.addEventListener(Event.CHANGE, onSearchTextChange);
			addChild(searchView);

			_noResultLabel = new Label();
			_noResultLabel.textRendererFactory = GalleryLabelFactory.sortByTitleLabel;
			_noResultLabel.text = UIStrings.NO_RESULT_LABEL;

			addChild(_noResultLabel);
			_noResultLabel.visible = false;
			
			
			pages = new PageIndicator();
			pages.visible=false;
			pages.normalSymbolFactory = function():DisplayObject {
				var img:Image=new Image(  AlertView.assetManager.getTexture("pageIndicator") );
				img.width=10;
				img.height=10;
				return img;
			};
			
			pages.selectedSymbolFactory = function():DisplayObject {
				var img:Image=new Image(  AlertView.assetManager.getTexture("pageIndicatorSelected") );
				img.width=10;
				img.height=10;
				return img;
			};
			
			pages.gap=6;
			
			pages.horizontalAlign=HorizontalAlign.CENTER;
			pages.verticalAlign=VerticalAlign.MIDDLE;
			
			pages.selectedIndex=0;
			pages.pageCount = 5;
			menuButton = ButtonFactory.menuBigButton("a_back_button", 0x23405e);

			menuButton.width = 35;
			menuButton.height = 35;

		
			menuButton.addEventListener(Event.TRIGGERED, mainMenuButtonHandler);
			addChild(menuButton);
			
			initializeVotesList();

			var bgColor:uint = 0xFFFFFF;
			typeSortGroup = new ToggleGroup();
			typeSortGroup.isSelectionRequired = true;

			var allCarsBtn:Radio = ButtonFactory.scheduleRadioButton(95, TOOLBAR_SIZE - 10, UIColors.UI_COMPONENT_GRAY, bgColor);
			allCarsBtn.label = "All Cars";
			allCarsBtn.name = "all_cars";
			typeSortGroup.addItem(allCarsBtn);

			var americanTruckBtn:Radio = ButtonFactory.scheduleRadioButton(100, TOOLBAR_SIZE - 10, UIColors.UI_COMPONENT_GRAY, bgColor);
			americanTruckBtn.label = "USA Truck";
			americanTruckBtn.name = "american_truck";
			typeSortGroup.addItem(americanTruckBtn);

			var americanMuscleBtn:Radio = ButtonFactory.scheduleRadioButton(100, TOOLBAR_SIZE - 10, UIColors.UI_COMPONENT_GRAY, bgColor);
			americanMuscleBtn.label = "USA Muscle";
			americanMuscleBtn.name = "american_muscle";
			typeSortGroup.addItem(americanMuscleBtn);

			typeSortGroup.selectedItem = americanTruckBtn;
			_votingType = typeSortGroup.selectedItem.name;
			_queryText = "";

			typeSortGroup.addEventListener(Event.CHANGE, typeSortChangeHandler);
			//
			typeSortLayout = new LayoutGroup();
			var hLayout:HorizontalLayout = new HorizontalLayout();
			typeSortLayout.layout = hLayout;
			typeSortLayout.addChild(americanTruckBtn);
			typeSortLayout.addChild(americanMuscleBtn);
			typeSortLayout.addChild(allCarsBtn);
			addChild(typeSortLayout);

		}

		private function createSortBySection():void{
			var border:Quad;
			sortByBorderList = [];
			sortByLayout = new LayoutGroup();
			var hLayout:HorizontalLayout = new HorizontalLayout();
			hLayout.horizontalAlign = HorizontalAlign.RIGHT;
			hLayout.verticalAlign = VerticalAlign.MIDDLE;
			hLayout.gap = 0;
			hLayout.paddingTop = 3;
			sortByLayout.layout = hLayout;

			border = GalleryScreen.createBorder();
			sortByBorderList.push(border);
			border.height = 20;
			sortByLayout.addChild(border);

			var viewLabel:Label = new Label();
			viewLabel.textRendererFactory = GalleryLabelFactory.sortByTitleLabel;
			viewLabel.paddingLeft = 10;
			viewLabel.paddingRight = 5;
			viewLabel.paddingBottom = 3;
			viewLabel.text = "Sort by";

			sortByLayout.addChild(viewLabel);
			sortByToggleGroup = new ToggleGroup();

			var toggleButton:ToggleButton;

			toggleButton = GalleryScreen.createSortByButton("gallery_like", RequestSort.LIKE, 0, true, UIColors.UI_COMPONENT_GRAY, true, 40);
			toggleButton.addEventListener(Event.TRIGGERED, sortButtonTriggeredHandler);
			sortByToggleGroup.addItem(toggleButton);
			sortByLayout.addChild(toggleButton);
			border = GalleryScreen.createBorder();
			sortByBorderList.push(border);
			border.height = 20;
			sortByLayout.addChild(border);
			if(_sortBy == RequestSort.LIKE){
				toggleButton.isSelected = true;
				GalleryScreen.setOrderIconColor(toggleButton);
			}

			toggleButton = GalleryScreen.createSortByButton("gallery_alphabet", RequestSort.AZ, 0, true, UIColors.UI_COMPONENT_GRAY, true, 40);
			toggleButton.addEventListener(Event.TRIGGERED, sortButtonTriggeredHandler);
			sortByToggleGroup.addItem(toggleButton);
			sortByLayout.addChild(toggleButton);
			border = GalleryScreen.createBorder();
			sortByBorderList.push(border);
			border.height = toggleButton.defaultSkin.height;
			sortByLayout.addChild(border);
			if(_sortBy == RequestSort.AZ){
				toggleButton.isSelected = true;
				GalleryScreen.setOrderIconColor(toggleButton);
			}
			sortByToggleGroup.addEventListener(Event.CHANGE, sortByGroupChangeHandler);
			addChild(sortByLayout);
		}

		private function sortButtonTriggeredHandler(event:Event):void {
			if(ToggleButton(event.currentTarget).isSelected) {
				GalleryScreen.setOrderIconDirection(ToggleButton(event.currentTarget));
				_sortByOrder = GalleryScreen.getOrderIconDirection(sortByToggleGroup.selectedItem as ToggleButton)?DESC:ASC;
				typeSortChangeHandler(null);
			}
		}

		private function sortByGroupChangeHandler(event:Event):void {
			if(sortByToggleGroup.selectedItem) {
				SoundManager.playSound(SoundManager.SELECT_PART);
				_sortByOrder = GalleryScreen.getOrderIconDirection(sortByToggleGroup.selectedItem as ToggleButton)?DESC:ASC;
				_sortBy = sortByToggleGroup.selectedItem.name;
			}
			for(var i:int = 0; i < sortByToggleGroup.numItems; i++){
				GalleryScreen.setOrderIconColor(sortByToggleGroup.getItemAt(i) as ToggleButton);
			}
			updateSortByBorders();
			typeSortChangeHandler(null);
		}

		private function updateSortByBorders():void{
			var nextIndex:int = sortByToggleGroup.selectedIndex + 1;
			if(sortByBorderList && sortByToggleGroup){
				for(var i:int = 1; i < sortByBorderList.length; i++){
					if(i == sortByToggleGroup.selectedIndex || i == nextIndex){
						sortByBorderList[i].alpha = 0;
					}else{
						sortByBorderList[i].alpha = 1;
					}
				}
			}
		}

		private function typeSortChangeHandler(event:Event):void{
			SoundManager.playSound(SoundManager.SELECT_PART);
			if(stage && typeSortGroup && typeSortGroup.selectedItem && sortByToggleGroup && sortByToggleGroup.selectedItem){
				_votingType = typeSortGroup.selectedItem.name;
				_sortBy = sortByToggleGroup.selectedItem.name;
				dispatchEvent(new Event(VOTE_TYPE_CHANGE, false, {votingType: votingType, sortBy: sortBy}));
			}
		}
		
		private function mainMenuButtonHandler(event:Event):void{
			homeButtonTriggeredHandler();
		}
		
		
		public function dispatchExternalEvent(msg:String):void
		{
			if (mainMenuView) {
				mainMenuView.hide(); 
			}
			
			dispatchEventWith(msg);
		}
		
		protected function onSearchTextChange(event:Event):void{
			Starling.juggler.removeDelayedCalls(requestSearch);
			Starling.juggler.delayCall(requestSearch, 0.5);
		}

		private function requestSearch():void{
			_queryText = searchView.text||"";
			dispatchEventWith(CHANGE_SEARCH_TEXT, false, {text: _queryText});
		}

		   
		private function initializeVotesList() : void {
		   	var layout : TiledRowsLayout = new TiledRowsLayout();
			layout.paging = Direction.HORIZONTAL;
			layout.useSquareTiles = false;
			layout.gap = 0;
			layout.horizontalAlign = HorizontalAlign.CENTER;
			layout.verticalAlign = VerticalAlign.MIDDLE;
			votesListCollection = new ListCollection();
						
			votesList = new List();
			votesList.minimumPageThrowVelocity=2;//special=true;
			votesList.dataProvider = votesListCollection;
			votesList.layout = layout;
			votesList.snapToPages = true;
			votesList.scrollBarDisplayMode = ScrollBarDisplayMode.NONE;
			votesList.horizontalScrollPolicy = ScrollPolicy.ON;
			votesList.addEventListener(Event.SCROLL, tuningsListScrollHandler);
			votesList.addEventListener(Event.CHANGE, tuningsListChangeHandler);
			votesList.itemRendererFactory =  votesItemRenderer;

			addChildAt(votesList, 1);
		}

		private function votesItemRenderer() : IListItemRenderer
		{
            var renderer : VoteItemRenderer = new VoteItemRenderer();
            var imageWidth:Number=actualWidth/3;
            var imageHeight:Number=actualHeight * 0.42 - topButtonPadding/2;
            if(Constants.aspectRatio < 1.5) // for squared devices there should be 3 rows
            {
                imageHeight *= 2/3;
            }

            if(Constants.aspectRatio < 1.5) {
                imageHeight = (actualHeight - topBarHeight) / 3;
            }else{
				imageHeight = (actualHeight - topBarHeight) / 2;
			}
            renderer.setSize(imageWidth, imageHeight);

            return renderer;
		}
		
		public function get loadedVotesCount() : int
		{
			if(!votesList || !votesList.dataProvider) return 0;
			return votesList.dataProvider.length;
		}
		
		public function get pagesCount() : int
		{
			return votesList.horizontalPageCount;
		}
		
		public function get selectedVote() :Vote
		{
			return votesList.selectedItem as Vote;
		}
		
		public function get selectedIndex() : int 
		{
			return votesList.selectedIndex;
		}
		
		/*public function get addedTunings() : ListCollection 
		{
			return tuningsListCollection;
		}*/
		
		public function set votes(value:Array):void {
			if(votesList ) {
				votesList.dataProvider = new ListCollection(value);
				votesList.validate();

				if (tuningCountLabel) {
					tuningCountLabel.text = value.length.toString()
                }
				setTitleLabelPosition();
				
				if(pages){
					pages.pageCount=votesList.horizontalPageCount;
					pages.selectedIndex=votesList.horizontalPageIndex;
					pages.x = (actualWidth-pages.width)/2;
					pagesLabel.text = (votesList.horizontalPageIndex+1)+"/"+votesList.horizontalPageCount;
					pagesLabel.updateWithLanguage(AlertView.language);
					pagesLabel.validate();
					setPageLabelPosition();
					
				}
				if(_onComplete != null){
					_onComplete();
					_onComplete = null;
				}
			} 
		}
		
		private function addElement(item:*,index:int=-1) : void
		{
			for (var i:int = 0; i < numChildren; i++) {
				if (getChildAt(i).name == item.name) return;
			}; index == -1 ? addChild(item) : addChildAt(item,index);
		}
		
		override protected function draw() : void {
			super.draw();
			
			var sizeInvalid : Boolean = isInvalid(FeathersControl.INVALIDATION_FLAG_SIZE);
			
			
			if (!mainMenuView){
				mainMenuView = new MainMenuView();
				mainMenuView.name = "mainMenuView";
				mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight);
				mainMenuView.parentActualWidth = actualWidth;
				mainMenuView.parentActualHeight = actualHeight;
				addElement(mainMenuView,this.numChildren-1);

				mainMenuView.addEventListener(MainMenuView.START_SHOW, menuOpenHandler);
				mainMenuView.addEventListener(Event.CLOSE, menuCloseHandler);
			}
			
			if(sizeInvalid) {
				if(bannerBackground){
					bannerBackground.width = actualWidth;
					bannerBackground.height = BannerStackedScreen.BANNER_SIZE;
				}

				backgroundQuad.width = actualWidth;
				backgroundQuad.height = actualHeight;
				var rowNum:int = 2;
				if(Constants.aspectRatio < 1.5) {
					rowNum = 3;
				}

				votesList.x = 0;
				votesList.y = topBarHeight;
				votesList.width = actualWidth;
				votesList.height = actualHeight - topBarHeight;


				menuButton.x = menuButton.y = (BannerStackedScreen.BANNER_SIZE - menuButton.height) / 2;
				if(Device.isIphoneXVariant()){
					menuButton.x += 6;
					searchView.x -= 6;
				}

				if(screenTitleLabel){
					screenTitleLabel.validate();
					screenTitleLabel.width = 150;
					screenTitleLabel.x = menuButton.x + menuButton.width + 9;
					screenTitleLabel.y = (BannerStackedScreen.BANNER_SIZE - screenTitleLabel.height) / 2;
				}

				
				typeSortLayout.y = BannerStackedScreen.BANNER_SIZE + (TOOLBAR_SIZE - typeSortLayout.height) / 2;

				setSearchLabelPosition();

				setTitleLabelPosition();
				
				
				
				
				pages.x = (actualWidth-pages.width)/2;
                pages.y = (BannerStackedScreen.BANNER_SIZE - pages.height) / 2;
				
				
				pages.pageCount = votesList.horizontalPageCount;
				pages.selectedIndex = votesList.horizontalPageIndex;
				
				
				pagesLabel.text=(votesList.horizontalPageIndex+1)+"/"+votesList.horizontalPageCount;
				
				pagesLabel.updateWithLanguage(AlertView.language);
				pagesLabel.width=NaN;
				pagesLabel.height=13;
				pagesLabel.validate();

				setPageLabelPosition();

				typeSortLayout.x = 0;

				if (mainMenuView){
					mainMenuView.y =topButtonPadding;
					mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight -topButtonPadding);
					mainMenuView.parentActualWidth = actualWidth;
					mainMenuView.parentActualHeight = actualHeight - topButtonPadding;
				}

				if(sortByLayout){
					sortByLayout.x = actualWidth / 2;
					sortByLayout.y = BannerStackedScreen.BANNER_SIZE + (BannerStackedScreen.TOOLBAR_SIZE - (sortByLayout.height + HorizontalLayout(sortByLayout.layout).padding)) / 2;
				}
			}
			
			if(this.isInvalid("ads") ){
				menuButton.y=topButtonPadding+6;
				/*if(Device.isIphoneXVariant()){
					menuButton.y+=6;	
				}*/

				setTitleLabelPosition();
				setSearchLabelPosition();
				setPageLabelPosition();

                pages.y = (BannerStackedScreen.BANNER_SIZE - pages.height) / 2;
                votesList.itemRendererFactory = votesItemRenderer;
				if (mainMenuView){
					mainMenuView.y =topButtonPadding;
					mainMenuView.setSize(MainMenuView.MENU_WIDTH, actualHeight - topButtonPadding);
					mainMenuView.parentActualWidth = actualWidth;
					mainMenuView.parentActualHeight = actualHeight -topButtonPadding;
				}
				
				
			}
		}

		override public function ShowDone():void {
			Tracker.trackEvent("Car Schedule Screen", "open");
		}

		override public function transitionComplete():void{
			BannerStackedScreen.showAdBanner();
		}

		private function menuOpenHandler(event:Event):void {
			BannerStackedScreen.hideAdBanner(false);
		}

		private function menuCloseHandler(event:Event):void {
			BannerStackedScreen.showAdBanner();
		}

		private function setPageLabelPosition():void{
			pagesLabel.x = searchView.x - (pagesLabel.width + 10);
			pagesLabel.y = BannerStackedScreen.BANNER_SIZE + (TOOLBAR_SIZE - pagesLabel.height) / 2;
		}

		private function setTitleLabelPosition():void{
			tuningCountLabel.width = NaN;
			tuningCountLabel.validate();

			countGroup.validate();
			countGroup.x = actualWidth - (countGroup.width + 10);
			countGroup.y = (BannerStackedScreen.BANNER_SIZE - countGroup.height) / 2 - 2;
		}

		private function setSearchLabelPosition():void{
			searchView.x = actualWidth - searchView.width - 10;
			searchView.y = BannerStackedScreen.BANNER_SIZE + (TOOLBAR_SIZE - searchView.height) / 2;
			if(Device.isIphoneXVariant()){
				searchView.x -= 6;
			}
		}


        public function homeButtonTriggeredHandler(event:Event = null):void {
            dispatchEventWith(StackedScreen.HOME_SELECTED);
        }

        public function brandsScreenButtonTriggeredHandler(event : Event=null) : void
		{
			dispatchEventWith(StackedScreen.BRANDS_SELECTED);
		}
		
		private function tuningsListScrollHandler(event : Event) : void {
			
			pages.selectedIndex=votesList.horizontalPageIndex;
			
			pagesLabel.text=(votesList.horizontalPageIndex+1)+"/"+votesList.horizontalPageCount;
			
			pagesLabel.updateWithLanguage(AlertView.language);
			pagesLabel.width=NaN;
			pagesLabel.height=13;
			pagesLabel.validate();

			setPageLabelPosition();
		}
		
		private function tuningsListChangeHandler(event : Event) : void {
			if(votesList.selectedIndex < 0)
					return;


        	if(!(votesList.dataProvider.getItemAt(votesList.selectedIndex) as Vote).showVotingCount) {
                votesList.dataProvider.updateItemAt(votesList.selectedIndex)
				votesList.selectedIndex = -1;
				return;
			}
			if(votesList.selectedIndex >= 0 ) {
				if(!(votesList.dataProvider.getItemAt(votesList.selectedIndex) as Vote).youHaveLiked){
					SoundManager.playSound(SoundManager.SELECT_PART);
					(votesList.dataProvider.getItemAt(votesList.selectedIndex) as Vote).youHaveLiked=true;
					(votesList.dataProvider.getItemAt(votesList.selectedIndex) as Vote).voting++;
				}else{
					SoundManager.playSound(SoundManager.SELECT_PART_BACK);
					(votesList.dataProvider.getItemAt(votesList.selectedIndex) as Vote).youHaveLiked=false;
					(votesList.dataProvider.getItemAt(votesList.selectedIndex) as Vote).voting--;
				}
				votesList.dataProvider.updateItemAt(votesList.selectedIndex);
				dispatchEventWith(VotesListScreen.VOTE_ITEM_LIKED);
				votesList.selectedIndex = -1;
			}
		}

        public  function get selectedLanguage() : Language
		{
			return this._selectedLanguage;
		}
        public function set selectedLanguage(value : Language) : void
		{
			this._selectedLanguage = value;
		}

		public function set mainMenuView(value : MainMenuView): void
		{
			this._mainMenuView = value;
			this._mainMenuView.owner = this;
		}

		public function get mainMenuView() : MainMenuView
		{
			return this._mainMenuView;
		}

		public function enterRowsState() : void
		{
			Tracer.print("Vote list doesn't have row state");
		}

		public function unselectSelectedTunning() : void
		{
			votesList.selectedIndex = -1;
		}

		public function get votingType():String {
			return _votingType;
		}

		public function get queryText():String {
			return _queryText;
		}

		public function get sortBy():String {
			return _sortBy;
		}

		public function get sortByOrder():String {
			return _sortByOrder;
		}

		public function set onComplete(onComplete:Function):void {
			_onComplete = onComplete;
		}
	}
}