package com.despark.tuning3d.view.core
{
	import com.despark.tuning3d.Notifications;
	import com.despark.tuning3d.model.assets.AssetsProxy;
	import com.despark.tuning3d.view.DownloadsPopUpMediator;
	import com.despark.tuning3d.view.NewsPopUpMediator;
	import com.despark.tuning3d.view.RewardConfirmPopUpMediator;
	import com.despark.tuning3d.view.RewardInfoPopUpMediator;
	import com.despark.tuning3d.view.RewardNoAdsPopUpMediator;
	import com.despark.tuning3d.view.RewardNoCoinPopUpMediator;
	import com.despark.tuning3d.view.TuningSharingPopUpMediator;
	import com.despark.tuning3d.view.TunningNameInputPopUpMediator;
	import com.despark.tuning3d.view.UserLevelInfoPopupMediator;
	import com.despark.tuning3d.view.components.core.PopUp;

	import org.puremvc.as3.interfaces.INotification;

	import starling.events.Event;

	public class PopUpMediator extends ExtendedMediator
	{
		private var downloadsPopUpMediator : DownloadsPopUpMediator;
		private var tunningNameInputPopUpMediator : TunningNameInputPopUpMediator;
		private var sharingPopUpMediator : TuningSharingPopUpMediator;
		private var rewardInfoPopUpMediator: RewardInfoPopUpMediator;

        private var rewardConfirmPopUpMediator: RewardConfirmPopUpMediator;
        private var rewardNoAdsPopUpMediator: RewardNoAdsPopUpMediator;
        private var rewardNoCoinPopUpMediator: RewardNoCoinPopUpMediator;
		private var newsPopupMediator:NewsPopUpMediator;
		private var userLevelInfoPopupMediator:UserLevelInfoPopupMediator;

		public function PopUpMediator(popUp : PopUp) {
			super(popUp.popUpName, popUp);
			
			var assetsProxy : AssetsProxy = facade.retrieveProxy(AssetsProxy.NAME) as AssetsProxy;
			popUp.assetManager = assetsProxy.assetManager;

		}
		
		protected function get popUp() : PopUp {
			return viewComponent as PopUp;
		}
		
		override public function onRegister() : void {
			super.onRegister();
			
			popUp.addEventListener(PopUp.CLOSE_BUTTON_SELECTED, popUpCloseButtonSelectedHandler);
			
			
		}
		
		override public function onRemove() : void {
			super.onRemove();
			
			popUp.removeEventListener(PopUp.CLOSE_BUTTON_SELECTED, popUpCloseButtonSelectedHandler);
		}
		
		protected function popUpCloseButtonSelectedHandler(event : Event) : void {
			sendNotification(Notifications.REMOVE_POP_UP, popUp);
		}

		override public function handleNotification(note: INotification):void{
			if(popUp.isDisposed()){
				facade.removeMediator(mediatorName);
				return;
			}
			super .handleNotification(note);
		}
	}
}