package com.distriqt {
    import by.blooddy.crypto.serialization.JSONer;

    import com.despark.tuning3d.Notifications;
    import com.despark.tuning3d.model.challenges.ChallengesProxy;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.core.http.HttpClient;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.utils.DateParser;

    import flash.filesystem.File;
    import flash.filesystem.FileMode;
    import flash.filesystem.FileStream;

    import org.puremvc.as3.patterns.command.SimpleCommand;

    public class GameService  extends SimpleCommand {
    private static var self: GameService;
    private const SAVED_GAME_NAME: String = 'tuningRewards';
    private var isCacheStrategy: Boolean;
    public var isInited: Boolean = false;
    public var httpClient : HttpClient;
    private const EXCLUDE_COUNTRY: Array = ['US'];

    private var _cachedData: String;
    private var _rewards:int = 0;
        //
    private var _userProxy:UsersProxy;
    private var _challengeProxy:ChallengesProxy;
    public static const REWARDED_PACKAGE_ACTIVE_DURATION:Number = 7 * DateParser.DAY;
    public static function get $() : GameService{
        if(!self){
            self = new GameService();
        }

        return self;
    }

    public function get userProxy():UsersProxy{
        _userProxy ||= facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        return _userProxy;
    }

    private function get challengeProxy():ChallengesProxy{
        _challengeProxy ||= facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
        return _challengeProxy;
    }

    public  function rewardsIsSupport(cb: Function): void {

        if (!Tuning3D.GEODATA) {
            if (!httpClient) {
                httpClient = new HttpClient();
            }
            httpClient.getPath("?country=true", null, function(success : Boolean, result : Object) : void {
                if (success) {
                    var data:Object = JSONer.parse(result as String);
                    if (data.hasOwnProperty('region')) {
                        Tuning3D.GEODATA = data.region;
                        cb(true);
                        /*if (EXCLUDE_COUNTRY.indexOf(Tuning3D.GEODATA.country) > -1 && Device.isIos()) {
                            cb(false);
                        } else {
                            cb(true);
                        }*/
                    }
                } else  {
                    cb(false);
                }
            })
        } else {
            cb(true);
            /*if (EXCLUDE_COUNTRY.indexOf(Tuning3D.GEODATA.country) > -1 && Device.isIos()) {
                cb(false);
            } else {
                cb(true);
            }*/

        }

    }

    public function init(): void {
        isCacheStrategy = true;
        isInited = true;
    }

    public function GameService(): void {
        if(self){
            throw new Error("GameService is singleton");
        }

    }

    public function getSaveData(cb: Function): void {
        if(!userProxy.currentUser){
            cb("{}");
            return;
        }

        var userId:String = userProxy.currentUser.id;
        if (isCacheStrategy) {
            if (!_cachedData) {
                var savedGameFile:File = File.cacheDirectory.resolvePath(SAVED_GAME_NAME + '.json');
                if (savedGameFile.exists) {
                    try{
                        var fileStream:FileStream = new FileStream();
                        fileStream.open(savedGameFile, FileMode.READ);
                        var savedGameData:String = fileStream.readUTF();
                        fileStream.close();
                        _cachedData = savedGameData;
                        var cacheDataObj:Object = JSON.parse(_cachedData);
                        if(!cacheDataObj.hasOwnProperty(userId)){
                            cacheDataObj[userId] = {"rewardsPackets":{}};
                            _cachedData = JSON.stringify(cacheDataObj);
                        }
                    }catch (e:Error) {
                        _cachedData = '{"' + userId + '":{"rewardsPackets":{}}}';
                    }
                } else {
                    _cachedData = '{"' + userId + '":{"rewardsPackets":{}}}';
                }
            }
        }

        if(userProxy.currentUser){
            var userData:Object = userProxy.currentUserJSON;
            if(userData.hasOwnProperty("challengeNewSystemDiamonds")){
                _rewards = userData["challengeNewSystemDiamonds"];
            }
            cb(_cachedData);
        }
    }

    public function addRewardPacket(packetId: String, packetPrice: Number, cb: Function, oneTimeUnlocked:Boolean = false): void {
        if(!userProxy.currentUser){
            return;
        }
        var userId:String = userProxy.currentUser.id;
        getSaveData(function (data: String): void {
            var rewardData: Object = JSONer.parse(data);
            if (!rewardData.hasOwnProperty(userId) || !rewardData[userId].hasOwnProperty('rewardsPackets')) {
                rewardData[userId] = {rewardsPackets:{}};
            }
            if ((_rewards >= packetPrice && !rewardData[userId].rewardsPackets.hasOwnProperty(packetId))) {
                _rewards -= packetPrice;
                rewardData[userId].rewardsPackets[packetId] = new Date().time;
                if(oneTimeUnlocked){
                    rewardData[userId].rewardsPackets[packetId] -= REWARDED_PACKAGE_ACTIVE_DURATION;
                    rewardData[userId].oneTimeUnlocked ||= {};
                    rewardData[userId].oneTimeUnlocked[packetId] = true;
                }

                userProxy.currentUser.diamonds -= packetPrice;
                challengeProxy.updateRewardData(userProxy.currentUser.id, {unlockedPacks:rewardData[userId].rewardsPackets});
                challengeProxy.addDiamondForChallenge(userProxy.currentUser.id, -packetPrice, function(data:Object):void{
                    saveGameData(JSONer.stringify(rewardData));
                    cb(true);
                });
            } else if(rewardData[userId].rewardsPackets.hasOwnProperty(packetId)) {
                cb(true);
            }else {
                cb(false);
            }
        });
    }

    public function deleteRewardPacket(packetId: String): void {
        if(!userProxy.currentUser){
            return;
        }
        var userId:String = userProxy.currentUser.id;
        getSaveData(function (data: String): void {
            var rewardData: Object = JSONer.parse(data);
            if (!rewardData.hasOwnProperty(userId) || !rewardData[userId].hasOwnProperty('rewardsPackets')) {
                rewardData[userId] = {rewardsPackets:{}};
            }
            if (rewardData[userId].rewardsPackets.hasOwnProperty(packetId)) {
                delete rewardData[userId].rewardsPackets[packetId];
                sendNotification(Notifications.DELETE_REWARD_PACKET, {packetId: packetId});
                saveGameData(JSONer.stringify(rewardData));
            }
        });
    }

    public function getRewardedPacketUnlockTime(packetId: String, callback:Function): void {
        if(!userProxy.currentUser){
            callback(0);
            return;
        }
        var userId:String = userProxy.currentUser.id;
        getSaveData(function (data: String): void {
            var rewardData: Object = JSONer.parse(data);
            if (!rewardData.hasOwnProperty(userId) || !rewardData[userId].hasOwnProperty('rewardsPackets')) {
                rewardData[userId] = {rewardsPackets:{}};
            }
            if (rewardData[userId].rewardsPackets.hasOwnProperty(packetId)) {
                callback(rewardData[userId].rewardsPackets[packetId]);
            }else{
                callback(0);
            }
        });
    }

    public function getRewardsData(cb: Function): void {
        if(userProxy.currentUser){
            userProxy.loadCurrentUser(function (result:Object):void {
                if(result){
                    var userData:Object = JSON.parse(result as String);
                    if(userData.hasOwnProperty("challengeNewSystemDiamonds")){
                        _rewards = userData["challengeNewSystemDiamonds"];
                    }
                }
                cb(_rewards);
            });
        }else{
            cb(0);
        }
    }

    public function addReward(count3DCount: Number): void {
        if(!userProxy.currentUser){
            return;
        }
        getSaveData(function (data: String): void {
            _rewards += count3DCount * Constants.UNIT_MULTIPLIER;
            challengeProxy.addDiamondForChallenge(userProxy.currentUser.id, count3DCount * Constants.UNIT_MULTIPLIER, function(data:Object):void{
                data["adsReceivedRewards"] = count3DCount * Constants.UNIT_MULTIPLIER;
                sendNotification(Notifications.REWARD_DATA_CHANGE, data);
            });
        });
    }


     public function saveGameData(data: String, notify:Boolean = true): void {
        if (isCacheStrategy) {
            _cachedData = data;
            var savedGameFile: File = File.cacheDirectory.resolvePath(SAVED_GAME_NAME + '.json');
            var fileStream: FileStream = new FileStream();
            fileStream.open(savedGameFile, FileMode.WRITE);
            fileStream.writeUTF(data);
            fileStream.close();
            if(notify){
                sendNotification(Notifications.REWARD_DATA_CHANGE, data);
            }
        }
    }
}
}
