package  com.utils
{
	import com.despark.tuning3d.model.core.Constants;
	import com.despark.tuning3d.model.core.http.URLLoaderObjects;
	import com.despark.tuning3d.model.core.images.BitmapDataUtil;
	import com.despark.tuning3d.model.parts.PartMaterialImageEvent;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.errors.IOError;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.HTTPStatusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.system.ImageDecodingPolicy;
	import flash.system.LoaderContext;
	import flash.utils.ByteArray;

	public class BitmapDataLoader extends EventDispatcher
	{
		private static var loaderContext:LoaderContext=new LoaderContext();
		
		public static var _countLoad:int=0;
		
		private static var urlRequest:URLRequest=new URLRequest();
		//private var _url:String;
		//private var _isEncrypted:Boolean;
		private var _data:Object=null;
		
		
		
		//private var _urlLoader:URLLoader;
		
		//private var _loader:Loader;
		
		public function BitmapDataLoader()
		{
			//var t:ImageDecodingPolicy
			loaderContext.imageDecodingPolicy=ImageDecodingPolicy.ON_DEMAND;
		}
		
		
		public function load(data:Object):void{
			
			
			//url:String, isEncrypted:Boolean
			//_url=url;
			_data=data;
			
		
			
			//URLLoaderObjects.getInstance().
			var urlLoader:URLLoader=URLLoaderObjects.getInstance().takeLoader();//new URLLoader();
			
			urlLoader.dataFormat=URLLoaderDataFormat.BINARY;
			
			urlLoader.addEventListener(Event.COMPLETE, onCompleteLoadImage);
			
			//urlLoader.addEventListener(Event.OPEN, onOpenLoadImge);
			
			urlLoader.addEventListener(IOErrorEvent.IO_ERROR, onIOErrorLoadImage);
		
			//trace("load url:",data.url);
			urlRequest.url=data.url;
			//var urlRequest:URLRequest=new URLRequest(data.url);
			urlRequest.idleTimeout=Constants.IMAGE_REQUESTS_TIMEOUT;
			//urlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
			//urlLoader.addEventListener(HTTPStatusEvent.HTTP_STATUS, httpStatusHandler);
			//trace("load:", data.vIndex, data.hIndex);
			
			urlLoader.load(urlRequest);
			
			//trace("url:", data.url);
			//trace("end load:", data.vIndex, data.hIndex);
			
		}
		
		public function get data():Object{
			
			return _data;
		}
		
		protected function httpStatusHandler(event:HTTPStatusEvent):void{
			
			//trace("httpStatusHandler:", data.vIndex, data.hIndex, event.status);
		}
		
		protected function securityErrorHandler(event:SecurityErrorEvent):void{
			
			//trace("securityErrorHandler");
		}
		
		protected function onOpenLoadImge(event:Event):void{
			
			//trace("onOpenLoadImge:", data.url);
		}
		
		protected function onIOErrorLoadImage(event:IOErrorEvent):void{
			
			//trace("onIOErrorLoadImage");
			var urlLoader:URLLoader=event.target as URLLoader;
			urlLoader.removeEventListener(Event.COMPLETE, onCompleteLoadImage);
			urlLoader.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorLoadImage);
			
			dispatchEvent(new BitmapDataLoaderEvent(BitmapDataLoaderEvent.FAILED, null));
		}
		
		protected function onCompleteLoadImage(event:Event):void{
			
			
			//trace("onCompleteLoadImage url:",data.url);
			
			//trace("onCompleteLoadImage:", data.vIndex, data.hIndex)
			//trace("onCompleteLoadImage url:", data.url);
			//trace("onCompleteLoadImage");
			var urlLoader:URLLoader=event.target as URLLoader;
			urlLoader.removeEventListener(Event.COMPLETE, onCompleteLoadImage);
			urlLoader.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorLoadImage);
			
			var imageBytes:ByteArray=urlLoader.data;
			
			//pngSize=imageBytes.bytesAvailable;
			
			var isEncrypted:Boolean=true;
			
			if(_data.hasOwnProperty("isEncrypted"))
				isEncrypted=_data.isEncrypted;
			
			if(isEncrypted){
				
				BitmapDataUtil.decryptImageBytes(imageBytes, _data.url);
			}
			
			loadBitmapData(imageBytes);
			
			URLLoaderObjects.getInstance().releaseLoader(urlLoader);
			urlLoader.data=null;
			urlLoader=null;
			
		}
		
		private function loadBitmapData(imageBytes:ByteArray):void{
			
			
			//trace("loadBitmapData:", data.vIndex, data.hIndex)
			//trace("loadBitmapData");
			
			
			var loader:Loader=new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadBitmapDataCompleteHandler);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, loadBitmapDataIOErrorHandler);
			loader.loadBytes(imageBytes, loaderContext);
		}
		
		private function loadBitmapDataIOErrorHandler(event:IOErrorEvent):void{
			
			var contentLoaderInfo:LoaderInfo=event.target as LoaderInfo;
			
			contentLoaderInfo.removeEventListener(Event.COMPLETE, loadBitmapDataCompleteHandler);
			contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, loadBitmapDataIOErrorHandler);
			
			//trace("loadBitmapDataIOErrorHandler");
		}
		
		private function loadBitmapDataCompleteHandler(event:Event):void{
			//trace("loadBitmapDataCompleteHandler url:", data.url);
			var contentLoaderInfo:LoaderInfo=event.target as LoaderInfo;//event.target as LoaderInfo;
			
			
			
			contentLoaderInfo.removeEventListener(Event.COMPLETE, loadBitmapDataCompleteHandler);
			contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, loadBitmapDataIOErrorHandler);
			
			var bitmap:Bitmap=contentLoaderInfo.content as Bitmap;
			
			var bitmapData:BitmapData=bitmap.bitmapData;
			
			bitmap.bitmapData=null;
			
			contentLoaderInfo=null;
			
			//_countLoad++;
			
			//trace("countImages:", _countLoad);
			
			dispatchEvent(new BitmapDataLoaderEvent(BitmapDataLoaderEvent.LOADED, bitmapData));
			
		}
		
	}
}