package com.utils
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
import flash.display.PixelSnapping;
import flash.display.Shape;
import flash.display.Sprite;
	import flash.events.Event;
import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;

	import starling.core.Starling;
	import starling.display.Image;

	import starling.display.Image;
import starling.textures.Texture;
	import starling.utils.MathUtil;

	public class ImageUtils extends Sprite
	{
		public static var bitmap:Bitmap;
		
		public static function loadImage(url:String) : void
		{
			var loader:Loader = new Loader();
				loader.load(new URLRequest(url));
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE,onLoadComplete);
		}
		
		public static  function onLoadComplete(event:Event) : void{
			bitmap = event.currentTarget.loader.content as Bitmap;
		}

        public static function getDashLine(width:Number, size:Number, dashSize:Number, gapSize:Number):Texture{
			var dashBd:BitmapData = new BitmapData(dashSize + gapSize, size, true, 0);
			var shape:Shape = new Shape();
			var lineBd:BitmapData = new BitmapData(width, size, true, 0);
			//
            dashBd.fillRect(new Rectangle(0,0,dashSize, size), 0xFFFFFFFF);
			//
            shape.graphics.beginBitmapFill(dashBd, null, true, true);
			shape.graphics.drawRect(0,0,width, size);
			shape.graphics.endFill();
			lineBd.draw(shape);
			return Texture.fromBitmapData(lineBd);
        }
		
        public static function clearAllTexture():void {
			trace("CLEAR ALL TEXTURES ____________________________________________________________________________");
			/*var texturesForDispose : Array = Texture.texturesToDispose;
			for each ( var st : Texture  in texturesForDispose)
			{
				if (st!=null && st.forDelete == true) {
					st.dispose();
				}
			}*/

			//ObjectUtils.cleanArray(Texture.texturesToDispose);

		}

		public static function getCarImage(image:Image):Image{
			if(!image){
				return null;
			}
			var result:BitmapData;
			var w:Number = image.width;
			var h:Number = image.height;
			image.scale /= Starling.current.contentScaleFactor;
			var bd:BitmapData = image.drawToBitmapData(new BitmapData(w, h, true, 0x00000000));
			if(!bd){
				return null;
			}
			bd.fillRect(new Rectangle(bd.width - 115, bd.height - 60, 115, 60), 0x00000000);
			var rect:Rectangle = bd.getColorBoundsRect(0xff000000, 0x00000000, false);
			if(rect){
				result = new BitmapData(rect.width, rect.height, true);
				var bArr:ByteArray = bd.getPixels(rect);
				bArr.position = 0;
				result.setPixels(new Rectangle(0, 0, rect.width, rect.height - 1), bArr);
				bd.dispose();
				bd = null;
				var resultImage:Image = new Image(Texture.fromBitmapData(result));
				result.dispose();
				result = null;
				bArr.clear();
				image.scale = 1;
				return resultImage;
			}
			return null;
		}

		public static function getCarImageRect(image:Image):Rectangle{
			if(!image){
				return null;
			}
			var dims:Object = {"w": 1440, "h": 900};
			var prevScale:Number = image.scale;
			image.scale = 1;
			var w:Number = image.width;
			var h:Number = image.height;
			image.scale = prevScale;
			var bd:BitmapData = image.drawToBitmapData(null, 0x00000000, 0);
			if(!bd){
				return null;
			}
			var ratio:Number = bd.width / dims.w;
			var badgeWidth:int = int(120 * ratio);
			var badgeHeight:int = int(65 * ratio);
			var fillRect:Rectangle = new Rectangle(bd.width - badgeWidth, bd.height - badgeHeight, badgeWidth, badgeHeight);
			bd.fillRect(fillRect, 0x00000000);
			bd.threshold(bd, new Rectangle(0, 0, bd.width, bd.height), new Point(), "<", 0x99000000, 0x00000000, 0xFFFFFFFF, true);
			var result:Rectangle = bd.getColorBoundsRect(0xff000000, 0x00000000, false);
			var resultRatio:Number = image.width / bd.width;
			bd.dispose();
			bd = null;
			/*var img:Image = new Image(Texture.fromBitmapData(bd));
			img.width = Starling.current.stage.stageWidth / 2;
			img.height = Starling.current.stage.stageHeight / 2;
			img.x = Starling.current.stage.stageWidth / 4;
			img.y = Starling.current.stage.stageHeight / 4;
			Starling.current.stage.addChild(img);*/
			if(result){
				result.x *= resultRatio;
				result.y *= resultRatio;
				result.width *= resultRatio;
				result.height *= resultRatio;
			}
			return result;
		}

    public static function scaleBitmapData(bigBMD : BitmapData, scale : Number) : BitmapData
    {
        //trace("scaleBitmapData");
        var matrix:Matrix = new Matrix();
        matrix.scale(scale, scale);

        var smallBMD:BitmapData = new BitmapData(bigBMD.width * scale, bigBMD.height * scale, true, 0x000000);
        smallBMD.draw(bigBMD, matrix, null, null, null, true);

        return smallBMD;
    }

    public static  function cropBMP(btm : Bitmap, _x:Number, _y:Number, _width:Number, _height:Number) : Bitmap {
        var cropArea:Rectangle = new Rectangle( 0, 0, _width, _height );
		const maxSizeSize:Number = 8191;
		const maxImageSize:Number = 16777215;
		if(MathUtil.clamp(_width, 0, maxSizeSize) != _width || MathUtil.clamp(_height, 0, maxSizeSize) != _height || _width * _height > maxImageSize){
			return btm;
		}
		var bmd:BitmapData = new BitmapData(_width, _height, true, 0x00000000);
        var croppedBitmap:Bitmap = new Bitmap(bmd, PixelSnapping.ALWAYS, true );
        croppedBitmap.bitmapData.draw(btm, new Matrix(1, 0, 0, 1, -_x, -_y) , null, null, cropArea, true );
        return croppedBitmap;
    }

		public static function roundCorners(bmp:Bitmap) : Bitmap
		{
			if (!bmp) return null;
				
			var width  : Number = bmp.width;
			var radius : Number = width / 2;
			
			var circle : Sprite = new Sprite();
				circle.addChild(bmp);
			
			var mask : Sprite = new Sprite();
				mask.graphics.beginFill(0xFFFFFF);
				mask.graphics.drawCircle(radius, radius, radius);
				mask.graphics.endFill();
			
			circle.addChild(mask);
			bmp.mask = mask;
			
			var bmpData : BitmapData = new BitmapData(width, width, true, 0x000000);
				bmpData.draw(circle, null, null, null, null, true);
			bmp.bitmapData.dispose();
			var newBmp : Bitmap = new Bitmap(bmpData, 'auto', true);
			circle = null; // clear
			
			return newBmp;
		}
	}
}