package com.utils {
    public class NumberUtils {
        public static function toFixed(value:Number, num:int = 0):String{
            var result:String = value.toString();
            var arr:Array = result.split(".");
            if(num){
                result = arr[0] + '.';
                var znum:int;
                if(arr.length == 2){
                    znum = Math.max(num - arr[1].length, 0);
                }else{
                    znum = num;
                }
                if(arr.length == 2){
                    result = result + arr[1].substr(0, num - znum);
                }
                if(znum){
                    while (znum > 0){
                        result += "0";
                        znum--;
                    }
                }
                return result;
            }
            return arr[0];
        }
        private static const lookup:Vector.<Object> = new <Object>[
            { value: 1e3, symbol: "k" },
            { value: 1e6, symbol: "M" },
            { value: 1e9, symbol: "G" },
            { value: 1e12, symbol: "T" },
            { value: 1e15, symbol: "P" },
            { value: 1e18, symbol: "E" }
        ];

        public static function toShortenString(num:Number):String{
            var symbol:String;
            for(var i:int = lookup.length - 1; i >= 0; i--){
                if(num >= lookup[i].value){
                    symbol = lookup[i].symbol;
                    return (num / lookup[i].value).toFixed(1) + symbol;
                }
            }
            return num.toString();
        }
    }
}
