package com.utils {
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.core.Constants;
    import com.despark.tuning3d.model.parts.Part;
    import com.despark.tuning3d.model.parts.PartMaterial;
    import com.despark.tuning3d.model.parts.PartMaterialImageTest;
    import com.despark.tuning3d.model.parts.PartSlot;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;

    import flash.filesystem.File;

    import starling.utils.ScaleMode;

    public class RandomSplashManager {
    public static const POSTER_IMAGE_COUNT : int = 30;
    private static var _rand:Array = [];
    public static function getRandomUrl():String{
        var randomIndex:int = getRandIndex();
        var randomSplashUrl:String = File.applicationDirectory.resolvePath("assets/textures/splashes_v2/"+randomIndex+".jpg").url;
        return randomSplashUrl;
    }

    private static function getRandIndex():int{
        if(_rand.length == 0){
            while (_rand.length<POSTER_IMAGE_COUNT){
                _rand.push(_rand.length+1);
            }
        }
        var randomIndex:int = int(Math.random()*_rand.length);
        return _rand.removeAt(randomIndex);
    }

    public static function createSplashImage(car:Car):ImageLoaderWithStates{
        var partSlot:PartSlot = new PartSlot(car);
        var partCarSplash:Part = new Part(partSlot);
        var partMaterial:PartMaterial = new PartMaterial(partCarSplash);
        var randomSplashUrl:String = RandomSplashManager.getRandomUrl();


        var carSplashImageProvider:PartMaterialImageTest = new PartMaterialImageTest(randomSplashUrl,"0",null,partMaterial);
        carSplashImageProvider.frameIndex = 0;
        carSplashImageProvider.angleIndex = 0;
        carSplashImageProvider.isEncrypted = false;


        var carSplashImage:ImageLoaderWithStates = new ImageLoaderWithStates();
        carSplashImage.overrideDispose = true;
        carSplashImage.snapToPixels = false;
        if(Constants.TOTAL_MEMORY < 1024 && Constants.SCALE_FACTOR<2){
            carSplashImage.bitmapScale = 0.5;
        }
        carSplashImage.visible = false;
        carSplashImage.scaleMode =	ScaleMode.NONE;
        carSplashImage.persistentImageProvider = carSplashImageProvider;
        return carSplashImage;
    }
}
}
