package com.utils {
import flash.display.BitmapData;
import flash.geom.Rectangle;

import starling.display.Image;
import starling.textures.Texture;

public class TextureUtil {
    public function TextureUtil() {
    }

    public static function saveDispose(texture:Texture):void{
        if(texture){
            try{
                texture.dispose();
            }catch (e:Error) {

            }
        }
    }

    public static function cropImage(image:Image, top:Number = 0, bottom:Number = 0, left:Number = 0, right:Number = 0, dispose:Boolean = false):void{
        var dw:Number = image.width/image.texture.width;
        var dh:Number = image.height/image.texture.height;
        image.texture =  Texture.fromTexture(image.texture, new Rectangle(left/dw, top/dh, image.texture.width-(left+right)/dw, image.texture.height-(top+bottom)/dh));
        image.width = image.width - (left+right);
        image.height = image.height - (top+bottom);
    }

    public static function cropImage2(image:Image, top:Number = 0, bottom:Number = 0, left:Number = 0, right:Number = 0):Image{
        var ratioWidth:Number = image.texture.frameWidth / image.width;
        var ratioHeight:Number = image.texture.frameHeight / image.height;
        var rect:Rectangle = new Rectangle(left * ratioWidth, top * ratioHeight, image.texture.width - ratioWidth * (left + right), image.texture.height - ratioHeight * (top + bottom));
        image.width = image.height = NaN;
        var result:Image =  new Image(Texture.fromTexture(image.texture, rect));
        image.removeFromParent(true);
        return result;
    }

    public static function scaleImage(image:Image, scale:Number):void{
        var bd:BitmapData = image.drawToBitmapData();
        image.texture =  Texture.fromBitmapData(bd, false, false, 1/scale);
    }

    public static function cropImageRel(image:Image, top:Number = 0, bottom:Number = 0, left:Number = 0, right:Number = 0, dispose:Boolean = false):void{
        cropImage(image, image.height*top, image.height*bottom, image.width*left, image.width*right, dispose);
    }

    public static function scaleTexture(texture:Texture, scale:Number):Texture{
        return Texture.fromTexture(texture, null, null, false, 1 / scale);
    }


}
}
