/*
Feathers
Copyright 2012-2017 Bowler Hat LLC. All Rights Reserved.

This program is free software. You can redistribute and/or modify it in
accordance with the terms of the accompanying license agreement.
*/
package feathers.layout
{
	/**
	 * Constants that define a direction.
	 *
	 * @productversion Feathers 3.0.0
	 */
	public class Direction
	{
		/**
		 * The object will be oriented vertically.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const VERTICAL:String = "vertical";

		/**
		 * The object will be oriented horizontally.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const HORIZONTAL:String = "horizontal";

		/**
		 * The object will be oriented in no particular direction.
		 *
		 * @productversion Feathers 3.3.0
		 */
		public static const NONE:String = "none";
	}
}
