/*
Feathers
Copyright 2012-2017 Bowler Hat LLC. All Rights Reserved.

This program is free software. You can redistribute and/or modify it in
accordance with the terms of the accompanying license agreement.
*/
package feathers.layout
{
	/**
	 * Constants for horizontal alignment of items in a layout.
	 *
	 * <p>Note: Some constants may not be valid for certain properties. Please
	 * see the description of the property in the API reference for full
	 * details.</p>
	 *
	 * @productversion Feathers 3.0.0
	 */
	public class HorizontalAlign
	{
		/**
		 * The items in the layout will be horizontally aligned to the left of
		 * the bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const LEFT:String = "left";

		/**
		 * The items in the layout will be horizontally aligned to the center of
		 * the bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const CENTER:String = "center";

		/**
		 * The items in the layout will be horizontally aligned to the right of
		 * the bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const RIGHT:String = "right";

		/**
		 * The items in the layout will fill the width of the bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const JUSTIFY:String = "justify";
	}
}
