/*
Feathers
Copyright 2012-2017 Bowler Hat LLC. All Rights Reserved.

This program is free software. You can redistribute and/or modify it in
accordance with the terms of the accompanying license agreement.
*/
package feathers.layout
{
	/**
	 * Constants for vertical alignment of items in a layout.
	 *
	 * <p>Note: Some constants may not be valid for certain properties. Please
	 * see the description of the property in the API reference for full
	 * details.</p>
	 *
	 * @productversion Feathers 3.0.0
	 */
	public class VerticalAlign
	{
		/**
		 * The items in the layout will be vertically aligned to the top of the
		 * bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const TOP:String = "top";

		/**
		 * The items in the layout will be vertically aligned to the middle of
		 * the bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const MIDDLE:String = "middle";

		/**
		 * The items in the layout will be vertically aligned to the bottom of
		 * the bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const BOTTOM:String = "bottom";

		/**
		 * The items in the layout will fill the height of the bounds.
		 *
		 * @productversion Feathers 3.0.0
		 */
		public static const JUSTIFY:String = "justify";
	}
}
